//==============================================================================
//    ANVvO ev[g
//
//        y  z parameter                   : [Nt[p[^IuWFNg
//                   parameter.loginGroupId      : OCO[vID
//                   parameter.localeId          : P[ID
//                   parameter.targetLocales     : ^[QbgP[ID
//                   parameter.contentsId        : RecID
//                   parameter.contentsVersionId : Reco[WID
//                   parameter.routeId           : [gID
//                   parameter.routeVersionId    : [go[WID
//                   parameter.flowId            : t[ID
//                   parameter.flowVersionId     : t[o[WID
//                   parameter.applyBaseDate     : \
//                   parameter.processDate       : /B
//                   parameter.systemMatterId    : VXeČID
//                   parameter.userDataId        : [Uf[^ID
//                   parameter.matterName        : Č
//                   parameter.matterNumber      : Čԍ
//                   parameter.priorityLevel     : Dx
//                   parameter.parameter         : svOpX
//                   parameter.actFlag           : 㗝tO
//                   parameter.nodeId            : m[hID
//                   parameter.nextNodeIds       : ړ(m[h)m[hID [߂A߂AČ쎞ɐݒ肳܂B]
//                   parameter.authUserCd        : ҃R[h
//                   parameter.execUserCd        : s҃R[h
//                   parameter.resultStatus      : ʃXe[^X
//                   parameter.authCompanyCode   : ЃR[h
//                   parameter.authOrgzSetCode   : gDZbgR[h
//                   parameter.authOrgzCode      : gDR[h
//                   parameter.processComment    : Rg
//                   parameter.lumpProcessFlag   : ꊇtO
//                   parameter.autoProcessFlag   : tO [BŎFob`Ŏ鎞ɐݒ肳܂B]
//                   userParameter               : NGXgp[^IuWFNg
//
//        yԋplz result.resultFlag           : ʃtO     [true:/false:s]
//                   result.message              : ʃbZ[W [ʃtOs̏ꍇ̂]
//                   result.data                 : Čԍ       [TCYF20oCg
//                                                                 \/Đ\/\(ꎞۑČ)/\(\ԈČ)̏ꍇ̂
//                                                                 nullȊȌꍇɈČԍ㏑܂B]
//
//        y ڍ z ̃vOłDBgUNV𒣂ȂŉB
//
//==============================================================================

// \
function apply(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - apply -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - apply -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : "",
                  "data"       : null
                 };

    var matterPropertyInfo = [{
                               "userDataId"          : parameter.userDataId,
                               "matterPropertyKey"   : "item_total",
                               "matterPropertyValue" : Number(userParameter.item_amount) * Number(userParameter.item_price) + ""
                             }];
    var property = new UserActvMatterPropertyValue(parameter.loginGroupId);
    var res = property.createMatterProperty(matterPropertyInfo);
    if (!res.resultFlag) {
        result = {
                  "resultFlag" : false,
                  "message"    : MessageManager.getMessage("SAMPLE.IMW.ERR.000"),
                  "data"       : null
                 };
    }

    return result;
}

// Đ\
function reapply(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - reapply -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - reapply -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : "",
                  "data"       : null
                 };

    var matterPropertyInfo = [{
                               "userDataId"          : parameter.userDataId,
                               "matterPropertyKey"   : "item_total",
                               "matterPropertyValue" : Number(userParameter.item_amount) * Number(userParameter.item_price) + ""
                             }];
    var property = new UserActvMatterPropertyValue(parameter.loginGroupId);
    var res      = property.updateMatterProperty(matterPropertyInfo);
    if (!res.resultFlag) {
        result = {
                  "resultFlag" : false,
                  "message"    : MessageManager.getMessage("SAMPLE.IMW.ERR.001"),
                  "data"       : null
                 };
    }

    return result;
}

// \(ꎞۑČ)
function applyFromTempSave(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - applyFromTempSave -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - applyFromTempSave -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : "",
                  "data"       : null
                 };

    // ꎞۑ  \
    var matterPropertyInfo = [{
                               "userDataId"          : parameter.userDataId,
                               "matterPropertyKey"   : "item_total",
                               "matterPropertyValue" : Number(userParameter.item_amount) * Number(userParameter.item_price) + ""
                             }];
    var property = new UserActvMatterPropertyValue(parameter.loginGroupId);
    var res      = property.updateMatterProperty(matterPropertyInfo);
    if (!res.resultFlag) {
        result = {
                  "resultFlag" : false,
                  "message"    : MessageManager.getMessage("SAMPLE.IMW.ERR.001"),
                  "data"       : null
                 };
    }

    return result;
}

// \(\ԈČ)
function applyFromUnapply(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - applyFromUnapply -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - applyFromUnapply -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : "",
                  "data"       : null
                 };

    // \  \
    var matterPropertyInfo = [{
                               "userDataId"          : parameter.userDataId,
                               "matterPropertyKey"   : "item_total",
                               "matterPropertyValue" : Number(userParameter.item_amount) * Number(userParameter.item_price) + ""
                             }];

    var property = new UserActvMatterPropertyValue(parameter.loginGroupId);
    var res = property.createMatterProperty(matterPropertyInfo);
    if (!res.resultFlag) {
        result = {
                  "resultFlag" : false,
                  "message"    : MessageManager.getMessage("SAMPLE.IMW.ERR.000"),
                  "data"       : null
                 };
    }

    return result;
}

// ~
function discontinue(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - discontinue -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - discontinue -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : ""
                 };
    return result;
}

// ߂
function pullBack(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - pullBack -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - pullBack -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : ""
                 };
    return result;
}

// ߂߂
function sendBackToPullBack(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - sendBackToPullBack -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - sendBackToPullBack -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : ""
                 };
    return result;
}

// F
function approve(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - approve -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - approve -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : ""
                 };
    return result;
}

// FI
function approveEnd(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - approveEnd -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - approveEnd -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : ""
                 };
    return result;
}

// ۔F
function deny(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - deny -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - deny -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : ""
                 };
    return result;
}

// ߂
function sendBack(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - sendBack -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - sendBack -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : ""
                 };
    return result;
}

// ۗ
function reserve(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - reserve -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - reserve -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : ""
                 };
    return result;
}

// ۗ
function reserveCancel(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - reserveCancel -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - reserveCancel -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : ""
                 };
    return result;
}

// Č
function matterHandle(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - matterHandle -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - matterHandle -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : ""
                 };
    return result;
}

// ꎞۑiVKo^j
function tempSaveCreate(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - tempSaveCreate -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - tempSaveCreate -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : ""
                 };

    var itemAmount = userParameter.item_amount;
    var itemPrice  = userParameter.item_price;
    if (itemAmount == "") {
        itemAmount = "0";
    }
    if (itemPrice == "") {
        itemPrice = "0";
    }

    var matterPropertyInfo = [{
                               "userDataId"          : parameter.userDataId,
                               "matterPropertyKey"   : "item_total",
                               "matterPropertyValue" : Number(itemAmount) * Number(itemPrice) + ""
                             }];
    var property = new UserActvMatterPropertyValue(parameter.loginGroupId);
    var res      = property.createMatterProperty(matterPropertyInfo);
    if (!res.resultFlag) {
        result = {
                  "resultFlag" : false,
                  "message"    : MessageManager.getMessage("SAMPLE.IMW.ERR.000")
                 };
    }

    return result;
}

// ꎞۑiXVj
function tempSaveUpdate(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - tempSaveUpdate -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - tempSaveUpdate -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : ""
                 };

    var itemAmount = userParameter.item_amount;
    var itemPrice  = userParameter.item_price;
    if (itemAmount == "") {
        itemAmount = "0";
    }
    if (itemPrice == "") {
        itemPrice = "0";
    }

    var matterPropertyInfo = [{
                               "userDataId"          : parameter.userDataId,
                               "matterPropertyKey"   : "item_total",
                               "matterPropertyValue" : Number(itemAmount) * Number(itemPrice) + ""
                             }];
    var property = new UserActvMatterPropertyValue(parameter.loginGroupId);
    var res      = property.updateMatterProperty(matterPropertyInfo);
    if (!res.resultFlag) {
        result = {
                  "resultFlag" : false,
                  "message"    : MessageManager.getMessage("SAMPLE.IMW.ERR.001")
                 };
    }

    return result;
}

// ꎞۑi폜j
function tempSaveDelete(parameter,userParameter) {
    Debug.print( "----- ActionProcess2.js - tempSaveDelete -----" );
    Debug.console(parameter);
    Debug.console(userParameter);
    Debug.print( "----- ActionProcess2.js - tempSaveDelete -----" );

    var result = {
                  "resultFlag" : true,
                  "message"    : ""
                 };

    var matterPropertyInfo = [{
                               "userDataId"          : parameter.userDataId,
                               "matterPropertyKey"   : "item_total",
                               "matterPropertyValue" : null
                             }];

    var property = new UserActvMatterPropertyValue(parameter.loginGroupId);
    var res      = property.deleteMatterProperty(matterPropertyInfo);
    if (!res.resultFlag) {
        result = {
                  "resultFlag" : false,
                  "message"    : MessageManager.getMessage("SAMPLE.IMW.ERR.002")
                 };
    }

    return result;
}
