// oChϐ錾
var oCaption = new Object();
var oCommon = new Object();
var oValidationMsg = new Object();
var oResult = new Object();
var oHidden = new Object();

var BASE_EXTENSION_POINT_ID = "jp.co.intra_mart.workflow.plugin.authority.user.act.targetAct.personalAct";

// =============================================================================
// ֐
//  y  zrequest: tqk擾IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z㗝ݒҏWʂ\܂B
// =============================================================================
function init(request) {
    var result;

    // ̂̎擾
    oCaption.title = MessageManager.getMessage("IMW.CAP.1151"); // ʃ^Cgu㗝ݒ - ҏWv
    oCaption.back = MessageManager.getMessage("IMW.CAP.0016"); // ߂
    oCaption.require = MessageManager.getMessage("IMW.CAP.0017"); // iK{j
    oCaption.search = MessageManager.getMessage("IMW.CAP.0359"); // 
    oCaption.orgActor = MessageManager.getMessage("IMW.CAP.0385"); // 㗝
    oCaption.trgActor = MessageManager.getMessage("IMW.CAP.1063"); // 㗝
    oCaption.actDate = MessageManager.getMessage("IMW.CAP.1057"); // 㗝
    oCaption.from = MessageManager.getMessage("IMW.CAP.0154"); // 
    oCaption.auth = MessageManager.getMessage("IMW.CAP.1059"); // Ϗ錠
    oCaption.note = MessageManager.getMessage("IMW.CAP.0011"); // l
    oCaption.apply = MessageManager.getMessage("IMW.CAP.0010"); // \
    oCaption.approval = MessageManager.getMessage("IMW.CAP.0046"); // F
    oCaption.mail4act = MessageManager.getMessage("IMW.CAP.1060"); // 㗝ݒʒm[
    oCaption.send = MessageManager.getMessage("IMW.CAP.1041"); // M
    oCaption.comment = MessageManager.getMessage("IMW.CAP.0318"); // Rg
    oCaption.update = MessageManager.getMessage("IMW.CAP.0022"); // XV
    oCaption.del = MessageManager.getMessage("IMW.CAP.0023"); // 폜

    // ϐ錾
    var oSession = AccessSecurityManager.getSessionInfo();
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;
    var localeId = oSession.locale;
    var codeUtil = new WorkflowCodeUtil();
    var actConfig = new ActConfig(loginGroupId);
    var wfpManager = new WorkflowParameterManager(loginGroupId);

    // 㗝ǗҐݒ̃`FbN
    if (!wfpManager.getBooleanParameter("personal-act")) {
        Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3510");
    }

    // of[VbZ[W̎擾
    makeValidation(localeId);

    // ʕ\NGXgp[^擾
    var imwCallOriginalParams = ImJson.parseJSON(URL.decode(request.imwCallOriginalParams));

    // ʕ\񂪃NGXgp[^擾łꍇ
    var oConditionInfo = new Object();
    if (isObject(imwCallOriginalParams) && isObject(imwCallOriginalParams.trgActListParam)) {
        oConditionInfo = imwCallOriginalParams.trgActListParam;
    }

    // 㗝̃`FbN
    var isShowActConfig = true;
    if (!Procedure.imw_admin_utils.isWkfAdmin(oSession, imwCallOriginalParams.imwOpeType)) {
        result = actConfig.isActAuthorityUser(userId);
        if (!result.resultFlag) {
            Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3537", result);
        }
        isShowActConfig = result.data;
    }

    // ʏ̐ݒ
    oResult.imwCallOriginalParams = request.imwCallOriginalParams;
    oResult.imwOpeType = imwCallOriginalParams.imwOpeType;
    oResult.no = request.no;
    oResult.baseDate = oConditionInfo.baseDate;
    oResult.originalActUserCode = oConditionInfo.originalActUserCode;
    oResult.isShowActConfig = isShowActConfig;
    oResult.originalActUserName = "";
    oResult.targetActUserName = "";

    // 㗝E㗝於̂̎擾
    if (isShowActConfig) {
        oResult.originalActUserName = isBlank(oConditionInfo.originalActUserCode) ? "" :
                Procedure.imw_user_list_utils.getUserName(userId, loginGroupId, localeId,
                oConditionInfo.originalActUserCode);
        oResult.targetActUserName = isBlank(oConditionInfo.targetActUserCode) ? "" :
                Procedure.imw_user_list_utils.getUserName(userId, loginGroupId, localeId,
                oConditionInfo.targetActUserCode);
    }

    // 㗝ݒ̎擾
    if (!isBlank(request.no)) {
        result = actConfig.getActConfig(request.no, oConditionInfo.originalActUserCode);
        if (!result.resultFlag) {
            Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3537", result);
        }
        oResult.targetActUserName = Procedure.imw_user_list_utils.getUserName(userId, loginGroupId, localeId,
                result.data.targetCode);
        oResult.startDate = result.data.startDate;
        oResult.limitDate = result.data.limitDate;
        oResult.note = result.data.note;
        oResult.applyAuthChecked =
                (codeUtil.getEnumCodeFlagStatus("Enable") == result.data.applyAuth) ? true : false;
        oResult.approveAuthChecked =
                (codeUtil.getEnumCodeFlagStatus("Enable") == result.data.approveAuth) ? true : false;
        oResult.targetCode = result.data.targetCode;
        oResult.targetType = result.data.targetType;
        oResult.pluginId = result.data.pluginId;
        oResult.parameter = result.data.parameter;
    }

    // AvP[Vʃ}X^̐ݒ
    oCaption.imwAppCommonTitle = "";
    Procedure.imw_plugin_utils.initAppCommonMaster(oResult,
            BASE_EXTENSION_POINT_ID, loginGroupId, localeId);

    // hidden ɏo͂鍀ڂ̐ݒ
    Procedure.imw_utils.makeHiddenObject(oHidden, oResult);
}

//=============================================================================
// of[V`FbN쐬֐
//  y  zlocaleId: P[ID
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zof[V`FbN쐬܂B
//=============================================================================
function makeValidation(localeId) {
    var oParameter;
    oCommon = new Object();
    oCommon.localeId = localeId;
    oCommon.locales = System.getLocales(localeId);

    // 㗝
    oParameter = Procedure.imw_validate_utils.makeParameter4SelectRequireId("targetActUserName", "IMW.CAP.1063");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);

    // 㗝
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("actDate", "IMW.CAP.1057");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    oParameter = Procedure.imw_validate_utils.makeParameter4InputRequireDate("actDateFrom", new Array("IMW.CAP.1057", "IMW.CAP.0367"));
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    oParameter = Procedure.imw_validate_utils.makeParameter4InputRequireDate("actDateTo", new Array("IMW.CAP.1057", "IMW.CAP.0368"));
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);

    // Ϗ錠
    oParameter = Procedure.imw_validate_utils.makeParameter4SelectRequireId("authReq", "IMW.CAP.1059");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);

    // 㗝ݒ폜܂B낵łH
    oValidationMsg.deleteMsg = MessageManager.getMessage("IMW.CLI.INF.3520");
}

// =============================================================================
// XV֐
//  y  zrequest: tqk擾IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zXVs܂B
// =============================================================================
function actionUpdate(request) {
    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();

    var databaseResult;
    var oSession = AccessSecurityManager.getSessionInfo();
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;
    var localeId = oSession.locale;
    var codeUtil = new WorkflowCodeUtil();
    var actConfig = new ActConfig(loginGroupId);
    var wfpManager = new WorkflowParameterManager(loginGroupId);

    // 㗝ǗҐݒ̃`FbN
    if (!wfpManager.getBooleanParameter("personal-act")) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage("IMW.CLI.WRN.3510");
        return result;
    }

    // ʕ\NGXgp[^擾
    var imwCallOriginalParams = ImJson.parseJSON(URL.decode(request.imwCallOriginalParams));

    // 㗝̃`FbN
    var imwOpeType = imwCallOriginalParams.imwOpeType;
    if (!Procedure.imw_admin_utils.isWkfAdmin(oSession, imwOpeType)) {
        databaseResult = actConfig.isActAuthorityUser(userId);
        if (!databaseResult.resultFlag) {
            result.resultFlag = false;
            result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                    "IMW.CLI.WRN.3588", databaseResult);
            return result;
        }
        if (!databaseResult.data && request.originalActUserCode != userId) {
            result.resultFlag = false;
            result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                    "IMW.CLI.WRN.3268", databaseResult);
            return result;
        }
    }

    // AvP[Vʃ}X^̐ݒ
    Procedure.imw_plugin_utils.initAppCommonMaster(oResult,
            BASE_EXTENSION_POINT_ID, loginGroupId, localeId);

    // ݃`FbN
    result = actConfig.getActConfig(request.no, request.originalActUserCode);
    if (!result.resultFlag) {
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3588", result);
        return result;
    }
    if (result.data == null) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage("IMW.CLI.INF.3524");
        return result;
    }

    // f[^쐬
    var enableFlag = codeUtil.getEnumCodeFlagStatus("Enable");
    var disableFlag = codeUtil.getEnumCodeFlagStatus("Disable");
    var updateRecord = new Array();
    updateRecord = new Object();
    updateRecord.actClassify = codeUtil.getEnumCodeActClassify("actClass_PersonalAct");
    updateRecord.applyAuth  = (request.applyAuth) ? enableFlag : disableFlag;
    updateRecord.approveAuth = (request.approveAuth) ? enableFlag : disableFlag;
    updateRecord.extensionPointId = oResult.imwAppCommonExtensionPointId;
    updateRecord.startDate = request.actDateFrom;
    updateRecord.limitDate = request.actDateTo;
    updateRecord.no = request.no;
    updateRecord.note = request.note;
    updateRecord.originalActUserCode = request.originalActUserCode;
    updateRecord.targetCode = request.targetCode;
    updateRecord.targetType = request.targetType;
    updateRecord.pluginId  = request.pluginId;
    updateRecord.parameter  = request.parameter;

    // gUNV̊Jn
    databaseResult = DatabaseManager.beginTransaction();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3588", databaseResult);
        return result;
    }

    // XV
    var sendMailFlag = (request.mailCheck == "on") ? "true" : "false";
    var noticeComment = sendMailFlag == "true" ? request.mailCmt : "";
    result = actConfig.updateActConfig(updateRecord, sendMailFlag, noticeComment);
    if (!result.resultFlag) {
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3588", result);
        // [obN
        databaseResult = DatabaseManager.rollback();
        if (databaseResult.error) {
            result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                    "IMW.CLI.WRN.3588", databaseResult);
        }
        return result;
    }

    // R~bg
    databaseResult = DatabaseManager.commit();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3588", databaseResult);
        return result;
    }

    return result;
}

// =============================================================================
// 폜֐
//  y  zrequest: tqk擾IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z폜s܂B
// =============================================================================
function actionDelete(request) {
    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();

    var databaseResult;
    var oSession = AccessSecurityManager.getSessionInfo();
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;
    var actConfig = new ActConfig(loginGroupId);
    var wfpManager = new WorkflowParameterManager(loginGroupId);

    // 㗝ǗҐݒ̃`FbN
    if (!wfpManager.getBooleanParameter("personal-act")) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage("IMW.CLI.WRN.3510");
        return result;
    }

    // ʕ\NGXgp[^擾
    var imwCallOriginalParams = ImJson.parseJSON(URL.decode(request.imwCallOriginalParams));

    // 㗝̃`FbN
    var imwOpeType = imwCallOriginalParams.imwOpeType;
    if (!Procedure.imw_admin_utils.isWkfAdmin(oSession, imwOpeType)) {
        databaseResult = actConfig.isActAuthorityUser(userId);
        if (!databaseResult.resultFlag) {
            result.resultFlag = false;
            result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                    "IMW.CLI.WRN.3589", databaseResult);
            return result;
        }
        if (!databaseResult.data && request.originalActUserCode != userId) {
            result.resultFlag = false;
            result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                    "IMW.CLI.WRN.3268", databaseResult);
            return result;
        }
    }

    // ݃`FbN
    result = actConfig.getActConfig(request.no, request.originalActUserCode);
    if (!result.resultFlag) {
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3589", result);
        return result;
    }
    if (result.data == null) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage("IMW.CLI.INF.3526");
        return result;
    }
    var deleteRecord = result.data;

    // gUNV̊Jn
    databaseResult = DatabaseManager.beginTransaction();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3589", databaseResult);
        return result;
    }

    // 폜
    result = actConfig.deleteActConfig(deleteRecord);
    if (!result.resultFlag) {
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3589", result);
        // [obN
        databaseResult = DatabaseManager.rollback();
        if (databaseResult.error) {
            result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                    "IMW.CLI.WRN.3589", databaseResult);
        }
        return result;
    }

    // R~bg
    databaseResult = DatabaseManager.commit();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3589", databaseResult);
        return result;
    }

    return result;
}
