Procedure.define("imw_error_utils", new imwErrorUtils());
var CLIENTTYPEID_SMARTPHONE = "sp";

// =============================================================================
// ֐`
// y  z
// yԋplz
// y쐬ҁzNTT DATA INTRAMART
// y XV z
// y Tv zProcedure̓o^
// =============================================================================
function imwErrorUtils() {
    this.showErrorAlert = showErrorAlert;
    this.showErrorReload = showErrorReload;
    this.showErrorLink = showErrorLink;
    this.showErrorGreyboxClose = showErrorGreyboxClose;
    this.getErrorMessage = getErrorMessage;
    this.getErrorMessageForWorkflowProcess = getErrorMessageForWorkflowProcess;
    this.getOuputMessage = getOuputMessage;
}

//=============================================================================
// G[bZ[WݒE\֐ (Module.alert.write)
//  y  zmsgId: eŗL̃bZ[WID
//            result: ʃIuWFNg
//            subMessage: TubZ[W (ȗ\)
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zModule.alert.write gpăG[eʏɕ\܂B
//=============================================================================
function showErrorAlert(msgId, result, subMessage) {

    var session = AccessSecurityManager.getSessionInfo();
    if(session.clientType == CLIENTTYPEID_SMARTPHONE){
        // for smartphone
        forward("workflow/smartphone/common/unit/error/simple_error_page", 
                { message_id : msgId, sub_message : subMessage });
    }else{
        // for PC
        Module.alert.write(msgId, subMessage);
    }
}

//=============================================================================
// G[bZ[WݒE\֐ (Module.alert.reload)
//  y  zmsgId: eŗL̃bZ[WID
//            request: NGXgIuWFNg
//            result: ʃIuWFNg
//            subMessage: TubZ[W (ȗ\)
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zModule.alert.reload gpăG[eʏɕ\܂B
//=============================================================================
function showErrorReload(msgId, request, result, subMessage) {

    var session = AccessSecurityManager.getSessionInfo();
    if(session.clientType == CLIENTTYPEID_SMARTPHONE){
        // for smartphone
        forward("workflow/smartphone/common/unit/error/simple_error_page", 
                { message_id : msgId, sub_message : subMessage });
    }else{
        // for PC
        Module.alert.reload(msgId, subMessage, request);
    }
}

//=============================================================================
// G[bZ[WݒE\֐ (Module.alert.link)
//  y  zmsgId: eŗL̃bZ[WID
//            result: ʃIuWFNg
//            path: RecpX
//            linkObj: G[ʗpNIuWFNg
//            fSub: ̗\tOp[^ (ȗ\)
//            subMessage: TubZ[W (ȗ\)
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zModule.alert.link gpăG[eʏɕ\܂B
//=============================================================================
function showErrorLink(msgId, result, path, linkObj, fSub, subMessage) {

    var session = AccessSecurityManager.getSessionInfo();
    if(session.clientType == CLIENTTYPEID_SMARTPHONE){
        // for smartphone
        forward("workflow/smartphone/common/unit/error/simple_error_page", 
                { message_id : msgId, sub_message : subMessage });
    }else{
        // for PC
        Module.alert.link(msgId, subMessage, path, linkObj);
    }
}

//=============================================================================
// G[bZ[WݒE\֐ (Greybox\)
//  y  zmsgId: eŗL̃bZ[WID
//            subMessage: TubZ[W (ȗ\)
//            callback: R[obN֐ (ȗ\)
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z[Nt[Ǝ gpăG[eʏɕ\܂B
//            Jڐʂł̓R[obN֐ƂĎw肳ꂽs\łB
//=============================================================================
function showErrorGreyboxClose(msgId, subMessage, callback) {
    var reqObj = {
        "messageId": Procedure.imw_utils.getValue(msgId, ""),
        "subMessage": Procedure.imw_utils.getValue(subMessage, ""),
        "callback": Procedure.imw_utils.getValue(callback, "")
    };

    var session = AccessSecurityManager.getSessionInfo();
    if(session.clientType == CLIENTTYPEID_SMARTPHONE){
        // for smartphone
        forward("workflow/smartphone/common/unit/error/simple_error_page", 
                { message_id : msgId, sub_message : subMessage });
    }else{
        // for PC
        forward("workflow/common/unit/greybox_close/greybox_close", reqObj);
    }
}

//=============================================================================
// G[bZ[WݒE\֐ (JS Action)
//  y  zmsgId: eŗL̃bZ[WID
//            result: ʃIuWFNg
//            params: u (ȗ\)
//  y ԋp zG[bZ[W
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zJS Action ̖߂lp̃G[bZ[W擾܂B
//=============================================================================
function getErrorMessage(msgId, result, params) {
    return MessageManager.getMessage(msgId, params);
}

//=============================================================================
// tG[bZ[W擾֐([Nt[p)
//  y  zmsgId: eŗL̃bZ[WID
//            result: ʃIuWFNg
//            params: u (ȗ\)
//  y ԋp zG[bZ[W
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zJS Action ̖߂lp̃G[bZ[W擾܂B(jsspRpcp)
//=============================================================================
function getErrorMessageForWorkflowProcess(msgId, result, params) {
    var message = MessageManager.getMessage(msgId);
    var subMessages = getOuputMessage(msgId, result, params);
    message += !isBlank(subMessages) ? "\n" + subMessages : "";
    return message;
}

//=============================================================================
// tG[bZ[W擾֐
//  y  zmsgId: eŗL̃bZ[WID
//            result: ʃIuWFNg
//            params: u (ȗ\)
//            fSub: ʃIuWFNg̃bZ[WIDgptO (ȗ\)
//  y ԋp zG[bZ[W
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zJS Action ̖߂lp̃G[bZ[W擾܂B
//=============================================================================
function getOuputMessage(msgId, result, params, fSub) {
    if (result) {
        // f[^x[XnG[
        if (result.error) {
            return result.errorMessage;
        }
        // pҌn API G[ (tbZ[W)
        if (!result.resultFlag && result.resultStatus.subMessages) {
            var msg = Procedure.imw_proc_utils.getSubMessagesWithArgs(
                    result.resultStatus.subMessages,
                    AccessSecurityManager.getSessionInfo().locale).join("\n");
            if (!isBlank(msg) && result.resultStatus.messageId && fSub) {
                msg = MessageManager.getMessage(result.resultStatus.messageId, params) + "\n" + msg;
            }
            return msg;
        }
        // ǗҌn API G[
        if (!result.resultFlag && result.resultStatus && result.resultStatus.messageId) {
            return MessageManager.getMessage(result.resultStatus.messageId, params);
        }
    }
    return isBlank(params) ? "" : params;
}
