Procedure.define("imw_matter_utils", new imwMatterUtils());

// =============================================================================
// ֐`
// y  z
// yԋplz
// y쐬ҁzNTT DATA INTRAMART
// y XV z
// y Tv zProcedure̓o^
// =============================================================================
function imwMatterUtils() {
    this.getActvMatterData = getActvMatterData;
    this.getCplMatterData = getCplMatterData;
    this.isExistRefActvMatter = isExistRefActvMatter;
    this.isExistRefCplMatter = isExistRefCplMatter;
    this.isExistMatterNode = isExistMatterNode;
    this.getCheckResultMoveTo = getCheckResultMoveTo;
    this.checkActvNodeConfigEditAuth = checkActvNodeConfigEditAuth;
    this.checkCplNodeConfigEditAuth = checkCplNodeConfigEditAuth;
    this.getActvNodeConfigEditAuth = getActvNodeConfigEditAuth;
    this.getCplNodeConfigEditAuth = getCplNodeConfigEditAuth;
    this.getActvProcessTargetExpandAuth = getActvProcessTargetExpandAuth;
    this.getCplProcessTargetExpandAuth = getCplProcessTargetExpandAuth;
    this.getActvNodeMoveAuth = getActvNodeMoveAuth;
    this.getCplNodeMoveAuth = getCplNodeMoveAuth;
    this.getActvReserveCancelAuth = getActvReserveCancelAuth;
    this.getCplReserveCancelAuth = getCplReserveCancelAuth;
    this.getActvProcessTargetShowAuth = getActvProcessTargetShowAuth;
    this.getCplProcessTargetShowAuth = getCplProcessTargetShowAuth;
    this.getMatterInfo = getMatterInfo;
    this.checkDisplayAuthActvMatter = checkDisplayAuthActvMatter;
    this.checkDisplayAuthCplMatter = checkDisplayAuthCplMatter;
    this.checkDisplayAuthArcMatter = checkDisplayAuthArcMatter;
    this.encodeGeneralParameter = encodeGeneralParameter;
}

//=============================================================================
// Č̈Č擾֐
//  y  zloginGroupId: OCO[vID
//            localeId: P[ID
//            userId: [UID
//            systemMatterId: VXeČID
//  y ԋp zČ (getMatterData Q)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zʕ\pɉHꂽČ擾܂B
//=============================================================================
function getActvMatterData(loginGroupId, localeId, userId, systemMatterId) {
    var matter = new ActvMatter(loginGroupId, localeId, systemMatterId);
    return getMatterData(matter, loginGroupId, localeId, userId, systemMatterId, true);
}

//=============================================================================
// Č̈Č擾֐
//  y  zloginGroupId: OCO[vID
//            localeId: P[ID
//            userId: [UID
//            systemMatterId: VXeČID
//  y ԋp zČ (getMatterData Q)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zʕ\pɉHꂽČ擾܂B
//=============================================================================
function getCplMatterData(loginGroupId, localeId, userId, systemMatterId) {
    var matter = new CplMatter(loginGroupId, localeId, systemMatterId);
    return getMatterData(matter, loginGroupId, localeId, userId, systemMatterId, false);
}

//=============================================================================
// Č擾֐
//  y  zmatter: ActvMatter, CplMatter NX̃CX^X
//            loginGroupId: OCO[vID
//            localeId: P[ID
//            userId: [UID
//            systemMatterId: VXeČID
//            isActv: ANeBu擾tO
//  y ԋp zČ ( or ) }l[W擾
//            result.resultFlag: ʂ̐^U
//            result.resultStatus: ʂ̏
//            result.data: 
//                matterNumber: Čԍ
//                matterName: Č
//                applyUser: \Җ
//                applyBaseDate: \
//                flowId: t[ID
//                flowVersionId: t[o[WID
//                confirmUserSetupFlag: mFҐݒۃtO
//                cplMatterConfirmFlag: ČmFtO
//                loginUserHandleAuth: OC[ÜČ쌠
//                    userCode: [UCD
//                    userName: [U
//                    localeId: P[ID
//                    handleLevel: x
//                    reserveCancelFlag: ۗtO
//                    changeUserFlag: ΏێҕύXtO
//                    expandUserFlag: ΏێғWJtO
//                    deleteDynamicNodeFlag: IFm[h폜tO
//                    undeleteDynamicNodeFlag: IFm[htO
//                    horizontalNodeConfigFlag: zum[hݒtO
//                    verticalNodeConfigFlag: czum[hݒtO
//                    handleMoveForwardFlag: ČOitO
//                    handleMoveBackwardFlag: ČitO
//                    handleTerminate: ČItO
//                execFlowNodeList: }X^t[̏}[Wst[̔z
//                    nodeId: m[hID
//                    nodeType: m[h
//                    nodeName: m[h
//                    status: ݂̏
//                            "0": s
//                            "1": s
//                            "2": ۗ
//                            "9": s
//                            "-": sԖicEzu/mF/JnEIm[hj
//                    lastStatus: ŏȈ
//                            "0": s
//                            "9": s
//                    enable: L/
//                            "0": 
//                            "1": L
//                    nodeNamePrefix: cEzu̓WJꂽm[hłꍇA
//                                    ǂ̃ACR\邩̃R[hl
//                                    "0":  C[W
//                                    "1":  C[W
//                    isChildNode: czuEzu̓WJꂽm[h̐^U
//                    expandCount: czuEzum[h̎qm[h̐
//                    expandProced: czuEzum[h̎qm[hŏς̐
//                    isNodeExpand: IFEczuEzuWJĂ邩̐^U
//                execFlowNodeMap: m[hIDL[Ƃm[h}bv
//                                  e execFlowNodeList Ɠ
//                execFlowHandleAuth: st[̈Č쌠̔z
//                    extensionPointId: g|CgID
//                    pluginId: vOCID
//                    parameter: p[^
//                    handleLevel: x
//                    targetTypeName: Ώێ
//                    targetName: Ώۖ
//                    reserveCancelFlag: ۗtO
//                    changeUserFlag: ΏێҕύXtO
//                    expandUserFlag: ΏێҍēWJtO
//                    deleteDynamicNodeFlag: IFm[h폜tO
//                    undeleteDynamicNodeFlag: IFm[htO
//                    horizontalNodeConfigFlag: zum[hݒtO
//                    verticalNodeConfigFlag: czum[hݒtO
//                    handleMoveForwardFlag: ČOitO
//                    handleMoveBackwardFlag: ČitO
//                    handleTerminateFlag: ČItO
//                    config: ݒʂւ̃p[^
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zʕ\pɉHꂽČ擾܂B
//=============================================================================
function getMatterData(matter, loginGroupId, localeId, userId, systemMatterId, isActv) {

    // m[h̎s
    var PROCESS_UNEXEC = "0"; // s
    var PROCESS_EXECEND = "9"; // sI

    var databaseResult;
    var i, j, k, l, record;
    var T_IMAGE = "0";
    var L_IMAGE = "1";

    var result = new Object();
    result.resultFlag = true;
    result.data = new Object();
    result.resultStatus = new Object();

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var flagStatusEnable = codeUtil.getEnumCodeFlagStatus("Enable");
    var flagStatusDisable = codeUtil.getEnumCodeFlagStatus("Disable");
    var nodeTypeDynamic = codeUtil.getEnumCodeNodeType("nodeTyp_Dynamic");
    var nodeTypeHorizontal = codeUtil.getEnumCodeNodeType("nodeTyp_Horizontal");
    var nodeTypeVertical = codeUtil.getEnumCodeNodeType("nodeTyp_Vertical");
    var nodeTypeTemplate = codeUtil.getEnumCodeNodeType("nodeTyp_Template");

    // Č擾
    databaseResult = matter.getMatter();
    if (!databaseResult.resultFlag) {
        return databaseResult;
    }
    var matterData = databaseResult.data;
    if (isBlank(matterData)) {
        return databaseResult;
    }
    result.data.matterNumber = matterData.matterNumber;
    result.data.matterName = matterData.matterName;
    result.data.applyUser = matterData.applyAuthUserName;
    result.data.applyBaseDate = matterData.applyBaseDate;

    // }X^t[擾
    databaseResult = matter.getMasterFlow();
    if (!databaseResult.resultFlag) {
        return databaseResult;
    }
    var masterFlow = databaseResult.data;

    // st[擾
    databaseResult = matter.getExecFlow();
    if (!databaseResult.resultFlag) {
        return databaseResult;
    }
    var execFlow = databaseResult.data;
    result.data.flowId = execFlow.flowId;
    result.data.flowVersionId = execFlow.flowVersionId;
    result.data.confirmUserSetupFlag = execFlow.confirmUserSetupFlag;
    result.data.cplMatterConfirmFlag = execFlow.cplMatterConfirmFlag;

    // OC[ÜČ쌠擾
    databaseResult = isActv ? matter.getMatterHandleAuth(userId) : matter.getMatterHandleAuthUser(userId);
    if (!databaseResult.resultFlag) {
        return databaseResult;
    }
    result.data.loginUserHandleAuth = databaseResult.data;

    // SĂ̏擾
    databaseResult = matter.getProcessHistoryList();
    if (!databaseResult.resultFlag) {
        return databaseResult;
    }
    var allHistoryList = databaseResult.data;

    // SĂ̏}bv쐬
    var allHistoryMap = new Object();
    for (i = 0; i < allHistoryList.length; i++) {
        record = allHistoryList[i];
        if (!allHistoryMap[record.nodeId]) {
            allHistoryMap[record.nodeId] = new Array();
        }
        allHistoryMap[record.nodeId].push(record);
    }

    // ŏIԂ擾
    databaseResult = matter.getNodeProgressList();
    if (!databaseResult.resultFlag) {
        return databaseResult;
    }
    var nodeProgressList = databaseResult.data;

    // ŏIԃ}bv쐬
    var nodeProgressMap = new Object();
    for (i = 0; i < nodeProgressList.length; i++) {
        record = nodeProgressList[i];
        nodeProgressMap[record.nodeId] = record;
    }

    // }X^t[̃m[hꗗ쐬
    var masterNodeMap = new Object();
    var masterNode;
    for (i = 0; i < masterFlow.nodes.length; i++) {
        masterNode = masterFlow.nodes[i];
        masterNodeMap[masterNode.nodeId] = masterNode;
    }

    // st[̃m[hꗗ쐬
    var execNodeMap = new Object();
    var execNode;
    for (i = 0; i < execFlow.nodes.length; i++) {
        execNode = execFlow.nodes[i];
        execNodeMap[execNode.nodeId] = execNode;
    }

    // st[ɓWJERs[ꂽm[h쐬
    var expandChildNodeMap = new Object();
    var copiedNodes = new Array();
    var nodeId;
    for (i = 0; i < execFlow.nodes.length; i++) {
        execNode = execFlow.nodes[i];
        nodeId = execNode.parentNodeId;
        if (isBlank(nodeId)) {
            if (!masterNodeMap[execNode.nodeId]) {
                copiedNodes.push(execNode);
            }
        } else if (masterNodeMap[nodeId] &&
                masterNodeMap[nodeId].nodeType != nodeTypeTemplate) {
            if (!expandChildNodeMap[nodeId]) {
                expandChildNodeMap[nodeId] = new Array();
            }
            expandChildNodeMap[nodeId].push(execNode);
        } else {
            if (!masterNodeMap[execNode.nodeId]) {
                copiedNodes.push(execNode);
            }
        }
    }

    // st[ɃRs[ꂽm[h}X^t[Ɉړ
    i = 0;
    var indexNodeMap;
    while (i < copiedNodes.length) {
        // Rs[m[hubN̊JnʒuƏIʒu擾
        j = copiedNodes.length;
        for (k = i; k < j; k++) {
            execNode = copiedNodes[k];
            if (!isArray(execNode.forwardNodeIds)) {
                continue;
            }
            nodeId = execNode.forwardNodeIds[0];
            if (isBlank(nodeId) || !masterNodeMap[nodeId]) {
                continue;
            }
            j = k + 1;
            break;
        }

        // Rs[ꂽm[hړ邽߂̃CfbNX쐬
        indexNodeMap = new Object();
        for (k = 0; k < masterFlow.nodes.length; k++) {
            masterNode = masterFlow.nodes[k];
            indexNodeMap[masterNode.nodeId] = k;
        }

        // ubN}X^t[ɃRs[
        do {
            // m[hIEI (Om[hւ̃N) ȊO
            do {
                l = null;
                execNode = copiedNodes[i];
                if (!isArray(execNode.forwardNodeIds)) {
                    break;
                }
                nodeId = execNode.forwardNodeIds[0];
                if (isBlank(nodeId)) {
                    break;
                }
                masterNode = masterNodeMap[nodeId];
                if (!masterNode) {
                    break;
                }
                if (isArray(masterNode.backwardNodeIds) && masterNode.backwardNodeIds.length > 1) {
                    break;
                }
                l = indexNodeMap[nodeId];
            } while (false);

            // Om[hJnEJn (m[hւ̃N) ȊO
            do {
                if (!isBlank(l)) {
                    break;
                }
                execNode = copiedNodes[i];
                if (!isArray(execNode.backwardNodeIds)) {
                    break;
                }
                nodeId = execNode.backwardNodeIds[0];
                if (isBlank(nodeId)) {
                    break;
                }
                masterNode = masterNodeMap[nodeId];
                if (!masterNode) {
                    break;
                }
                if (isArray(masterNode.forwardNodeIds) && masterNode.forwardNodeIds.length > 1) {
                    break;
                }
                l = indexNodeMap[nodeId];
                if (!isBlank(l)) {
                    l++;
                }
            } while (false);

            // m[h
            do {
                if (!isBlank(l)) {
                    break;
                }
                execNode = copiedNodes[i];
                if (!isArray(execNode.forwardNodeIds)) {
                    break;
                }
                nodeId = execNode.forwardNodeIds[0];
                if (isBlank(nodeId)) {
                    break;
                }
                l = indexNodeMap[nodeId];
            } while (false);

            // Rs[ʒułȂꍇ
            if (isBlank(l)) {
                break;
            }

            // Rs[
            var ary = new Array();
            for (k = 0; k < l; k++) {
                ary.push(masterFlow.nodes[k]);
            }
            for (k = i; k < j; k++) {
                ary.push(copiedNodes[k]);
            }
            for (k = l; k < masterFlow.nodes.length; k++) {
                ary.push(masterFlow.nodes[k]);
            }
            masterFlow.nodes = ary;

            // Om[h̑OナNXV
            execNode = copiedNodes[j - 1];
            if (!isArray(execNode.forwardNodeIds)) {
                break;
            }
            nodeId = execNode.forwardNodeIds[0];
            if (isBlank(nodeId)) {
                break;
            }
            masterNode = masterNodeMap[nodeId];
            if (masterNode) {
                updateBackwardNodeLink(masterNodeMap, masterNode, execNode);
            }

            // m[h̑OナNXV
            execNode = copiedNodes[i];
            if (!isArray(execNode.backwardNodeIds)) {
                break;
            }
            nodeId = execNode.backwardNodeIds[0];
            if (isBlank(nodeId)) {
                break;
            }
            masterNode = masterNodeMap[nodeId];
            if (masterNode) {
                updateForwardNodeLink(masterNodeMap, masterNode, execNode);
            }
        } while (false);

        i = j;
    }

    // }X^t[̃m[hꗗŃ[v
    var execFlowNodes = new Array();
    var childNodes, node;
    for (i = 0; i < masterFlow.nodes.length; i++) {
        masterNode = masterFlow.nodes[i];
        if (masterNode.nodeType == nodeTypeDynamic) {
            // IFm[h̏ꍇ
            node = getNormalNodeInfoBase(masterNode, allHistoryMap, nodeProgressMap,
                    flagStatusEnable);
            execFlowNodes.push(node);

            // m[hWJĂ邩`FbN
            execNode = execNodeMap[masterNode.nodeId];
            node.isNodeExpand = execNode ? false : true;
            node.enable = execNode ? flagStatusEnable : flagStatusDisable;
            if (!execNode && (isBlank(node.status) || node.status == PROCESS_UNEXEC)) {
                node.status = "-";
            }
        } else if (masterNode.nodeType == nodeTypeHorizontal ||
                masterNode.nodeType == nodeTypeVertical) {
            // zuEczum[h̏ꍇ
            node = getParentNodeInfoBase(masterNode, allHistoryMap, nodeProgressMap,
                    flagStatusEnable);
            execFlowNodes.push(node);

            // m[hWJĂ邩`FbN
            execNode = execNodeMap[masterNode.nodeId];
            childNodes = expandChildNodeMap[masterNode.nodeId];
            node.isNodeExpand = execNode && !childNodes ? false : true;
            node.enable = childNodes ? flagStatusEnable : flagStatusDisable;
            if (!childNodes) {
                continue;
            }
            node.expandCount = childNodes.length;
            masterNode = node;

            // Om[h̑OナNXV
            if (childNodes.length > 0) {
                execNode = childNodes[childNodes.length - 1];
                execNode.forwardNodeIds = masterNode.forwardNodeIds;
                execNode = childNodes[0];
                execNode.backwardNodeIds = new Array();
                execNode.backwardNodeIds.push(masterNode.nodeId);
                masterNode.forwardNodeIds = new Array();
                masterNode.forwardNodeIds.push(execNode.nodeId);
            }

            // qm[hWJ
            for (j = 0; j < childNodes.length; j++) {
                execNode = childNodes[j];
                node = getChildNodeInfoBase(execNode, allHistoryMap, nodeProgressMap,
                    flagStatusEnable);
                node.nodeNamePrefix = T_IMAGE;
                node.enable = flagStatusEnable;
                execFlowNodes.push(node);
                if (node.status == PROCESS_EXECEND) {
                    masterNode.expandProced++;
                }
            }
            if (childNodes.length == 0) {
                continue;
            }
            execFlowNodes[execFlowNodes.length - 1].nodeNamePrefix = L_IMAGE;

            // m[h̑OナNXV
            execNode = childNodes[childNodes.length - 1];
            updateForwardNodeLink(masterNodeMap, masterNode, execNode);
        } else {
            // ̑̃m[h̏ꍇ
            node = getNormalNodeInfoBase(masterNode, allHistoryMap, nodeProgressMap,
                    flagStatusEnable);
            execFlowNodes.push(node);

            // m[hWJĂ邩`FbN
            execNode = execNodeMap[masterNode.nodeId];
            node.enable = execNode ? flagStatusEnable : flagStatusDisable;
        }
    }

    // st[̃m[hꗗ}bv쐬
    var execFlowNodeMap = new Object();
    for (i = 0; i < execFlowNodes.length; i++) {
        execNode = execFlowNodes[i];
        execFlowNodeMap[execNode.nodeId] = execNode;
    }

    // m[hꗗݒ
    result.data.execFlowNodeList = execFlowNodes;
    result.data.execFlowNodeMap = execFlowNodeMap;

    // Č쌠擾
    result.data.execFlowHandleAuth = getExecFlowHandleAuth(
            execFlow.handleAuth, matterData.applyBaseDate, loginGroupId, localeId);

    return result;
}

//=============================================================================
// m[hꗗpm[h擾֐iʏj
//  y  zmasterNode: }X^t[̃m[h
//            allHistoryMap: m[h̑S}bv
//            nodeProgressMap: m[h̍ŏI}bv
//  y ԋp zm[hIuWFNg
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zm[hꗗp̒ʏm[h擾܂B
//=============================================================================
function getNormalNodeInfoBase(masterNode, allHistoryMap, nodeProgressMap) {
    var node = new Object();
    node.nodeId = masterNode.nodeId;
    node.nodeType = masterNode.nodeType;
    node.nodeName = masterNode.nodeName;
    node.backwardNodeIds = masterNode.backwardNodeIds;
    node.forwardNodeIds = masterNode.forwardNodeIds;
    node.status = getNodeStatus(nodeProgressMap, masterNode);
    node.lastStatus = getNodeLastStatus(allHistoryMap, masterNode);
    node.expandCount = 0;
    node.expandProced = 0;
    node.nodeNamePrefix = "";
    node.isChildNode = false;
    node.isNodeExpand = false;
    return node;
}

//=============================================================================
// m[hꗗpm[h擾֐iczuEzuj
//  y  zmasterNode: }X^t[̃m[h
//            allHistoryMap: m[h̑S}bv
//            nodeProgressMap: m[h̍ŏI}bv
//  y ԋp zm[hIuWFNg
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zm[hꗗp̏czuEzum[h擾܂B
//=============================================================================
function getParentNodeInfoBase(masterNode, allHistoryMap, nodeProgressMap) {
    var node = new Object();
    node.nodeId = masterNode.nodeId;
    node.nodeType = masterNode.nodeType;
    node.nodeName = masterNode.nodeName;
    node.backwardNodeIds = masterNode.backwardNodeIds;
    node.forwardNodeIds = masterNode.forwardNodeIds;
    node.status = "-"; // em[h͏ "-" \
    node.lastStatus = getNodeLastStatus(allHistoryMap, masterNode);
    node.expandCount = 0;
    node.expandProced = 0;
    node.nodeNamePrefix = "";
    node.isChildNode = false;
    node.isNodeExpand = false;
    return node;
}

//=============================================================================
// m[hꗗpm[h擾֐iWJj
//  y  zmasterNode: }X^t[̃m[h
//            allHistoryMap: m[h̑S}bv
//            nodeProgressMap: m[h̍ŏI}bv
//  y ԋp zm[hIuWFNg
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zm[hꗗp̓WJm[h擾܂B
//=============================================================================
function getChildNodeInfoBase(execNode, allHistoryMap, nodeProgressMap) {
    var node = new Object();
    node.nodeId = execNode.nodeId;
    node.nodeType = execNode.nodeType;
    node.nodeName = execNode.nodeName;
    node.backwardNodeIds = execNode.backwardNodeIds;
    node.forwardNodeIds = execNode.forwardNodeIds;
    node.parentNodeId = execNode.parentNodeId;
    node.status = getNodeStatus(nodeProgressMap, execNode);
    node.lastStatus = getNodeLastStatus(allHistoryMap, execNode);
    node.expandCount = 0;
    node.expandProced = 0;
    node.nodeNamePrefix = "";
    node.isChildNode = true;
    node.isNodeExpand = false;
    return node;
}

//=============================================================================
// Om[hOナNXV֐
//  y  zmasterNodeMap: }X^t[̃m[h}bv
//            masterNode: }X^t[̃m[h (̃Nm[h)
//            execNode: st[̃m[h (VNm[h)
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zOm[h̃NXV܂B
//=============================================================================
function updateBackwardNodeLink(masterNodeMap, masterNode, execNode) {
    if (!isArray(execNode.backwardNodeIds)) {
        return;
    }
    var i, j, f, node;
    for (i = 0; i < execNode.backwardNodeIds.length; i++) {
        node = masterNodeMap[execNode.backwardNodeIds[i]];
        if (!node || !isArray(node.forwardNodeIds)) {
            continue;
        }
        f = 0;
        for (j = 0; j < node.forwardNodeIds.length; j++) {
            if (node.forwardNodeIds[j] == masterNode.nodeId) {
                node.forwardNodeIds[j] = execNode.nodeId;
                f = 1;
            }
        }
        if (!f) {
            node.forwardNodeIds.push(execNode.nodeId);
        }
    }
}

//=============================================================================
// m[hOナNXV֐
//  y  zmasterNodeMap: }X^t[̃m[h}bv
//            masterNode: }X^t[̃m[h (̃Nm[h)
//            execNode: st[̃m[h (VNm[h)
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zm[h̃NXV܂B
//=============================================================================
function updateForwardNodeLink(masterNodeMap, masterNode, execNode) {
    if (!isArray(execNode.forwardNodeIds)) {
        return;
    }
    var i, j, f, node;
    for (i = 0; i < execNode.forwardNodeIds.length; i++) {
        node = masterNodeMap[execNode.forwardNodeIds[i]];
        if (!node || !isArray(node.backwardNodeIds)) {
            continue;
        }
        f = 0;
        for (j = 0; j < node.backwardNodeIds.length; j++) {
            if (node.backwardNodeIds[j] == masterNode.nodeId) {
                node.backwardNodeIds[j] = execNode.nodeId;
                f = 1;
            }
        }
        if (!f) {
            node.backwardNodeIds.push(execNode.nodeId);
        }
    }
}

//=============================================================================
// m[hԎ擾֐
//  y  zstatus: Xe[^X
//  y ԋp zs
//            "0": s
//            "1": s
//            "2": ۗ
//            "9": s
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zm[h̎sԂ擾܂B
//=============================================================================
function getNodeStatusBase(status) {
    // m[h̎s
    var PROCESS_UNEXEC = "0"; // s
    var PROCESS_EXEC = "1"; // s
    var PROCESS_RESERVE = "2"; // ۗ
    var PROCESS_EXECEND = "9"; // sI

    var result = PROCESS_UNEXEC;
    if (status == "applywait" || status == "reapplywait" || status == "approvewait" ||
            status == "cancelwait" || status == "systemwait" || status == "matterstartwait" ||
            status == "mattercompletewait") {
        result = PROCESS_EXEC;
    } else if (status == "reservewait" || status == "reserve") {
        result = PROCESS_RESERVE;
    } else if (status == "apply" || status == "applyrestore" || status == "reapply" ||
            status == "reapplyrestore" || status == "approve" || status == "approverestore" ||
            status == "approveend" || status == "branch" || status == "union" ||
            status == "deny" || status == "matterstart" || status == "mattercomplete") {
        result = PROCESS_EXECEND;
    }

    return result;
}

//=============================================================================
// m[hԎ擾֐
//  y  znodeProgressMap: m[h̍ŏI}bv
//            data: Ԃ擾m[h̏
//  y ԋp zs
//            "0": s
//            "1": s
//            "2": ۗ
//            "9": s
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zm[h̎sԂ擾܂B
//=============================================================================
function getNodeStatus(nodeProgressMap, data) {
    // m[h̎s
    var PROCESS_UNEXEC = "0"; // s

    var hist = nodeProgressMap[data.nodeId];
    return isObject(hist) ? getNodeStatusBase(hist.status) : PROCESS_UNEXEC;
}

//=============================================================================
// m[hŏIԎ擾֐
//  y  zallHistoryMap: m[h̑S}bv
//            data: Ԃ擾m[h̏
//  y ԋp zs
//            "0": s
//            "9": s
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zm[h̍Ō̎sԂ擾܂B
//=============================================================================
function getNodeLastStatus(allHistoryMap, data) {
    // m[h̎s
    var PROCESS_UNEXEC = "0"; // s
    var PROCESS_EXECEND = "9"; // sI

    var hists = allHistoryMap[data.nodeId];
    var i, status;
    for (i = isArray(hists) ? hists.length - 1 : -1; i >= 0; i--) {
        status = getNodeStatusBase(hists[i].status);
        if (status == PROCESS_EXECEND) {
            return PROCESS_EXECEND;
        }
    }

    return PROCESS_UNEXEC;
}

//=============================================================================
// QƎҎ擾֐ist[j
//  y  zhandleAuthList: st[ێĂQƎ҂̔z
//            baseDate: 
//            loginGroupId: OCO[vID
//            localeId: P[ID
//  y ԋp zQƎ҂̔z
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zQƎ҂擾܂B
//=============================================================================
function getExecFlowHandleAuth(handleAuthList, baseDate, loginGroupId, localeId) {
    var result = new Array();
    if (handleAuthList == null) {
        return result;
    }

    var databaseResult;
    // AvP[Vʃ}X^̐ݒ
    var pluginResult = new Object();
    Procedure.imw_plugin_utils.initAppCommonMaster(pluginResult,
            "jp.co.intra_mart.workflow.plugin.authority.administrator.flow.handle",
            loginGroupId, localeId);
    var plugin;

    var handleAuth;
    var config;

    var record;
    var pluginModel;
    for (var i = 0; i < handleAuthList.length; i++) {
        record = handleAuthList[i];

        handleAuth = new Object();
        handleAuth.extensionPointId = record.matterHandleUserInfo.extensionPointId;
        handleAuth.pluginId = record.matterHandleUserInfo.pluginId;
        handleAuth.parameter = record.matterHandleUserInfo.parameter;
        handleAuth.handleLevel = record.handleLevel;

        // ݒʂ̃p[^
        config = new Object();
        config.reserveCancelFlag = record.reserveCancelFlag;
        config.changeUserFlag = record.changeUserFlag;
        config.expandUserFlag = record.expandUserFlag;
        config.reserveCancelFlag = record.reserveCancelFlag;
        config.deleteDynamicNodeFlag = record.deleteDynamicNodeFlag;
        config.undeleteDynamicNodeFlag = record.undeleteDynamicNodeFlag;
        config.horizontalNodeConfigFlag = record.horizontalNodeConfigFlag;
        config.verticalNodeConfigFlag = record.verticalNodeConfigFlag;
        config.handleMoveForwardFlag = record.handleMoveForwardFlag;
        config.handleMoveBackwardFlag = record.handleMoveBackwardFlag;
        config.handleTerminateFlag = record.handleTerminateFlag;
        handleAuth.config = Procedure.imw_utils.escapeHTML(ImJson.toJSONString(config));

        handleAuth.TypeName = "";
        handleAuth.Name = "";
        plugin = pluginResult.imwAppCommonPluginConfigObject.configObject[handleAuth.pluginId];
        if (plugin) {
            handleAuth.TypeName = Procedure.imw_utils.escapeHTML(plugin.name);
        }
        pluginModel = new Object();
        pluginModel.extensionPointId = handleAuth.extensionPointId;
        pluginModel.pluginId = handleAuth.pluginId;
        pluginModel.parameter = handleAuth.parameter;
        databaseResult = WorkflowPluginUtil.getLocaleDisplayName(
                loginGroupId, localeId, pluginModel, baseDate, null);
        if (databaseResult.resultFlag && databaseResult.data != null) {
            handleAuth.Name = Procedure.imw_utils.escapeHTML(databaseResult.data);
        }

        result.push(handleAuth);
    }

    return result;
}

//=============================================================================
// Č̑݃`FbN֐iQƗpj
//  y  zloginGroupId: OCO[vID
//            localeId: P[ID
//            userId: [UID
//            systemMatterId: VXeČID
//            administratorType: ǗҎ
//  y ԋp z
//              result
//                resultFlag: ݂ꍇ trueAȊO false
//                resultStatus:
//                  messageId: G[bZ[WID
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ񂪑݂邩̐^U擾܂B
//=============================================================================
function isExistRefActvMatter(loginGroupId, localeId, userId, systemMatterId, administratorType) {
    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();
    result.data = new Object();
    result.data.isZero = false;

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var admorTypeWkfSysAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfSysAdmor");
    var admorTypeWkfOpeAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfOpeAdmor");

    var manager;
    var databaseResult;
    var searchCondition = new ListSearchCondition();
    searchCondition.setAndCombination(true);
    if (administratorType == admorTypeWkfSysAdmor) {
        manager = new RefActvMatterAdminList(loginGroupId, localeId);
        searchCondition.addCondition(RefActvMatterAdminList.SYSTEM_MATTER_ID,
                systemMatterId, ListSearchCondition.OP_EQ);
        databaseResult = manager.getActvMatterListCount(searchCondition, null);
    } else if (administratorType == admorTypeWkfOpeAdmor) {
        manager = new RefActvMatterAdminList(loginGroupId, localeId);
        searchCondition.addCondition(RefActvMatterAdminList.SYSTEM_MATTER_ID,
                systemMatterId, ListSearchCondition.OP_EQ);
        databaseResult = manager.getActvMatterListCount(searchCondition, userId);
    } else {
        manager = new RefActvMatterList(userId, loginGroupId, localeId);
        searchCondition.addCondition(RefActvMatterList.SYSTEM_MATTER_ID,
                systemMatterId, ListSearchCondition.OP_EQ);
        databaseResult = manager.getRefListCount(searchCondition);
    }

    // O
    if (!databaseResult.resultFlag) {
        return databaseResult;
    }

    // ݃`FbN
    if (databaseResult.data.length < 1) {
        result.resultFlag = false;
        result.resultStatus.messageId = "IMW.CLI.WRN.3504";
        result.data.isZero = true;
        return result;
    }

    return result;
}

//=============================================================================
// Č̑݃`FbN֐iQƗpj
//  y  zloginGroupId: OCO[vID
//            localeId: P[ID
//            userId: [UID
//            systemMatterId: VXeČID
//            administratorType: ǗҎ
//  y ԋp z
//              result
//                resultFlag: ݂ꍇ trueAȊO false
//                resultStatus:
//                  messageId: G[bZ[WID
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ񂪑݂邩̐^U擾܂B
//=============================================================================
function isExistRefCplMatter(loginGroupId, localeId, userId, systemMatterId, administratorType) {
    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();
    result.data = new Object();
    result.data.isZero = false;

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var admorTypeWkfSysAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfSysAdmor");
    var admorTypeWkfOpeAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfOpeAdmor");

    var manager;
    var databaseResult;
    var searchCondition = new ListSearchCondition();
    searchCondition.setAndCombination(true);
    if (administratorType == admorTypeWkfSysAdmor) {
        manager = new RefCplMatterAdminList(loginGroupId, localeId);
        searchCondition.addCondition(RefCplMatterAdminList.SYSTEM_MATTER_ID,
                systemMatterId, ListSearchCondition.OP_EQ);
        databaseResult = manager.getCplMatterListCount(searchCondition, null);
    } else if (administratorType == admorTypeWkfOpeAdmor) {
        manager = new RefCplMatterAdminList(loginGroupId, localeId);
        searchCondition.addCondition(RefCplMatterAdminList.SYSTEM_MATTER_ID,
                systemMatterId, ListSearchCondition.OP_EQ);
        databaseResult = manager.getCplMatterListCount(searchCondition, userId);
    } else {
        manager = new RefCplMatterList(userId, loginGroupId, localeId);
        searchCondition.addCondition(RefCplMatterList.SYSTEM_MATTER_ID,
                systemMatterId, ListSearchCondition.OP_EQ);
        databaseResult = manager.getRefListCount(searchCondition);
    }

    // O
    if (!databaseResult.resultFlag) {
        return databaseResult;
    }

    // ݃`FbN
    if (databaseResult.data.length < 1) {
        result.resultFlag = false;
        result.resultStatus.messageId = "IMW.CLI.WRN.3504";
        result.data.isZero = true;
        return result;
    }

    return result;
}

//=============================================================================
// Čm[h݃`FbN֐
//  y  zmatter: ActvMatter, CplMatter NX̃CX^X
//            nodeId: `FbNΏۂ̃m[hID
//  y ԋp z
//              result
//                resultFlag: ݂ꍇ trueAȊO false
//                resultStatus:
//                  messageId: G[bZ[WID
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČɃm[h񂪑݂邩̐^U擾܂B
//=============================================================================
function isExistMatterNode(matter, nodeId) {
    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();

    // s̃m[h擾
    result = getExecFlowNodeMap(matter);
    if (!result.resultFlag) {
        return result;
    }
    // s̃m[hɎw̃m[h݂OK
    if (result.data[nodeId]) {
        return result;
    }

    // st[̃m[hɎw̃m[h݂Ȃꍇ
    // }X^t[Q
    result = getMasterFlowNodeMap(matter);
    if (!result.resultFlag) {
        return result;
    }
    // }X^t[̃m[hɎw̃m[h݂OK
    if (result.data[nodeId]) {
        return result;
    }

    result.resultFlag = false;
    result.resultStatus.messageId = "IMW.CLI.WRN.3509"; // m[hݒ񂪑݂܂B
    return result;
}

//=============================================================================
// }X^t[m[h}bv擾֐
//  y  zmatter: ActvMatter, CplMatter NX̃CX^X
//  y ԋp z
//              result
//                resultFlag: Ɏ擾łꍇ trueAȊO false
//                resultStatus: ʏ
//                data: nbV
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zL[}X^t[̃m[hIDƂm[h̃nbV擾܂B
//=============================================================================
function getMasterFlowNodeMap(matter) {
    // }X^t[
    var result = matter.getMasterFlow();
    if (!result.resultFlag) {
        return result;
    }
    result.data = createMatterFlowNodeMap(result.data);
    return result;
}

//=============================================================================
// st[m[h}bv擾֐
//  y  zmatter: ActvMatter, CplMatter NX̃CX^X
//  y ԋp z
//              result
//                resultFlag: Ɏ擾łꍇ trueAȊO false
//                resultStatus: ʏ
//                data: nbV
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zL[st[̃m[hIDƂm[h̃nbV擾܂B
//=============================================================================
function getExecFlowNodeMap(matter) {
    // st[
    var result = matter.getExecFlow();
    if (!result.resultFlag) {
        return result;
    }
    result.data = createMatterFlowNodeMap(result.data);
    return result;
}

//=============================================================================
// m[h}bv擾֐
//  y  zflow: t[
//  y ԋp z
//              result
//                resultFlag: Ɏ擾łꍇ trueAȊO false
//                resultStatus: ʏ
//                data: nbV
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zw̃t[񂩂L[m[hIDƂm[h̃nbV擾
//            ܂B
//=============================================================================
function createMatterFlowNodeMap(flow) {
    var result = new Object();
    var nodes = flow.nodes;
    var leng = nodes.length;
    for (var i = 0; i < leng; i++) {
        result[nodes[i].nodeId] = nodes[i];
    }
    return result;
}

//=============================================================================
// ړ\ړ擾֐
//  y  zloginGroupId: OCO[vID
//            localeId: P[ID
//            systemMatterId: VXeČID
//            moveTo: ړɎw肵m[hID̔z
//            nodeList: I\ȃm[hID̔z
//            matterNodes: Čm[h̔z
//              im[hj: nodeId: m[hID
//              im[hj: forwardNodeIds: m[hID̔z
//              im[hj: backwardNodeIds: tm[hID̔z
//  y ԋp zm[hړۃtOMAP
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zړ̃`FbNsAړłƔfꂽm[hړ\
//            tO̔z擾܂B
//=============================================================================
function getCheckResultMoveTo(loginGroupId, localeId,
        systemMatterId, moveTo, nodeList, matterNodes) {
    var i;
    var j;
    var leng;
    var nodeMap = {};
    if (isBlank(moveTo) || moveTo.length == 0) {
        // I\ȃm[hID̔z񂪋̏ꍇAׂđI\
        for (i = 0; i < nodeList.length; i++) {
            nodeMap[nodeList[i]] = true;
        }
        return nodeMap;
    }

    var nodes = matterNodes;
    var nodeh = {};
    var node;
    var backwardNodeIds = new Array();
    var forwardNodeIds = new Array();
    var disabledNodeh = {};

    // m[hꗗ̎擾
    for (i = 0; i < nodes.length; i++) {
        node = nodes[i];
        nodeh[node.nodeId] = node;
    }
    var moveToMap = {};
    for (i = 0; i < moveTo.length; i++) {
        moveToMap[moveTo[i]] = 1;
        node = nodeh[moveTo[i]];
        if (!node) {
            continue;
        }
        for (leng = isArray(node.backwardNodeIds) ?
                node.backwardNodeIds.length : 0, j = 0; j < leng; j++) {
            backwardNodeIds.push(node.backwardNodeIds[j]);
        }
        for (leng = isArray(node.forwardNodeIds) ?
                node.forwardNodeIds.length : 0, j = 0; j < leng; j++) {
            forwardNodeIds.push(node.forwardNodeIds[j]);
        }
    }

    // O
    while (backwardNodeIds.length) {
        node = nodeh[backwardNodeIds.shift()];
        if (!node || disabledNodeh[node.nodeId]) {
            continue;
        }
        disabledNodeh[node.nodeId] = 1;
        for (leng = isArray(node.backwardNodeIds) ?
                node.backwardNodeIds.length : 0, j = 0; j < leng; j++) {
            backwardNodeIds.push(node.backwardNodeIds[j]);
        }
    }

    // 
    while (forwardNodeIds.length) {
        node = nodeh[forwardNodeIds.shift()];
        if (!node || disabledNodeh[node.nodeId]) {
            continue;
        }
        disabledNodeh[node.nodeId] = 1;
        for (leng = isArray(node.forwardNodeIds) ?
                node.forwardNodeIds.length : 0, j = 0; j < leng; j++) {
            forwardNodeIds.push(node.forwardNodeIds[j]);
        }
    }

    // m[hړۃtOMAP̐ݒ
    for (i = 0; i < nodeList.length; i++) {
        if (moveToMap[nodeList[i]]) {
            // ړɎw肵m[h͖Ń`FbN\
            nodeMap[nodeList[i]] = true;
            continue;
        }
        nodeMap[nodeList[i]] = disabledNodeh[nodeList[i]] ? false : true;
    }

    return nodeMap;
}

//=============================================================================
// Č̃m[hݒҏW`FbN֐iinit ֐Ŏgpj
//  y  zloginGroupId: OCO[vID
//            userId: [UID
//            localeId: P[ID
//            administratorType: ǗҎ
//            matterData: ČIuWFNg
//            nodeId: m[hID
//  y ԋp z (checkNodeConfigEditAuth Q)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ̃m[hݒҏW`FbN܂B
//=============================================================================
function checkActvNodeConfigEditAuth(loginGroupId, userId, localeId, administratorType, matterData, nodeId) {
    return checkNodeConfigEditAuth(loginGroupId, userId, localeId, administratorType, matterData, nodeId, true);
}

//=============================================================================
// Č̃m[hݒҏW`FbN֐iinit ֐Ŏgpj
//  y  zloginGroupId: OCO[vID
//            userId: [UID
//            localeId: P[ID
//            administratorType: ǗҎ
//            matterData: ČIuWFNg
//            nodeId: m[hID
//  y ԋp z (checkNodeConfigEditAuth Q)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ̃m[hݒҏW`FbN܂B
//=============================================================================
function checkCplNodeConfigEditAuth(loginGroupId, userId, localeId, administratorType, matterData, nodeId) {
    return checkNodeConfigEditAuth(loginGroupId, userId, localeId, administratorType, matterData, nodeId, false);
}

//=============================================================================
// m[hݒҏW`FbN֐iinit ֐Ŏgpj
//  y  zloginGroupId: OCO[vID
//            userId: [UID
//            localeId: P[ID
//            administratorType: ǗҎ
//            matterData: ČIuWFNg
//            nodeId: m[hID
//            isActv: ANeBu擾tO
//  y ԋp z
//              result
//                resultFlag: 쌠邩̐^Uiꍇtrue: Ȃꍇfalsej
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zm[hݒҏW`FbN܂B
//=============================================================================
function checkNodeConfigEditAuth(loginGroupId, userId, localeId, administratorType, matterData, nodeId, isActv) {
    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var admorTypeWkfSysAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfSysAdmor");
    var admorTypeWkfOpeAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfOpeAdmor");
    var flagStatusEnable = codeUtil.getEnumCodeFlagStatus("Enable");

    if (administratorType == admorTypeWkfSysAdmor || administratorType == admorTypeWkfOpeAdmor) {
        // Qƌ`FbNƌʂ̎擾
        var oResult = new Object();
        var oParameter = new Object();
        oParameter.userId = userId;
        oParameter.loginGroupId = loginGroupId;
        oParameter.localeId = localeId;
        oParameter.uniqueId = matterData.flowId;
        oParameter.errorId = "IMW.CLI.WRN.3505";
        oParameter.administratorType = administratorType;
        Procedure.imw_admin_group_utils.checkInitAuth(new Object(), oResult, oParameter);
    }

    var node = matterData.execFlowNodeMap[nodeId];
    var nodeList, map;
    if (node) {
        // x邽߂Ƀ`FbNΏۂ̃m[ĥ݂o^
        nodeList = new Array();
        nodeList.push(node);
        // mFm[h̃`FbN̂߂ɁAPÕm[ho^
        if (isArray(node.backwardNodeIds)) {
            node = matterData.execFlowNodeMap[node.backwardNodeIds[0]];
            if (node) {
                nodeList.push(node);
            }
        }
        map = getNodeConfigEditAuth(matterData, administratorType, nodeList, isActv);
        result.resultFlag = map[nodeId] == flagStatusEnable;
    } else {
        result.resultFlag = false;
    }
    if (!result.resultFlag) {
        result.resultStatus.messageId = "IMW.CLI.WRN.3505";
    }

    return result;
}

//=============================================================================
// Č̃m[h쌠擾֐
//  y  zmatterData: ČIuWFNg
//            administratorType: OC[ŮǗҎ
//            nodeList: `FbNΏۂ̃m[h
//  y ԋp zm[hIDL[ƂAҏW̃}bv
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ̃m[h̑쌠擾܂B
//=============================================================================
function getActvNodeConfigEditAuth(matterData, administratorType, nodeList) {
    return getNodeConfigEditAuth(matterData, administratorType, nodeList, true);
}

//=============================================================================
// Č̃m[h쌠擾֐
//  y  zmatterData: ČIuWFNg
//            administratorType: OC[ŮǗҎ
//            nodeList: `FbNΏۂ̃m[h
//  y ԋp zm[hIDL[ƂAҏW̃}bv
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ̃m[h̑쌠擾܂B
//=============================================================================
function getCplNodeConfigEditAuth(matterData, administratorType, nodeList) {
    return getNodeConfigEditAuth(matterData, administratorType, nodeList, false);
}

//=============================================================================
// m[h쌠擾֐
//  y  zmatterData: ČIuWFNg
//            administratorType: OC[ŮǗҎ
//            nodeList: `FbNΏۂ̃m[h
//            isActv: ANeBu擾tO
//  y ԋp zm[hIDL[ƂAҏW̃}bv
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zm[h̑쌠擾܂B
//=============================================================================
function getNodeConfigEditAuth(matterData, administratorType, nodeList, isActv) {
    // m[h̎s
    var PROCESS_EXECEND = "9"; // sI

    var i;
    var leng = nodeList.length;
    var result = new Object();
    var loginUserHandleAuth = matterData.loginUserHandleAuth;
    var confirmUserSetupFlag = matterData.confirmUserSetupFlag;
    var cplMatterConfirmFlag = matterData.cplMatterConfirmFlag;

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var admorTypeWkfSysAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfSysAdmor");
    var admorTypeWkfOpeAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfOpeAdmor");
    var flagStatusEnable = codeUtil.getEnumCodeFlagStatus("Enable");
    var flagStatusDisable = codeUtil.getEnumCodeFlagStatus("Disable");
    var nodeTypeApply = codeUtil.getEnumCodeNodeType("nodeTyp_Apply");
    var nodeTypeApprove = codeUtil.getEnumCodeNodeType("nodeTyp_Approve");
    var nodeTypeDynamic = codeUtil.getEnumCodeNodeType("nodeTyp_Dynamic");
    var nodeTypeConfirm = codeUtil.getEnumCodeNodeType("nodeTyp_Confirm");
    var nodeTypeVertical = codeUtil.getEnumCodeNodeType("nodeTyp_Vertical");
    var nodeTypeHorizontal = codeUtil.getEnumCodeNodeType("nodeTyp_Horizontal");

    // OC[ÜČ쌠擾
    var hasChangeUserAuth; // m[h̏EmFΏێ҂̕ύX
    var hasDeleteDynamicNodeAuth; // IFm[h̍폜
    var hasUndeleteDynamicNodeAuth; // IFm[h̕
    var hasHorizontalNodeConfigAuth; // zum[h̍ĐݒEēWJ
    var hasVerticalNodeConfigAuth; // czum[h̍ĐݒEēWJ
    if (administratorType == admorTypeWkfSysAdmor || administratorType == admorTypeWkfOpeAdmor) {
        // [Nt[VXeǗҁE[Nt[^pǗ҂̏ꍇ
        hasChangeUserAuth = true;
        hasDeleteDynamicNodeAuth = true;
        hasUndeleteDynamicNodeAuth = true;
        hasHorizontalNodeConfigAuth = true;
        hasVerticalNodeConfigAuth = true;
    } else {
        // p҂̏ꍇ
        hasChangeUserAuth = !isBlank(loginUserHandleAuth.changeUserFlag) &&
                loginUserHandleAuth.changeUserFlag == flagStatusEnable;
        hasDeleteDynamicNodeAuth = !isBlank(loginUserHandleAuth.deleteDynamicNodeFlag) &&
                loginUserHandleAuth.deleteDynamicNodeFlag == flagStatusEnable;
        hasUndeleteDynamicNodeAuth = !isBlank(loginUserHandleAuth.undeleteDynamicNodeFlag) &&
                loginUserHandleAuth.undeleteDynamicNodeFlag == flagStatusEnable;
        hasHorizontalNodeConfigAuth = !isBlank(loginUserHandleAuth.horizontalNodeConfigFlag) &&
                loginUserHandleAuth.horizontalNodeConfigFlag == flagStatusEnable;
        hasVerticalNodeConfigAuth = !isBlank(loginUserHandleAuth.verticalNodeConfigFlag) &&
                loginUserHandleAuth.verticalNodeConfigFlag == flagStatusEnable;
    }

    var nodeId, nodeType, status, backNode;
    var nodeHash = new Object();
    for (i = 0; i < leng; i++) {
        nodeHash[nodeList[i].nodeId] = nodeList[i];
    }
    for (i = 0; i < leng; i++) {
        nodeId = nodeList[i].nodeId;
        nodeType = nodeList[i].nodeType;
        status = nodeList[i].status;
        if (nodeType == nodeTypeConfirm && hasChangeUserAuth && confirmUserSetupFlag == flagStatusEnable) {
            // umFm[hvum[h̏EmFΏێ҂̕ύXv
            // umFҐݒۃtOvL
            if (isActv) {
                result[nodeId] = flagStatusEnable;
                continue;
            } else {
                result[nodeId] = flagStatusDisable;
            }
            if (cplMatterConfirmFlag != flagStatusEnable) {
                continue;
            }
            if (!isArray(nodeList[i].backwardNodeIds)) {
                continue;
            }
            backNode = nodeHash[nodeList[i].backwardNodeIds[0]];
            if (!backNode) {
                continue;
            }
            if (backNode.lastStatus == PROCESS_EXECEND && backNode.enable == flagStatusEnable) {
                result[nodeId] = flagStatusEnable;
            }
        } else if (!isActv || status == PROCESS_EXECEND) {
            // ČA܂́Asσm[h
            result[nodeId] = flagStatusDisable;
        } else if ((nodeType == nodeTypeApply || nodeType == nodeTypeApprove || nodeType == nodeTypeDynamic ||
                nodeType == nodeTypeHorizontal || nodeType == nodeTypeVertical) && hasChangeUserAuth) {
            // u\m[hvuFm[hvuIFm[hvuczum[hvuzum[hv
            // um[h̏EmFΏێ҂̕ύXv
            result[nodeId] = flagStatusEnable;
        } else if (nodeType == nodeTypeDynamic && (hasDeleteDynamicNodeAuth || hasUndeleteDynamicNodeAuth)) {
            // uIFm[hvuIFm[h̍폜v܂́uIFm[h̕v
            result[nodeId] = flagStatusEnable;
        } else if (nodeType == nodeTypeHorizontal && hasHorizontalNodeConfigAuth) {
            // uzum[hvuzum[h̍ĐݒEēWJv
            result[nodeId] = flagStatusEnable;
        } else if (nodeType == nodeTypeVertical && hasVerticalNodeConfigAuth) {
            // uczum[hvuczum[h̍ĐݒEēWJv
            result[nodeId] = flagStatusEnable;
        } else {
            // Ȃ
            result[nodeId] = flagStatusDisable;
        }
    }

    return result;
}

//=============================================================================
// Č̍ēWJ擾֐
//  y  zmatterData: ČIuWFNg
//            administratorType: OC[ŮǗҎ
//            nodeList: `FbNΏۂ̃m[h
//  y ԋp zm[hIDL[ƂAēWJ̃}bv
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ̃m[h̍ēWJ擾܂B
//=============================================================================
function getActvProcessTargetExpandAuth(matterData, administratorType, nodeList) {
    return getProcessTargetExpandAuth(matterData, administratorType, nodeList, true);
}

//=============================================================================
// Č̍ēWJ擾֐
//  y  zmatterData: ČIuWFNg
//            administratorType: OC[ŮǗҎ
//            nodeList: `FbNΏۂ̃m[h
//  y ԋp zm[hIDL[ƂAēWJ̃}bv
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ̃m[h̍ēWJ擾܂B
//=============================================================================
function getCplProcessTargetExpandAuth(matterData, administratorType, nodeList) {
    return getProcessTargetExpandAuth(matterData, administratorType, nodeList, false);
}

//=============================================================================
// ēWJ擾֐
//  y  zmatterData: ČIuWFNg
//            administratorType: OC[ŮǗҎ
//            nodeList: `FbNΏۂ̃m[h
//            isActv: ANeBu擾tO
//  y ԋp zm[hIDL[ƂAēWJ̃}bv
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zm[h̍ēWJ擾܂B
//=============================================================================
function getProcessTargetExpandAuth(matterData, administratorType, nodeList, isActv) {
    // m[h̎s
    var PROCESS_EXEC = "1"; // s
    var PROCESS_EXECEND = "9"; // sI

    var i;
    var leng = nodeList.length;
    var result = new Object();
    var loginUserHandleAuth = matterData.loginUserHandleAuth;
    var confirmUserSetupFlag = matterData.confirmUserSetupFlag;
    var cplMatterConfirmFlag = matterData.cplMatterConfirmFlag;

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var admorTypeWkfSysAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfSysAdmor");
    var admorTypeWkfOpeAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfOpeAdmor");
    var flagStatusEnable = codeUtil.getEnumCodeFlagStatus("Enable");
    var flagStatusDisable = codeUtil.getEnumCodeFlagStatus("Disable");
    var nodeTypeApply = codeUtil.getEnumCodeNodeType("nodeTyp_Apply");
    var nodeTypeApprove = codeUtil.getEnumCodeNodeType("nodeTyp_Approve");
    var nodeTypeDynamic = codeUtil.getEnumCodeNodeType("nodeTyp_Dynamic");
    var nodeTypeConfirm = codeUtil.getEnumCodeNodeType("nodeTyp_Confirm");

    // OC[ÜČ쌠擾
    var hasExpandUserAuth; // m[h̏EmFΏێ҂̍ēWJ
    if (administratorType == admorTypeWkfSysAdmor || administratorType == admorTypeWkfOpeAdmor) {
        // [Nt[VXeǗҁE[Nt[^pǗ҂̏ꍇ
        hasExpandUserAuth = true;
    } else {
        // p҂̏ꍇ
        hasExpandUserAuth = !isBlank(loginUserHandleAuth.expandUserFlag) &&
                loginUserHandleAuth.expandUserFlag == flagStatusEnable;
    }

    var nodeId, nodeType, status, enable, backNode;
    var nodeHash = new Object();
    for (i = 0; i < leng; i++) {
        nodeHash[nodeList[i].nodeId] = nodeList[i];
    }
    for (i = 0; i < leng; i++) {
        nodeId = nodeList[i].nodeId;
        nodeType = nodeList[i].nodeType;
        status = nodeList[i].status;
        enable = nodeList[i].enable;
        if (!hasExpandUserAuth || enable != flagStatusEnable) {
            // um[h̍ēWJvȂA܂́Aȃm[h
            result[nodeId] = flagStatusDisable;
        } else if (nodeType == nodeTypeConfirm) {
            // umFm[hv
            result[nodeId] = flagStatusDisable;
            if (confirmUserSetupFlag != flagStatusEnable) {
                continue;
            }
            if (!isActv && cplMatterConfirmFlag != flagStatusEnable) {
                continue;
            }
            if (!isArray(nodeList[i].backwardNodeIds)) {
                continue;
            }
            backNode = nodeHash[nodeList[i].backwardNodeIds[0]];
            if (!backNode) {
                continue;
            }
            if (backNode.lastStatus == PROCESS_EXECEND && hasExpandUserAuth &&
                    backNode.enable == flagStatusEnable) {
                result[nodeId] = flagStatusEnable;
            }
        } else if (status != PROCESS_EXEC) {
            // sȊÕm[h
            result[nodeId] = flagStatusDisable;
        } else if (nodeType == nodeTypeApply || nodeType == nodeTypeApprove || nodeType == nodeTypeDynamic) {
            // u\m[hvuFm[hvuIFm[hv
            result[nodeId] = flagStatusEnable;
        } else {
            // ̑̃m[h
            result[nodeId] = flagStatusDisable;
        }
    }

    return result;
}

//=============================================================================
// Č̃m[hړ擾֐
//  y  zmatterData: ČIuWFNg
//            administratorType: OC[ŮǗҎ
//            nodeList: `FbNΏۂ̃m[h
//  y ԋp zm[hIDL[ƂAm[hړ̃}bv
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ̃m[ḧړ擾܂B
//=============================================================================
function getActvNodeMoveAuth(matterData, administratorType, nodeList) {
    // m[h̎s
    var PROCESS_EXEC = "1"; // s

    var leng = nodeList.length;
    var result = new Object();
    var loginUserHandleAuth = matterData.loginUserHandleAuth;

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var admorTypeWkfSysAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfSysAdmor");
    var admorTypeWkfOpeAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfOpeAdmor");
    var flagStatusEnable = codeUtil.getEnumCodeFlagStatus("Enable");
    var flagStatusDisable = codeUtil.getEnumCodeFlagStatus("Disable");

    // OC[ÜČ쌠擾
    var hasHandleMoveForwardAuth; // m[ḧړiiށj
    var hasHandleMoveBackwardAuth; // m[ḧړi߂j
    var hasHandleTerminateAuth; // m[ḧړiIj
    if (administratorType == admorTypeWkfSysAdmor || administratorType == admorTypeWkfOpeAdmor) {
        // [Nt[VXeǗҁE[Nt[^pǗ҂̏ꍇ
        hasHandleMoveForwardAuth = true;
        hasHandleMoveBackwardAuth = true;
        hasHandleTerminateAuth = true;
    } else {
        // p҂̏ꍇ
        hasHandleMoveForwardAuth = !isBlank(loginUserHandleAuth.handleMoveForwardFlag) &&
                loginUserHandleAuth.handleMoveForwardFlag == flagStatusEnable;
        hasHandleMoveBackwardAuth = !isBlank(loginUserHandleAuth.handleMoveBackwardFlag) &&
                loginUserHandleAuth.handleMoveBackwardFlag == flagStatusEnable;
        hasHandleTerminateAuth = !isBlank(loginUserHandleAuth.handleTerminateFlag) &&
                loginUserHandleAuth.handleTerminateFlag == flagStatusEnable;
    }

    var nodeId;
    for (var i = 0; i < leng; i++) {
        nodeId = nodeList[i].nodeId;
        if (nodeList[i].status == PROCESS_EXEC &&
                (hasHandleMoveForwardAuth || hasHandleMoveBackwardAuth || hasHandleTerminateAuth)) {
            result[nodeId] = flagStatusEnable;
        } else {
            result[nodeId] = flagStatusDisable;
        }
    }

    return result;
}

//=============================================================================
// Č̃m[hړ擾֐
//  y  zmatterData: ČIuWFNg
//            administratorType: OC[ŮǗҎ
//            nodeList: `FbNΏۂ̃m[h
//  y ԋp zm[hIDL[ƂAm[hړ̃}bv
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ̃m[ḧړ擾܂B
//=============================================================================
function getCplNodeMoveAuth(matterData, administratorType, nodeList) {
    var leng = nodeList.length;
    var result = new Object();

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var flagStatusDisable = codeUtil.getEnumCodeFlagStatus("Disable");

    var nodeId;
    for (var i = 0; i < leng; i++) {
        nodeId = nodeList[i].nodeId;
        result[nodeId] = flagStatusDisable;
    }

    return result;
}

//=============================================================================
// Čۗ̕擾֐
//  y  zmatterData: ČIuWFNg
//            administratorType: OC[ŮǗҎ
//            nodeList: `FbNΏۂ̃m[h
//  y ԋp zm[hIDL[ƂAۗ̃}bv
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ̃m[hۗ̕擾܂B
//=============================================================================
function getActvReserveCancelAuth(matterData, administratorType, nodeList) {
    // m[h̎s
    var PROCESS_RESERVE = "2"; // ۗ

    var leng = nodeList.length;
    var result = new Object();
    var loginUserHandleAuth = matterData.loginUserHandleAuth;

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var admorTypeWkfSysAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfSysAdmor");
    var admorTypeWkfOpeAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfOpeAdmor");
    var flagStatusEnable = codeUtil.getEnumCodeFlagStatus("Enable");
    var flagStatusDisable = codeUtil.getEnumCodeFlagStatus("Disable");

    // OC[ÜČ쌠擾
    var hasReserveCancelAuth; // ۗ
    if (administratorType == admorTypeWkfSysAdmor || administratorType == admorTypeWkfOpeAdmor) {
        // [Nt[VXeǗҁE[Nt[^pǗ҂̏ꍇ
        hasReserveCancelAuth = true;
    } else {
        // p҂̏ꍇ
        hasReserveCancelAuth = !isBlank(loginUserHandleAuth.reserveCancelFlag) &&
                loginUserHandleAuth.reserveCancelFlag == flagStatusEnable;
    }

    var nodeId;
    for (var i = 0; i < leng; i++) {
        nodeId = nodeList[i].nodeId;
        if (nodeList[i].status == PROCESS_RESERVE && hasReserveCancelAuth) {
            result[nodeId] = flagStatusEnable;
        } else {
            result[nodeId] = flagStatusDisable;
        }
    }

    return result;
}

//=============================================================================
// Čۗ̕擾֐
//  y  zmatterData: ČIuWFNg
//            administratorType: OC[ŮǗҎ
//            nodeList: `FbNΏۂ̃m[h
//  y ԋp zm[hIDL[ƂAۗ̃}bv
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ̃m[hۗ̕擾܂B
//=============================================================================
function getCplReserveCancelAuth(matterData, administratorType, nodeList) {
    var leng = nodeList.length;
    var result = new Object();

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var flagStatusDisable = codeUtil.getEnumCodeFlagStatus("Disable");

    var nodeId;
    for (var i = 0; i < leng; i++) {
        nodeId = nodeList[i].nodeId;
        result[nodeId] = flagStatusDisable;
    }
    return result;
}

//=============================================================================
// Ώێҕ\擾֐
//  y  zmatterData: ČIuWFNg
//            administratorType: OC[ŮǗҎ
//            nodeList: `FbNΏۂ̃m[h
//  y ԋp zm[hIDL[ƂAΏێҕ\̃}bv
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zm[h̏Ώێҕ\擾܂B
//=============================================================================
function getActvProcessTargetShowAuth(matterData, administratorType, nodeList) {
    return getProcessTargetShowAuth(matterData, administratorType, nodeList, true);
}

//=============================================================================
// Ώێҕ\擾֐
//  y  zmatterData: ČIuWFNg
//            administratorType: OC[ŮǗҎ
//            nodeList: `FbNΏۂ̃m[h
//  y ԋp zm[hIDL[ƂAΏێҕ\̃}bv
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zm[h̏Ώێҕ\擾܂B
//=============================================================================
function getCplProcessTargetShowAuth(matterData, administratorType, nodeList) {
    return getProcessTargetShowAuth(matterData, administratorType, nodeList, false);
}

//=============================================================================
// Ώێҕ\擾֐
//  y  zmatterData: ČIuWFNg
//            administratorType: OC[ŮǗҎ
//            nodeList: `FbNΏۂ̃m[h
//            isActv: ANeBu擾tO
//  y ԋp zm[hIDL[ƂAΏێҕ\̃}bv
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zm[h̏Ώێҕ\擾܂B
//=============================================================================
function getProcessTargetShowAuth(matterData, administratorType, nodeList, isActv) {
    // m[h̎s
    var PROCESS_EXEC = "1"; // s
    var PROCESS_RESERVE = "2"; // ۗ
    var PROCESS_EXECEND = "9"; // sI

    var i;
    var leng = nodeList.length;
    var result = new Object();
    var cplMatterConfirmFlag = matterData.cplMatterConfirmFlag;

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var flagStatusEnable = codeUtil.getEnumCodeFlagStatus("Enable");
    var flagStatusDisable = codeUtil.getEnumCodeFlagStatus("Disable");
    var nodeTypeApply = codeUtil.getEnumCodeNodeType("nodeTyp_Apply");
    var nodeTypeApprove = codeUtil.getEnumCodeNodeType("nodeTyp_Approve");
    var nodeTypeDynamic = codeUtil.getEnumCodeNodeType("nodeTyp_Dynamic");
    var nodeTypeConfirm = codeUtil.getEnumCodeNodeType("nodeTyp_Confirm");

    var nodeId, nodeType, status, backNode;
    var nodeHash = new Object();
    for (i = 0; i < leng; i++) {
        nodeHash[nodeList[i].nodeId] = nodeList[i];
    }
    for (i = 0; i < leng; i++) {
        nodeId = nodeList[i].nodeId;
        nodeType = nodeList[i].nodeType;
        status = nodeList[i].status;
        if ((nodeType == nodeTypeApply || nodeType == nodeTypeApprove || nodeType == nodeTypeDynamic) &&
                (status == PROCESS_EXEC || status == PROCESS_RESERVE) &&
                nodeList[i].enable == flagStatusEnable) {
            // \AFAIFm[h
            result[nodeId] = flagStatusEnable;
        } else if (nodeType == nodeTypeConfirm && nodeList[i].enable == flagStatusEnable) {
            // mFm[h
            result[nodeId] = flagStatusDisable;
            if (!isActv && cplMatterConfirmFlag != flagStatusEnable) {
                continue;
            }
            if (!isArray(nodeList[i].backwardNodeIds)) {
                continue;
            }
            backNode = nodeHash[nodeList[i].backwardNodeIds[0]];
            if (!backNode) {
                continue;
            }
            if (backNode.lastStatus == PROCESS_EXECEND && backNode.enable == flagStatusEnable) {
                result[nodeId] = flagStatusEnable;
            }
        } else {
            // ̑̃m[h
            result[nodeId] = flagStatusDisable;
        }
    }

    return result;
}

//=============================================================================
// Č擾֐
//  y  zloginGroupId: OCO[vID
//            localeId: P[ID
//            systemMatterId: VXeČID
//            nodeId: m[hID (ȗ)
//  y ԋp zʃIuWFNg (data: ČIuWFNg)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zWorkflowPluginUtil ŎgpČ̃IuWFNg擾܂B
//=============================================================================
function getMatterInfo(loginGroupId, localeId, systemMatterId, nodeId) {
    var matterInfo = new Object();
    var result = new Object();
    if (isBlank(systemMatterId)) {
        result.resultFlag = true; // 
        result.resultStatus = new Object();
        result.data = matterInfo;
        return result;
    }
    var userMatterStatus = new UserMatterStatus(loginGroupId, localeId, "2");
    result = userMatterStatus.getMatterStatus(systemMatterId);
    if (!result.resultFlag || result.data == null) {
        result.resultFlag = false; // s
        result.data = matterInfo;
        return result;
    }
    matterInfo.systemMatterId = result.data.systemMatterId;
    matterInfo.userDataId = result.data.userDataId;
    matterInfo.flowId = result.data.flowId;
    matterInfo.flowVersionId = result.data.flowVersionId;
    if (!isBlank(nodeId)) {
        matterInfo.nodeId = nodeId;
    }
    var matter;
    var status = result.data.matterStatusCode;
    var codeUtil = new WorkflowCodeUtil();
    if (codeUtil.getEnumCodeMatterStatus("matSts_Active") == status) {
        matter = new ActvMatter(loginGroupId, localeId, systemMatterId);
    } else if (codeUtil.getEnumCodeMatterStatus("matSts_Complete") == status) {
        matter = new CplMatter(loginGroupId, localeId, systemMatterId);
    } else if (codeUtil.getEnumCodeMatterStatus("matSts_Archived") == status) {
        matter = new ArcMatter(loginGroupId, localeId, systemMatterId, result.data.archiveMonth);
    } else {
        result.resultFlag = false; // s
        result.data = matterInfo;
        return result;
    }
    result = matter.getExecFlow();
    if (!result.resultFlag || result.data == null) {
        result.resultFlag = false; // s
        result.data = matterInfo;
        return result;
    }
    matterInfo.contentsId = result.data.contentsId;
    matterInfo.contentsVersionId = result.data.contentsVersionId;
    matterInfo.routeId = result.data.routeId;
    matterInfo.routeVersionId = result.data.routeVersionId;
    result.resultFlag = true; // 
    result.data = matterInfo;
    return result;
}

//=============================================================================
// Č\擾֐ij
//  y  zoSession: ZbV
//            systemMatterId: VXeČID
//            imwOpeType: ǗҎʁiÍρAȗj
//  y ԋp ztO (true: , false: Ȃ)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČQƂł錠Ă邩肵܂B
//=============================================================================
function checkDisplayAuthActvMatter(oSession, systemMatterId, imwOpeType) {
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;
    var localeId = oSession.locale;
    var isAdmin = Procedure.imw_admin_utils.isWkfAdmin(oSession, imwOpeType);
    var wkfOpeAdmorCode = Procedure.imw_admin_utils.isWkfOpeAdmor(oSession, imwOpeType) ? userId : null;
    var authCondition, searchCondition, manager, databaseResult;

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var flagStatusEnable = codeUtil.getEnumCodeFlagStatus("Enable");

    // ꗗ
    authCondition = new Object();
    authCondition.applyFlg = flagStatusEnable;
    authCondition.approveFlg = flagStatusEnable;
    authCondition.applyActFlg = flagStatusEnable;
    authCondition.approveActFlg = flagStatusEnable;
    searchCondition = new ListSearchCondition();
    searchCondition.setAndCombination(true);
    searchCondition.addCondition(UnprocessActvMatterList.SYSTEM_MATTER_ID,
            systemMatterId, ListSearchCondition.OP_EQ);
    searchCondition.setCount("0");
    searchCondition.setOffset("0");
    manager = new UnprocessActvMatterList(userId, loginGroupId, localeId);
    databaseResult = manager.getProcessListCount(authCondition, searchCondition);
    if (!databaseResult.resultFlag) {
        return false;
    }
    if (databaseResult.data > 0) {
        return true;
    }

    // ρijꗗ
    authCondition = new Object();
    authCondition.applyFlg = flagStatusEnable;
    authCondition.approveFlg = flagStatusEnable;
    authCondition.applyTargetActFlg = flagStatusEnable;
    authCondition.approveTargetActFlg = flagStatusEnable;
    authCondition.applySelfActFlg = flagStatusEnable;
    authCondition.approveSelfActFlg = flagStatusEnable;
    authCondition.applyOriginalActFlg = flagStatusEnable;
    authCondition.approveOriginalActFlg = flagStatusEnable;
    searchCondition = new ListSearchCondition();
    searchCondition.setAndCombination(true);
    searchCondition.addCondition(ProcessedActvMatterList.SYSTEM_MATTER_ID,
            systemMatterId, ListSearchCondition.OP_EQ);
    searchCondition.setCount("0");
    searchCondition.setOffset("0");
    manager = new ProcessedActvMatterList(userId, loginGroupId, localeId);
    databaseResult = manager.getProcessedListCount(authCondition, searchCondition);
    if (!databaseResult.resultFlag) {
        return false;
    }
    if (databaseResult.data > 0) {
        return true;
    }

    // QƁijꗗ
    searchCondition = new ListSearchCondition();
    searchCondition.setAndCombination(true);
    searchCondition.addCondition(
            isAdmin ? RefActvMatterAdminList.SYSTEM_MATTER_ID : RefActvMatterList.SYSTEM_MATTER_ID,
            systemMatterId, ListSearchCondition.OP_EQ);
    searchCondition.setCount("0");
    searchCondition.setOffset("0");
    manager = isAdmin ? new RefActvMatterAdminList(loginGroupId, localeId) :
            new RefActvMatterList(userId, loginGroupId, localeId);
    databaseResult = isAdmin ? manager.getActvMatterListCount(searchCondition, wkfOpeAdmorCode) :
            manager.getRefListCount(searchCondition);
    if (!databaseResult.resultFlag) {
        return false;
    }
    if (databaseResult.data > 0) {
        return true;
    }

    // mFijꗗ
    searchCondition = new ListSearchCondition();
    searchCondition.setAndCombination(true);
    searchCondition.addCondition(CnfmActvMatterList.SYSTEM_MATTER_ID,
            systemMatterId, ListSearchCondition.OP_EQ);
    searchCondition.setCount("0");
    searchCondition.setOffset("0");
    manager = new CnfmActvMatterList(userId, loginGroupId, localeId);
    databaseResult = manager.getCnfmListCount(searchCondition);
    if (!databaseResult.resultFlag) {
        return false;
    }
    if (databaseResult.data > 0) {
        return true;
    }

    return false;
}

//=============================================================================
// Č\擾֐ij
//  y  zoSession: ZbV
//            systemMatterId: VXeČID
//            imwOpeType: ǗҎʁiÍρAȗj
//  y ԋp ztO (true: , false: Ȃ)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČQƂł錠Ă邩肵܂B
//=============================================================================
function checkDisplayAuthCplMatter(oSession, systemMatterId, imwOpeType) {
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;
    var localeId = oSession.locale;
    var isAdmin = Procedure.imw_admin_utils.isWkfAdmin(oSession, imwOpeType);
    var wkfOpeAdmorCode = Procedure.imw_admin_utils.isWkfOpeAdmor(oSession, imwOpeType) ? userId : null;
    var authCondition, searchCondition, manager, databaseResult;

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var flagStatusEnable = codeUtil.getEnumCodeFlagStatus("Enable");

    // ρijꗗ
    authCondition = new Object();
    authCondition.applyFlg = flagStatusEnable;
    authCondition.approveFlg = flagStatusEnable;
    authCondition.applyTargetActFlg = flagStatusEnable;
    authCondition.approveTargetActFlg = flagStatusEnable;
    authCondition.applySelfActFlg = flagStatusEnable;
    authCondition.approveSelfActFlg = flagStatusEnable;
    authCondition.applyOriginalActFlg = flagStatusEnable;
    authCondition.approveOriginalActFlg = flagStatusEnable;
    searchCondition = new ListSearchCondition();
    searchCondition.setAndCombination(true);
    searchCondition.addCondition(ProcessedCplMatterList.SYSTEM_MATTER_ID,
            systemMatterId, ListSearchCondition.OP_EQ);
    searchCondition.setCount("0");
    searchCondition.setOffset("0");
    manager = new ProcessedCplMatterList(userId, loginGroupId, localeId);
    databaseResult = manager.getProcessedListCount(authCondition, searchCondition);
    if (!databaseResult.resultFlag) {
        return false;
    }
    if (databaseResult.data > 0) {
        return true;
    }

    // QƁijꗗ
    searchCondition = new ListSearchCondition();
    searchCondition.setAndCombination(true);
    searchCondition.addCondition(
            isAdmin ? RefCplMatterAdminList.SYSTEM_MATTER_ID : RefCplMatterList.SYSTEM_MATTER_ID,
            systemMatterId, ListSearchCondition.OP_EQ);
    searchCondition.setCount("0");
    searchCondition.setOffset("0");
    manager = isAdmin ? new RefCplMatterAdminList(loginGroupId, localeId) :
            new RefCplMatterList(userId, loginGroupId, localeId);
    databaseResult = isAdmin ? manager.getCplMatterListCount(searchCondition, wkfOpeAdmorCode) :
            manager.getRefListCount(searchCondition);
    if (!databaseResult.resultFlag) {
        return false;
    }
    if (databaseResult.data > 0) {
        return true;
    }

    // mFijꗗ
    searchCondition = new ListSearchCondition();
    searchCondition.setAndCombination(true);
    searchCondition.addCondition(CnfmCplMatterList.SYSTEM_MATTER_ID,
            systemMatterId, ListSearchCondition.OP_EQ);
    searchCondition.setCount("0");
    searchCondition.setOffset("0");
    manager = new CnfmCplMatterList(userId, loginGroupId, localeId);
    databaseResult = manager.getCnfmUserSetListCount(searchCondition);
    if (!databaseResult.resultFlag) {
        return false;
    }
    if (databaseResult.data > 0) {
        return true;
    }

    return false;
}

//=============================================================================
// Č\擾֐iߋj
//  y  zoSession: ZbV
//            systemMatterId: VXeČID
//            archiveMonth: Ώ۔N
//            imwOpeType: ǗҎʁiÍρAȗj
//  y ԋp ztO (true: , false: Ȃ)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zߋČQƂł錠Ă邩肵܂B
//=============================================================================
function checkDisplayAuthArcMatter(oSession, systemMatterId, archiveMonth, imwOpeType) {
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;
    var localeId = oSession.locale;
    var isAdmin = Procedure.imw_admin_utils.isWkfAdmin(oSession, imwOpeType);
    var wkfOpeAdmorCode = Procedure.imw_admin_utils.isWkfOpeAdmor(oSession, imwOpeType) ? userId : null;
    var searchCondition, manager, databaseResult;

    // ߋČꗗ
    searchCondition = new ListSearchCondition();
    searchCondition.setAndCombination(true);
    searchCondition.addCondition(
            isAdmin ? ArcMatterAdminList.SYSTEM_MATTER_ID : ArcMatterList.SYSTEM_MATTER_ID,
            systemMatterId, ListSearchCondition.OP_EQ);
    searchCondition.setCount("0");
    searchCondition.setOffset("0");
    manager = isAdmin ? new ArcMatterAdminList(loginGroupId, localeId, archiveMonth) :
            new ArcMatterList(userId, loginGroupId, localeId, archiveMonth);
    databaseResult = isAdmin ? manager.getArcMatterListCount(searchCondition, wkfOpeAdmorCode) :
            manager.getProcessedListCount(searchCondition);
    if (!databaseResult.resultFlag) {
        return false;
    }
    if (databaseResult.data > 0) {
        return true;
    }

    return false;
}

//=============================================================================
// ėpÍ֐
//  y  zoSession: ZbVIuWFNg
//            parameter: ÍΏە
//  y ԋp zÍL[
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zw肵Í܂B
//=============================================================================
function encodeGeneralParameter(oSession, parameter) {
    var key = getAPOPKey(oSession, "generalDigest");
    return getMessageDigest("SHA-1", key + parameter);
}

//=============================================================================
// APOP F؃L[擾֐
//  y  zoSession: ZbVIuWFNg
//            paramName: p[^
//  y ԋp zF؃L[
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zÍ邽߂̋^ APOP F؃L[擾܂B
//=============================================================================
function getAPOPKey(oSession, paramName) {
    return oSession.loginGroup + "\n" + oSession.user + "\n" + oSession.locale + "\n" +
            Format.fromDate("yyyy/MM/dd HH:mm:ss.SSS", oSession.loginTime) + "\n" +
            oSession.signature + "\n" + paramName + "\n<IM-Workflow7.2>" + "\n";
}
