Procedure.define("imw_paging_utils", new imwPagingUtils());

// =============================================================================
// ֐`
// y  z
// yԋplz
// y쐬ҁzNTT DATA INTRAMART
// y XV z
// y Tv zProcedure̓o^
// =============================================================================
function imwPagingUtils() {
    this.createPagingParts = createPagingParts;
    this.adjustPagingNumber = adjustPagingNumber;
    this.createSortIconParts = createSortIconParts;
    this.initActionRefresh = initActionRefresh;
    this.initActionSort = initActionSort;
    this.initActionPaging = initActionPaging;
}

// =============================================================================
// y[WOHTML쐬֐
//  y  zmaxRecord: S
//            currentPage: ݂̃y[Wԍ
//            perPageRecord: Py[W̕\
//  y ԋp zy[WONp[c
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zy[WÕNHTML쐬܂B
// =============================================================================
function createPagingParts(oAttr) {
    // S
    var nMaxRecord = 0;
    // ݂̃y[Wԍ
    var nCurrentPage = 1;
    // Py[W̕\
    var nPageLine = 10;
    // y[W\Jnԍ
    var nStartLine = 0;
    // y[W\Iԍ
    var nEndLine = 0;
    // 擪y[Wt@C
    var FIRST_FILE_NAME = "images/icons/16x16/fugue-icons/shadow/control-double-180.png";
    // Oy[Wt@C
    var PREVIOUS_FILE_NAME = "images/icons/16x16/fugue-icons/shadow/control-180.png";
    // y[Wt@C
    var NEXT_FILE_NAME = "images/icons/16x16/fugue-icons/shadow/control.png";
    // ŏĨy[Wt@C
    var LAST_FILE_NAME = "images/icons/16x16/fugue-icons/shadow/control-double.png";
    var FIRST_IMG_TITLE = MessageManager.getMessage("IMW.CAP.0398"); // ŏ̃y[W
    var PREVIOUS_IMG_TITLE = MessageManager.getMessage("IMW.CAP.0399"); // Õy[W
    var NEXT_IMG_TITLE = MessageManager.getMessage("IMW.CAP.0400"); // ̃y[W
    var LAST_IMG_TITLE = MessageManager.getMessage("IMW.CAP.0401"); // ŏĨy[W
    if (!isNaN(oAttr.maxRecord)) {
        nMaxRecord = parseFloat(oAttr.maxRecord);
    }
    if (nMaxRecord == 0 && oAttr.isBlankWhenEmpty) {
        return "";
    }
    if (!isNaN(oAttr.currentPage)) {
        nCurrentPage = parseFloat(oAttr.currentPage);
    }
    if (!isNaN(oAttr.perPageRecord)) {
        nPageLine = parseFloat(oAttr.perPageRecord);
    }
    if (nMaxRecord > 0) {
        nStartLine = nPageLine * (nCurrentPage - 1) + 1;
    }
    if (nMaxRecord > nPageLine * nCurrentPage) {
        nEndLine = nPageLine * nCurrentPage;
    } else {
        nEndLine = nMaxRecord;
    }
    // y[W̌vZ
    var nPageNum1 = 1;
    // ŏ̃y[W
    var nPageNum2 = nCurrentPage - 1;
    // Õy[W
    var nPageNum3 = nCurrentPage + 1;
    // ̃y[W
    var nPageNum4 = Math.ceil(nMaxRecord / nPageLine);
    // ŏĨy[W
    // ey[WN̕\ݒ
    var blnPageNum1 = (nCurrentPage > 1);
    var blnPageNum2 = (nCurrentPage > 1);
    var blnPageNum3 = (nCurrentPage < nPageNum4);
    var blnPageNum4 = (nCurrentPage < nPageNum4);
    // eACRNbNJS֐
    var strFirstPageFunc = "javascript:onClickPageLink('" + nPageNum1 + "');";
    if (isString(oAttr.firstPageFunc)) {
        strFirstPageFunc = oAttr.firstPageFunc;
    }
    var strPrevPageFunc = "javascript:onClickPageLink('" + nPageNum2 + "');";
    if (isString(oAttr.prevPageFunc)) {
        strPrevPageFunc = oAttr.prevPageFunc;
    }
    var strNextPageFunc = "javascript:onClickPageLink('" + nPageNum3 + "');";
    if (isString(oAttr.nextPageFunc)) {
        strNextPageFunc = oAttr.nextPageFunc;
    }
    var strLastPageFunc = "javascript:onClickPageLink('" + nPageNum4 + "');";
    if (isString(oAttr.lastPageFunc)) {
        strLastPageFunc = oAttr.lastPageFunc;
    }
    // HTML̍쐬
    var strHTML = "";
    var htmlTABLE_Begin = "<TABLE border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"5\">";
    var htmlTABLE_End = "</TABLE>";
    var htmlTR_Begin = "<TR>";
    var htmlTR_End = "</TR>";
    var htmlTD_Page_Begin = "";
    var htmlTD_End = "</TD>";
    var htmlSTRONG_Page = "";
    var htmlA_Page1_Begin = "";
    var htmlA_Page2_Begin = "";
    var htmlA_Page3_Begin = "";
    var htmlA_Page4_Begin = "";
    htmlTD_Page_Begin = "<TD align=\"right\" nowrap>";
    // uŏ̃y[Wցv\Ƃ
    if (blnPageNum1) {
        htmlA_Page1_Begin = "<A href=\"" + strFirstPageFunc + "\">" + "<IMG src=\"" + FIRST_FILE_NAME + "\" border=\"0\" title=\"" + FIRST_IMG_TITLE + "\" align=\"absmiddle\">" + "</A>&nbsp;";
    }
    // uÕy[Wցv\Ƃ
    if (blnPageNum2) {
        htmlA_Page2_Begin = "<A href=\"" + strPrevPageFunc + "\">" + "<IMG src=\"" + PREVIOUS_FILE_NAME + "\" border=\"0\" title=\"" + PREVIOUS_IMG_TITLE + "\" align=\"absmiddle\">" + "</A>&nbsp;";
    }
    // Oy[WN쐬
    var pagingBeforeNumberOfLine = 3;
    // Pʒ̃y[WOő\(\y[WO)
    var pagingAfterNumberOfLine = 3;
    // Pʒ̃y[WOő\(\y[W)
    var nPageNumBefore = nPageNum1;
    var nPageNumNext = nPageNum4;
    if (nCurrentPage - pagingBeforeNumberOfLine > nPageNumBefore) {
        nPageNumBefore = nCurrentPage - pagingBeforeNumberOfLine;
    }
    if (nCurrentPage + pagingAfterNumberOfLine < nPageNumNext) {
        nPageNumNext = nCurrentPage + pagingAfterNumberOfLine;
    }
    var aryHtmlOtherPages = new Array();
    for (var i = nPageNumBefore; i <= nPageNumNext; i++) {
        if (i == nCurrentPage) {
            aryHtmlOtherPages.push("<b style=\"font-size:120%;padding-right:1px;\">" + i + "</b>");
        } else {
            aryHtmlOtherPages.push("<a href ='javascript:onClickPageLink(\"" + i + "\");'><b><u>" + i + "</u></b></a>");
        }
    }
    var htmlOtherPages = "&nbsp;" + aryHtmlOtherPages.join("&nbsp;") + "&nbsp;&nbsp;";
    htmlSTRONG_Page = "<STRONG>" + nStartLine + "-" + nEndLine + "/" + nMaxRecord + "</STRONG>&nbsp;";
    // ũy[Wցv\Ƃ
    if (blnPageNum3) {
        htmlA_Page3_Begin = "<A href=\"" + strNextPageFunc + "\">" + "<IMG src=\"" + NEXT_FILE_NAME + "\" border=\"0\" title=\"" + NEXT_IMG_TITLE + "\" align=\"absmiddle\">" + "</A>&nbsp;";
    }
    // uŏĨy[Wցv\Ƃ
    if (blnPageNum4) {
        htmlA_Page4_Begin = "<A href=\"" + strLastPageFunc + "\">" + "<IMG src=\"" + LAST_FILE_NAME + "\" border=\"0\" title=\"" + LAST_IMG_TITLE + "\" align=\"absmiddle\">" + "</A>&nbsp;";
    }
    strHTML = htmlTABLE_Begin + htmlTR_Begin + htmlTD_Page_Begin + htmlA_Page1_Begin + htmlA_Page2_Begin + (nPageNum4 <= 1 ? "" : htmlOtherPages) + htmlA_Page3_Begin + htmlA_Page4_Begin + " " + htmlSTRONG_Page + htmlTD_End + htmlTR_End + htmlTABLE_End;
    return strHTML;
}

//=============================================================================
// y[W֐
//  y  zoConditionInfo: 
//            count: R[h
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zJgy[WƃItZbg𒲐܂B
//=============================================================================
function adjustPagingNumber(oConditionInfo, count) {

    if (count == 0) {
        oConditionInfo.offset = 0;
        oConditionInfo.currentPage = 1;
        return;
    }
    var currentPage = Math.floor((count - 1) / oConditionInfo.count);
    var offset = currentPage * oConditionInfo.count;

    currentPage++;
    if (currentPage < oConditionInfo.currentPage) {
        oConditionInfo.offset = offset;
        oConditionInfo.currentPage = currentPage;
    }
}

// =============================================================================
// \[gN쐬֐
//  y  zorderByObj: Jg\[g
//            targetColumnId: Ώۂ̃wb_J
//  y ԋp zꗗwb_[̃\[hNp[c
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zꗗwb_[̃\[gN쐬܂B
// =============================================================================
function createSortIconParts(orderByObj, targetColumnId) {
    var sortIcon = "";

    if (!isObject(orderByObj) || orderByObj.columnName != targetColumnId) {
        return sortIcon;
    }

    if ("ASC" == orderByObj.sortType) {
        sortIcon = "<img border=\"0\" src=\"images/icons/16x16/fugue-icons/shadow/chevron.png\" align=\"absmiddle\">&nbsp;";
    } else if ("DESC" == orderByObj.sortType) {
        sortIcon = "<img border=\"0\" src=\"images/icons/16x16/fugue-icons/shadow/chevron-expand.png\" align=\"absmiddle\">&nbsp;";
    }
    return sortIcon;
}

//=============================================================================
// ꗗʍŐVݒ֐
//   y  zrequest: tqk擾IuWFNg
//             oConditionInfo: IuWFNg
//   y ԋp zȂ
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zꗗʂ̍ŐV񃊃NNbN̏s܂B
//=============================================================================
function initActionRefresh(request, oConditionInfo) {
    oConditionInfo.offset = 0;
    oConditionInfo.currentPage = 1;
}

//=============================================================================
// ꗗʃwb_NbNݒ֐
//   y  zrequest: tqk擾IuWFNg
//             oConditionInfo: IuWFNg
//   y ԋp zȂ
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zꗗʂ̃wb_NNbN̏s܂B
//=============================================================================
function initActionSort(request, oConditionInfo) {
    var leng;
    var i;
    var columnName = request.sortColumn;
    var sortType = "ASC";
    var orderByList = oConditionInfo.orderByList;
    if (orderByList.length > 0 && columnName == orderByList[0].columnName && "ASC" == orderByList[0].sortType) {
        sortType = "DESC";
    }

    // 擪}
    var workSortList = new Array();
    var orderByCount = 0;
    workSortList[orderByCount] = new Object();
    workSortList[orderByCount].columnName = columnName;
    workSortList[orderByCount].sortType = sortType;
    orderByCount++;

    // ɒǉ
    for (leng = orderByList.length, i = 0; i < leng; i++) {
        if (columnName == orderByList[i].columnName) {
            continue;
        }
        workSortList[orderByCount] = orderByList[i];
        orderByCount++;
    }

    oConditionInfo.offset = 0;
    oConditionInfo.currentPage = 1;
    oConditionInfo.orderByList = workSortList;
}

//=============================================================================
// ꗗʃy[W؂ւݒ֐
//   y  zrequest: tqk擾IuWFNg
//             oConditionInfo: IuWFNg
//   y ԋp zȂ
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zꗗʂ̃y[WNNbN̏s܂B
//=============================================================================
function initActionPaging(request, oConditionInfo) {
    var pageNo = parseInt(request.pageNo);
    var oSession = AccessSecurityManager.getSessionInfo();
    var loginGroupId = oSession.loginGroup;
    var wfpManager = new WorkflowParameterManager(loginGroupId);
    var recordAtPage = wfpManager.getIntegerParameter("record-at-page");
    var offset = recordAtPage * (pageNo - 1);

    oConditionInfo.offset = offset;
    oConditionInfo.currentPage = pageNo;
}
