Procedure.define("imw_plugin_utils", new imwPluginUtils());
// =============================================================================
// ֐`
// y  z
// yԋplz
// y쐬ҁzNTT DATA INTRAMART
// y XV z
// y Tv z Procedure̓o^
// =============================================================================
function imwPluginUtils() {
    this.getPluginConfigPageInfo        = getPluginConfigPageInfo;
    this.getParameterObject             = getParameterObject;
    this.initAppCommonMaster            = initAppCommonMaster;
    this.getProcessPluginConfigPageInfo = getProcessPluginConfigPageInfo;
}

//=============================================================================
//vOCݒʏ擾֐
//y  zextensionPointId: g|CgID
//          localeId:         P[ID
//          loginGroupId:     OCO[vID
//          applicationFlag:  pҐ䖳tO
//          excludeIdObj:     Op[^IDL[ɂnbV
//y ԋp zw肵g|Cg̃vOCݒʏ
//y쐬ҁzNTT DATA INTRAMART
//y Tv zw肵g|Cg̃vOCݒʏQ擾܂B
//
//=============================================================================
function getPluginConfigPageInfo(extensionPointId, localeId, loginGroupId, applicationFlag, excludeIdObj) {
    var disableFlag = true;
    if(!isBlank(applicationFlag) && isTrue(applicationFlag)) {
        disableFlag = false;
    }
    // vOC}l[W[𐶐
    var manager = new PluginManager(localeId, loginGroupId);
    // vOCfBXNv^̔z擾
    var descriptors = manager.getPluginDescriptors(extensionPointId);
    var returnObject = new Object();
    returnObject.configObject = new Object();
    returnObject.configList = new Array();

    //vOCʃXg̎擾
    var param = new Object();
    // vOCfBXNv^̔z񂩂vf𒊏o
    for( var index in descriptors){
        var descriptor = descriptors[index];
        var xmlString = descriptor.getXmlString();
        if(isBlank(xmlString)){
            continue;
        }
        if (isObject(excludeIdObj) && excludeIdObj[descriptor.getId()]) {
            continue;
        }
        // vOCݒ擾
        var xml = new XML(xmlString);
        // pҗp
        if(disableFlag) {
            var disable = xml.application.@disable.toString();
            if(disable != null && disable == "true") {
                continue;
            }
        }
        // {ݒ
        var obj = new Object();
        obj.id = descriptor.getId();
        obj.name = descriptor.getName();
        param = new Object();
        // v[e[Vt[[N̏ꍇ
        var script = xml.configPage.script;
        if(script.length() > 0) {
            var pagePath = script[0].@pagePath;
            if(pagePath.length() > 0) {
                obj.path = Procedure.imw_proc_utils.getFormActionScript(pagePath.toString());
                obj.width = script[0].@width.toString();
                obj.height = script[0].@height.toString();
                param = getParameterObject(script[0].parameter);
                if(param != null) {
                    obj.param = param;
                }
                returnObject.configObject[obj.id]= obj;
                returnObject.configList[returnObject.configList.length] = obj;
                continue;
            }
        }
        // JavaEEt[[N̏ꍇ
        var javaeeList = xml.configPage.javaee;
        if(javaeeList.length() > 0) {
            var javaee = javaeeList[0];
            var applicationId = javaee.@applicationId;
            var serviceId = javaee.@serviceId;
            if(applicationId.length() > 0 && serviceId.length() > 0) {
                obj.path = Procedure.imw_proc_utils.getFormActionJavaEE(applicationId, serviceId);
                obj.width = javaee.@width.toString();
                obj.height = javaee.@height.toString();
                param = getParameterObject(javaee.parameter);
                if(param != null) {
                    obj.param = param;
                }
                returnObject.configObject[obj.id]= obj;
                returnObject.configList[returnObject.configList.length] = obj;
                continue;
            }
        }
        // LȊȌꍇ
        var urlList = xml.configPage.url;
        if(urlList.length() > 0) {
            var path = urlList[0].@path;
            if(path.length() > 0) {
                obj.path = Procedure.imw_proc_utils.getFormActionJspOrServlet(path.toString());
                obj.width = urlList[0].@width.toString();
                obj.height = urlList[0].@height.toString();
                param = getParameterObject(urlList[0].parameter);
                if(param != null) {
                    obj.param = param;
                }
                returnObject.configObject[obj.id]= obj;
                returnObject.configList[returnObject.configList.length] = obj;
                continue;
            }
        }
        returnObject.configObject[obj.id]= obj;
        returnObject.configList[returnObject.configList.length] = obj;
    }
    var i;
    for (i = 0; i < returnObject.configList.length; i++) {
        obj = returnObject.configList[i];
        obj.hiddenPluginId = Procedure.imw_utils.escapeHTML(obj.id);
        obj.hiddenPluginName = Procedure.imw_utils.escapeHTML(obj.name);
    }
    return returnObject;
}

//=============================================================================
// key&ValueIuWFNgϊ֐
//   y  znode: XMLm[h(e4x)̃IuWFNgz
//   y ԋp zkey&valueIuWFNg
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zw肳ꂽparameternode
//             keyvpeBƂA
//             valuelƂIuWFNg𐶐ԋp
//             <parameter key="key" value="value">  Object["key"]=["value"]
//=============================================================================
function getParameterObject(node) {
    if(node.length() < 1) {
        return null;
    }
    var paramObject = new Object();
    for(var param in node) {
        var key = node[param].@key.toString();
        if(key != null && key != "") {
            paramObject[key] = node[param].@value.toString();
        }
    }
    return paramObject;
}

//=============================================================================
// AvP[Vʃ}X^
//  y  zresult: ʃIuWFNg
//            extensionPointId: g|CgID
//            loginGroupId: OCO[vID
//            localeId: P[ID
//            isAdmin: ǗҌntO
//            excludeObjs: Op[^IuWFNg
//                         (NodeAttributeCooperationDataInfo or String) ̔z
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zʃIuWFNgɃAvP[Vʃ}X^̕\ɕKv
//            ݒ肵܂B
//=============================================================================
function initAppCommonMaster(result, extensionPointId, loginGroupId, localeId, isAdmin, excludeObjs) {
    var excludeIdObj = null;
    var i, leng;
    if (!isAdmin && isArray(excludeObjs)) {
        var codeUtil = new WorkflowCodeUtil();
        var attrType = codeUtil.getEnumCodeAttributeType("attrTyp_pluginParameterDisable");
        excludeIdObj = new Object();
        for (leng = excludeObjs.length, i = 0; i < leng; i++) {
            if (isString(excludeObjs[i])) {
                excludeIdObj[excludeObjs[i]] = true;
            } else if (isObject(excludeObjs[i]) && excludeObjs[i].attributeType == attrType) {
                excludeIdObj[excludeObjs[i].value] = true;
            }
        }
    }
    var pluginConfigObject = Procedure.imw_plugin_utils.getPluginConfigPageInfo(
        extensionPointId, localeId, loginGroupId, !!isAdmin, excludeIdObj);
    result.imwAppCommonPluginConfigObject = pluginConfigObject;
    result.imwAppCommonPluginObject = ImJson.toJSONString(pluginConfigObject.configObject);
    result.imwAppCommonPluginList = pluginConfigObject.configList;
    result.imwAppCommonPluginListCount = pluginConfigObject.configList.length;
    result.imwAppCommonExtensionPointId = extensionPointId;
    result.imwAppCommonTargetDate = Format.fromDate("yyyy/MM/dd", new Date());
    result.imwAppCommonTargetSearchWidth = 300;
    result.imwAppCommonTargetSearchHeight = pluginConfigObject.configList.length * 26 + 3;
    result.imwAppCommonLoginGroupId = loginGroupId;
    result.imwAppCommonLocaleId = localeId;
}

//=============================================================================
//m[h-vOCݒʏ擾֐
//y  zextensionPointId: g|CgID
//          nodeTypeIds     : m[hIDL[ƂIuWFNg
//          localeId        : P[ID
//          loginGroupId    : OCO[vID
//y ԋp zw肵g|Cg̏vOCݒʏ
//y쐬ҁzNTT DATA INTRAMART
//y Tv zw肵g|Cg̏vOCݒʏQ擾܂B
//=============================================================================
function getProcessPluginConfigPageInfo(extensionPointId, nodeTypeIds, localeId, loginGroupId) {
    // vOC}l[W[𐶐
    var manager = new PluginManager(localeId, loginGroupId);
    // vOCfBXNv^̔z擾
    var descriptors = manager.getPluginDescriptors(extensionPointId);
    // 
    var nodeTypePluginIds = new Object();
    for(var i = 0; i < nodeTypeIds.length; i++) {
        nodeTypePluginIds[nodeTypeIds[i].id] = new Object();
    }
    var param = new Object();
    var plugins = new Object();
    // vOCfBXNv^̔z񂩂vf𒊏o
    for( var index in descriptors){
        var descriptor = descriptors[index];
        var obj = new Object();
        obj.id = descriptor.getId();
        obj.name = descriptor.getName();
        var xmlString = descriptor.getXmlString();
        if(!isBlank(xmlString)){
            var xml = new XML(xmlString);
            param = new Object();
            // vOCwm[hʎ擾
            var targetTypes = null;
            var nodeType = xml.targetNode.node.@nodeType;
            var length = nodeType.length();
            if( length > 0) {
                targetTypes = new Object();
                for(var i = 0; i < length; i++) {
                    var nodeTypeId = nodeType[i].toString();
                    targetTypes[nodeTypeId] = nodeTypeId;
                }
            }
            // v[e[Vt[[N̏ꍇ
            var script = xml.configPage.script;
            if(script.length() > 0) {
                var pagePath = script[0].@pagePath;
                if(pagePath.length() > 0) {
                    obj.path = Procedure.imw_proc_utils.getFormActionScript(pagePath.toString());
                    obj.width = script[0].@width.toString();
                    obj.height = script[0].@height.toString();
                    param = getParameterObject(script[0].parameter);
                    if(param != null) {
                        obj.param = param;
                    }
                    plugins[obj.id] = obj;
                    nodeTypePluginIds = setNodeTypePluginObject(nodeTypePluginIds, nodeTypeIds, obj.id, targetTypes);
                    continue;
                }
            }
            // JavaEEt[[N̏ꍇ
            var javaeeList = xml.configPage.javaee;
            if(javaeeList.length() > 0) {
                var javaee = javaeeList[0];
                var applicationId = javaee.@applicationId;
                var serviceId = javaee.@serviceId;
                if(applicationId.length() > 0 && serviceId.length() > 0) {
                    obj.path = Procedure.imw_proc_utils.getFormActionJavaEE(applicationId, serviceId);
                    obj.width = javaee.@width.toString();
                    obj.height = javaee.@height.toString();
                    param = getParameterObject(javaee.parameter);
                    if(param != null) {
                        obj.param = param;
                    }
                    plugins[obj.id] = obj;
                    nodeTypePluginIds = setNodeTypePluginObject(nodeTypePluginIds, nodeTypeIds, obj.id, targetTypes);
                    continue;
                }
            }
            // LȊȌꍇ
            var urlList = xml.configPage.url;
            if(urlList.length() > 0) {
                var path = urlList[0].@path;
                if(path.length() > 0) {
                    obj.path = Procedure.imw_proc_utils.getFormActionJspOrServlet(path.toString());
                    obj.width = urlList[0].@width.toString();
                    obj.height = urlList[0].@height.toString();
                    param = getParameterObject(urlList[0].parameter);
                    if(param != null) {
                        obj.param = param;
                    }
                    plugins[obj.id] = obj;
                    nodeTypePluginIds = setNodeTypePluginObject(nodeTypePluginIds, nodeTypeIds, obj.id, targetTypes);
                    continue;
                }
            }
            plugins[obj.id] = obj;
            nodeTypePluginIds = setNodeTypePluginObject(nodeTypePluginIds, nodeTypeIds, obj.id, targetTypes);
        }
    }
    var returnObject = new Object();
    returnObject.plugins = plugins;
    returnObject.nodeTypePluginIds = nodeTypePluginIds;
    return returnObject;
}

//=============================================================================
//m[hIDL[ƂvOCIuWFNgϊ֐
//y  zreturnObject    : m[hIDʃvOC
//          nodeTypeIds     : g|Cg̃m[hʃIuWFNg̔z
//          pluginObject    : vOC 
//          targetNodeTypes : m[hIDL[ƂIuWFNg(g|Cgwm[h)
//y ԋp zm[hIDʃvOC
//y쐬ҁzNTT DATA INTRAMART
//y Tv zvOC̎wm[hʂɃvOCi[Aԋp܂B
//    { nodeTypeId : {pluginId : pluginId}}
//=============================================================================
function setNodeTypePluginObject(returnObject, nodeTypeIds, pluginId, targetNodeTypes) {
    var key = "";
    var nodeTypeLength = nodeTypeIds.length;
    // g|CgƃvOCꂼɃm[hʂw肳ĂȂꍇ
    if(nodeTypeLength < 1 && isNull(targetNodeTypes)){
        var nodeTypePlugins = returnObject[key];
        if(isBlank(nodeTypePlugins)) {
            nodeTypePlugins = new Object();
        }
        nodeTypePlugins[pluginId] =  pluginId;
        returnObject[key] = nodeTypePlugins;
        return returnObject;
    }
    // g|Cg̃m[hʂݒ肳ĂȂꍇ
    if(nodeTypeLength < 1){
        return returnObject;
    }
    // vOC̃m[hʂw肳ĂȂꍇ
    if(isNull(targetNodeTypes) || targetNodeTypes == {}){
        // m[hʂƂɃvOCݒݒ
        for(var i = 0; i < nodeTypeLength; i++) {
            key = nodeTypeIds[i].id;
            // vOCwm[hʂvOCIuWFNg擾
            var nodeTypePlugins = returnObject[key];
            nodeTypePlugins[pluginId] = pluginId;
            returnObject[key] = nodeTypePlugins;
        }
        return returnObject;
    }
    // m[hʂƂɃvOCݒݒ
    for(var i = 0; i < nodeTypeLength; i++) {
        key = nodeTypeIds[i].id;
        // g|Cgwm[hʈȊO͖
        if(isUndefined(targetNodeTypes[key])) {
            continue;
        }
        // vOCwm[hʂvOCIuWFNg擾
        var nodeTypePlugins = returnObject[key];
        nodeTypePlugins[pluginId] = pluginId;
        returnObject[key] = nodeTypePlugins;
    }
    return returnObject;
}
