Procedure.define("imw_tag_param_utils", new imwTagParamUtils());

// =============================================================================
// ֐`
// y  z
// yԋplz
// y쐬ҁzNTT DATA INTRAMART
// y XV z
// y Tv zProcedure̓o^
// =============================================================================
function imwTagParamUtils() {
    this.tagParamCheckApply = tagParamCheckApply;
    this.tagParamCheckTemporarySave = tagParamCheckTemporarySave;
    this.tagParamCheckApprove = tagParamCheckApprove;
    this.tagParamCheckReapply = tagParamCheckReapply;
    this.tagParamCheckUnapply = tagParamCheckUnapply;
    this.tagParamCheckConfirm = tagParamCheckConfirm;
}

// LoggerName
var LOGGER_NAME = "imw_tag_param_utils";
// p[^`
var PARAM_NAME_IMW_SYSTEM_MATTER_ID = "imwSystemMatterId";
var PARAM_NAME_IMW_USER_DATA_ID = "imwUserDataId";
var PARAM_NAME_IMW_NODE_ID = "imwNodeId";
var PARAM_NAME_IMW_APPLY_BASE_DATE = "imwApplyBaseDate";
var PARAM_NAME_IMW_FLOW_ID = "imwFlowId";
var PARAM_NAME_IMW_PAGE_TYPE = "imwPageType";

//=============================================================================
// \ʃ^O`FbN
//  y  ztagParam: ^Op[^IuWFNg
//            imwAuthUserCode      :CD
//            imwSystemMatterId    :VXeČID
//            imwUserDataId        :[Uf[^ID
//            imwNodeId            :m[hID
//            imwApplyBaseDate     :\
//            imwFlowId            :t[ID
//            imwSerialProcParams  :Ap[^
//            imwCallOriginalParams:ďop[^
//            imwNextScriptPath    :ɑJڂʂ̃XNvgpX
//            imwNextApplicationId :ɑJڂʂ̃AvP[VID
//            imwNextServiceId     :ɑJڂʂ̃T[rXID
//            imwNextPagePath      :ɑJڂʂ̃y[WpX
//            imwPageType          :ʎ
//  y ԋp zʃtO(true/falseُ)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z\ʕ\̂߂ɕKvȃp[^̃`FbNs܂B
//            p[^sꍇALoggerIuWFNg𗘗pA
//            errorxŃOo͂܂B
//=============================================================================
function tagParamCheckApply(tagParam) {
    // `FbNΏی
    var checkTargets = new Array();
    checkTargets.push(PARAM_NAME_IMW_APPLY_BASE_DATE);
    checkTargets.push(PARAM_NAME_IMW_FLOW_ID);
    checkTargets.push(PARAM_NAME_IMW_PAGE_TYPE);
    // `FbNs
    var resultFlag = doCheck(tagParam, checkTargets);
    return resultFlag;
}

//=============================================================================
// ꎞۑʃ^O`FbN
//  y  ztagParam: ^Op[^IuWFNg
//            imwAuthUserCode      :CD
//            imwSystemMatterId    :VXeČID
//            imwUserDataId        :[Uf[^ID
//            imwNodeId            :m[hID
//            imwApplyBaseDate     :\
//            imwFlowId            :t[ID
//            imwSerialProcParams  :Ap[^
//            imwCallOriginalParams:ďop[^
//            imwNextScriptPath    :ɑJڂʂ̃XNvgpX
//            imwNextApplicationId :ɑJڂʂ̃AvP[VID
//            imwNextServiceId     :ɑJڂʂ̃T[rXID
//            imwNextPagePath      :ɑJڂʂ̃y[WpX
//            imwPageType          :ʎ
//  y ԋp zʃtO(true/falseُ)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zꎞۑʕ\̂߂ɕKvȃp[^̃`FbNs܂B
//            p[^sꍇALoggerIuWFNg𗘗pA
//            errorxŃOo͂܂B
//=============================================================================
function tagParamCheckTemporarySave(tagParam) {
    // `FbNΏی
    var checkTargets = new Array();
    checkTargets.push(PARAM_NAME_IMW_USER_DATA_ID);
    checkTargets.push(PARAM_NAME_IMW_APPLY_BASE_DATE);
    checkTargets.push(PARAM_NAME_IMW_FLOW_ID);
    checkTargets.push(PARAM_NAME_IMW_PAGE_TYPE);
    // `FbNs
    var resultFlag = doCheck(tagParam, checkTargets);
    return resultFlag;
}

//=============================================================================
// ʃ^O`FbN
//  y  ztagParam: ^Op[^IuWFNg
//            imwAuthUserCode      :CD
//            imwSystemMatterId    :VXeČID
//            imwUserDataId        :[Uf[^ID
//            imwNodeId            :m[hID
//            imwApplyBaseDate     :\
//            imwFlowId            :t[ID
//            imwSerialProcParams  :Ap[^
//            imwCallOriginalParams:ďop[^
//            imwNextScriptPath    :ɑJڂʂ̃XNvgpX
//            imwNextApplicationId :ɑJڂʂ̃AvP[VID
//            imwNextServiceId     :ɑJڂʂ̃T[rXID
//            imwNextPagePath      :ɑJڂʂ̃y[WpX
//            imwPageType          :ʎ
//  y ԋp zʃtO(true/falseُ)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zʕ\̂߂ɕKvȃp[^̃`FbNs܂B
//            p[^sꍇALoggerIuWFNg𗘗pA
//            errorxŃOo͂܂B
//=============================================================================
function tagParamCheckApprove(tagParam) {
    // `FbNΏی
    var checkTargets = new Array();
    checkTargets.push(PARAM_NAME_IMW_SYSTEM_MATTER_ID);
    checkTargets.push(PARAM_NAME_IMW_NODE_ID);
    checkTargets.push(PARAM_NAME_IMW_PAGE_TYPE);
    // `FbNs
    var resultFlag = doCheck(tagParam, checkTargets);
    return resultFlag;
}

//=============================================================================
// Đ\ʃ^O`FbN
//  y  ztagParam: ^Op[^IuWFNg
//            imwAuthUserCode      :CD
//            imwSystemMatterId    :VXeČID
//            imwUserDataId        :[Uf[^ID
//            imwNodeId            :m[hID
//            imwApplyBaseDate     :\
//            imwFlowId            :t[ID
//            imwSerialProcParams  :Ap[^
//            imwCallOriginalParams:ďop[^
//            imwNextScriptPath    :ɑJڂʂ̃XNvgpX
//            imwNextApplicationId :ɑJڂʂ̃AvP[VID
//            imwNextServiceId     :ɑJڂʂ̃T[rXID
//            imwNextPagePath      :ɑJڂʂ̃y[WpX
//            imwPageType          :ʎ
//  y ԋp zʃtO(true/falseُ)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zĐ\ʕ\̂߂ɕKvȃp[^̃`FbNs܂B
//            p[^sꍇALoggerIuWFNg𗘗pA
//            errorxŃOo͂܂B
//=============================================================================
function tagParamCheckReapply(tagParam) {
    // `FbNΏی
    var checkTargets = new Array();
    checkTargets.push(PARAM_NAME_IMW_SYSTEM_MATTER_ID);
    checkTargets.push(PARAM_NAME_IMW_NODE_ID);
    checkTargets.push(PARAM_NAME_IMW_PAGE_TYPE);
    // `FbNs
    var resultFlag = doCheck(tagParam, checkTargets);
    return resultFlag;
}

//=============================================================================
// N[̐\ʃ^O`FbN
//  y  ztagParam: ^Op[^IuWFNg
//            imwAuthUserCode      :CD
//            imwSystemMatterId    :VXeČID
//            imwUserDataId        :[Uf[^ID
//            imwNodeId            :m[hID
//            imwApplyBaseDate     :\
//            imwFlowId            :t[ID
//            imwSerialProcParams  :Ap[^
//            imwCallOriginalParams:ďop[^
//            imwNextScriptPath    :ɑJڂʂ̃XNvgpX
//            imwNextApplicationId :ɑJڂʂ̃AvP[VID
//            imwNextServiceId     :ɑJڂʂ̃T[rXID
//            imwNextPagePath      :ɑJڂʂ̃y[WpX
//            imwPageType          :ʎ
//  y ԋp zʃtO(true/falseُ)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zN[̐\ʕ\̂߂ɕKvȃp[^̃`FbNs܂B
//            p[^sꍇALoggerIuWFNg𗘗pA
//            errorxŃOo͂܂B
//=============================================================================
function tagParamCheckUnapply(tagParam) {
    // `FbNΏی
    var checkTargets = new Array();
    checkTargets.push(PARAM_NAME_IMW_SYSTEM_MATTER_ID);
    checkTargets.push(PARAM_NAME_IMW_NODE_ID);
    checkTargets.push(PARAM_NAME_IMW_PAGE_TYPE);
    // `FbNs
    var resultFlag = doCheck(tagParam, checkTargets);
    return resultFlag;
}

//=============================================================================
// mFʃ^O`FbN
//  y  ztagParam: ^Op[^IuWFNg
//            imwAuthUserCode      :CD
//            imwSystemMatterId    :VXeČID
//            imwUserDataId        :[Uf[^ID
//            imwNodeId            :m[hID
//            imwApplyBaseDate     :\
//            imwFlowId            :t[ID
//            imwSerialProcParams  :Ap[^
//            imwCallOriginalParams:ďop[^
//            imwNextScriptPath    :ɑJڂʂ̃XNvgpX
//            imwNextApplicationId :ɑJڂʂ̃AvP[VID
//            imwNextServiceId     :ɑJڂʂ̃T[rXID
//            imwNextPagePath      :ɑJڂʂ̃y[WpX
//            imwPageType          :ʎ
//  y ԋp zʃtO(true/falseُ)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zmFʕ\̂߂ɕKvȃp[^̃`FbNs܂B
//            p[^sꍇALoggerIuWFNg𗘗pA
//            errorxŃOo͂܂B
//=============================================================================
function tagParamCheckConfirm(tagParam) {
    // `FbNΏی
    var checkTargets = new Array();
    checkTargets.push(PARAM_NAME_IMW_SYSTEM_MATTER_ID);
    checkTargets.push(PARAM_NAME_IMW_NODE_ID);
    checkTargets.push(PARAM_NAME_IMW_PAGE_TYPE);
    // `FbNs
    var resultFlag = doCheck(tagParam, checkTargets);
    return resultFlag;
}

//=============================================================================
// `FbN
//  y  ztagParam: ^Op[^IuWFNg
//            checkTargets: `FbNΏۃp[^z
//  y ԋp zʃtO(true/falseُ)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zw肳ꂽp[^̃`FbNs܂B
//            p[^sꍇALoggerIuWFNg𗘗pA
//            errorxŃOo͂܂B
//=============================================================================
function doCheck(tagParam, checkTargets) {
    var cnt;
    var len = checkTargets.length;
    var resultFlag = true;
    var logger = Logger.getLogger(LOGGER_NAME);
    for (cnt=0; cnt<len; cnt++) {
        if (isBlank(tagParam[checkTargets[cnt]])) {
            // Oo
            resultFlag = false;
            logger.error(MessageManager.getMessage(
                    "IMW.CLI.WRN.3630",
                    checkTargets[cnt], tagParam[checkTargets[cnt]]));
        }
    }
    return resultFlag;
}
