Procedure.define("imw_user_list_utils", new imwUserListUtils());

// =============================================================================
// ֐`
// y  z
// yԋplz
// y쐬ҁzNTT DATA INTRAMART
// y XV z
// y Tv zProcedure̓o^
// =============================================================================
function imwUserListUtils() {
    this.createListMasterFlowLink = createListMasterFlowLink;
    this.createListDetailLink = createListDetailLink;
    this.createListFlowLink = createListFlowLink;
    this.createListHistoryLink = createListHistoryLink;
    this.createListApplyLink = createListApplyLink;
    this.createListProcessLink = createListProcessLink;
    this.createListTransferLink = createListTransferLink;
    this.createListPullbackLink = createListPullbackLink;
    this.createListHandleLink = createListHandleLink;
    this.createListConfirmLink = createListConfirmLink;
    this.createListMatterDeleteLink = createListMatterDeleteLink;
    this.createListTemporaryDelete = createListTemporaryDelete;
    this.createListChangeBaseDate = createListChangeBaseDate;
    this.setOrderCondition = setOrderCondition;
    this.setListPatternHeader = setListPatternHeader;
    this.getListDisplayPattern = getListDisplayPattern;
    this.getUserName = getUserName;
    this.getListColumnObject = getListColumnObject;
    this.setListColumnAttribute = setListColumnAttribute;
    this.defaultListColumnObjectPriority = defaultListColumnObjectPriority;
    this.defaultListColumnObjectStatus = defaultListColumnObjectStatus;
    this.defaultListColumnObjectEndStatus = defaultListColumnObjectEndStatus;
    this.defaultListColumnObjectProcessAuth = defaultListColumnObjectProcessAuth;
    this.getMatterPropertyCodes = getMatterPropertyCodes;
    this.setMatterPropertyConditionObject = setMatterPropertyConditionObject;
    this.setMatterPropertyColumnObject = setMatterPropertyColumnObject;
    this.defaultSearchColumnValidate = defaultSearchColumnValidate;
    this.getSearchColumnObject = getSearchColumnObject;
    this.defaultSearchColumnObject = defaultSearchColumnObject;
    this.setMatterPropertySearchObject = setMatterPropertySearchObject;
    this.addSearchColumnObject = addSearchColumnObject;
    this.updateUserListPattern = updateUserListPattern;
}

//=============================================================================
// ꗗEt[N쐬֐
//  y  zflowId: t[ID
//            baseDate: 
//            methodName: \bh (ȗ)
//  y ԋp zN
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zt[ʂ\邽߂̃XNvgtA^O𐶐܂B
//=============================================================================
function createListMasterFlowLink(flowId, baseDate, methodName) {
    if (isBlank(methodName)) {
        methodName = "onClickFlow";
    }
    var linkValue = "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(flowId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(baseDate) + "'>" +
            "<a href=\"javascript: void(0);\" onclick=\"" +
            "var _p1=getPreviousElement(this), _p2=getPreviousElement(_p1); " +
            methodName + "(_p2.value, _p1.value); return false;\">" +
            "<img src=\"images/icons/16x16/fugue-icons/shadow/image.png\" border=\"0\"></a>";
    return linkValue;
}

//=============================================================================
// ꗗEڍ׃N쐬֐
//  y  zsystemMatterId: VXeČID
//            userDataId: [Uf[^ID
//  y ԋp zN
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zڍ׉ʂ\邽߂̃XNvgtA^O𐶐܂B
//=============================================================================
function createListDetailLink(systemMatterId, userDataId) {
    var linkValue = "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(systemMatterId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(userDataId) + "'>" +
            "<a href=\"javascript: void(0);\" onclick=\"" +
            "var _p1=getPreviousElement(this), _p2=getPreviousElement(_p1); " +
            "onClickDetail(_p2.value, _p1.value); return false;\">" +
            "<img src=\"images/icons/16x16/fugue-icons/shadow/clipboard-text.png\" border=\"0\"></a>";
    return linkValue;
}

//=============================================================================
// ꗗEt[N쐬֐
//  y  zsystemMatterId: VXeČID
//  y ԋp zN
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zt[ʂ\邽߂̃XNvgtA^O𐶐܂B
//=============================================================================
function createListFlowLink(systemMatterId) {
    var linkValue = "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(systemMatterId) + "'>" +
            "<a href=\"javascript: void(0);\" onclick=\"" +
            "var _p1=getPreviousElement(this); " +
            "onClickFlow(_p1.value); return false;\">" +
            "<img src=\"images/icons/16x16/fugue-icons/shadow/image.png\" border=\"0\"></a>";
    return linkValue;
}

//=============================================================================
// ꗗEN쐬֐
//  y  zsystemMatterId: VXeČID
//  y ԋp zN
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zʂ\邽߂̃XNvgtA^O𐶐܂B
//=============================================================================
function createListHistoryLink(systemMatterId) {
    var linkValue = "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(systemMatterId) + "'>" +
            "<a href=\"javascript: void(0);\" onclick=\"" +
            "var _p1=getPreviousElement(this); " +
            "onClickHistory(_p1.value); return false;\">" +
            "<img src=\"images/icons/16x16/fugue-icons/shadow/ui-menu-blue.png\" border=\"0\"></a>";
    return linkValue;
}

//=============================================================================
// ꗗE\N쐬֐
//  y  zflowId: t[ID
//            nodeId: m[hID
//            userDataId: [Uf[^ID (ꎞۑ̏ꍇAK{)
//            actUserId: 㗝[UCD (ꎞۑ̏ꍇAK{)
//            applyBaseDate: \ (ꎞۑ̏ꍇAK{)
//  y ԋp zN
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z\/ꎞۑʂ\邽߂̃XNvgtA^O𐶐܂B
//=============================================================================
function createListApplyLink(flowId, nodeId, userDataId, actUserId, applyBaseDate) {
    var linkValue = "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(flowId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(nodeId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(userDataId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(actUserId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(applyBaseDate) + "'>" +
            "<a href=\"javascript: void(0);\" onclick=\"" +
            "var _p1=getPreviousElement(this), _p2=getPreviousElement(_p1), _p3=getPreviousElement(_p2), _p4=getPreviousElement(_p3), _p5=getPreviousElement(_p4); " +
            "onClickApply(_p5.value, _p4.value, _p3.value, _p2.value, _p1.value); return false;\">" +
            "<img src=\"images/icons/16x16/fugue-icons/shadow/clipboard-sign.png\" border=\"0\"></a>";
    return linkValue;
}

//=============================================================================
// ꗗEN쐬֐
//  y  zsystemMatterId: VXeČID
//            userDataId: [Uf[^ID
//            nodeId: m[hID
//            pageType: ʎ
//  y ԋp zN
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zʂ\邽߂̃XNvgtA^O𐶐܂B
//=============================================================================
function createListProcessLink(systemMatterId, userDataId, nodeId, pageType) {
    var linkValue = "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(systemMatterId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(userDataId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(nodeId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(pageType) + "'>" +
            "<a href=\"javascript: void(0);\" onclick=\"" +
            "var _p1=getPreviousElement(this), _p2=getPreviousElement(_p1), _p3=getPreviousElement(_p2), _p4=getPreviousElement(_p3); " +
            "onClickProcess(_p4.value, _p3.value, _p2.value, _p1.value); return false;\">" +
            "<img src=\"images/icons/16x16/fugue-icons/shadow/clipboard-sign.png\" border=\"0\"></a>";
    return linkValue;
}

//=============================================================================
// ꗗEUփN쐬֐
//  y  zsystemMatterId: VXeČID
//            nodeId: m[hID
//  y ԋp zN
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zU։ʂ\邽߂̃XNvgtA^O𐶐܂B
//=============================================================================
function createListTransferLink(systemMatterId, nodeId) {
    var linkValue = "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(systemMatterId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(nodeId) + "'>" +
            "<a href=\"javascript: void(0);\" onclick=\"" +
            "var _p1=getPreviousElement(this), _p2=getPreviousElement(_p1); " +
            "onClickTransfer(_p2.value, _p1.value); return false;\">" +
            "<img src=\"images/icons/16x16/fugue-icons/shadow/property-export.png\" border=\"0\"></a>";
    return linkValue;
}

//=============================================================================
// ꗗE߃N쐬֐
//  y  zsystemMatterId: VXeČID
//            userDataId: [Uf[^ID
//            flowId: t[ID
//            applyBaseDate: \
//  y ԋp zN
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z߂ʂ\邽߂̃XNvgtA^O𐶐܂B
//=============================================================================
function createListPullbackLink(systemMatterId, userDataId, flowId, applyBaseDate) {
    var linkValue = "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(systemMatterId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(userDataId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(flowId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(applyBaseDate) + "'>" +
            "<a href=\"javascript: void(0);\" onclick=\"" +
            "var _p1=getPreviousElement(this), _p2=getPreviousElement(_p1), _p3=getPreviousElement(_p2), _p4=getPreviousElement(_p3); " +
            "onClickPullback(_p4.value, _p3.value, _p2.value, _p1.value); return false;\">" +
            "<img src=\"images/icons/16x16/fugue-icons/shadow/clipboard-sign-out.png\" border=\"0\"></a>";
    return linkValue;
}

//=============================================================================
// ꗗE샊N쐬֐
//  y  zsystemMatterId: VXeČID
//            userDataId: [Uf[^ID
//  y ԋp zN
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČʂ\邽߂̃XNvgtA^O𐶐܂B
//=============================================================================
function createListHandleLink(systemMatterId, userDataId) {
    var linkValue = "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(systemMatterId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(userDataId) + "'>" +
            "<a href=\"javascript: void(0);\" onclick=\"" +
            "var _p1=getPreviousElement(this), _p2=getPreviousElement(_p1); " +
            "onClickHandle(_p2.value, _p1.value); return false;\">" +
            "<img src=\"images/icons/16x16/fugue-icons/shadow/clipboard-sign.png\" border=\"0\"></a>";
    return linkValue;
}

//=============================================================================
// ꗗEmFN쐬֐
//  y  zsystemMatterId: VXeČID
//            userDataId: [Uf[^ID
//            nodeId: m[hID
//  y ԋp zN
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zmFʂ\邽߂̃XNvgtA^O𐶐܂B
//=============================================================================
function createListConfirmLink(systemMatterId, userDataId, nodeId) {
    var linkValue = "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(systemMatterId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(userDataId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(nodeId) + "'>" +
            "<a href=\"javascript: void(0);\" onclick=\"" +
            "var _p1=getPreviousElement(this), _p2=getPreviousElement(_p1), _p3=getPreviousElement(_p2); " +
            "onClickConfirm(_p3.value, _p2.value, _p1.value); return false;\">" +
            "<img src=\"images/icons/16x16/fugue-icons/shadow/clipboard-sign.png\" border=\"0\"></a>";
    return linkValue;
}

//=============================================================================
// ꗗE폜N쐬֐
//  y  zsystemMatterId: VXeČID
//            flowId: t[ID
//  y ԋp zN
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ폜邽߂̃XNvgtA^O𐶐܂B
//=============================================================================
function createListMatterDeleteLink(systemMatterId, flowId) {
    var linkValue = "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(systemMatterId) + "'>" +
            "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(flowId) + "'>" +
            "<a href=\"javascript: void(0);\" onclick=\"" +
            "var _p1=getPreviousElement(this), _p2=getPreviousElement(_p1); " +
            "onClickDelete(_p2.value, _p1.value); return false;\">" +
            "<img src=\"images/icons/16x16/deletecell.png\" border=\"0\"></a>";
    return linkValue;
}

//=============================================================================
// ꗗEꎞۑ폜N쐬֐
//  y  zuserDataId: [Uf[^ID
//  y ԋp zN
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zꎞۑ폜邽߂̃XNvgtA^O𐶐܂B
//=============================================================================
function createListTemporaryDelete(userDataId) {
    var linkValue = "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(userDataId) + "'>" +
            "<a href=\"javascript: void(0);\" onclick=\"" +
            "var _p1=getPreviousElement(this); " +
            "onClickTemporaryDelete(_p1.value); return false;\">" +
            "<img src=\"images/icons/16x16/deletecell.png\" border=\"0\"></a>";
    return linkValue;
}

//=============================================================================
//ꗗEꎞۑ\ύXN쐬֐
//y  zflowId: t[ID
//          nodeId: m[hID
//          userDataId:[Uf[^ID
//          authUserCode:҃R[h
//          baseDate:
//y ԋp zN
//y쐬ҁzNTT DATA INTRAMART
//y Tv zꎞۑ̐\ύX邽߂̃XNvgtA^O𐶐܂B
//=============================================================================
function createListChangeBaseDate(flowId, nodeId, userDataId, authUserCode, baseDate) {
 var linkValue = "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(flowId) + "'>" +
         "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(nodeId) + "'>" +
         "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(userDataId) + "'>" +
         "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(authUserCode) + "'>" +
         "<input type='hidden' value='" + Procedure.imw_utils.escapeHTML(baseDate) + "'>" +
         "<a href=\"javascript: void(0);\" onclick=\"" +
         "var _p1=getPreviousElement(this), _p2=getPreviousElement(_p1), _p3=getPreviousElement(_p2), _p4=getPreviousElement(_p3), _p5=getPreviousElement(_p4); " +
         "onClickChangeBaseDate(_p5.value, _p4.value, _p3.value, _p2.value, _p1.value); return false;\">" +
         "<img src=\"images/icons/16x16/fugue-icons/shadow/clipboard-sign.png\" border=\"0\">&nbsp;" +
         Procedure.imw_utils.escapeHTML(baseDate) + "</a>";
 return linkValue;
}

//=============================================================================
// pҌnꗗʃ\[gݒ菈
//  y  zlistSearchCondition : f (I/O)
//            orderByList         : \[g
//            listPageType        : ꗗʎ
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zꗗ\p^[A͉ʏőIꂽڂ\[gƂ
//            fɐݒ肵܂B
//=============================================================================
function setOrderCondition(listSearchCondition, orderByList, listPageType) {
    var codeUtil = new WorkflowCodeUtil();
    var i;
    var columnObject = new Object();
    var uniqueOrderByColumn = UnprocessActvMatterNodeList.SYSTEM_MATTER_ID;

    // ftHgl̐ݒ
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FlowName")] = UnprocessActvMatterNodeList.FLOW_NAME; // t[
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FlowVersionNote")] = ApplyFlowList.FLOW_VERSION_NOTE; // lit[o[Wj
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ArriveDate")] = UnprocessActvMatterNodeList.START_DATE; // B
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_Priority")] = UnprocessActvMatterNodeList.PRIORITY_LEVEL; // Dx
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterName")] = UnprocessActvMatterNodeList.MATTER_NAME; // Č
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterNumber")] = UnprocessActvMatterNodeList.MATTER_NUMBER; // Čԍ
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyUser")] = UnprocessActvMatterNodeList.APPLY_AUTH_USER_NAME ; // \
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyDate")] = UnprocessActvMatterNodeList.APPLY_DATE; // \
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_BaseDate")] = UnprocessActvMatterNodeList.APPLY_BASE_DATE; // \
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_NodeName")] = UnprocessActvMatterNodeList.NODE_NAME; // m[h
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_Status")] = UnprocessActvMatterNodeList.STATUS; // 
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ProcLimit")] = UnprocessActvMatterNodeList.AUTO_PROCESS_LIMIT_DATE; // 
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FinalProcDate")] = ProcessedActvMatterList.LAST_PROCESS_DATE; // ŏI
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_EndDate")] = ProcessedCplMatterList.MATTER_CPL_DATE; // ČI
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_EndStatus")] = ProcessedCplMatterList.STATUS; // 
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_TemporarySaveComment")] = TempSaveMatterList.PROCESS_COMMENT; // ꎞۑ̃Rg
    columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ConfirmStatus")] = CnfmActvMatterList.CONFIRM_CPL_FLAG; // mF

    // \ꗗ
    if (listPageType == codeUtil.getEnumCodeListPageType("listPageType_ApplyList")) {
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FlowName")] = ApplyFlowList.FLOW_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FlowVersionNote")] = ApplyFlowList.FLOW_VERSION_NOTE;
        uniqueOrderByColumn = ApplyFlowList.FLOW_ID;

    // ꎞۑꗗ
    } else if (listPageType == codeUtil.getEnumCodeListPageType("listPageType_TempSaveList")) {
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FlowName")] = TempSaveMatterList.FLOW_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyUser")] = TempSaveMatterList.AUTH_USER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_BaseDate")] = TempSaveMatterList.APPLY_BASE_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterName")] = TempSaveMatterList.MATTER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_TemporarySaveComment")] = TempSaveMatterList.PROCESS_COMMENT;
        uniqueOrderByColumn = TempSaveMatterList.USER_DATA_ID;

    // ꗗ
    } else if (listPageType == codeUtil.getEnumCodeListPageType("listPageType_Proclist")) {
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ArriveDate")] = UnprocessActvMatterNodeList.START_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_Priority")] = UnprocessActvMatterNodeList.PRIORITY_LEVEL;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterName")] = UnprocessActvMatterNodeList.MATTER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterNumber")] = UnprocessActvMatterNodeList.MATTER_NUMBER;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FlowName")] = UnprocessActvMatterNodeList.FLOW_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyUser")] = UnprocessActvMatterNodeList.APPLY_AUTH_USER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyDate")] = UnprocessActvMatterNodeList.APPLY_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_BaseDate")] = UnprocessActvMatterNodeList.APPLY_BASE_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_NodeName")] = UnprocessActvMatterNodeList.NODE_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_Status")] = UnprocessActvMatterNodeList.STATUS;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ProcLimit")] = UnprocessActvMatterNodeList.AUTO_PROCESS_LIMIT_DATE;
        uniqueOrderByColumn = UnprocessActvMatterNodeList.SYSTEM_MATTER_ID;

    // ꗗiČj
    } else if (listPageType == codeUtil.getEnumCodeListPageType("listPageType_CplProcAtvMatterList")) {
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FinalProcDate")] = ProcessedActvMatterList.LAST_PROCESS_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_Priority")] = ProcessedActvMatterList.PRIORITY_LEVEL;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterName")] = ProcessedActvMatterList.MATTER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterNumber")] = ProcessedActvMatterList.MATTER_NUMBER;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FlowName")] = ProcessedActvMatterList.FLOW_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyUser")] = ProcessedActvMatterList.APPLY_AUTH_USER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyDate")] = ProcessedActvMatterList.APPLY_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_BaseDate")] = ProcessedActvMatterList.APPLY_BASE_DATE;
        uniqueOrderByColumn = ProcessedActvMatterList.SYSTEM_MATTER_ID;

    // ꗗiČj
    } else if (listPageType == codeUtil.getEnumCodeListPageType("listPageType_CplProcCplMatterList")) {
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FinalProcDate")] = ProcessedCplMatterList.MATTER_CPL_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_EndDate")] = ProcessedCplMatterList.MATTER_CPL_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_Priority")] = ProcessedCplMatterList.PRIORITY_LEVEL;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterName")] = ProcessedCplMatterList.MATTER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterNumber")] = ProcessedCplMatterList.MATTER_NUMBER;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FlowName")] = ProcessedCplMatterList.FLOW_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyDate")] = ProcessedCplMatterList.APPLY_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_BaseDate")] = ProcessedCplMatterList.APPLY_BASE_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyUser")] = ProcessedCplMatterList.APPLY_AUTH_USER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_EndStatus")] = ProcessedCplMatterList.STATUS;
        uniqueOrderByColumn = ProcessedCplMatterList.SYSTEM_MATTER_ID;

    // ߋČQ
    } else if (listPageType == codeUtil.getEnumCodeListPageType("listPageType_ArchivedMatterList")) {
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_BaseDate")] = ArcMatterList.APPLY_BASE_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyDate")] = ArcMatterList.APPLY_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_EndDate")] = ArcMatterList.MATTER_CPL_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_Priority")] = ArcMatterList.PRIORITY_LEVEL;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterName")] = ArcMatterList.MATTER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterNumber")] = ArcMatterList.MATTER_NUMBER;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FlowName")] = ArcMatterList.FLOW_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_EndStatus")] = ArcMatterList.STATUS;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyUser")] = ArcMatterList.APPLY_AUTH_USER_NAME;
        uniqueOrderByColumn = ArcMatterList.SYSTEM_MATTER_ID;

    // QƈꗗiČj
    } else if (listPageType == codeUtil.getEnumCodeListPageType("listPageType_RefAtvMatterList")) {
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_Priority")] = RefActvMatterList.PRIORITY_LEVEL;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterName")] = RefActvMatterList.MATTER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterNumber")] = RefActvMatterList.MATTER_NUMBER;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FlowName")] = RefActvMatterList.FLOW_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyDate")] = RefActvMatterList.APPLY_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_BaseDate")] = RefActvMatterList.APPLY_BASE_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyUser")] = RefActvMatterList.APPLY_AUTH_USER_NAME;
        uniqueOrderByColumn = RefActvMatterList.SYSTEM_MATTER_ID;

    // QƈꗗiČj
    } else if (listPageType == codeUtil.getEnumCodeListPageType("listPageType_RefCplMatterList")) {
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_EndDate")] = RefCplMatterList.MATTER_CPL_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_Priority")] = RefCplMatterList.PRIORITY_LEVEL;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterName")] = RefCplMatterList.MATTER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterNumber")] = RefCplMatterList.MATTER_NUMBER;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FlowName")] = RefCplMatterList.FLOW_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyDate")] = RefCplMatterList.APPLY_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_BaseDate")] = RefCplMatterList.APPLY_BASE_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyUser")] = RefCplMatterList.APPLY_AUTH_USER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_EndStatus")] = RefCplMatterList.STATUS;
        uniqueOrderByColumn = RefCplMatterList.SYSTEM_MATTER_ID;

    // mFꗗiČj
    } else if (listPageType == codeUtil.getEnumCodeListPageType("listPageType_ConfirmAtvMatterList")) {
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ArriveDate")] = CnfmActvMatterList.ARRIVED_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_Priority")] = CnfmActvMatterList.PRIORITY_LEVEL;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterName")] = CnfmActvMatterList.MATTER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterNumber")] = CnfmActvMatterList.MATTER_NUMBER;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FlowName")] = CnfmActvMatterList.FLOW_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_BaseDate")] = CnfmActvMatterList.APPLY_BASE_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyDate")] = CnfmActvMatterList.APPLY_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyUser")] = CnfmActvMatterList.APPLY_AUTH_USER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ConfirmStatus")] = CnfmActvMatterList.CONFIRM_CPL_FLAG;
        uniqueOrderByColumn = CnfmActvMatterList.SYSTEM_MATTER_ID;

    // mFꗗiČj
    } else if (listPageType == codeUtil.getEnumCodeListPageType("listPageType_ConfirmCplMatterList")) {
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ArriveDate")] = CnfmCplMatterList.ARRIVED_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_EndDate")] = CnfmCplMatterList.MATTER_CPL_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_Priority")] = CnfmCplMatterList.PRIORITY_LEVEL;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterName")] = CnfmCplMatterList.MATTER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_MatterNumber")] = CnfmCplMatterList.MATTER_NUMBER;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_FlowName")] = CnfmCplMatterList.FLOW_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_BaseDate")] = CnfmCplMatterList.APPLY_BASE_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyDate")] = CnfmCplMatterList.APPLY_DATE;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyUser")] = CnfmCplMatterList.APPLY_AUTH_USER_NAME;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_EndStatus")] = CnfmCplMatterList.STATUS;
        columnObject[codeUtil.getEnumCodeListPageColumn("listPageCol_ConfirmStatus")] = CnfmCplMatterList.CONFIRM_CPL_FLAG;
        uniqueOrderByColumn = CnfmCplMatterList.SYSTEM_MATTER_ID;
        
    }

    // ꗗ\ƂĎgpČvpeB擾
    var matterPropertyDataManager = new MatterPropertyDataManager(
            AccessSecurityManager.getSessionInfo().loginGroup);
    var oConditionInfo = new Object();
    oConditionInfo.matterPropertyType = codeUtil.getEnumCodeMatterPropertyType("propertyTyp_List");
    var result = matterPropertyDataManager.getMatterPropertyDataList(oConditionInfo);
    var numberColumnMap = new Object();
    var modelTypeNumber = codeUtil.getEnumCodeModelType("modelTyp_Num");
    if (!isBlank(result.data)) {
        for (var index = 0; index < result.data.length; index++) {
            if (result.data[index].matterPropertyModelType == modelTypeNumber) {
                // l^̈ČvpeB
                numberColumnMap[result.data[index].matterPropertyKey] = true;
            }
        }
    }

    for (i = 0; i < orderByList.length; i++) {
        if (orderByList[i].columnClassify == codeUtil.getEnumCodeColumnType("colTyp_Standard")) {
            listSearchCondition.addOrder(columnObject[orderByList[i].columnName],
            (orderByList[i].sortType == "ASC") ? true : false);
        } else if (orderByList[i].columnClassify == codeUtil.getEnumCodeColumnType("colTyp_MatProperty")) {
            // ČvpeBɑ΂\[ǧ^il/j̓}X^`ɏ]
            listSearchCondition.addOrderByMatterProp(
                orderByList[i].columnName,
                (orderByList[i].sortType=="ASC") ? true : false,
                numberColumnMap[orderByList[i].columnName] ?
                        ListSearchCondition.COL_NUMBER : ListSearchCondition.COL_VARCHAR);
        }
    }

    // Ӑ\[gڂ̍Ōɒǉ
    listSearchCondition.addOrder(uniqueOrderByColumn, true);
}

//=============================================================================
// pҌnꗗʃwb_[ݒ菈
//  y  zheaderObject        : wb_[IuWFNg (I/O)
//            loginGroupId        : OCO[vID
//            localeId            : P[ID
//            listPatternDataInfo : ꗗ\p^[
//            orderByObj          : \[g
//            listPageType        : ꗗʎ
//            exceptList          : OXgiȗjBꗗp^[őIĂ邪A
//                                  ꗗɂ͕\ȂꍇɁAɏǉB
//                                  jexceptList[JID] = "";
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zꗗ\p^[A͉ʏőIꂽڂ\[gƂ
//            fɐݒ肵܂B
//=============================================================================
function setListPatternHeader(headerObject, loginGroupId, localeId, listPatternDataInfo, orderByObj, listPageType, exceptList) {
    var codeUtil = new WorkflowCodeUtil();
    var i;
    var obj;
    var result;
    var caption;
    var condition;

    // J̎擾
    var listPageColumn = new Object();
    var enumCodes;
    result = codeUtil.getListPageColumn();
    if (result.resultFlag) {
        enumCodes = result.data;
        for (i = 0; i < enumCodes.length; i++) {
            listPageColumn[enumCodes[i].code] = enumCodes[i].messageId;
        }
    }

    // ꗗ\p^[`Ǘ}l[W̐
    var listPatternManager = new ListDisplayPatternManager(loginGroupId);
    if (isBlank(listPageType)) {
        result = new Object();
        result.data = new Array();
    } else {
        result = listPatternManager.getColumnDataListWithListPageType(listPageType);
        if (!result.resultFlag) {
            Procedure.imw_error_utils.showErrorAlert(result.resultStatus.messageId, result, "");
        } else if (result.data == null || result.data.length == 0) {
            Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3502", null, "");
        }
    }

    // \[g\ڃnbV̍쐬
    var enabledFlag = codeUtil.getEnumCodeFlagStatus("Enable");
    var sortMap = new Object();
    for (i = 0; i < result.data.length; i++) {
        sortMap[result.data[i].columnId] = result.data[i].sortFlag;
    }

    for (i = 0; i < listPatternDataInfo.length; i++) {
        caption = "";
        condition = true;

        // 펞\ڂ̒ŕ\IĂ̂邩mF
        if (listPatternDataInfo[i].columnClassify ==
                codeUtil.getEnumCodeColumnType("colTyp_Standard")) {
            if (!isBlank(exceptList)) {
                // OXgɃJݒ肳ĂꍇA񂩂珜O
                if (!isUndefined(exceptList[listPatternDataInfo[i].columnId])) {
                    continue;
                }
            }

            // \(ACR)
            if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_Apply")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_Apply"]);
                condition = false;
            // (ACR)
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_Proc")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_Proc"]);
                condition = false;
            // U(ACR)
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_Transfer")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_Transfer"]);
                condition = false;
            // (ACR)
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_PullBack")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_PullBack"]);
                condition = false;
            // (ACR)
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_Handle")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_Handle"]);
                condition = false;
            // mF(ACR)
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_Confirm")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_Confirm"]);
                condition = false;
            // 폜(ACR)
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_MatterDelete")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_MatterDelete"]);
                condition = false;
            // t[(ACR)
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_Flow")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_Flow"]);
                condition = false;
            // (ACR)
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_History")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_History"]);
                condition = false;
            // ڍ(ACR)
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_Detail")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_Detail"]);
                condition = false;
            // t[
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_FlowName")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_FlowName"]);
            // lit[o[Wj
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_FlowVersionNote")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_FlowVersionNote"]);
            // B
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_ArriveDate")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_ArriveDate"]);
            // Dx
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_Priority")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_Priority"]);
            // Č
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_MatterName")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_MatterName"]);
            // Čԍ
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_MatterNumber")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_MatterNumber"]);
            // \
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyUser")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_ApplyUser"]);
            // \
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyDate")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_ApplyDate"]);
            // \
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_BaseDate")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_BaseDate"]);
            // m[h
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_NodeName")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_NodeName"]);
            // 
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_Status")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_Status"]);
            // 
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_ProcLimit")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_ProcLimit"]);
            // 
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_ProcAuth")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_ProcAuth"]);
            // ŏI
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_FinalProcDate")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_FinalProcDate"]);
            // ČI
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_EndDate")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_EndDate"]);
            // 
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_EndStatus")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_EndStatus"]);
            // ꎞۑ̃Rg
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_TemporarySaveComment")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_TemporarySaveComment"]);
            // mF
            } else if (listPatternDataInfo[i].columnId ==
                    codeUtil.getEnumCodeListPageColumn("listPageCol_ConfirmStatus")) {
                caption = MessageManager.getMessage(listPageColumn["listPageCol_ConfirmStatus"]);
            }

            // \[g\tO
            if (!isBlank(sortMap[listPatternDataInfo[i].columnId])) {
                condition = sortMap[listPatternDataInfo[i].columnId] == enabledFlag;
            }

        // ꗗ\p^[őIꂽČvpeB`̍
        } else if (listPatternDataInfo[i].columnClassify ==
                codeUtil.getEnumCodeColumnType("colTyp_MatProperty")) {
            caption = isObject(listPatternDataInfo[i].matterProperty) ?
                    Procedure.imw_utils.escapeHTML(listPatternDataInfo[i].matterProperty.matterPropertyName) :
                    "";
        }

        // ݒ
        obj = new Object();
        obj.caption = caption;
        obj.columnId = listPatternDataInfo[i].columnId;
        obj.columnClassify = listPatternDataInfo[i].columnClassify;
        obj.icon = Procedure.imw_paging_utils.createSortIconParts(orderByObj, listPatternDataInfo[i].columnId);
        obj.condition = condition;
        obj.tdStyle = "";

        // J̐ݒ
        if (!isBlank(listPatternDataInfo[i].columnWidth)) {
            obj.tdStyle += "width:" + listPatternDataInfo[i].columnWidth + "px;";
        }

        headerObject.push(obj);
    }
}

//=============================================================================
// ꗗ\p^[擾
//  y  zloginGroupId : OCO[vID
//            userId       : [UID
//            localeId     : P[ID
//            listPageType : y[W
//  y ԋp zꗗ\p^[
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zꗗ\p^[AftHg̏擾܂B
//=============================================================================
function getListDisplayPattern(loginGroupId, userId, localeId, listPageType) {
    var i;
    var result;
    var result2;
    var codeUtil = new WorkflowCodeUtil();
    var userSelectPatternId = "";
    var enabledFlag = codeUtil.getEnumCodeFlagStatus("Enable");

    // w肳ꂽʎʂɂėLȈꗗ\p^[擾
    var userListDisplayPatternManager = new UserListDisplayPattern(loginGroupId, userId);
    result = userListDisplayPatternManager.getAvailableListPattern(listPageType);
    if (result.resultFlag && result.data != null && result.data.patternId != "") {
        userSelectPatternId = result.data.patternId;
    }

    // ꗗ\p^[`Ǘ}l[W̐
    var listPatternManager = new ListDisplayPatternManager(loginGroupId);

    // ꗗp^[IuWFNǧ
    var lpsConditionInfo = new Object();
    lpsConditionInfo.localeId = localeId;
    lpsConditionInfo.listPageType = listPageType;
    var listPatternDataInfo = new Array();

    // w肵ňꗗ\p^[`܂ij
    if (isBlank(userSelectPatternId)) {
        result = listPatternManager.getListPatternDataList(lpsConditionInfo);
        if (!result.resultFlag) {
            Procedure.imw_error_utils.showErrorAlert(result.resultStatus.messageId, result, "");
        } else if (result.data == null || result.data.length == 0) {
            Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3502", null, "");
        }
        var defaultFlag = false;
        for (i = 0; i < result.data.length; i++) {
            // ftHgƂđIĂꗗ\p^[擾
            if (result.data[i].defaultFlag == enabledFlag) {
                defaultFlag = true;
                result2 = listPatternManager.getSelectedColumnListData(result.data[i].patternId);
                break;
            }
        }
        // ftHg̈ꗗ\p^[擾łȂꍇ
        if (!defaultFlag) {
            Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3503", null, "");
        }
    } else {
        result2 = listPatternManager.getSelectedColumnListData(userSelectPatternId);
    }
    if (!result2.resultFlag) {
        Procedure.imw_error_utils.showErrorAlert(result2.resultStatus.messageId, result2, "");
    } else {
        if (result2.data == null || result2.data.length == 0) {
            Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3502", null, "");
        }
    }

    // 擾ꗗIJ̏񂩂\pɑIĂ̂𒊏o
    listPatternDataInfo = new Array();
    for (i = 0; i < result2.data.length; i++) {
        listPatternDataInfo[listPatternDataInfo.length] = result2.data[i];
    }

    // ꗗ\p^[݂ꍇA\[g̒璊o
    var matterPropertyDataManager = new MatterPropertyDataManager(loginGroupId);
    var sortArray = new Array();
    if (listPatternDataInfo.length > 0) {
        for (i = 0; i < listPatternDataInfo.length; i++) {
            if (listPatternDataInfo[i].sortFlag == enabledFlag) {
                sortArray.push(
                    {sortOrder:listPatternDataInfo[i].sortOrder,
                     columnName:listPatternDataInfo[i].columnId,
                     sortType:(listPatternDataInfo[i].sortClassify ==
                                codeUtil.getEnumCodeSortSequence("sortSeq_Desc")) ? "DESC" : "ASC",
                     columnClassify:listPatternDataInfo[i].columnClassify});
            }
        }
    }

    // ꗗ\p^[E\[gڂ݂ȂꍇftHg̃\[gڂw
    if (sortArray.length == 0) {
        // ꗗ\p^[ŋʓIɗp\ȍڂwit[j
        sortArray.push({
            "columnName"     : codeUtil.getEnumCodeListPageColumn("listPageCol_FlowName"),
            "sortType"       : "ASC",
            "columnClassify" : "0"
        });
    }
    sortArray.sort( function (v1, v2) { return v1.sortOrder > v2.sortOrder ? 1 : -1; } );

    // ČvpeB擾
    for (i = 0; i < listPatternDataInfo.length; i++) {
        if (listPatternDataInfo[i].columnClassify == codeUtil.getEnumCodeColumnType("colTyp_MatProperty")) {
            result = matterPropertyDataManager.getMatterPropertyDataWithLocale(
                    listPatternDataInfo[i].columnId, localeId);
            if (!result.resultFlag) {
                Procedure.imw_error_utils.showErrorAlert(result.resultStatus.messageId, result, "");
            }
            if (result.data == null) {
                Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3230", null, "");
            }
            listPatternDataInfo[i].matterProperty = result.data;
        }
    }

    result = new Object();
    result.listPatternDataInfo = listPatternDataInfo;
    result.sortArray = sortArray;

    return result;
}

//=============================================================================
// [U擾
//  y  zloginUserId  : OC[UID
//            loginGroupId : OCO[vID
//            localeId     : P[ID
//            targetUserId : ̎擾Ώۃ[UID
//            baseDate     :  (ȗ͌ݓt)
//  y ԋp z[U
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z[U擾܂B擾Ɏsꍇ͋󕶎ԋp܂B
//=============================================================================
function getUserName(loginUserId, loginGroupId, localeId, targetUserId, baseDate) {
    if (isBlank(targetUserId)) {
        return "";
    }
    if (isBlank(baseDate)) {
        baseDate = Format.fromDate("yyyy/MM/dd", new Date());
    }
    var databaseResult = WorkflowPluginUtil.getLocaleUserName(loginGroupId, localeId,
            "jp.co.intra_mart.workflow.plugin.standard.target.user.extend",
            "jp.co.intra_mart.workflow.plugin.standard.target.user.extend.user",
            baseDate, targetUserId, localeId);
    if (!databaseResult.resultFlag || databaseResult.data == null) {
        return "";
    }
    return databaseResult.data;
}

//=============================================================================
// ꗗ\pJf[^֐
//  y  zȂ
//  y ԋp zJf[^i[IuWFNg
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zꗗ\p̃Jf[^܂B
//=============================================================================
function getListColumnObject() {
    var colObj = new Object();
    colObj.value = "";
    colObj.align = "left";
    colObj.type = "string";
    colObj.tdStyle = "";
    colObj.title = "";
    colObj.nowrap = false;
    return colObj;
}

//=============================================================================
// ꗗ\p^[`ݒ̃Jݒ
//  y  zcodeInfo: R[hli[ꂽIuWFNg
//            listInfo: ꗗ\p^[̃Jf[^
//            colObj: Jf[^i[IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zJݒɈꗗ\p^[`̐ݒǋL܂B
//=============================================================================
function setListColumnAttribute(codeInfo, listInfo, colObj) {
    // J̐ݒ
    if (!isBlank(listInfo.columnWidth)) {
        colObj.tdStyle += "width:" + listInfo.columnWidth + "px;";
    }

    // ܂Ԃ̐ݒ
    if (!isBlank(listInfo.nowrapFlag)) {
        colObj.nowrap = listInfo.nowrapFlag == codeInfo.enabledFlag;
    }
}

//=============================================================================
// ꗗ\pJf[^lݒ֐iDxj
//  y  zcodeUtil: WorkflowCodeUtil IuWFNg
//            valueObj: Jl
//            colObj: Jf[^i[IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zꗗ\p̃Jf[^̏lݒ肵܂B
//=============================================================================
function defaultListColumnObjectPriority(codeUtil, valueObj, colObj) {
    // 
    if (valueObj == codeUtil.getEnumCodePriorityLevel("pryLevel_H")) {
        colObj.value = "images/icons/16x16/fugue-icons/shadow/star.png";
        colObj.type = "icon";
        colObj.title = MessageManager.getMessage("IMW.CAP.1015");
    // ʏ
    } else if (valueObj == codeUtil.getEnumCodePriorityLevel("pryLevel_N")) {
        colObj.value = "images/icons/16x16/fugue-icons/shadow/star-empty.png";
        colObj.type = "icon";
        colObj.title = MessageManager.getMessage("IMW.CAP.1016");
    // 
    } else if (valueObj == codeUtil.getEnumCodePriorityLevel("pryLevel_L")) {
    // ̑
    } else {
        colObj.value = "images/icons/16x16/fugue-icons/shadow/star-empty.png";
        colObj.type = "icon";
        colObj.title = MessageManager.getMessage("IMW.CAP.1016");
    }
}

//=============================================================================
// ꗗ\pJf[^lݒ֐itOXe[^Xj
//  y  zcodeUtil: WorkflowCodeUtil IuWFNg
//            valueObj: Jl
//            colObj: Jf[^i[IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zꗗ\p̃Jf[^̏lݒ肵܂B
//=============================================================================
function defaultListColumnObjectStatus(codeUtil, valueObj, colObj) {
    // \
    if (valueObj == codeUtil.getEnumCodeNodeStatus("nodeSts_ApplyWait")) {
        colObj.value = "workflow/img/node_status/" + valueObj + ".gif";
        colObj.type = "icon";
        colObj.title = MessageManager.getMessage("IMW.CAP.1116");
    // F҂
    } else if (valueObj == codeUtil.getEnumCodeNodeStatus("nodeSts_ApproveWait")) {
        colObj.value = "workflow/img/node_status/" + valueObj + ".gif";
        colObj.type = "icon";
        colObj.title = MessageManager.getMessage("IMW.CAP.1117");
    // Đ\҂
    } else if (valueObj == codeUtil.getEnumCodeNodeStatus("nodeSts_ReAppryWait")) {
        colObj.value = "workflow/img/node_status/" + valueObj + ".gif";
        colObj.type = "icon";
        colObj.title = MessageManager.getMessage("IMW.CAP.1118");
    // ۗ҂
    } else if (valueObj == codeUtil.getEnumCodeNodeStatus("nodeSts_ReserveWait")) {
        colObj.value = "workflow/img/node_status/" + valueObj + ".gif";
        colObj.type = "icon";
        colObj.title = MessageManager.getMessage("IMW.CAP.1084");
    }
}

//=============================================================================
// ꗗ\pJf[^lݒ֐iČIXe[^Xj
//  y  zcodeUtil: WorkflowCodeUtil IuWFNg
//            valueObj: Jl
//            colObj: Jf[^i[IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zꗗ\p̃Jf[^̏lݒ肵܂B
//=============================================================================
function defaultListColumnObjectEndStatus(codeUtil, valueObj, colObj) {
    // Im[hB
    if (valueObj == codeUtil.getEnumCodeMatterEndStatus("matEndSts_EndNode")) {
        colObj.value = "workflow/img/matter_end_status/end_node.gif";
        colObj.type = "icon";
        colObj.title = MessageManager.getMessage("IMW.CAP.0125");
    // FI
    } else if (valueObj == codeUtil.getEnumCodeMatterEndStatus("matEndSts_Approve")) {
        colObj.value = "workflow/img/matter_end_status/approve_end.gif";
        colObj.type = "icon";
        colObj.title = MessageManager.getMessage("IMW.CAP.0126");
    // ~
    } else if (valueObj == codeUtil.getEnumCodeMatterEndStatus("matEndSts_Discon")) {
        colObj.value = "workflow/img/matter_end_status/discontinue.gif";
        colObj.type = "icon";
        colObj.title = MessageManager.getMessage("IMW.CAP.0127");
    // ۔F
    } else if (valueObj == codeUtil.getEnumCodeMatterEndStatus("matEndSts_Deny")) {
        colObj.value = "workflow/img/matter_end_status/deny.gif";
        colObj.type = "icon";
        colObj.title = MessageManager.getMessage("IMW.CAP.0128");
    // Č
    } else if (valueObj == codeUtil.getEnumCodeMatterEndStatus("matEndSts_MatterHandle")) {
        colObj.value = "workflow/img/matter_end_status/matter_handle.gif";
        colObj.type = "icon";
        colObj.title = MessageManager.getMessage("IMW.CAP.1079");
    }
}

//=============================================================================
// ꗗ\pJf[^lݒ֐ij
//  y  zcodeUtil: WorkflowCodeUtil IuWFNg
//            valueObj: Jl
//            colObj: Jf[^i[IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zꗗ\p̃Jf[^̏lݒ肵܂B
//=============================================================================
function defaultListColumnObjectProcessAuth(codeUtil, valueObj, colObj) {
    // {l
    if (valueObj == codeUtil.getEnumCodeProcessAuth("processAuth_Self")) {
        colObj.value = "workflow/img/process_auth/self.gif";
        colObj.type = "icon";
        colObj.title = MessageManager.getMessage("IMW.CAP.1121");
    // 㗝
    } else if (valueObj == codeUtil.getEnumCodeProcessAuth("processAuth_Act")) {
        colObj.value = "workflow/img/process_auth/act.gif";
        colObj.type = "icon";
        colObj.title = MessageManager.getMessage("IMW.CAP.1122");
    // {lł㗝ł
    } else if (valueObj == codeUtil.getEnumCodeProcessAuth("processAuth_SelfAndAct")) {
        colObj.value = "workflow/img/process_auth/self_and_act.gif";
        colObj.type = "icon";
        colObj.title = MessageManager.getMessage("IMW.CAP.1123");
    }
}

//=============================================================================
// ČvpeBR[hl擾֐
//  y  zȂ
//  y ԋp zR[hli[ꂽIuWFNg
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČvpeB߂̃R[hl擾܂B
//=============================================================================
function getMatterPropertyCodes() {
    var obj = new Object();
    var codeUtil = new WorkflowCodeUtil();

    // ČvpeBL[^
    obj.modelTypeChar = codeUtil.getEnumCodeModelType("modelTyp_Char");
    obj.modelTypeNum = codeUtil.getEnumCodeModelType("modelTyp_Num");

    // \ʒu
    obj.alignTypeLeft = codeUtil.getEnumCodeAlignType("alignTyp_Left");
    obj.alignTypeCenter = codeUtil.getEnumCodeAlignType("alignTyp_Center");
    obj.alignTypeRight = codeUtil.getEnumCodeAlignType("alignTyp_Right");

    // ͈͎
    obj.searchRangeTypeSingle = codeUtil.getEnumCodeSearchRangeType("searchRangeTyp_Single");
    obj.searchRangeTypeRange = codeUtil.getEnumCodeSearchRangeType("searchRangeTyp_Range");

    // LEtO
    obj.enabledFlag = codeUtil.getEnumCodeFlagStatus("Enable");
    obj.disabledFlag = codeUtil.getEnumCodeFlagStatus("Disable");

    return obj;
}

//=============================================================================
// ČvpeBꗗݒ֐
//  y  zcodeInfo: R[hli[ꂽIuWFNg
//            listInfo: ꗗ\p^[̃Jf[^
//            dispInfo: ČvpeB̌ݒlIuWFNg
//            colObj: Jf[^i[IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČvpeBꗗʂɕ\ۂ̌f[^ݒ肵܂B
//=============================================================================
function setMatterPropertyConditionObject(codeInfo, listInfo, dispInfo, condObj) {
    condObj.addColumnByMatterProp(listInfo.columnId);
    var matterProperty = listInfo.matterProperty;
    var objValue1 = dispInfo["mp1_" + listInfo.columnId];
    var objValue2 = dispInfo["mp2_" + listInfo.columnId];

    // ͈͎ʂɂĕ\ڂ𐧌
    if (!matterProperty) {
        // ČvpeB񂪌Ȃꍇ͕̕v
        if (!isBlank(objValue1)) {
            condObj.addConditionByMatterProp(listInfo.columnId, objValue1,
                    ListSearchCondition.OP_LIKE, ListSearchCondition.COL_VARCHAR);
        }
    } else if (matterProperty.searchRangeType == codeInfo.searchRangeTypeSingle) {
        // Pꌟ
        if (matterProperty.matterPropertyModelType == codeInfo.modelTypeNum) {
            // l̏ꍇ͊Sv
            if (!isBlank(objValue1)) {
                condObj.addConditionByMatterProp(listInfo.columnId, objValue1,
                        ListSearchCondition.OP_EQ, ListSearchCondition.COL_NUMBER);
            }
        } else if (matterProperty.calendarFlag == codeInfo.enabledFlag) {
            // t̏ꍇ͊Sv
            if (!isBlank(objValue1)) {
                condObj.addConditionByMatterProp(listInfo.columnId, objValue1,
                        ListSearchCondition.OP_EQ, ListSearchCondition.COL_VARCHAR);
            }
        } else {
            // ̏ꍇ͕v
            if (!isBlank(objValue1)) {
                condObj.addConditionByMatterProp(listInfo.columnId, objValue1,
                        ListSearchCondition.OP_LIKE, ListSearchCondition.COL_VARCHAR);
            }
        }
    } else if (matterProperty.searchRangeType == codeInfo.searchRangeTypeRange) {
        // ͈͑I
        if (matterProperty.matterPropertyModelType == codeInfo.modelTypeNum) {
            // l̏ꍇ
            if (!isBlank(objValue1)) {
                condObj.addConditionByMatterProp(listInfo.columnId, objValue1,
                        ListSearchCondition.OP_GE, ListSearchCondition.COL_NUMBER);
            }
            if (!isBlank(objValue2)) {
                condObj.addConditionByMatterProp(listInfo.columnId, objValue2,
                        ListSearchCondition.OP_LE, ListSearchCondition.COL_NUMBER);
            }
        } else {
            // ̏ꍇ
            if (!isBlank(objValue1)) {
                condObj.addConditionByMatterProp(listInfo.columnId, objValue1,
                        ListSearchCondition.OP_GE, ListSearchCondition.COL_VARCHAR);
            }
            if (!isBlank(objValue2)) {
                condObj.addConditionByMatterProp(listInfo.columnId, objValue2,
                        ListSearchCondition.OP_LE, ListSearchCondition.COL_VARCHAR);
            }
        }
    } else {
        // ͕̑̕v
        if (!isBlank(objValue1)) {
            condObj.addConditionByMatterProp(listInfo.columnId, objValue1,
                    ListSearchCondition.OP_LIKE, ListSearchCondition.COL_VARCHAR);
        }
    }
}

//=============================================================================
// ČvpeBꗗ\Jf[^ݒ֐
//  y  zcodeInfo: R[hli[ꂽIuWFNg
//            mpInfo: ČvpeB̔z
//            listInfo: ꗗ\p^[̃Jf[^
//            colObj: Jf[^i[IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČvpeBꗗʂɕ\ۂ̃Jf[^ݒ肵܂B
//=============================================================================
function setMatterPropertyColumnObject(codeInfo, mpInfos, listInfo, colObj) {
    var i;
    var codeUtil = new WorkflowCodeUtil();

    // ČvpeB̒lݒ
    for (i = 0; i < mpInfos.length; i++) {
        if (listInfo.columnId == mpInfos[i].matterPropertyKey) {
            colObj.value = Procedure.imw_utils.escapeHTML(mpInfos[i].matterPropertyValue);
            var mp = listInfo.matterProperty;
            if (colObj.value == null || colObj.value == "") {
                break;
            }
            if (codeUtil.getEnumCodeModelType("modelTyp_Num") != mp.matterPropertyModelType) {
                break;
            }
            if (codeUtil.getEnumCodeFlagStatus("Enable") != mp.commaSeparatedFlag) {
                break;
            }
            colObj.value = WorkflowCommonUtil.formatNumberCommaSeparated(colObj.value);
            break;
        }
    }

    // ČvpeB񂪌Ȃꍇ͏I
    var matterProperty = listInfo.matterProperty;
    if (!matterProperty) {
        return;
    }

    // \ʒuݒ擾
    if (matterProperty.alignType == codeInfo.alignTypeLeft) {
        colObj.align = "left";
    } else if (matterProperty.alignType == codeInfo.alignTypeCenter) {
        colObj.align = "center";
    } else if (matterProperty.alignType == codeInfo.alignTypeRight) {
        colObj.align = "right";
    }

    // ܂Ԃ̐ݒ
    if (matterProperty.matterPropertyModelType == codeInfo.modelTypeNum ||
            matterProperty.calendarFlag == codeInfo.enabledFlag) {
        colObj.nowrap = true;
    }

    // \ݒ
    setListColumnAttribute(codeInfo, listInfo, colObj);
}

//=============================================================================
// pof[Vlݒ֐
//  y  zoValidationMsg: of[VbZ[Wi[IuWFNg
//            oCommon: of[VbZ[W쐬pʏ (Object)
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zp̃of[V̏lݒ肵܂B
//=============================================================================
function defaultSearchColumnValidate(oValidationMsg, oCommon) {
    var oParameter;

    // \
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("listPageCol_ApplyDate", "IMW.CAP.1035");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("listPageCol_ApplyDateFrom", new Array("IMW.CAP.1035", "IMW.CAP.0367"));
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("listPageCol_ApplyDateTo", new Array("IMW.CAP.1035", "IMW.CAP.0368"));
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);

    // \
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("listPageCol_BaseDate", "IMW.CAP.0391");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("listPageCol_BaseDateFrom", new Array("IMW.CAP.0391", "IMW.CAP.0367"));
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("listPageCol_BaseDateTo", new Array("IMW.CAP.0391", "IMW.CAP.0368"));
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);

    // B
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("listPageCol_ArriveDate", "IMW.CAP.0387");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("listPageCol_ArriveDateFrom", new Array("IMW.CAP.0387", "IMW.CAP.0367"));
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("listPageCol_ArriveDateTo", new Array("IMW.CAP.0387", "IMW.CAP.0368"));
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);

    // ŏI
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("listPageCol_FinalProc", "IMW.CAP.0395");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("listPageCol_FinalProcDateFrom", new Array("IMW.CAP.0395", "IMW.CAP.0367"));
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("listPageCol_FinalProcDateTo", new Array("IMW.CAP.0395", "IMW.CAP.0368"));
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);

    // ČI
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("listPageCol_EndDate", "IMW.CAP.0396");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("listPageCol_EndDateFrom", new Array("IMW.CAP.0396", "IMW.CAP.0367"));
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("listPageCol_EndDateTo", new Array("IMW.CAP.0396", "IMW.CAP.0368"));
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
}

//=============================================================================
// pJf[^֐
//  y  zcolumnId: JID
//  y ԋp zJf[^i[IuWFNg
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zp̃Jf[^܂B
//=============================================================================
function getSearchColumnObject(columnId) {
    var searchObj = new Object();
    searchObj.caption = "";
    searchObj.objType = "";
    searchObj.objName = columnId;
    searchObj.objName1 = "";
    searchObj.objName2 = "";
    searchObj.objValue1 = "";
    searchObj.objValue2 = "";
    searchObj.optionValue = "";
    return searchObj;
}

//=============================================================================
// pJf[^lݒ֐
//  y  zcodeUtil: WorkflowCodeUtil IuWFNg
//            dispInfo: ݒlIuWFNg
//            listInfo: ꗗ\p^[̃Jf[^
//            searchObj: Jf[^i[IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zp̃Jf[^̏lݒ肵܂B
//=============================================================================
function defaultSearchColumnObject(codeUtil, dispInfo, listInfo, searchObj) {
    var j;
    var listObj;

    // Dx
    if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_Priority")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.0388");
        searchObj.objType = "select";
        searchObj.objName1 = listInfo.columnId;
        searchObj.objValue1 = dispInfo[searchObj.objName1];

        listObj = new Object();
        var enumPriorityLevel = codeUtil.getPriorityLevel();
        listObj[""] = "";
        for (j = 0; j < enumPriorityLevel.data.length; j++) {
            listObj[enumPriorityLevel.data[j].code] =
                    MessageManager.getMessage(enumPriorityLevel.data[j].messageId);
        }
        searchObj.objList = Procedure.imw_utils.escapePullDownObject(listObj);
    // Čԍivj
    } else if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_MatterNumber")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.1029");
        searchObj.objType = "text";
        searchObj.objName1 = listInfo.columnId;
        searchObj.objValue1 = dispInfo[searchObj.objName1];
    // Čivj
    } else if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_MatterName")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.0389");
        searchObj.objType = "text";
        searchObj.objName1 = listInfo.columnId;
        searchObj.objValue1 = dispInfo[searchObj.objName1];
    // \
    } else if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyUser")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.0390");
        searchObj.objType = "user";
        searchObj.objName1 = listInfo.columnId;
        searchObj.objName2 = listInfo.columnId + "Name";
        searchObj.objValue1 = dispInfo[searchObj.objName1];
        searchObj.objValue2 = dispInfo[searchObj.objName2];
    // \iFROM\TOj
    } else if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_ApplyDate")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.1035");
        searchObj.objType = "dateFromTo";
        searchObj.objName1 = listInfo.columnId + "From";
        searchObj.objName2 = listInfo.columnId + "To";
        searchObj.objPass1 = "document.mainForm['" + searchObj.objName1 + "']";
        searchObj.objPass2 = "document.mainForm['" + searchObj.objName2 + "']";
        searchObj.objValue1 = dispInfo[searchObj.objName1];
        searchObj.objValue2 = dispInfo[searchObj.objName2];
    // \
    } else if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_BaseDate")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.0391");
        searchObj.objType = "dateFromTo";
        searchObj.objName1 = listInfo.columnId + "From";
        searchObj.objName2 = listInfo.columnId + "To";
        searchObj.objPass1 = "document.mainForm['" + searchObj.objName1 + "']";
        searchObj.objPass2 = "document.mainForm['" + searchObj.objName2 + "']";
        searchObj.objValue1 = dispInfo[searchObj.objName1];
        searchObj.objValue2 = dispInfo[searchObj.objName2];
    // t[ivj
    } else if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_FlowName")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.0109");
        searchObj.objType = "text";
        searchObj.objName1 = listInfo.columnId;
        searchObj.objValue1 = dispInfo[searchObj.objName1];
    // m[hivj
    } else if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_NodeName")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.0250");
        searchObj.objType = "text";
        searchObj.objName1 = listInfo.columnId;
        searchObj.objValue1 = dispInfo[searchObj.objName1];
    // 
    } else if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_Status")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.0392");
        searchObj.objType = "select";
        searchObj.objName1 = listInfo.columnId;
        searchObj.objValue1 = dispInfo[searchObj.objName1];

        listObj = new Object();
        var enumNodeStatus = codeUtil.getNodeStatus();
        listObj[""] = "";
        for (j = 0; j < enumNodeStatus.data.length; j++) {
            listObj[enumNodeStatus.data[j].code] =
                    MessageManager.getMessage(enumNodeStatus.data[j].messageId);
        }
        searchObj.objList = Procedure.imw_utils.escapePullDownObject(listObj);
    // BiFROM\TOj
    } else if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_ArriveDate")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.0387");
        searchObj.objType = "dateFromTo";
        searchObj.objName1 = listInfo.columnId + "From";
        searchObj.objName2 = listInfo.columnId + "To";
        searchObj.objPass1 = "document.mainForm['" + searchObj.objName1 + "']";
        searchObj.objPass2 = "document.mainForm['" + searchObj.objName2 + "']";
        searchObj.objValue1 = dispInfo[searchObj.objName1];
        searchObj.objValue2 = dispInfo[searchObj.objName2];
    // i\TOj
    } else if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_ProcLimit")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.0208");
        searchObj.objType = "date";
        searchObj.objName1 = listInfo.columnId + "To";
        searchObj.objPass1 = "document.mainForm['" + searchObj.objName1 + "']";
        searchObj.objValue1 = dispInfo[searchObj.objName1];
        searchObj.optionValue = MessageManager.getMessage("IMW.CAP.1036");
    // ŏIiFROM\TOj
    } else if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_FinalProcDate")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.0395");
        searchObj.objType = "dateFromTo";
        searchObj.objName1 = listInfo.columnId + "From";
        searchObj.objName2 = listInfo.columnId + "To";
        searchObj.objPass1 = "document.mainForm['" + searchObj.objName1 + "']";
        searchObj.objPass2 = "document.mainForm['" + searchObj.objName2 + "']";
        searchObj.objValue1 = dispInfo[searchObj.objName1];
        searchObj.objValue2 = dispInfo[searchObj.objName2];
    // ČIiFROM\TOj
    } else if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_EndDate")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.0396");
        searchObj.objType = "dateFromTo";
        searchObj.objName1 = listInfo.columnId + "From";
        searchObj.objName2 = listInfo.columnId + "To";
        searchObj.objPass1 = "document.mainForm['" + searchObj.objName1 + "']";
        searchObj.objPass2 = "document.mainForm['" + searchObj.objName2 + "']";
        searchObj.objValue1 = dispInfo[searchObj.objName1];
        searchObj.objValue2 = dispInfo[searchObj.objName2];
    // 
    } else if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_EndStatus")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.0118");
        searchObj.objType = "select";
        searchObj.objName1 = listInfo.columnId;
        searchObj.objValue1 = dispInfo[searchObj.objName1];

        listObj = new Object();
        var enumMatterEndStatus = codeUtil.getMatterEndStatus();
        listObj[""] = "";
        listObj["mattercomplete"] = MessageManager.getMessage(enumMatterEndStatus.data[0].messageId);
        listObj["approveend"] = MessageManager.getMessage(enumMatterEndStatus.data[1].messageId);
        listObj["discontinue"] = MessageManager.getMessage(enumMatterEndStatus.data[2].messageId);
        listObj["deny"] = MessageManager.getMessage(enumMatterEndStatus.data[3].messageId);
        listObj["matterhandle"] = MessageManager.getMessage(enumMatterEndStatus.data[4].messageId);
        searchObj.objList = Procedure.imw_utils.escapePullDownObject(listObj);
    // lit[j
    } else if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_FlowVersionNote")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.0384");
        searchObj.objType = "text";
        searchObj.objName1 = listInfo.columnId;
        searchObj.objValue1 = dispInfo[searchObj.objName1];
    // Rgivj
    } else if (listInfo.columnId == codeUtil.getEnumCodeListPageColumn("listPageCol_TemporarySaveComment")) {
        searchObj.caption = MessageManager.getMessage("IMW.CAP.0318");
        searchObj.objType = "text";
        searchObj.objName1 = listInfo.columnId;
        searchObj.objValue1 = dispInfo[searchObj.objName1];
    }
}

//=============================================================================
// ČvpeBꗗ\f[^ݒ֐
//  y  zmpManager: MatterPropertyDataManager NX̃CX^X
//            codeInfo: R[hli[ꂽIuWFNg
//            listInfo: ꗗ\p^[̃Jf[^
//            dispInfo: ČvpeB̌ݒlIuWFNg
//            localeId: P[ID
//            searchObj: f[^i[IuWFNg
//            oValidationMsg: of[VbZ[Wi[IuWFNg
//            oCommon: ʏ
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČvpeB\ʂɕ\ۂ̕\f[^ݒ肵܂B
//=============================================================================
function setMatterPropertySearchObject(mpManager, codeInfo, listInfo, dispInfo, localeId, searchObj, oValidationMsg, oCommon) {
    // ČvpeB擾
    var result = mpManager.getMatterPropertyDataWithLocale(listInfo.columnId, localeId);
    if (!result.resultFlag || result.data == null) {
        Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3559", result);
    }
    var matterProperty = result.data;
    searchObj.caption = Procedure.imw_utils.escapeHTML(matterProperty.matterPropertyName);
    searchObj.objName = "mp_" + listInfo.columnId;
    searchObj.objName1 = "mp1_" + listInfo.columnId;
    searchObj.objName2 = "mp2_" + listInfo.columnId;

    // ͈͎ʂɂĕ\ڂ𐧌
    var validParam = new Object();
    var fDate = false;
    if (matterProperty.searchRangeType == codeInfo.searchRangeTypeSingle) {
        if (matterProperty.matterPropertyModelType == codeInfo.modelTypeNum) {
            searchObj.objType = "number";
            validParam = Procedure.imw_validate_utils.makeParameter4Decimal(searchObj.objName1);
        } else if (matterProperty.calendarFlag == codeInfo.enabledFlag) {
            searchObj.objType = "date";
            validParam = Procedure.imw_validate_utils.makeParameter4Date(searchObj.objName1);
        } else {
            searchObj.objType = "text";
            validParam = Procedure.imw_validate_utils.makeParameter4Text(searchObj.objName1);
        }
        validParam.fieldName = matterProperty.matterPropertyName;
        Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, validParam);
    } else if (matterProperty.searchRangeType == codeInfo.searchRangeTypeRange) {
        if (matterProperty.matterPropertyModelType == codeInfo.modelTypeNum) {
            searchObj.objType = "numberFromTo";
            validParam = Procedure.imw_validate_utils.makeParameter4Decimal(searchObj.objName);
            validParam.decRange = true;
        } else if (matterProperty.calendarFlag == codeInfo.enabledFlag) {
            searchObj.objType = "dateFromTo";
            validParam = Procedure.imw_validate_utils.makeParameter4Date(searchObj.objName);
            validParam.dateRange = true;
            fDate = true;
        } else {
            searchObj.objType = "textFromTo";
            validParam = Procedure.imw_validate_utils.makeParameter4Text(searchObj.objName);
        }
        validParam.fieldName = matterProperty.matterPropertyName;
        Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, validParam);
        validParam.name = searchObj.objName1;
        validParam.fieldName = matterProperty.matterPropertyName + MessageManager.getMessage(fDate ? "IMW.CAP.0367" : "IMW.CAP.0563");
        Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, validParam);
        validParam.name = searchObj.objName2;
        validParam.fieldName = matterProperty.matterPropertyName + MessageManager.getMessage(fDate ? "IMW.CAP.0368" : "IMW.CAP.0564");
        Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, validParam);
    } else {
        searchObj.objType = "text";
        validParam = Procedure.imw_validate_utils.makeParameter4Text(searchObj.objName1);
        validParam.fieldName = matterProperty.matterPropertyName;
        Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, validParam);
    }

    // lݒ
    if (!isBlank(searchObj.objName1)) {
        searchObj.objPass1 = "document.mainForm['" + searchObj.objName1 + "']";
        searchObj.objValue1 = dispInfo ? dispInfo[searchObj.objName1] : ""; // HTMLGXP[v͉ʑōs
        searchObj.objValue1 = isBlank(searchObj.objValue1) ? "" : searchObj.objValue1;
    }
    if (!isBlank(searchObj.objName2)) {
        searchObj.objPass2 = "document.mainForm['" + searchObj.objName2 + "']";
        searchObj.objValue2 = dispInfo ? dispInfo[searchObj.objName2] : ""; // HTMLGXP[v͉ʑōs
        searchObj.objValue2 = isBlank(searchObj.objValue2) ? "" : searchObj.objValue2;
    }

    // of[VbZ[Wݒ
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, validParam);
}

//=============================================================================
// pJf[^ǉ֐
//  y  zary: Jf[^i[z
//            searchObj: Jf[^i[IuWFNg
//  y ԋp zary ƓIuWFNg̃CX^X
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zp̃Jf[^̍ŏIsAzɒǉ܂B
//=============================================================================
function addSearchColumnObject(ary, searchObj) {
    if (!isBlank(searchObj.objType)) {
        searchObj.objValue1 = Procedure.imw_utils.escapeHTML(searchObj.objValue1);
        searchObj.objValue2 = Procedure.imw_utils.escapeHTML(searchObj.objValue2);
        ary.push(searchObj);
    }
    return ary;
}

//=============================================================================
// ꗗ\p^[ύXo^
//  y  zrequest: NGXgIuWFNg
//            listPageType: ꗗ\p^[
//  y ԋp zʃIuWFNg
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zIꗗ\p^[[ŨftHgƂēo^܂B
//=============================================================================
function updateUserListPattern(request, listPageType) {
    var databaseResult;
    var result = new Object();
    result.resultFlag = false;
    result.resultStatus = new Object();

    // OC[U̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;

    // gUNV̊Jn
    databaseResult = DatabaseManager.beginTransaction();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3601", databaseResult);
        return result;
    }

    // p҈ꗗ\p^[̐ݒ
    var userListPattern = new Object();
    userListPattern.listPageType = listPageType;
    userListPattern.patternId = request.listPatternId;

    // p҈ꗗ\p^[̐VKo^EXV
    var manager = new UserListDisplayPattern(loginGroupId, userId);
    databaseResult = manager.createUserListPattern(userListPattern);
    if (!databaseResult.resultFlag) {
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3601", databaseResult);
        // [obN
        databaseResult = DatabaseManager.rollback();
        if (databaseResult.error) {
            result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                    "IMW.CLI.WRN.3601", databaseResult);
        }
        return result;
    }
    result.data = databaseResult.data;

    // R~bg
    databaseResult = DatabaseManager.commit();
    if (databaseResult.error) {
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3601", databaseResult);
        return result;
    }

    result.resultFlag = true;
    return result;
}
