//=============================================================================
// tO@}[W֐
//  y  zflags : `tOSĂ̖(String)߂z
//            enableFlags : flagsAenableƂĐݒ肷tO̖(String)߂z
//  y ԋp zL̃tOvpeBƂĐݒ肵IuWFNg
//  y Tv ztO}[WIuWFNg𐶐܂B
//   ex:
//   input :
//     flags : ["a", "b","c"]
//     enableFlags : ["a"]
//   return :
//     { a:"1", b:"0", c:"0" }
//        vpeB̒lIM-Workflow̒`lɂ
//=============================================================================
function createMergedObject(flags, enableFlags) {
    // Xe[^XpR[hl
    var codeUtil = new WorkflowCodeUtil();
    var statusEnable = codeUtil.getEnumCodeFlagStatus("Enable");
    var statusDisable = codeUtil.getEnumCodeFlagStatus("Disable");

    var i;
    // Kvȃp[^IuWFNg𐶐B
    var baseObject = new Object();
    for (i = 0; i < flags.length; i++) {
        baseObject[flags[i]] = statusDisable;
    }
    // statusp[^̗L
    for (i = 0 ; i < enableFlags.length; i++) {
        baseObject[enableFlags[i]] = statusEnable;
    }

    return baseObject;
}

//=============================================================================
// tOw荇֐
//  y  zflags : `tOSĂ̖(String)߂z
//            enableFlags : flagsAenableƂĐݒ肷tO̖(String)߂z
//            props : ꗗ\p[^̃vpeB̔z
//  y ԋp zꗗ\p[^
//  y Tv ztOwăp[^𐶐܂BiimwCallOriginalParamsɈꗗp̃vpeBʓr݂Ăꍇpj
//=============================================================================
function createParamsWithProps(flags, enableFlags, props) {

    var baseObject = createMergedObject(flags, enableFlags);
    var statusParams = new Object();
    var cnt;
    var leng = props.length;
    for (cnt = 0; cnt < leng; cnt++) {
        statusParams[props[cnt]] = baseObject;
    }

    // p[^̃tH[}bgϊ
    var param_obj = new Object();
    param_obj.imwCallOriginalParams = URL.encode(ImJson.toJSONString(statusParams));

    return param_obj;
}

//=============================================================================
// tOw荇֐
//  y  zflags : `tOSĂ̖(String)߂z
//            enableFlags : flagsAenableƂĐݒ肷tO̖(String)߂z
//  y ԋp zꗗ\p[^
//  y Tv ztOwăp[^𐶐܂BiimwCallOriginalParamsꗗp̃vpeB̏ꍇpj
//=============================================================================
function createParams(flags, enableFlags) {

    var baseObject = createMergedObject(flags, enableFlags);

    // p[^̃tH[}bgϊ
    var param_obj = new Object();
    param_obj.imwCallOriginalParams = URL.encode(ImJson.toJSONString(baseObject));

    return param_obj;
}

//=============================================================================
// IM-Workflowψꗗ\pp[^擾֐
//  y  zstatus_flags : LɂXe[^X̔z
//  y ԋp zꗗ\p[^
//  y Tv zIM-Workflowψꗗ\̃p[^擾܂B
//=============================================================================
function getCplProcListSearchParameter(status_flags) {

    // declare flags
    var base_flags = [
            "applyFlg",
            "approveFlg",
            "applySelfActFlg",
            "approveSelfActFlg",
            "applyOriginalActFlg",
            "approveOriginalActFlg",
            "applyTargetActFlg",
            "approveTargetActFlg"];

    // declare properties
    var props = [
            "actvProcListParams",
            "cplProcListParams"];

    return createParamsWithProps(base_flags, status_flags, props);
}

//=============================================================================
// IM-WorkflowmFꗗ\pp[^擾֐
//  y  zstatus_flags : LɂXe[^X̔z
//  y ԋp zꗗ\p[^
//  y Tv zIM-WorkflowmFꗗ\̃p[^擾܂B
//=============================================================================
function getConfirmListSearchParameter(status_flags) {

    // declare flags
    var base_flags = [
            "unconfirmFlg", 
            "confirmedFlg"];

    // declare properties
    var props = [
            "confirmActvListParams",
            "confirmCplListParams"];

    return createParamsWithProps(base_flags, status_flags, props);
}

//=============================================================================
// IM-Workflowꗗ\pp[^擾֐
//  y  zstatus_flags : LɂXe[^X̔z
//  y ԋp zꗗ\p[^
//  y Tv zIM-Workflowꗗ\̃p[^擾܂B
//=============================================================================
function getProcessListSearchParameter(status_flags) {

    // declare flags
    var base_flags = [
            "applyActFlg",
            "applyFlg",
            "approveActFlg",
            "approveFlg"];

    // declare properties
    var props = ["unprocListParams"];

    return createParamsWithProps(base_flags, status_flags, props);
}
