function getBpwRequestParameter(processData, targetDate, bpw_flag, userCode, loginGroupId, parameterCodes, user_setting_key) {

    var bpwDetailPageObj = new Object();
    bpwDetailPageObj.param = null;
    bpwDetailPageObj.formAction = "";

    var util = Procedure.imw_utils;
    var param = new Object();
    param.account               = util.getValue(userCode, "");
    param.group                 = util.getValue(loginGroupId, "");
    param.caller                = "";

    // ďovZX̐ݒ
    if(!isBlank(processData.parentProcessDefCode)
            && !isBlank(processData.parentVersionCode)
            && !isBlank(processData.parentProcessCode)) {
        param.parent_process_def_cd = processData.parentProcessDefCode;
        param.parent_version_cd     = processData.parentVersionDefCode;
        param.parent_process_cd     = processData.parentProcessCode;
    } else {
        param.parent_process_def_cd = "";
        param.parent_version_cd     = "";
        param.parent_process_cd     = "";
    }
    param.next_task_info_flg    = "";
    param.runSelectActivityCd   = "";
    param.user_setting_key      = util.getValue(user_setting_key, "");

    // vZXʖɃp[^ݒ
    if(bpw_flag){
        param.process_def_cd  = getValue(processData.processDefCode, "");
        param.version_cd      = getValue(processData.versionCode, "");
        param.process_cd      = getValue(processData.processCode, "");
        param.activity_cd     = "";
        param.contentsType    = "DETAIL";
        param.mineTransferFlg = "";
        param.agent_user_cd   = "";
    } else {
        param.bpw_process_def_cd     = getValue(processData.processDefCode, "");
        param.bpw_version_cd         = getValue(processData.versionCode, "");
        param.bpw_process_cd         = getValue(processData.processCode, "");
        param.bpw_activity_cd        = "";
        param.bpw_draft_appoint_date =util.getValue(targetDate);
        param.bpw_parameter_cds      = util.getValue(parameterCodes);
        param.bpw_ack_mode           = "detail";
        param.bpw_app_type           = "";
        param.bpw_agt_user_cd        = "";
        param.bpw_ack_retry_type     = "";
        param.next_task_type         = "";
    }

    // [Nt[R[hUtil
    var codeUtil = new WorkflowCodeUtil();
    var pathType = util.getValue(processData.pathType, "");
    if (codeUtil.getEnumCodePathType("pathTyp_Script") == pathType) {
        param.path          = getValue(processData.scriptPath, "");
        bpwDetailPageObj.formAction = Procedure.imw_proc_utils.getFormActionScript(param.path);
    } else if (codeUtil.getEnumCodePathType("pathTyp_JEE") == pathType) {
        param.application   = getValue(processData.applicationId, "");
        param.service       = getValue(processData.serviceId, "");
        bpwDetailPageObj.formAction = Procedure.imw_proc_utils.getFormActionJavaEE(
                param.application, param.service);
    } else if (codeUtil.getEnumCodePathType("pathTyp_JspOrServlet") == pathType) {
        var jspPath           = getValue(processData.pagePath, "");
        param.path      = jspPath;
        bpwDetailPageObj.formAction = Procedure.imw_proc_utils.getFormActionJspOrServlet(param.path);
    }
    bpwDetailPageObj.param = param;
    return bpwDetailPageObj;
}

function getValue(stringValue, defaultValue){
    var returnString = Module.string.escapeHtml(Procedure.imw_utils.getValue(stringValue, defaultValue));
    return returnString;
}
