var oRequest = new Object();
var oMessages = {
        "cap0039" : MessageManager.getMessage("IMW.CAP.0039"),
        "cap1165" : MessageManager.getMessage("IMW.CAP.1165")
    };

function init(request) {
    // `FbN
    if (isBlank(request.imwSystemMatterId)) {
        Procedure.imw_error_utils.showErrorGreyboxClose("IMW.CLI.WRN.3515", "");
    }

    // ZbV
    var sessionInfo = AccessSecurityManager.getSessionInfo();
    var loginGroupId = sessionInfo.loginGroup;

    var util = Procedure.imw_utils;
    var systemMatterId = util.getValue(request.imwSystemMatterId, "");
    var baseDate = util.getValue(request.imwApplyBaseDate, "");
    var archiveMonth = Format.fromDate("yyyyMM", Format.toDate ("yyyy/MM/dd" , baseDate)); 
    var manager = new ImwBpwArchiveUtil(loginGroupId);
    var processDatas = manager.getArcMatterBpwProcessData(archiveMonth, systemMatterId);
    var parameterCodes = manager.getArcMatterBpwParameterCodes(archiveMonth, systemMatterId);

    var targetDate = baseDate;
    if(processDatas.length < 1) {
        oRequest.param = new Object();
        return;
    }

    var callPageObj = Content.executeFunction("workflow_bpw/archive/detail/archive_detail", "getBpwRequestParameter",
                                                processDatas[0], baseDate, false, sessionInfo.user, loginGroupId, parameterCodes);
    if(callPageObj == null || callPageObj.param == null) {
        oRequest.param = new Object();
        oRequest.formAction = "";
        return;
    }

    oRequest.param = callPageObj.param;
    oRequest.formAction = util.getValue(callPageObj.formAction, "");

}
