<%@ page contentType="text/html; charset=%JSP_CONTENT_CHAR_SET%" pageEncoding="%CHAR_SET%" %>
<%@ taglib prefix="imartj2ee" uri="http://www.intra-mart.co.jp/taglib/core/framework" %>
<%@ taglib prefix="imarttag" uri="http://www.intra-mart.co.jp/taglib/foundation/imarttag" %>
<%@ taglib prefix="imart" uri="http://www.intra-mart.co.jp/taglib/core/standard" %>
<%@ taglib prefix="workflow" uri="http://www.intra-mart.co.jp/taglib/imw/workflow" %>
<imartj2ee:HelperBean id="bean" class="jp.co.intra_mart.sample.workflow.purchase.controller.view.CommonHelperBean"/>

<html>
<head>
<imarttag:imartDesignCss/>
<workflow:workflowOpenPageCsjs />
<script type="text/javascript">
function onClickOpenPage(pageType) {
    if (pageType != "1") {
        if(!inputCheck()) {
            return;
        }
    }

    document.workflowOpenPageForm.imwMatterName.value      = document.workflowOpenPageForm.item_name.value;
    document.workflowOpenPageForm.imwComment.value         = document.workflowOpenPageForm.item_comment.value;
    document.workflowOpenPageForm.imwForcedParamFlag.value = "1";

    workflowOpenPage(pageType);
}

function inputCheck() {
    if ( document.workflowOpenPageForm.item_name.value == "" ) {
        alert('<%=bean.getMessage("SAMPLE.IMW.INF.000")%>');
        return false;
    }
    if ( document.workflowOpenPageForm.item_amount.value == "" ) {
        alert('<%=bean.getMessage("SAMPLE.IMW.INF.001")%>');
        return false;
    }
    if ( document.workflowOpenPageForm.item_price.value == "" ) {
        alert('<%=bean.getMessage("SAMPLE.IMW.INF.002")%>');
        return false;
    }
    if ( document.workflowOpenPageForm.item_amount.value.match( /[^0-9]+/ ) ) {
        alert('<%=bean.getMessage("SAMPLE.IMW.INF.003")%>');
        return false;
    }
    if ( document.workflowOpenPageForm.item_price.value.match( /[^0-9]+/ ) ) {
        alert('<%=bean.getMessage("SAMPLE.IMW.INF.004")%>');
        return false;
    }
    return true;
}
</script>
</head>
<body>
<workflow:workflowOpenPage name="workflowOpenPageForm"
                           method="POST"
                           target="IM_MAIN"
                           imwUserDataId='<%=(String)request.getAttribute("imwUserDataId")%>'
                           imwSystemMatterId='<%=(String)request.getAttribute("imwSystemMatterId")%>'
                           imwAuthUserCode='<%=(String)request.getAttribute("imwAuthUserCode")%>'
                           imwApplyBaseDate='<%=(String)request.getAttribute("imwApplyBaseDate")%>'
                           imwNodeId='<%=(String)request.getAttribute("imwNodeId")%>'
                           imwFlowId='<%=(String)request.getAttribute("imwFlowId")%>'
                           imwSerialProcParams='<%=(String)request.getAttribute("imwSerialProcParams")%>'
                           imwCallOriginalParams='<%=(String)request.getAttribute("imwCallOriginalParams")%>'
                           imwNextScriptPath='<%=(String)request.getAttribute("imwCallOriginalPagePath")%>'>
<imarttag:imartTitleBar title='<%=bean.getMessage("SAMPLE.IMW.CAP.011")%>'/>
<imarttag:imartToolbarFrame>
    <imarttag:imartToolbarLeft>
        <imart:decision case="0" value='<%=(String)request.getAttribute("imwPageType")%>'>
            <!-- \ -->
            <imarttag:imartIcon
                name = '<%=bean.getMessage("SAMPLE.IMW.CAP.003")%>'
                icon = "images/icons/16x16/window_new.png"
                href = "javascript:onClickOpenPage('0');" />
            <imarttag:imartIcon
                name = '<%=bean.getMessage("SAMPLE.IMW.CAP.002")%>'
                icon = "images/icons/16x16/windowlist.png"
                href = "javascript:onClickOpenPage('1');" />
        </imart:decision>
        <imart:decision case="1" value='<%=(String)request.getAttribute("imwPageType")%>'>
            <!-- ꎞۑ -->
            <imarttag:imartIcon
                name = '<%=bean.getMessage("SAMPLE.IMW.CAP.003")%>'
                icon = "images/icons/16x16/window_new.png"
                href = "javascript:onClickOpenPage('0');" />
            <imarttag:imartIcon
                name ='<%=bean.getMessage("SAMPLE.IMW.CAP.002")%>'
                icon = "images/icons/16x16/windowlist.png"
                href = "javascript:onClickOpenPage('1');" />
        </imart:decision>
        <imart:decision case="2" value='<%=(String)request.getAttribute("imwPageType")%>'>
            <!-- N[ -->
            <imarttag:imartIcon
                name = '<%=bean.getMessage("SAMPLE.IMW.CAP.003")%>'
                icon = "images/icons/16x16/window_new.png"
                href = "javascript:onClickOpenPage('2');" />
        </imart:decision>
        <imart:decision case="3" value='<%=(String)request.getAttribute("imwPageType")%>'>
            <!-- Đ\ -->
            <imarttag:imartIcon
                name = '<%=bean.getMessage("SAMPLE.IMW.CAP.004")%>'
                icon = "images/icons/16x16/window_new.png"
                href = "javascript:onClickOpenPage('3');" />
        </imart:decision>
    </imarttag:imartToolbarLeft>
    <imarttag:imartToolbarRight>
        <imarttag:imartIcon
            name = '<%=bean.getMessage("SAMPLE.IMW.CAP.001")%>'
            icon = "images/icons/16x16/agt_back.png"
            href = "javascript:document.backForm.submit();" />
    </imarttag:imartToolbarRight>
</imarttag:imartToolbarFrame>
<br>
<br>
<table cellSpacing="0" cellPadding="0" width="100%" border="0">
<tr><td align="center">
    <table class="edit">
        <tr>
            <imarttag:imartItemNameTd name      = '<%=bean.getMessage("SAMPLE.IMW.CAP.020")%>'
                                      require   = "true"/>
            <imarttag:imartInputTd    type      = "text"
                                      name      = "item_name"
                                      value     = '<%=(String)request.getAttribute("item_name")%>'
                                      size      = "50"
                                      inputAttr = 'maxlength = "127"' />
        </tr>
        <tr>
            <imarttag:imartItemNameTd name      = '<%=bean.getMessage("SAMPLE.IMW.CAP.021")%>'
                                      require   = "true"/>
            <imarttag:imartInputTd    type      = "text"
                                      name      = "item_amount"
                                      value     = '<%=(String)request.getAttribute("item_amount")%>'
                                      size      = "3"
                                      inputAttr = 'maxlength = "2"' />
        </tr>
        <tr>
            <imarttag:imartItemNameTd name      = '<%=bean.getMessage("SAMPLE.IMW.CAP.022")%>'
                                      require   = "true"/>
            <imarttag:imartInputTd    type      = "text"
                                      name      = "item_price"
                                      value     = '<%=(String)request.getAttribute("item_price")%>'
                                      size      = "10"
                                      inputAttr = 'maxlength = "8"' />
        </tr>
        <tr>
            <imarttag:imartItemNameTd name      = '<%=bean.getMessage("SAMPLE.IMW.CAP.024")%>'/>
            <imarttag:imartInputTd    type      = "textarea"
                                      name      = "item_comment"
                                      value     = '<%=(String)request.getAttribute("item_comment")%>'
                                      cols      = "40"
                                      rows      = "3" />
        </tr>
    </table>
</td></tr>
</table>

<input type="hidden" name="imwMatterName" value="">
<input type="hidden" name="imwComment" value="">
<input type="hidden" name="imwForcedParamFlag" value=""> 

</workflow:workflowOpenPage>

<imartj2ee:JSSPForm name="backForm" method="POST" page='<%=(String)request.getAttribute("imwCallOriginalPagePath")%>'>
    <input type="hidden" name=imwCallOriginalParams value='<%=(String)request.getAttribute("imwCallOriginalParams")%>' />
</imartj2ee:JSSPForm>
</body>
</html>
