<%@ page contentType="text/html; charset=%JSP_CONTENT_CHAR_SET%" pageEncoding="%CHAR_SET%" %>
<%@ taglib prefix="imartj2ee" uri="http://www.intra-mart.co.jp/taglib/core/framework" %>
<%@ taglib prefix="imarttag" uri="http://www.intra-mart.co.jp/taglib/foundation/imarttag" %>
<%@ taglib prefix="workflow" uri="http://www.intra-mart.co.jp/taglib/imw/workflow" %>
<imartj2ee:HelperBean id="bean" class="jp.co.intra_mart.sample.workflow.purchase.controller.view.CommonHelperBean"/>

<html>
<head>
<imarttag:imartDesignCss/>
<workflow:workflowOpenPageCsjs />
<script type="text/javascript">
function onClickOpenPage() {
    workflowOpenPage('<%=(String)request.getAttribute("imwPageType")%>');
}
</script>
</head>
<body>
<workflow:workflowOpenPage name="workflowOpenPageForm"
                           method="POST"
                           target="IM_MAIN"
                           imwSystemMatterId='<%=(String)request.getAttribute("imwSystemMatterId")%>'
                           imwNodeId='<%=(String)request.getAttribute("imwNodeId")%>'
                           imwSerialProcParams='<%=(String)request.getAttribute("imwSerialProcParams")%>'
                           imwCallOriginalParams='<%=(String)request.getAttribute("imwCallOriginalParams")%>'
                           imwNextScriptPath='<%=(String)request.getAttribute("imwCallOriginalPagePath")%>' />

<imarttag:imartTitleBar title='<%=bean.getMessage("SAMPLE.IMW.CAP.011")%>'/>
<imarttag:imartToolbarFrame>
    <imarttag:imartToolbarLeft>
        <imarttag:imartIcon
            name = '<%=bean.getMessage("SAMPLE.IMW.CAP.005")%>'
            icon = "images/icons/16x16/window_new.png"
            href = "javascript:onClickOpenPage();" />
    </imarttag:imartToolbarLeft>
    <imarttag:imartToolbarRight>
        <imarttag:imartIcon
            name = '<%=bean.getMessage("SAMPLE.IMW.CAP.001")%>'
            icon = "images/icons/16x16/agt_back.png"
            href = "javascript:document.backForm.submit();" />
    </imarttag:imartToolbarRight>
</imarttag:imartToolbarFrame>
<br>
<br>
<table cellSpacing="0" cellPadding="0" width="100%" border="0">
<tr><td align="center">
    <table class="edit">
        <tr>
            <imarttag:imartItemNameTd name     = '<%=bean.getMessage("SAMPLE.IMW.CAP.020")%>'/>
            <imarttag:imartInputTd    type     = "text"
                                      name     = "item_name"
                                      value    = '<%=(String)request.getAttribute("item_name")%>'
                                      size     = "50"
                                      readonly = "true"/>
        </tr>
        <tr>
            <imarttag:imartItemNameTd name     = '<%=bean.getMessage("SAMPLE.IMW.CAP.021")%>'/>
            <imarttag:imartInputTd    type     = "text"
                                      name     = "item_amount"
                                      value    = '<%=(String)request.getAttribute("item_amount")%>'
                                      size     = "3"
                                      readonly = "true"/>
        </tr>
        <tr>
            <imarttag:imartItemNameTd name     = '<%=bean.getMessage("SAMPLE.IMW.CAP.022")%>'/>
            <imarttag:imartInputTd    type     = "text"
                                      name     = "item_price"
                                      value    = '<%=(String)request.getAttribute("item_price")%>'
                                      size     = "10"
                                      readonly = "true"/>
        </tr>
        <tr>
            <imarttag:imartItemNameTd name     = '<%=bean.getMessage("SAMPLE.IMW.CAP.023")%>'/>
            <imarttag:imartInputTd    type     = "text"
                                      name     = "item_total"
                                      value    = '<%=(String)request.getAttribute("item_total")%>'
                                      size     = "15"
                                      readonly = "true"/>
        </tr>
        <tr>
            <imarttag:imartItemNameTd name     = '<%=bean.getMessage("SAMPLE.IMW.CAP.024")%>'/>
            <imarttag:imartInputTd    type     = "textarea"
                                      name     = "item_comment"
                                      value    = '<%=(String)request.getAttribute("item_comment")%>'
                                      cols     = "40"
                                      rows     = "3"
                                      readonly = "true"/>
        </tr>
    </table>
</td></tr>
</table>

<imartj2ee:JSSPForm name="backForm" method="POST" page='<%=(String)request.getAttribute("imwCallOriginalPagePath")%>'>
    <input type="hidden" name=imwCallOriginalParams value='<%=(String)request.getAttribute("imwCallOriginalParams")%>' />
</imartj2ee:JSSPForm>
</body>
</html>
