<%@ page contentType="text/html; charset=%JSP_CONTENT_CHAR_SET%" pageEncoding="%CHAR_SET%" %>
<%@ taglib prefix="imartj2ee" uri="http://www.intra-mart.co.jp/taglib/core/framework" %>
<%@ taglib prefix="imarttag" uri="http://www.intra-mart.co.jp/taglib/foundation/imarttag" %>
<%@ taglib prefix="workflow" uri="http://www.intra-mart.co.jp/taglib/imw/workflow" %>
<imartj2ee:HelperBean id="bean" class="jp.co.intra_mart.sample.workflow.purchase.controller.view.CommonHelperBean"/>

<html>
<head>
<imarttag:imartDesignCss/>
<workflow:workflowDesignCss />
<workflow:workflowOpenPageCsjs />
</head>
<body>
<imarttag:imartTitleBar title='<%=bean.getMessage("SAMPLE.IMW.CAP.011")%>'/>
<imarttag:imartToolbarFrame>
    <imarttag:imartToolbarLeft>
        <workflow:workflowMatterDetailLink systemMatterId='<%=(String)request.getAttribute("imwSystemMatterId")%>'>
            <imarttag:imartIcon
                name = '<%=bean.getMessage("SAMPLE.IMW.CAP.007")%>'
                icon = "images/icons/16x16/fugue-icons/shadow/clipboard-text.png" />
        </workflow:workflowMatterDetailLink>
    </imarttag:imartToolbarLeft>
    <imarttag:imartToolbarRight>
        <imarttag:imartIcon
            name = '<%=bean.getMessage("SAMPLE.IMW.CAP.000")%>'
            icon = "images/icons/16x16/close.png"
            href = "javascript:window.close();" />
    </imarttag:imartToolbarRight>
</imarttag:imartToolbarFrame>
<br>
<br>
<br>
<table cellSpacing="0" cellPadding="0" width="100%" border="0">
<tr><td align="center">
    <table class="edit">
        <tr>
            <imarttag:imartItemNameTd name     = '<%=bean.getMessage("SAMPLE.IMW.CAP.020")%>'/>
            <imarttag:imartInputTd    type     = "text"
                                      name     = "item_name"
                                      value    = '<%=(String)request.getAttribute("item_name")%>'
                                      size     = "50"
                                      readonly = "true"/>
        </tr>
        <tr>
            <imarttag:imartItemNameTd name     = '<%=bean.getMessage("SAMPLE.IMW.CAP.021")%>'/>
            <imarttag:imartInputTd    type     = "text"
                                      name     = "item_amount"
                                      value    = '<%=(String)request.getAttribute("item_amount")%>'
                                      size     = "3"
                                      readonly = "true"/>
        </tr>
        <tr>
            <imarttag:imartItemNameTd name     = '<%=bean.getMessage("SAMPLE.IMW.CAP.022")%>'/>
            <imarttag:imartInputTd    type     = "text"
                                      name     = "item_price"
                                      value    = '<%=(String)request.getAttribute("item_price")%>'
                                      size     = "10"
                                      readonly = "true"/>
        </tr>
        <tr>
            <imarttag:imartItemNameTd name     = '<%=bean.getMessage("SAMPLE.IMW.CAP.023")%>'/>
            <imarttag:imartInputTd    type     = "text"
                                      name     = "item_total"
                                      value    = '<%=(String)request.getAttribute("item_total")%>'
                                      size     = "15"
                                      readonly = "true"/>
        </tr>
        <tr>
            <imarttag:imartItemNameTd name     = '<%=bean.getMessage("SAMPLE.IMW.CAP.024")%>'/>
            <imarttag:imartInputTd    type     = "textarea"
                                      name     = "item_comment"
                                      value    = '<%=(String)request.getAttribute("item_comment")%>'
                                      cols     = "40"
                                      rows     = "3"
                                      readonly = "true"/>
        </tr>
    </table>
</td></tr>
</table>
</body>
</html>
