//==============================================================================
//    Ώێ҃vOC ev[g
//==============================================================================

//==============================================================================
//    ΏێҎ擾֐
//
//        y  z workflowParam                 : [Nt[p[^IuWFNg
//                   workflowParam.loginGroupId    : OCO[vID
//                   workflowParam.localeId        : P[ID
//                   workflowParam.targetLocales   : ^[QbgP[ID
//                   workflowParam.applyBaseDate   : \
//                   workflowParam.parameter       : p[^
//                   workflowParam.targetCodes     : ^[QbgR[hz
//
//                   matterParam                   : Čp[^IuWFNg
//                   matterParam.contentsId        : RecID
//                   matterParam.contentsVersionId : Reco[WID
//                   matterParam.routeId           : [gID
//                   matterParam.routeVersionId    : [go[WID
//                   matterParam.flowId            : t[ID
//                   matterParam.flowVersionId     : t[o[WID
//                   matterParam.nodeId            : m[hID
//                   matterParam.systemMatterId    : VXeČID
//                   matterParam.userDataId        : [Uf[^ID
//
//        yԋplz result                        : ԋplIuWFNg
//                   result.resultFlag             : ʃtO     [true:/false:s]
//                   result.message                : ʃbZ[W [ʃtOs̏ꍇ̂]
//                   result.data                   : Ώێ҂̔z
//                   result.data[]                         : ΏێҏIuWFNg
//                   result.data[].userCode                : Ώێ҂̃[UCD
//                   result.data[].userName                : Ώێ҂̃[U
//                   result.data[].localeId                : Ώێ҂̃P[ID
//                   result.data[].userOrgzModels          : Ώێ҂̏ꗗzij
//                   result.data[].userOrgzModels[]                : Ώێ҂̏IuWFNg
//                   result.data[].userOrgzModels[].companyName    : Ώێ҂̉Ж
//                   result.data[].userOrgzModels[].orgzName       : Ώێ҂̑gD
//                   result.data[].userOrgzModels[].companyCode    : Ώێ҂̉CD
//                   result.data[].userOrgzModels[].orgzSetCode    : Ώێ҂̑gDZbgCD
//                   result.data[].userOrgzModels[].orgzCode       : Ώێ҂̑gDCD
//
//        y ڍ z ČɎs֐łB
//                   Ώێ҂̃[UƏgDZbgƂ̔zԋp܂B
//
//                    ʂ́uSgDvꗗɕ\܂B
//==============================================================================
function execute(workflowParam, matterParam){

    Debug.print( "----- WorkflowAuthorityExecEventListener.js - execute -----" );
    Debug.console(workflowParam,matterParam);

    // [Uꗗ擾
    var listUser = getListUser(workflowParam.loginGroupId,
                               workflowParam.localeId,
                               workflowParam.applyBaseDate,
                               matterParam.systemMatterId,
                               matterParam.userDataId);

    var userList       = new Array();
    var userBizKeyInfo = new Object();
    var listDepartment = new Object();
    var i = 0;
    var j = 0;

    // e[UgDꗗ擾
    var companyManager = new IMMCompanyManager(WorkflowPluginUtilManager.getUser(),
                                               WorkflowPluginUtilManager.getLocale(),
                                               WorkflowPluginUtilManager.getLoginGroup());
    for (i=0;i<listUser.data.length; i++) {
         userBizKeyInfo.userCd = listUser.data[i].userCd;
         listDepartment        = companyManager.listDepartmentWithUser(userBizKeyInfo,
                                                                       new AppCmnSearchCondition(),
                                                                       false,
                                                                       new Date(workflowParam.applyBaseDate),
                                                                       WorkflowPluginUtilManager.getLocale());
         userList[i]                = new Object();
         userList[i].userCode       = listUser.data[i].userCd;
         userList[i].userName       = listUser.data[i].displayName;
         userList[i].localeId       = workflowParam.localeId;
         userList[i].userOrgzModels = new Array();

         for (j=0; j<listDepartment.data.length; j++) {
             userList[i].userOrgzModels[j]             = new Object();
             userList[i].userOrgzModels[j].companyName = "";
             userList[i].userOrgzModels[j].orgzName    = listDepartment.data[j].displayName;
             userList[i].userOrgzModels[j].companyCode = listDepartment.data[j].companyCd;
             userList[i].userOrgzModels[j].orgzSetCode = listDepartment.data[j].departmentSetCd;
             userList[i].userOrgzModels[j].orgzCode    = listDepartment.data[j].departmentCd;
         }
    }

    var result        = new Object();
    result.resultFlag = true;
    result.message    = "";
    result.data       = userList;

    Debug.console(result);
    Debug.print( "----- WorkflowAuthorityExecEventListener.js - execute -----" );

    return result;
}

//==============================================================================
//    Ώێ҃vOCݒ\擾֐
//
//        y  z workflowParam                 : [Nt[p[^IuWFNg
//                   workflowParam.loginGroupId    : OCO[vID
//                   workflowParam.localeId        : P[ID
//                   workflowParam.targetLocales   : ^[QbgP[ID
//                   workflowParam.applyBaseDate   : \
//                   workflowParam.parameter       : p[^
//
//        yԋplz result                        : ԋplIuWFNg
//                   result.resultFlag             : ʃtO     [true:/false:s]
//                   result.message                : ʃbZ[W [ʃtOs̏ꍇ̂]
//                   result.data                   : vOCIuWFNg
//                   result.data.[localeId]        : \
//
//        y ڍ z vOĈ̖\邽߂̊֐łB
//                   P[ɐݒ肷Kv܂B
//
//==============================================================================
function getDisplayName(workflowParam) {

    Debug.print( "----- WorkflowAuthorityExecEventListener.js - getDisplayName -----" );
    Debug.console(workflowParam);

    var data = new Object();
    data[workflowParam.localeId] = MessageManager.getMessage(workflowParam.parameter);

    var result        = new Object();
    result.resultFlag = true;
    result.message    = "";
    result.data       = data;

    Debug.console(result);
    Debug.print( "----- WorkflowAuthorityExecEventListener.js - getDisplayName -----" );

    return result;
}

//==============================================================================
//    Ώۃ[UXg擾֐
//
//        y  z workflowParam                 : [Nt[p[^IuWFNg
//                   workflowParam.loginGroupId    : OCO[vID
//                   workflowParam.localeId        : P[ID
//                   workflowParam.targetLocales   : ^[QbgP[ID
//                   workflowParam.applyBaseDate   : \
//                   workflowParam.parameter       : p[^
//                   workflowParam.targetCodes     : ^[QbgR[hz
//
//                   matterParam                   : Čp[^IuWFNg
//                   matterParam.contentsId        : RecID
//                   matterParam.contentsVersionId : Reco[WID
//                   matterParam.routeId           : [gID
//                   matterParam.routeVersionId    : [go[WID
//                   matterParam.flowId            : t[ID
//                   matterParam.flowVersionId     : t[o[WID
//                   matterParam.nodeId            : m[hID
//                   matterParam.systemMatterId    : VXeČID
//                   matterParam.userDataId        : [Uf[^ID
//
//                   sort                          : \[gz
//
//        yԋplz result                        : ԋplIuWFNg
//                   result.resultFlag             : ʃtO     [true:/false:s]
//                   result.message                : ʃbZ[W [ʃtOs̏ꍇ̂]
//                   result.data                   : ΏێҏIuWFNg
//                   result.data.[localeId]                : Ώێ҂̔z
//                   result.data.[localeId].userCode       : Ώێ҂̃[UCD
//                   result.data.[localeId].userName       : Ώێ҂̕\
//                   result.data.[localeId].localeId       : Ώێ҂̃P[ID
//
//        y ڍ z [Č]-[m[hҏW]ʂ́u󋵊mFv{^ɕ\
//                   [Ώێҏ󋵊mF]ʂŕ\郆[Uꗗԋp܂B
//
//==============================================================================
function getTargetUserList(workflowParam,matterParam,sort) {

    Debug.print( "----- WorkflowAuthorityExecEventListener.js - getTargetUserList -----" );
    Debug.console(workflowParam,matterParam,sort);

    // [Uꗗ擾
    var listUser = getListUser(workflowParam.loginGroupId,
                               workflowParam.localeId,
                               workflowParam.applyBaseDate,
                               matterParam.systemMatterId,
                               matterParam.userDataId);

    var userList =  new Array();
    for (var i=0;i<listUser.data.length; i++) {
        userList[i]          = new Object();
        userList[i].userCode = listUser.data[i].userCd;
        userList[i].userName = listUser.data[i].displayName;
        userList[i].localeId = workflowParam.localeId;
    }
    var data = new Object();
    data[workflowParam.localeId] = userList;

    var result        = new Object();
    result.resultFlag = true;
    result.message    = "";
    result.data       = data;

    Debug.console(result);
    Debug.print( "----- WorkflowAuthorityExecEventListener.js - getTargetUserList -----" );

    return result;
}



//==============================================================================
//   Ώێ҂̈ꗗ擾֐ivCx[g֐j
//
//   [vz]ɂAΏۂ̖EύX
//       5~ȏ             В
//       1~ȏA5~  
//       1~             ے
//==============================================================================
function getListUser(loginGroupId,localeId,applyBaseDate,systemMatterId,userDataId){
    var POST1 = "ps001";  // ECDFВ
    var POST2 = "ps002";  // ECDF
    var POST3 = "ps003";  // ECDFے
    
    // ČvpeB[vz]擾
    var matterProperty = new UserActvMatterPropertyValue(loginGroupId);
    var property       = matterProperty.getMatterProperty(userDataId,"item_total");
    var itemTotal      = Number(property.data.matterPropertyValue);

    // Eɏ郆[Uꗗ擾邽߂̏擾
    var bizKeyInfo      = new Object();
    var actvMatter      = new ActvMatter(loginGroupId,localeId,systemMatterId);
    var processHistory  = actvMatter.getProcessHistoryLatestList();
    for (var i=0; i<processHistory.data.length; i++) {
        // \҂IgDAuCDvugDZbgCDv擾
        if(processHistory.data[i].nodeType == "2") {
            bizKeyInfo.companyCd       = processHistory.data[i].authCompanyCode;
            bizKeyInfo.departmentSetCd = processHistory.data[i].authOrgzSetCode;
            break;
        }
    }
    if (itemTotal>=50000) {
        // 5~ȏ             В
        bizKeyInfo.postCd = POST1;
    } else if (itemTotal<50000 && itemTotal>=10000) {
        // 1~ȏA5~  
        bizKeyInfo.postCd = POST2;
    } else {
        // 1~             ے
        bizKeyInfo.postCd = POST3;
    }

    // Eɏ郆[Uꗗ擾
    var companyManager = new IMMCompanyManager(WorkflowPluginUtilManager.getUser(),
                                               WorkflowPluginUtilManager.getLocale(),
                                               WorkflowPluginUtilManager.getLoginGroup());
    var listUser       = companyManager.listUserWithCompanyPost(bizKeyInfo,
                                                                new AppCmnSearchCondition(),
                                                                new Date(applyBaseDate),
                                                                WorkflowPluginUtilManager.getLocale());

    return listUser;
}
