// oChϐ錾
var oCaption = new Object();
var oCommon = new Object();
var oValidationMsg = new Object();
var oResult = new Object();
var oHidden = new Object();
var oSortIcon = new Object();
var oResultTargetAct = new Object();
var oHiddenTargetAct = new Object();
var listData;
var pagingParts;

var IMW_T_ACT_START_DATE = OriginalActAdminList.START_DATE;
var IMW_T_ACT_LIMIT_DATE = OriginalActAdminList.LIMIT_DATE;
var IMW_T_ACT_APPLY_AUTH = OriginalActAdminList.APPLY_AUTH;
var IMW_T_ACT_APPROVE_AUTH = OriginalActAdminList.APPROVE_AUTH;

var BASE_EXTENSION_POINT_ID = "jp.co.intra_mart.workflow.plugin.authority.user.act.targetAct.personalAct";

//=============================================================================
// ֐
//  y  zrequest: tqk擾IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z㗝ꗗʂ\܂B
//=============================================================================
function init(request) {
    var result;
    var i;

    // ̂̎擾
    oCaption.title = MessageManager.getMessage("IMW.CAP.1062"); // ʃ^Cgu㗝mFv
    oCaption.conditionChange = MessageManager.getMessage("IMW.CAP.1022"); // \
    oCaption.refresh = MessageManager.getMessage("IMW.CAP.0003"); // ŐV
    oCaption.act = MessageManager.getMessage("IMW.CAP.1031"); // 㗝
    oCaption.appliAct = MessageManager.getMessage("IMW.CAP.1056"); // Ɩ㗝
    oCaption.start = MessageManager.getMessage("IMW.CAP.0072"); // Jn
    oCaption.end = MessageManager.getMessage("IMW.CAP.0073"); // I
    oCaption.targetAct = MessageManager.getMessage("IMW.CAP.1063"); // 㗝
    oCaption.baseDate = MessageManager.getMessage("IMW.CAP.1058"); // 
    oCaption.actDateRange = MessageManager.getMessage("IMW.CAP.1057"); // 㗝
    oCaption.originaiAct = MessageManager.getMessage("IMW.CAP.0385"); // 㗝
    oCaption.apply = MessageManager.getMessage("IMW.CAP.0010"); // \
    oCaption.approve = MessageManager.getMessage("IMW.CAP.0046"); // F
    oCaption.flowName = MessageManager.getMessage("IMW.CAP.0109"); // t[
    oCaption.search = MessageManager.getMessage("IMW.CAP.0359"); // 
    oCaption.decisionButton = MessageManager.getMessage("IMW.CAP.0343"); // 

    // ϐ錾
    var oSession = AccessSecurityManager.getSessionInfo();
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;
    var localeId = oSession.locale;
    var codeUtil = new WorkflowCodeUtil();
    var actConfig = new ActConfig(loginGroupId);
    var wfpManager = new WorkflowParameterManager(loginGroupId);

    // of[VbZ[W̎擾
    makeValidation(localeId);

    // ďop[^̐ݒ
    var imwCallOriginalParams;
    if (!isBlank(request.imwCallOriginalParams)) {
        imwCallOriginalParams = ImJson.parseJSON(URL.decode(request.imwCallOriginalParams));
    }
    if (!isObject(imwCallOriginalParams)) {
        imwCallOriginalParams = new Object();
    }

    // ʕ\񂪃NGXgp[^擾łꍇ
    var oConditionInfo = new Object();
    if (isObject(imwCallOriginalParams) && isObject(imwCallOriginalParams.orgActListParam)) {
        oConditionInfo = imwCallOriginalParams.orgActListParam;
    }

    // ̏ݒ
    oConditionInfo.offset = Procedure.imw_utils.getValue(oConditionInfo.offset, 0);
    oConditionInfo.count = wfpManager.getIntegerParameter("record-at-page");
    oConditionInfo.currentPage = Procedure.imw_utils.getValue(oConditionInfo.currentPage, 1);
    oConditionInfo.baseDate = Procedure.imw_utils.getValue(
            oConditionInfo.baseDate, Format.fromDate("yyyy/MM/dd", new Date()));
    oConditionInfo.originalActUserCode = Procedure.imw_utils.getValue(oConditionInfo.originalActUserCode, "");
    oConditionInfo.targetActUserCode = Procedure.imw_utils.getValue(oConditionInfo.targetActUserCode, userId);
    oConditionInfo.note = Procedure.imw_utils.getValue(oConditionInfo.note, "");
    oConditionInfo.applyAuthCheck = Procedure.imw_utils.getValue(oConditionInfo.applyAuthCheck, "");
    oConditionInfo.approveAuthCheck = Procedure.imw_utils.getValue(oConditionInfo.approveAuthCheck, "");
    oConditionInfo.enableFlag = codeUtil.getEnumCodeFlagStatus("Enable");
    oConditionInfo.disableFlag = codeUtil.getEnumCodeFlagStatus("Disable");
    oConditionInfo.personalActCond = wfpManager.getBooleanParameter("personal-act");
    oConditionInfo.applicationalActCond = wfpManager.getBooleanParameter("applicational-act");

    // \[g̐ݒ
    if (isBlank(oConditionInfo.orderByList)) {
        var orderByObj = new Array();
        orderByObj[0] = new Object();
        orderByObj[0].columnName = IMW_T_ACT_START_DATE;
        orderByObj[0].sortType = "ASC";
        orderByObj[1] = new Object();
        orderByObj[1].columnName = IMW_T_ACT_LIMIT_DATE;
        orderByObj[1].sortType = "ASC";
        orderByObj[2] = new Object();
        orderByObj[2].columnName = OriginalActAdminList.ORIGINAL_ACT_USER_CODE;
        orderByObj[2].sortType = "ASC";
        oConditionInfo.orderByList = orderByObj;
    }

    // inpj̎擾
    imwCallOriginalParams.imwOpeType = Procedure.imw_utils.getValue(imwCallOriginalParams.imwOpeType,
            request.imwOpeType);
    imwCallOriginalParams.orgActListParam = oConditionInfo;
    oResult.imwCallOriginalParams = URL.encode(ImJson.toJSONString(imwCallOriginalParams));

    // 㗝̃`FbN
    var isShowActConfig = true;
    if (!Procedure.imw_admin_utils.isWkfAdmin(oSession, imwCallOriginalParams.imwOpeType)) {
        result = actConfig.isActAuthorityUser(userId);
        if (!result.resultFlag) {
            Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3534", result);
        }
        isShowActConfig = result.data;
    }

    // ̍쐬
    var searchCondition = new ListSearchConditionNoMatterProperty();
    setListSearchCondition(searchCondition, oConditionInfo);

    // \[g̍쐬
    for (i = 0; i < oConditionInfo.orderByList.length; i++) {
        searchCondition.addOrder(oConditionInfo.orderByList[i].columnName,
                (oConditionInfo.orderByList[i].sortType == "ASC") ? true : false);
    }
    // Ӑ\[gڂ̍Ōɒǉ
    searchCondition.addOrder((isShowActConfig) ? OriginalActAdminList.NO : OriginalActList.NO, true);

    // 㗝ꗗ}l[W̐
    var manager;
    if (isShowActConfig) {
        manager = new OriginalActAdminList(loginGroupId, localeId);
    } else {
        manager = new OriginalActList(userId, loginGroupId, localeId);
    }

    // 㗝ꗗ̌擾
    searchCondition.setCount("0");
    searchCondition.setOffset("0");
    var count = manager.getPersListCount(searchCondition);
    if (!count.resultFlag) {
        Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3534", count);
    }

    // y[WO
    Procedure.imw_paging_utils.adjustPagingNumber(oConditionInfo, count.data);

    // 㗝ꗗ̎擾
    searchCondition.setCount(oConditionInfo.count + "");
    searchCondition.setOffset(oConditionInfo.offset + "");
    result = manager.getPersList(searchCondition);
    if (!result.resultFlag) {
        Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3534", result);
    }
    listData = result.data;

    // [Û̎擾
    for (i = 0; i < listData.length; i++) {
        listData[i].originalActUserName = Procedure.imw_user_list_utils.getUserName(userId, loginGroupId,
                localeId, listData[i].originalActUserCode);
    }

    // ꗗ̐ݒ
    for (i = 0; i < listData.length; i++) {
        listData[i].no = Procedure.imw_utils.escapeHTML(listData[i].no);
        listData[i].startDate = Procedure.imw_utils.escapeHTML(listData[i].startDate);
        listData[i].limitDate = Procedure.imw_utils.escapeHTML(listData[i].limitDate);
        listData[i].note = Procedure.imw_utils.escapeHTML(listData[i].note);
        listData[i].applyAuth = Procedure.imw_utils.escapeHTML(listData[i].applyAuth);
        listData[i].approveAuth = Procedure.imw_utils.escapeHTML(listData[i].approveAuth);
        listData[i].originalActUserCode = Procedure.imw_utils.escapeHTML(listData[i].originalActUserCode);
        listData[i].originalActUserName = Procedure.imw_utils.escapeHTML(listData[i].originalActUserName);
    }

    // ʏ̐ݒ
    oResult.isShowActConfig = isShowActConfig;
    oResult.isShowTab = (oConditionInfo.personalActCond && oConditionInfo.applicationalActCond) ? true : false;
    oResult.originalActUserName = "";
    oResult.targetActUserName = "";

    // 㗝E㗝於̂̎擾
    if (isShowActConfig) {
        oResult.originalActUserName = isBlank(oConditionInfo.originalActUserCode) ? "" :
                Procedure.imw_user_list_utils.getUserName(userId, loginGroupId, localeId,
                oConditionInfo.originalActUserCode);
        oResult.targetActUserName = isBlank(oConditionInfo.targetActUserCode) ? "" :
                Procedure.imw_user_list_utils.getUserName(userId, loginGroupId, localeId,
                oConditionInfo.targetActUserCode);
    }

    // ʈꗗwb_̐
    getHeaderInfo(oConditionInfo.orderByList[0]);

    // y[WO񐶐
    var oAttr = new Object();
    oAttr.maxRecord = count.data;
    oAttr.currentPage = oConditionInfo.currentPage;
    oAttr.perPageRecord = oConditionInfo.count;
    oAttr.isBlankWhenEmpty = true;
    pagingParts = Procedure.imw_paging_utils.createPagingParts(oAttr);

    // AvP[Vʃ}X^̐ݒ
    oCaption.imwAppCommonTitle = "";
    Procedure.imw_plugin_utils.initAppCommonMaster(oResultTargetAct,
            BASE_EXTENSION_POINT_ID, loginGroupId, localeId);

    // hidden ɏo͂鍀ڂ̐ݒ
    Procedure.imw_utils.makeHiddenObject(oHidden, oResult);
    Procedure.imw_utils.makeHiddenObject(oHidden, oConditionInfo);
    Procedure.imw_utils.makeHiddenObject(oHiddenTargetAct, oResultTargetAct);
}

//=============================================================================
// of[V`FbN쐬֐
//  y  zlocaleId: P[ID
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zof[V`FbN쐬܂B
//=============================================================================
function makeValidation(localeId) {
    var oParameter;
    oCommon = new Object();
    oCommon.localeId = localeId;
    oCommon.locales = System.getLocales(localeId);

    // 㗝̃[UID
    oParameter = Procedure.imw_validate_utils.makeParameter4SelectRequireId("targetActUserCode", "IMW.CAP.1063");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);

    // 
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("baseDate", "IMW.CAP.1058");
    oParameter.requireInput = true;
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
}

//=============================================================================
// wb_[ݒ֐
//   y  zorderByObj:  wb_[IuWFNg
//   y ԋp z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zwb_iLvVƃACRj𐶐܂B
//=============================================================================
function getHeaderInfo(orderByObj) {
    // ACR
    oSortIcon.startDate = Procedure.imw_paging_utils.createSortIconParts(orderByObj, IMW_T_ACT_START_DATE);
    oSortIcon.limitDate = Procedure.imw_paging_utils.createSortIconParts(orderByObj, IMW_T_ACT_LIMIT_DATE);
    oSortIcon.applyAuth = Procedure.imw_paging_utils.createSortIconParts(orderByObj, IMW_T_ACT_APPLY_AUTH);
    oSortIcon.approveAuth = Procedure.imw_paging_utils.createSortIconParts(orderByObj, IMW_T_ACT_APPROVE_AUTH);
}

//=============================================================================
// ݒ菈
//  y  zsearchCondition: f (I/O)
//            dispInfo: ʏ
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zʂ瑗Ă錟ݒ肷B
//=============================================================================
function setListSearchCondition(searchCondition, dispInfo) {
    // 㗝
    if (!isBlank(dispInfo.targetActUserCode)) {
        searchCondition.addCondition(
                OriginalActAdminList.TARGET_ACT_USER_CODE,
                dispInfo.targetActUserCode,
                ListSearchCondition.OP_EQ);
    }

    // 
    if (!isBlank(dispInfo.baseDate) && !isBlank(Format.toDate("yyyy/MM/dd", dispInfo.baseDate))) {
        searchCondition.addCondition(
                OriginalActAdminList.START_DATE,
                Procedure.imw_datetime_utils.formatDateToLastTimestamp(dispInfo.baseDate),
                ListSearchCondition.OP_LE);
        searchCondition.addCondition(
                OriginalActList.LIMIT_DATE,
                Procedure.imw_datetime_utils.formatDateToFirstTimestamp(dispInfo.baseDate),
                ListSearchCondition.OP_GE);
    }

    // 㗝
    if (!isBlank(dispInfo.originalActUserCode)) {
        searchCondition.addCondition(
                OriginalActAdminList.ORIGINAL_ACT_USER_CODE,
                dispInfo.originalActUserCode,
                ListSearchCondition.OP_EQ);
    }

    // i\j
    if (!isBlank(dispInfo.applyAuthCheck)) {
        searchCondition.addCondition(
                OriginalActAdminList.APPLY_AUTH,
                dispInfo.applyAuthCheck,
                ListSearchCondition.OP_EQ);
    }

    // iFj
    if (!isBlank(dispInfo.approveAuthCheck)) {
        searchCondition.addCondition(
                OriginalActAdminList.APPROVE_AUTH,
                dispInfo.approveAuthCheck,
                ListSearchCondition.OP_EQ);
    }
}

//=============================================================================
// \ύX
//  y  zrequest: tqk擾IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zw肳ꂽ\ŌA1y[Wڂ\쐬܂B
//=============================================================================
function actionDispSearch(request) {
    var imwCallOriginalParams = ImJson.parseJSON(URL.decode(request.imwCallOriginalParams));
    var oConditionInfo = imwCallOriginalParams.orgActListParam;
    if (!isBlank(request.searchCondition)) {
        var searchCondition = ImJson.parseJSON(request.searchCondition);
        for (var key in searchCondition) {
            oConditionInfo[key] = searchCondition[key];
        }
    }

    oConditionInfo.offset = 0;
    oConditionInfo.currentPage = 1;
    if (request.sortRefreshFlag == "true") {
        oConditionInfo.orderByList = "";
    }

    var oReqParam = new Object();
    oReqParam["imwCallOriginalParams"] = URL.encode(ImJson.toJSONString(imwCallOriginalParams));
    forward("workflow/act_config/org_act_cnfm/org_act_cnfm_list", oReqParam);
}

//=============================================================================
// ŐV֐
//  y  zrequest: tqk擾IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zw肳ꂽŌA1ڂ\쐬܂B
//=============================================================================
function actionRefresh(request) {
    var imwCallOriginalParams = ImJson.parseJSON(URL.decode(request.imwCallOriginalParams));
    var oConditionInfo = imwCallOriginalParams.orgActListParam;

    Procedure.imw_paging_utils.initActionRefresh(request, oConditionInfo);
    imwCallOriginalParams.orgActListParam = oConditionInfo;

    var oReqParam = new Object();
    oReqParam["imwCallOriginalParams"] = URL.encode(ImJson.toJSONString(imwCallOriginalParams));
    forward("workflow/act_config/org_act_cnfm/org_act_cnfm_list", oReqParam);
}

//=============================================================================
// wb_[NbN\[g֐
//  y  zrequest: tqk擾IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zNbNwb_Ń\[g쐬܂B
//=============================================================================
function actionSort(request) {
    var imwCallOriginalParams = ImJson.parseJSON(URL.decode(request.imwCallOriginalParams));
    var oConditionInfo = imwCallOriginalParams.orgActListParam;

    Procedure.imw_paging_utils.initActionSort(request, oConditionInfo);
    imwCallOriginalParams.orgActListParam = oConditionInfo;

    var oReqParam = new Object();
    oReqParam["imwCallOriginalParams"] = URL.encode(ImJson.toJSONString(imwCallOriginalParams));
    forward("workflow/act_config/org_act_cnfm/org_act_cnfm_list", oReqParam);
}

//=============================================================================
// y[WO֐
//  y  zrequest: tqk擾IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zy[WOs܂B
//=============================================================================
function actionPaging(request) {
    var imwCallOriginalParams = ImJson.parseJSON(URL.decode(request.imwCallOriginalParams));
    var oConditionInfo = imwCallOriginalParams.orgActListParam;

    Procedure.imw_paging_utils.initActionPaging(request, oConditionInfo);
    imwCallOriginalParams.orgActListParam = oConditionInfo;

    var oReqParam = new Object();
    oReqParam["imwCallOriginalParams"] = URL.encode(ImJson.toJSONString(imwCallOriginalParams));
    forward("workflow/act_config/org_act_cnfm/org_act_cnfm_list", oReqParam);
}

//=============================================================================
// ֐
//  y  zrequest: tqk擾IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zw肳ꂽŌ쐬܂B
//=============================================================================
function actionDecision(request) {
    var imwCallOriginalParams = ImJson.parseJSON(URL.decode(request.imwCallOriginalParams));
    var oConditionInfo = imwCallOriginalParams.orgActListParam;

    oConditionInfo.offset = 0;
    oConditionInfo.currentPage = 1;
    oConditionInfo.baseDate = request.baseDate;
    oConditionInfo.targetActUserCode = request.targetActUserCode;
    imwCallOriginalParams.orgActListParam = oConditionInfo;

    var oReqParam = new Object();
    oReqParam["imwCallOriginalParams"] = URL.encode(ImJson.toJSONString(imwCallOriginalParams));
    forward("workflow/act_config/org_act_cnfm/org_act_cnfm_list", oReqParam);
}
