// oChϐ錾
var oCaption = new Object();
var oCommon = new Object();
var oValidationMsg = new Object();
var oResult = new Object();
var oHidden = new Object();
var oResultOriginalAct = new Object();
var oHiddenOriginalAct = new Object();
var oResultTargetAct = new Object();
var oHiddenTargetAct = new Object();

var ORG_EXTENSION_POINT_ID = "jp.co.intra_mart.workflow.plugin.authority.user.act.originalAct";
var TGT_EXTENSION_POINT_ID = "jp.co.intra_mart.workflow.plugin.authority.user.act.targetAct.personalAct";

//=============================================================================
// ֐
//  y  zrequest: tqk擾IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z㗝ݒꗗʁigreyboxj\܂B
//=============================================================================
function init(request) {
    var result;

    // ʍږ̐ݒ
    oCaption.title = MessageManager.getMessage("IMW.CAP.1022"); // \
    oCaption.close = MessageManager.getMessage("IMW.CAP.0039"); // 
    oCaption.clear = MessageManager.getMessage("IMW.CAP.0093"); // S
    oCaption.originAct = MessageManager.getMessage("IMW.CAP.0385"); // 㗝
    oCaption.require = MessageManager.getMessage("IMW.CAP.0017"); // K{
    oCaption.baseDate = MessageManager.getMessage("IMW.CAP.1058"); // 
    oCaption.targetAct = MessageManager.getMessage("IMW.CAP.1063"); // 㗝
    oCaption.note = MessageManager.getMessage("IMW.CAP.0011"); // l
    oCaption.auth = MessageManager.getMessage("IMW.CAP.0234"); // 
    oCaption.approve = MessageManager.getMessage("IMW.CAP.0046"); // F
    oCaption.apply = MessageManager.getMessage("IMW.CAP.0010"); // \
    oCaption.person = MessageManager.getMessage("IMW.CAP.1030"); // {l
    oCaption.proxy = MessageManager.getMessage("IMW.CAP.1031"); // 㗝
    oCaption.search = MessageManager.getMessage("IMW.CAP.0359"); // 
    oCaption.remove = MessageManager.getMessage("IMW.CAP.0062"); // 
    oCaption.searchButton = MessageManager.getMessage("IMW.CAP.0005"); //  

    // ϐ錾
    var oSession = AccessSecurityManager.getSessionInfo();
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;
    var localeId = oSession.locale;
    var codeUtil = new WorkflowCodeUtil();
    var actConfig = new ActConfig(loginGroupId);
    var wfpManager = new WorkflowParameterManager(loginGroupId);

    // of[VbZ[W̎擾
    makeValidation(localeId);

    // ďop[^̐ݒ
    var imwCallOriginalParams;
    if (!isBlank(request.imwCallOriginalParams)) {
        imwCallOriginalParams = ImJson.parseJSON(URL.decode(request.imwCallOriginalParams));
    }
    if (!isObject(imwCallOriginalParams)) {
        imwCallOriginalParams = new Object();
    }

    // ʕ\񂪃NGXgp[^擾łꍇ
    var oConditionInfo = new Object();
    if (isObject(imwCallOriginalParams) && isObject(imwCallOriginalParams.trgActListParam)) {
        oConditionInfo = imwCallOriginalParams.trgActListParam;
    }

    // ̏ݒ
    oResult.isDirectPage = isBlank(oConditionInfo.count);
    oConditionInfo.baseDate = Procedure.imw_utils.getValue(
            oConditionInfo.baseDate, Format.fromDate("yyyy/MM/dd", new Date()));
    oConditionInfo.targetActUserExtensionPointId = Procedure.imw_utils.getValue(
            oConditionInfo.targetActUserExtensionPointId, "");
    oConditionInfo.targetActUserPluginId = Procedure.imw_utils.getValue(
            oConditionInfo.targetActUserPluginId, "");
    oConditionInfo.targetActUserParameter = Procedure.imw_utils.getValue(
            oConditionInfo.targetActUserParameter, "");
    oConditionInfo.originalActUserCode = Procedure.imw_utils.getValue(oConditionInfo.originalActUserCode, userId);
    oConditionInfo.targetActUserCode = Procedure.imw_utils.getValue(oConditionInfo.targetActUserCode, "");
    oConditionInfo.note = Procedure.imw_utils.getValue(oConditionInfo.note, "");
    oConditionInfo.applyAuthCheck = Procedure.imw_utils.getValue(oConditionInfo.applyAuthCheck, "");
    oConditionInfo.approveAuthCheck = Procedure.imw_utils.getValue(oConditionInfo.approveAuthCheck, "");
    oConditionInfo.enableFlag = codeUtil.getEnumCodeFlagStatus("Enable");
    oConditionInfo.disableFlag = codeUtil.getEnumCodeFlagStatus("Disable");
    oConditionInfo.personalActCond = wfpManager.getBooleanParameter("personal-act");
    oConditionInfo.applicationalActCond = wfpManager.getBooleanParameter("applicational-act");

    // inpj̎擾
    imwCallOriginalParams.imwOpeType = Procedure.imw_utils.getValue(imwCallOriginalParams.imwOpeType,
            request.imwOpeType);
    imwCallOriginalParams.trgActListParam = oConditionInfo;
    oResult.imwCallOriginalParams = URL.encode(ImJson.toJSONString(imwCallOriginalParams));

    // 㗝̃`FbN
    var isShowActConfig = true;
    if (!Procedure.imw_admin_utils.isWkfAdmin(oSession, imwCallOriginalParams.imwOpeType)) {
        result = actConfig.isActAuthorityUser(userId);
        if (!result.resultFlag) {
            Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3538", result);
        }
        isShowActConfig = result.data;
    }

    // ʏ̐ݒ
    oResult.originalActUserName = "";
    oResult.targetActUserName = "";

    // 㗝E㗝於̂̎擾
    if (isShowActConfig) {
        oResult.originalActUserName = isBlank(oConditionInfo.originalActUserCode) ? "" :
                Procedure.imw_user_list_utils.getUserName(userId, loginGroupId, localeId,
                oConditionInfo.originalActUserCode);
        oResult.targetActUserName = isBlank(oConditionInfo.targetActUserCode) ? "" :
                Procedure.imw_user_list_utils.getUserName(userId, loginGroupId, localeId,
                oConditionInfo.targetActUserCode);
    }

    // AvP[Vʃ}X^̐ݒ
    oCaption.imwAppCommonTitle = "";
    Procedure.imw_plugin_utils.initAppCommonMaster(oResultOriginalAct,
            ORG_EXTENSION_POINT_ID, loginGroupId, localeId);
    Procedure.imw_plugin_utils.initAppCommonMaster(oResultTargetAct,
            TGT_EXTENSION_POINT_ID, loginGroupId, localeId);

    // hidden ɏo͂鍀ڂ̐ݒ
    Procedure.imw_utils.makeHiddenObject(oHidden, oResult);
    Procedure.imw_utils.makeHiddenObject(oHidden, oConditionInfo);
    Procedure.imw_utils.makeHiddenObject(oHiddenOriginalAct, oResultOriginalAct);
    Procedure.imw_utils.makeHiddenObject(oHiddenTargetAct, oResultTargetAct);
}

//=============================================================================
// of[V`FbN쐬֐
//  y  zlocaleId: P[ID
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zof[V`FbN쐬܂B
//=============================================================================
function makeValidation(localeId) {
    var oParameter;
    oCommon = new Object();
    oCommon.localeId = localeId;
    oCommon.locales = System.getLocales(localeId);

    // 㗝̃[UID
    oParameter = Procedure.imw_validate_utils.makeParameter4SelectRequireId("originalActUserCode", "IMW.CAP.0385");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);

    // 
    oParameter = Procedure.imw_validate_utils.makeParameter4Date("baseDate", "IMW.CAP.1058");
    oParameter.requireInput = true;
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
}

//=============================================================================
// \ύX
//  y  zrequest: tqk擾IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zw肳ꂽ\ŌA1y[Wڂ\쐬܂B
//=============================================================================
function actionDispSearch(request) {
    var oReqParam = new Object();
    var imwCallOriginalParams = ImJson.parseJSON(URL.decode(request.imwCallOriginalParams));
    var oConditionInfo = imwCallOriginalParams.trgActListParam;
    if (!isBlank(request.searchCondition)) {
        var searchCondition = ImJson.parseJSON(request.searchCondition);
        for (var key in searchCondition) {
            oConditionInfo[key] = searchCondition[key];
        }
    }

    imwCallOriginalParams.trgActListParam = oConditionInfo;
    oReqParam["imwCallOriginalParams"] = URL.encode(ImJson.toJSONString(imwCallOriginalParams));
    forward("workflow/act_config/trg_act_conf/trg_act_conf_list", oReqParam);
}
