// oChϐ錾
var oCaption = new Object();
var oValidationMsg = new Object();
var oResult = new Object();
var oHidden = new Object();
var oConditionInfo = new Object();
var conditionInfo4Json;
var conditionInfo4JsonVersion;
var oSortIcon = new Object();
var listData;

// Java Model Bean ̃tB[h
var IMW_M_FLOW_DETAIL_START_DATE = FlowDataSearchConditionInfo.START_DATE;
var IMW_M_FLOW_DETAIL_LIMIT_DATE = FlowDataSearchConditionInfo.LIMIT_DATE;
var IMW_M_FLOW_DETAIL_NOTE = FlowDataSearchConditionInfo.NOTE;
var IMW_M_FLOW_DETAIL_VERSION_STATUS_FLAG = FlowDataSearchConditionInfo.VERSION_STATUS;
var IMW_M_FLOW_DETAIL_CONTENTS_FLAG = FlowDataSearchConditionInfo.CONTENTS_ID;
var IMW_M_FLOW_DETAIL_ROUTE_FLAG = FlowDataSearchConditionInfo.ROUTE_ID;

//=============================================================================
// ֐
//   y  zrequest: tqk擾IuWFNg
//   y ԋp zȂ
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zt[`ݒʂ\܂B
//=============================================================================
function init(request) {
    var databaseResult;
    var leng;
    var i;

    // inpj
    conditionInfo4Json = request.conditionInfo4Json;
    conditionInfo4JsonVersion = request.conditionInfo4JsonVersion;

    // ̂̎擾
    oCaption.title = MessageManager.getMessage("IMW.CAP.0198"); // ʃ^Cg
    oCaption.back = MessageManager.getMessage("IMW.CAP.0016"); // ߂
    oCaption.create = MessageManager.getMessage("IMW.CAP.0002"); // VK쐬
    oCaption.refresh = MessageManager.getMessage("IMW.CAP.0003"); // ŐV
    oCaption.require = MessageManager.getMessage("IMW.CAP.0017"); // K{
    oCaption.baseInfo = MessageManager.getMessage("IMW.CAP.0147"); // {
    oCaption.versionList = MessageManager.getMessage("IMW.CAP.0151"); // o[Wꗗ
    oCaption.flowId = MessageManager.getMessage("IMW.CAP.0196"); // t[ID
    oCaption.flowName = MessageManager.getMessage("IMW.CAP.0109"); // t[
    oCaption.note = MessageManager.getMessage("IMW.CAP.0011"); // l
    oCaption.adminGroup = MessageManager.getMessage("IMW.CAP.0149"); // ǗO[v
    oCaption.search = MessageManager.getMessage("IMW.CAP.0359"); // 
    oCaption.adminGroupName = MessageManager.getMessage("IMW.CAP.0104"); // ǗO[v
    oCaption.authType = MessageManager.getMessage("IMW.CAP.0110"); // ҏW
    oCaption.cancel = MessageManager.getMessage("IMW.CAP.0062"); // 
    oCaption.edit = MessageManager.getMessage("IMW.CAP.0006"); // ҏW
    oCaption.versionTerm = MessageManager.getMessage("IMW.CAP.0071"); // o[W
    oCaption.versionStatus = MessageManager.getMessage("IMW.CAP.0152"); // L
    oCaption.contentsFlag = MessageManager.getMessage("IMW.CAP.0108"); // Rec
    oCaption.routeFlag = MessageManager.getMessage("IMW.CAP.0107"); // [g
    oCaption.startDate = MessageManager.getMessage("IMW.CAP.0072"); // Jn
    oCaption.limitDate = MessageManager.getMessage("IMW.CAP.0073"); // I
    oCaption.select = MessageManager.getMessage("IMW.CAP.0092"); // I
    oCaption.update = MessageManager.getMessage("IMW.CAP.0022"); // XV
    oCaption.expunge = MessageManager.getMessage("IMW.CAP.0023"); // 폜

    // OC[U̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;
    var localeId = oSession.locale;

    // Qƌ`FbNƃANZX[̎擾
    var codeUtil = new WorkflowCodeUtil();
    var oParameter = new Object();
    oParameter.userId = userId;
    oParameter.loginGroupId = loginGroupId;
    oParameter.localeId = localeId;
    oParameter.adminType = codeUtil.getEnumCodeAdministrationType("adminTyp_Flow");
    oParameter.uniqueId = request.flowId;
    oParameter.errorId = "IMW.CLI.WRN.3249";
    oParameter.administratorType = Procedure.imw_admin_utils.decodeAdministratorType(oSession, request.imwOpeType);
    var accessRoles = Procedure.imw_admin_group_utils.checkInitAuth(request, oResult, oParameter);

    // of[VbZ[W̎擾
    var oCommon = new Object();
    oCommon.localeId = localeId;
    oCommon.locales = System.getLocales(localeId);
    oValidationMsg.confirmDelete = MessageManager.getMessage("IMW.CLI.INF.3224"); // 폜܂B낵łH
    // t[ID
    oParameter = Procedure.imw_validate_utils.makeParameter4InputRequireId("flowId", "IMW.CAP.0196");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    // t[
    oParameter = Procedure.imw_validate_utils.makeParameter4InputRequireName("flowName", "IMW.CAP.0109");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    // l
    oParameter = Procedure.imw_validate_utils.makeParameter4Note("note", "IMW.CAP.0011");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    // ǗO[v
    oParameter = Procedure.imw_validate_utils.makeParameter4Id("adminGroupId", "IMW.CAP.0149");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    // ҏW
    oParameter = Procedure.imw_validate_utils.makeParameter4Id("authType", "IMW.CAP.0110");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);

    // ʏ̏
    oResult.imwOpeType = request.imwOpeType;
    oResult.flowId = request.flowId;
    oResult.selectTab = isBlank(request.selectTab) ? "" : request.selectTab;

    // `̎擾
    oResult.locales = oCommon.locales;
    leng = oResult.locales.length;
    oResult.i18nFlag = leng > 1;
    oResult.flowNameList = new Array();
    oResult.noteList = new Array();
    for (i = 0; i < leng; i++) {
        var oNames = new Object();
        oNames.localeDisplayName = Procedure.imw_utils.escapeHTML(oResult.locales[i].displayName);
        oNames.flowName = "";
        oResult.flowNameList[i] = oNames;
        var oNotes = new Object();
        oNotes.localeDisplayName = Procedure.imw_utils.escapeHTML(oResult.locales[i].displayName);
        oNotes.note = "";
        oResult.noteList[i] = oNotes;
    }

    // Ǘ҃O[vꗗ̐ݒ
    if ("true" == oResult.wkfAdminGroupUseFlag) {
        var adminGroupManager = new AdminGroupManager(loginGroupId);
        var adminType = codeUtil.getEnumCodeAdministrationType("adminTyp_Flow");
        databaseResult = adminGroupManager.getAdminGroupManageWithAdminTypeTargetId(adminType, request.flowId);
        if (!databaseResult.resultFlag) {
            Module.alert.write(databaseResult.resultStatus.messageId, "");
        }
        var adminGroups = databaseResult.data;
        var authTypeEdit = codeUtil.getEnumCodeAuthorityType("authTypeEdit");
        oResult.adminGroupListData = new Array();
        for (leng = adminGroups.length, i = 0; i < leng; i++) {
            var adminGroup = new Object();
            adminGroup.adminGroupId = Procedure.imw_utils.escapeHTML(adminGroups[i].adminGroupId);
            adminGroup.authType = adminGroups[i].authType == authTypeEdit;
            databaseResult = adminGroupManager.getAdminGroupName(adminGroups[i].adminGroupId, localeId);
            if (databaseResult.resultFlag) {
                adminGroup.adminGroupName = Procedure.imw_utils.escapeHTML(databaseResult.data);
            }
            oResult.adminGroupListData[i] = adminGroup;
        }
    }

    // p̃IuWFNg (oConditionInfo) ̐ݒ
    var versionStatuses = new Array();
    var orderByObj = new Array();
    if (isUndefined(conditionInfo4JsonVersion)) {
        oConditionInfo.localeId = localeId;
        oConditionInfo.likeSearchCondition = IMW_M_FLOW_DETAIL_START_DATE;
        oConditionInfo.likeSearchValue = "";
        oConditionInfo.offset = 0;
        oConditionInfo.currentPage = 1;
        versionStatuses[0] = codeUtil.getEnumCodeVersionStatus("versionStatus_UserEnabled");
        versionStatuses[1] = codeUtil.getEnumCodeVersionStatus("versionStatus_UserDisabled");
        oConditionInfo.versionStatuses = versionStatuses;
        orderByObj[0] = new Object();
        orderByObj[0].columnName = IMW_M_FLOW_DETAIL_START_DATE;
        orderByObj[0].sortType = "ASC";
        oConditionInfo.orderByList = orderByObj;
    } else {
        oConditionInfo = ImJson.parseJSON(URL.decode(request.conditionInfo4JsonVersion));
        oConditionInfo.likeSearchValue = unescape(oConditionInfo.likeSearchValue);
    }

    // np[^̐ݒ
    conditionInfo4JsonVersion = URL.encode(ImJson.toJSONString(oConditionInfo));

    // t[ڍ׏ꗗ̎擾
    var manager = new FlowDataManager(loginGroupId);
    databaseResult = getFlowData(request, manager, localeId);
    if (!databaseResult.resultFlag) {
        Module.alert.write(databaseResult.resultStatus.messageId, "");
    }
    var contentsData = new Object(), routeData = new Object();
    if ("true" == oResult.wkfOpeAdmorFlag) {
        databaseResult = manager.getFlowDetailDataListWithAccessRole(request.flowId, oConditionInfo, accessRoles);
        if (!databaseResult.resultFlag) {
            Module.alert.write(databaseResult.resultStatus.messageId, "");
        }
        listData = databaseResult.data;

        var oEmptyConditionInfo = new Object();
        oEmptyConditionInfo.localeId = localeId;
        oEmptyConditionInfo.likeSearchCondition = "";
        oEmptyConditionInfo.likeSearchValue = "";
        oEmptyConditionInfo.offset = 0;

        // Rec̎擾
        var contentsManager = new ContentsDataManager(loginGroupId);
        databaseResult = contentsManager.getContentsDataListWithAccessRole(oEmptyConditionInfo, accessRoles);
        if (!databaseResult.resultFlag) {
            Module.alert.write(databaseResult.resultStatus.messageId, "");
        }
        for (leng = databaseResult.data.length, i = 0; i < leng; i++) {
            contentsData[databaseResult.data[i].contentsId] = true;
        }

        // [g̎擾
        var routeManager = new RouteDataManager(loginGroupId);
        databaseResult = routeManager.getRouteDataListWithAccessRole(oEmptyConditionInfo, accessRoles);
        if (!databaseResult.resultFlag) {
            Module.alert.write(databaseResult.resultStatus.messageId, "");
        }
        for (leng = databaseResult.data.length, i = 0; i < leng; i++) {
            routeData[databaseResult.data[i].routeId] = true;
        }
    } else {
        databaseResult = manager.getFlowDetailDataList(request.flowId, oConditionInfo);
        if (!databaseResult.resultFlag) {
            Module.alert.write(databaseResult.resultStatus.messageId, "");
        }
        listData = databaseResult.data;
    }

    // t[ڍ׏ꗗ̐ݒ
    oConditionInfo.likeSearchCondition = Procedure.imw_utils.escapeHTML(oConditionInfo.likeSearchCondition);
    oConditionInfo.likeSearchValue = Procedure.imw_utils.escapeHTML(oConditionInfo.likeSearchValue);
    var versionStatusEnabled = codeUtil.getEnumCodeVersionStatus("versionStatus_UserEnabled");
    if ("true" == oResult.wkfOpeAdmorFlag) {
        for (leng = listData.length, i = 0; i < leng; i++) {
            listData[i].flowVersionId = Procedure.imw_utils.escapeHTML(listData[i].flowVersionId);
            listData[i].startDate = Procedure.imw_utils.escapeHTML(listData[i].startDate);
            listData[i].limitDate = Procedure.imw_utils.escapeHTML(listData[i].limitDate);
            listData[i].note = Procedure.imw_utils.escapeHTML(listData[i].note);
            listData[i].versionStatus = listData[i].versionStatus == versionStatusEnabled ? "1" : "0";
            listData[i].contentsFlag = (listData[i].contentsId == Procedure.imw_utils.convertEmpty(listData[i].enabledContentsId) &&
                    contentsData[listData[i].contentsId]) ? "1" : "0";
            listData[i].routeFlag = (listData[i].routeId == Procedure.imw_utils.convertEmpty(listData[i].enabledRouteId) &&
                    routeData[listData[i].routeId]) ? "1" : "0";
        }
    } else {
        for (leng = listData.length, i = 0; i < leng; i++) {
            listData[i].flowVersionId = Procedure.imw_utils.escapeHTML(listData[i].flowVersionId);
            listData[i].startDate = Procedure.imw_utils.escapeHTML(listData[i].startDate);
            listData[i].limitDate = Procedure.imw_utils.escapeHTML(listData[i].limitDate);
            listData[i].note = Procedure.imw_utils.escapeHTML(listData[i].note);
            listData[i].versionStatus = listData[i].versionStatus == versionStatusEnabled ? "1" : "0";
            listData[i].contentsFlag = listData[i].contentsId == Procedure.imw_utils.convertEmpty(listData[i].enabledContentsId) ? "1" : "0";
            listData[i].routeFlag = listData[i].routeId == Procedure.imw_utils.convertEmpty(listData[i].enabledRouteId) ? "1" : "0";
        }
    }

    // \[gACR̐ݒ
    orderByObj = oConditionInfo.orderByList;
    oSortIcon.startDate = Procedure.imw_paging_utils.createSortIconParts(orderByObj[0], IMW_M_FLOW_DETAIL_START_DATE);
    oSortIcon.limitDate = Procedure.imw_paging_utils.createSortIconParts(orderByObj[0], IMW_M_FLOW_DETAIL_LIMIT_DATE);
    oSortIcon.note = Procedure.imw_paging_utils.createSortIconParts(orderByObj[0], IMW_M_FLOW_DETAIL_NOTE);
    oSortIcon.versionStatus = Procedure.imw_paging_utils.createSortIconParts(orderByObj[0], IMW_M_FLOW_DETAIL_VERSION_STATUS_FLAG);
    oSortIcon.contentsFlag = Procedure.imw_paging_utils.createSortIconParts(orderByObj[0], IMW_M_FLOW_DETAIL_CONTENTS_FLAG);
    oSortIcon.routeFlag = Procedure.imw_paging_utils.createSortIconParts(orderByObj[0], IMW_M_FLOW_DETAIL_ROUTE_FLAG);

    // hidden ɏo͂鍀ڂ̐ݒ
    Procedure.imw_utils.makeHiddenObject(oHidden, oResult);
    conditionInfo4Json = Procedure.imw_utils.escapeHTML(conditionInfo4Json);
    conditionInfo4JsonVersion = Procedure.imw_utils.escapeHTML(conditionInfo4JsonVersion);
}

//=============================================================================
// wb_[NbN\[g֐
//   y  zrequest: tqk擾IuWFNg
//   y ԋp zȂ
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zNbNwb_Ń\[g쐬܂B
//=============================================================================
function actionSort(request) {
    oConditionInfo = ImJson.parseJSON(URL.decode(request.conditionInfo4JsonVersion));
    Procedure.imw_paging_utils.initActionSort(request, oConditionInfo);

    var oReqParam = new Object();
    oReqParam["imwOpeType"] = request.imwOpeType;
    oReqParam["flowId"] = request.flowId;
    oReqParam["updateCount"] = request.updateCount;
    oReqParam["conditionInfo4Json"] = request.conditionInfo4Json;
    oReqParam["conditionInfo4JsonVersion"] = URL.encode(ImJson.toJSONString(oConditionInfo));
    oReqParam["selectTab"] = "version";
    forward("workflow/admin/master/flow/flow_edit", oReqParam);
}

//=============================================================================
// XV֐
//   y  zrequest: tqk擾IuWFNg
//   y ԋp z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zw肳ꂽt[`VK쐬܂B
//=============================================================================
function actionUpdate(request) {
    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();

    // OC[U̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;
    var localeId = oSession.locale;

    // ǗҎʂ̎擾
    result.wkfOpeAdmorFlag = Procedure.imw_admin_utils.isWkfOpeAdmor(oSession, request.imwOpeType);

    // f[^x[X`FbN
    var manager = new FlowDataManager(loginGroupId);
    if (!checkUpdateData(request, result, manager, userId, loginGroupId, localeId)) {
        return result;
    }

    // f[^XV
    if (!updateData(request, result, manager, userId, loginGroupId, localeId)) {
        return result;
    }

    return result;
}

//=============================================================================
// 폜֐
//   y  zrequest: tqk擾IuWFNg
//   y ԋp z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zw肳ꂽt[`폜܂B
//=============================================================================
function actionDelete(request) {
    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();

    // OC[U̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;
    var localeId = oSession.locale;

    // ǗҎʂ̎擾
    result.wkfOpeAdmorFlag = Procedure.imw_admin_utils.isWkfOpeAdmor(oSession, request.imwOpeType);

    // f[^x[X`FbN
    var manager = new FlowDataManager(loginGroupId);
    if (!checkDeleteData(request, result, manager, userId, loginGroupId, localeId)) {
        return result;
    }

    // f[^폜
    if (!deleteData(request, result, manager, userId, loginGroupId, localeId)) {
        return result;
    }

    return result;
}

//=============================================================================
// t[擾֐
//   y  zrequest:     tqk擾IuWFNg
//             manager:     FlowDataManagerNX̃CX^X
//             localeId:    P[ID
//   y ԋp z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zt[擾܂B
//=============================================================================
function getFlowData(request, manager, localeId) {
    var databaseResult;
    var leng;
    var leng2;
    var i;
    var j;

    // t[̎擾
    databaseResult = manager.getFlowData(request.flowId);
    if (!databaseResult.resultFlag) {
        return databaseResult;  // G[
    }
    if (databaseResult.data.length == 0) {
        databaseResult.resultFlag = false;
        databaseResult.resultStatus = new Object();
        databaseResult.resultStatus.messageId = "IMW.CLI.WRN.3224";
        return databaseResult;  // G[
    }

    // t[̐ݒ
    leng = oResult.locales.length;
    oResult.flowName = new Array();
    oResult.note = new Array();
    for (leng2 = databaseResult.data.length, j = 0; j < leng2; j++) {
        oResult.updateCount = databaseResult.data[j].updateCount || "";
        for (i = 0; i < leng; i++) {
            if (oResult.locales[i].locale != databaseResult.data[j].localeId) {
                continue;
            }
            oResult.flowNameList[i].flowName = Procedure.imw_utils.escapeHTML(
                    Procedure.imw_utils.convertEmpty(databaseResult.data[j].flowName));
            oResult.noteList[i].note = Procedure.imw_utils.escapeHTML(
                    Procedure.imw_utils.convertEmpty(databaseResult.data[j].note));
        }
    }

    return databaseResult;
}

//=============================================================================
// t[`ԃ`FbN֐(XVp)
//   y  zrequest:     tqk擾IuWFNg
//             result:      
//             manager:     FlowDataManagerNX̃CX^X
//             userId:      [UID
//             loginGroupId:OCO[vID
//             localeId:    P[ID
//   y ԋp z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zt[`XV\Ԃł邩mF܂B
//=============================================================================
function checkUpdateData(request, result, manager, userId, loginGroupId, localeId) {
    var databaseResult;

    // t[`̑݃`FbN
    databaseResult = manager.getFlowData(request.flowId);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        return false;
    }
    if (databaseResult.data.length == 0) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage("IMW.CLI.WRN.3224");
        return false;
    }
    result.flowData = databaseResult.data;

    // XVJE^̃`FbN
    if ((databaseResult.data[0].updateCount || "") != request.updateCount) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage("IMW.CLI.WRN.3225");
        return false;
    }

    // ǗO[v`̑݃`FbN
    if (!Procedure.imw_admin_group_utils.checkAdminGroup(request, result, loginGroupId, localeId)) {
        return false;
    }

    // ^pǗ҂̏ꍇ͊e팠`FbN
    if (result.wkfOpeAdmorFlag) {
        var codeUtil = new WorkflowCodeUtil();
        var oParameter = new Object();
        oParameter.userId = userId;
        oParameter.loginGroupId = loginGroupId;
        oParameter.localeId = localeId;

        // t[`̕ҏW`FbN
        oParameter.adminType = codeUtil.getEnumCodeAdministrationType("adminTyp_Flow");
        oParameter.uniqueId = request.flowId;
        oParameter.errorId = "IMW.CLI.WRN.3249";
        if (!Procedure.imw_admin_group_utils.checkUpdateAuth(result, oParameter)) {
            return false;
        }
    }

    return true;
}

//=============================================================================
// t[`ԃ`FbN֐(폜p)
//   y  zrequest:     tqk擾IuWFNg
//             result:      
//             manager:     FlowDataManagerNX̃CX^X
//             userId:      [UID
//             loginGroupId:OCO[vID
//             localeId:    P[ID
//   y ԋp z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zt[`폜\Ԃł邩mF܂B
//=============================================================================
function checkDeleteData(request, result, manager, userId, loginGroupId, localeId) {
    var databaseResult;

    // t[`̑݃`FbN
    databaseResult = manager.getFlowData(request.flowId);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        return false;
    }
    if (databaseResult.data.length == 0) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage("IMW.CLI.WRN.3224");
        return false;
    }
    result.flowData = databaseResult.data;

    // XVJE^̃`FbN
    if ((databaseResult.data[0].updateCount || "") != request.updateCount) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage("IMW.CLI.WRN.3225");
        return false;
    }

    // ^pǗ҂̏ꍇ͊e팠`FbN
    if (result.wkfOpeAdmorFlag) {
        var codeUtil = new WorkflowCodeUtil();
        var oParameter = new Object();
        oParameter.userId = userId;
        oParameter.loginGroupId = loginGroupId;
        oParameter.localeId = localeId;

        // t[`̕ҏW`FbN
        oParameter.adminType = codeUtil.getEnumCodeAdministrationType("adminTyp_Flow");
        oParameter.uniqueId = request.flowId;
        oParameter.errorId = "IMW.CLI.WRN.3249";
        if (!Procedure.imw_admin_group_utils.checkUpdateAuth(result, oParameter)) {
            return false;
        }
    }

    return true;
}

//=============================================================================
// t[XV֐
//   y  zrequest:     tqk擾IuWFNg
//             result:      
//             manager:     FlowDataManagerNX̃CX^X
//             userId:      [UID
//             loginGroupId:OCO[vID
//             localeId:    P[ID
//   y ԋp z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zt[XV܂B
//=============================================================================
function updateData(request, result, manager, userId, loginGroupId, localeId) {
    var databaseResult;
    var leng;
    var i;

    // łɓo^ς݂̃P[擾
    var existLocales = new Object();
    for (leng = result.flowData.length, i = 0; i < leng; i++) {
        existLocales[result.flowData[i].localeId] = true;
    }

    // t[ݒ
    var createRecords = new Array();
    var updateRecords = new Array();
    var deleteRecords = new Array();
    var record;
    for (leng = request.localeId.length, i = 0; i < leng; i++) {
        record = new Object();
        record.flowId = request.flowId;
        record.localeId = request.localeId[i];
        record.flowName = request.flowName[i];
        record.note = request.note[i];
        record.updateCount = Procedure.imw_utils.incrementCount(request.updateCount);
        if (existLocales[request.localeId[i]]) {
            updateRecords[updateRecords.length] = record;
        } else {
            createRecords[createRecords.length] = record;
        }
        existLocales[request.localeId[i]] = false;
    }
    for (i in existLocales) {
        if (!existLocales[i]) {
            continue;
        }
        record = new Object();
        record.flowId = request.flowId;
        record.localeId = i;
        deleteRecords[deleteRecords.length] = record;
    }

    // of[V`FbN
    var validateUtil = new WorkflowValidateUtil(loginGroupId);
    if (createRecords.length > 0) {
        databaseResult = validateUtil.validateForClass("FlowDataModel", createRecords);
        if (!Procedure.imw_validate_utils.getWorkflowValidateMessage(databaseResult, result, "IMW.CLI.WRN.3270")) {
            return false;
        }
    }
    if (updateRecords.length > 0) {
        databaseResult = validateUtil.validateForClass("FlowDataModel", updateRecords);
        if (!Procedure.imw_validate_utils.getWorkflowValidateMessage(databaseResult, result, "IMW.CLI.WRN.3270")) {
            return false;
        }
    }

    // ǗO[vǗΏۏݒ
    var codeUtil = new WorkflowCodeUtil();
    var adminType = codeUtil.getEnumCodeAdministrationType("adminTyp_Flow");
    var adminRecords = Procedure.imw_admin_group_utils.getAdminGroup4Update(request, result,
            loginGroupId, adminType, request.flowId);
    if (!Procedure.imw_admin_group_utils.validateAdminGroup4Update(result, validateUtil, adminRecords)) {
        return false;
    }

    // gUNV̊Jn
    databaseResult = DatabaseManager.beginTransaction();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = databaseResult.errorMessage;
        return false;
    }

    // t[폜
    if (deleteRecords.length > 0) {
        databaseResult = manager.deleteFlowDataFamily(deleteRecords);
        if (!databaseResult.resultFlag) {
            result.resultFlag = false;
            result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
            // [obN
            databaseResult = DatabaseManager.rollback();
            if (databaseResult.error) {
                result.resultStatus.message = databaseResult.errorMessage;
            }
            return false;
        }
    }

    // t[VK쐬
    if (createRecords.length > 0) {
        databaseResult = manager.createFlowDataWithAdjust(createRecords);
        if (!databaseResult.resultFlag) {
            result.resultFlag = false;
            result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
            // [obN
            databaseResult = DatabaseManager.rollback();
            if (databaseResult.error) {
                result.resultStatus.message = databaseResult.errorMessage;
            }
            return false;
        }
    }

    // t[XV
    if (updateRecords.length > 0) {
        databaseResult = manager.updateFlowDataWithAdjust(updateRecords);
        if (!databaseResult.resultFlag) {
            result.resultFlag = false;
            result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
            // [obN
            databaseResult = DatabaseManager.rollback();
            if (databaseResult.error) {
                result.resultStatus.message = databaseResult.errorMessage;
            }
            return false;
        }
    }

    // ǗO[vǗΏۏXV
    if (!Procedure.imw_admin_group_utils.updateAdminGroup(request, result, loginGroupId, adminType, request.flowId, adminRecords)) {
        // [obN
        databaseResult = DatabaseManager.rollback();
        if (databaseResult.error) {
            result.resultStatus.message = databaseResult.errorMessage;
        }
        return false;
    }

    // R~bg
    databaseResult = DatabaseManager.commit();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = databaseResult.errorMessage;
        return false;
    }

    return true;
}

//=============================================================================
// t[폜֐
//   y  zrequest:     tqk擾IuWFNg
//             result:      
//             manager:     FlowDataManagerNX̃CX^X
//             userId:      [UID
//             loginGroupId:OCO[vID
//             localeId:    P[ID
//   y ԋp z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zt[폜܂B
//=============================================================================
function deleteData(request, result, manager, userId, loginGroupId, localeId) {
    var databaseResult;

    // t[ݒ
    var record = new Object();
    record.flowId = request.flowId;

    // ǗO[vǗΏۏݒ
    var codeUtil = new WorkflowCodeUtil();
    var adminType = codeUtil.getEnumCodeAdministrationType("adminTyp_Flow");

    // gUNV̊Jn
    databaseResult = DatabaseManager.beginTransaction();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = databaseResult.errorMessage;
        return false;
    }

    // t[Ɣz̑S폜
    databaseResult = manager.deleteFlowDataFamily(record);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        // [obN
        databaseResult = DatabaseManager.rollback();
        if (databaseResult.error) {
            result.resultStatus.message = databaseResult.errorMessage;
        }
        return false;
    }

    // ǗO[vǗΏۏ폜
    if (!Procedure.imw_admin_group_utils.deleteAdminGroup(request, result, loginGroupId, adminType, request.flowId)) {
        // [obN
        databaseResult = DatabaseManager.rollback();
        if (databaseResult.error) {
            result.resultStatus.message = databaseResult.errorMessage;
        }
        return false;
    }

    // t[O[vݒ폜
    var flowGroupManager = new FlowGroupManager(loginGroupId);
    var flowGroup = new Object();
    flowGroup.flowId = request.flowId;
    databaseResult = flowGroupManager.deleteFlowGroupInfo(flowGroup);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        // [obN
        databaseResult = DatabaseManager.rollback();
        if (databaseResult.error) {
            result.resultStatus.message = databaseResult.errorMessage;
        }
        return false;
    }

    // R~bg
    databaseResult = DatabaseManager.commit();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = databaseResult.errorMessage;
        return false;
    }

    return true;
}
