// oChϐ錾
var oCaption = new Object();
var oValidationMsg = new Object();
var oResult = new Object();
var oHidden = new Object();
var listLocales = Array();
var i18nFlag;
var conditionInfo4Json;
var oMailTemplateDataModel = new Object();
var oMailTemplateFile = new Object();

var MAIL_ADDRESS_SEPARATOR = ",";

//=============================================================================
// ֐
//   y  zrequest: tqk擾IuWFNg
//   y ԋp zȂ
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv z[`ҏWʂ\܂B
//=============================================================================
function init(request) {

    // inpj
    conditionInfo4Json = request.conditionInfo4Json;

    // LvV擾
    oCaption.title = MessageManager.getMessage("IMW.CAP.0183"); // ʃ^Cgi[` - ҏWj
    oCaption.require = MessageManager.getMessage("IMW.CAP.0017"); // K{
    oCaption.systemStandard = MessageManager.getMessage("IMW.CAP.0049"); // iVXeWj
    oCaption.back = MessageManager.getMessage("IMW.CAP.0016"); // ߂(N)
    oCaption.copy = MessageManager.getMessage("IMW.CAP.0050"); // Rs[
    oCaption.preview = MessageManager.getMessage("IMW.CAP.0030"); // vr[
    oCaption.checkStatus = MessageManager.getMessage("IMW.CAP.0052"); // p󋵊mF
    oCaption.mailReplaceList = MessageManager.getMessage("IMW.CAP.0031"); // [u
    oCaption.mailId = MessageManager.getMessage("IMW.CAP.0026"); // [ID
    oCaption.mailType = MessageManager.getMessage("IMW.CAP.0025"); // [
    oCaption.mailName = MessageManager.getMessage("IMW.CAP.0027"); // [
    oCaption.note = MessageManager.getMessage("IMW.CAP.0011"); // l
    oCaption.to = MessageManager.getMessage("IMW.CAP.0032"); // 
    oCaption.cc = MessageManager.getMessage("IMW.CAP.0033"); // CC
    oCaption.bcc = MessageManager.getMessage("IMW.CAP.0034"); // BCC
    oCaption.replyTo = MessageManager.getMessage("IMW.CAP.0035"); // ԐM̈
    oCaption.subject = MessageManager.getMessage("IMW.CAP.0036"); // 
    oCaption.body = MessageManager.getMessage("IMW.CAP.0037"); // {
    oCaption.update = MessageManager.getMessage("IMW.CAP.0022"); // X V
    oCaption.del = MessageManager.getMessage("IMW.CAP.0023"); //  
    oCaption.from = MessageManager.getMessage("IMW.CAP.0574"); // ol(FROM)

    // OC[U̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;
    var localeId = oSession.locale;

    // Qƌ`FbNƌʂ̎擾
    var codeUtil = new WorkflowCodeUtil();
    var oParameter = new Object();
    oParameter.userId = userId;
    oParameter.loginGroupId = loginGroupId;
    oParameter.localeId = localeId;
    oParameter.adminType = codeUtil.getEnumCodeAdministrationType("adminTyp_MailTemplate");
    oParameter.errorId = "IMW.CLI.WRN.3207";
    oParameter.administratorType = Procedure.imw_admin_utils.decodeAdministratorType(oSession, request.imwOpeType);
    oResult.accessRoles = Procedure.imw_admin_group_utils.checkInitAuth(request, oResult, oParameter);
    oResult.imwOpeType = request.imwOpeType;

    // `̎擾
    var locales = System.getLocales(oSession.locale);
    var localeCount = locales.length;
    i18nFlag = (localeCount>1) ? true : false;

    // of[VbZ[W̎擾
    var oCommon = new Object();
    oCommon.localeId = localeId;
    oCommon.locales = locales;
    oValidationMsg.confirm = MessageManager.getMessage("IMW.CLI.INF.3208"); // [`폜܂B낵łH
    // [ID
    oParameter = Procedure.imw_validate_utils.makeParameter4InputRequireId("mailId", "IMW.CAP.0026");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    // [
    oParameter = Procedure.imw_validate_utils.makeParameter4InputRequireName("mailName", "IMW.CAP.0027");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    // [
    oParameter = Procedure.imw_validate_utils.makeParameter4Flags("mailType", "IMW.CAP.0025", 5);
    oParameter.requireSelect = true;
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);
    // l
    oParameter = Procedure.imw_validate_utils.makeParameter4Note("note", "IMW.CAP.0011");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);

    // ۉΉڂ̏
    var localeMap = new Array();
    var listMailName = new Array(localeCount);
    var listNote = new Array(localeCount);
    var listSubject = new Array(localeCount);
    var listBody = new Array(localeCount);
    var displayName;
    var i;
    for (i = 0; i < localeCount; i++) {
        localeId = locales[i].locale;
        displayName = locales[i].displayName;
        localeMap[localeId] = i;

        listLocales[i] = new Object();
        listLocales[i].locale = localeId;
        listLocales[i].localeDisplayName = Procedure.imw_utils.escapeHTML(displayName);
        listLocales[i].encoding = locales[i].encoding;
        listLocales[i].encodings = locales[i].encodings.join("<br>");

        listMailName[i] = new Object();
        listMailName[i].localeId = localeId;
        listMailName[i].localeDisplayName = Procedure.imw_utils.escapeHTML(displayName);
        listMailName[i].mailName = "";

        listNote[i] = new Object();
        listNote[i].localeId = localeId;
        listNote[i].localeDisplayName = Procedure.imw_utils.escapeHTML(displayName);
        listNote[i].note = "";

        listSubject[i] = new Object();
        listSubject[i].localeId = localeId;
        listSubject[i].localeDisplayName = Procedure.imw_utils.escapeHTML(displayName);
        listSubject[i].subject = "";

        listBody[i] = new Object();
        listBody[i].localeId = localeId;
        listBody[i].localeDisplayName = Procedure.imw_utils.escapeHTML(displayName);
        listBody[i].body = "";
    }

    // NGXgp[^擾
    oMailTemplateDataModel.mailId = request.mailId;

    // ca擾
    var manager = new MailTemplateManager(loginGroupId);
    var result = manager.getMailTemplateDataFamily(oMailTemplateDataModel.mailId);
    if (!result.resultFlag) {
        Module.alert.write(result.resultStatus.messageId, "");
    }
    var dataCount = result.data.length;
    if (dataCount == 0) {
        Module.alert.write("IMW.CLI.WRN.3205", ""); // ҏWΏۂ̃[`񂪑݂܂B
    }

    // R{쐬
    var enumCodes;
    var mailTypeList = new Object();
    var resultCode = codeUtil.getMailType();
    if (resultCode.resultFlag) {
        enumCodes = resultCode.data;
        mailTypeList[""] = "";
        for (i = 0; i < enumCodes.length; i++) {
            mailTypeList[enumCodes[i].code] = MessageManager.getMessage(enumCodes[i].messageId);
        }
    }

    // ʕ\ڂ̐ݒ
    oMailTemplateDataModel.mailId = result.data[0].mailId;
    var j;
    for (i = 0; i < dataCount; i++) {
        j = localeMap[result.data[i].localeId];
        if (isUndefined(j)) {
            continue;
        }
        listMailName[j].mailName = Procedure.imw_utils.escapeHTML(result.data[i].mailName);
        listNote[j].note = Procedure.imw_utils.escapeHTML(result.data[i].note);
        listSubject[j].subject = Procedure.imw_utils.escapeHTML(result.data[i].mailTempFileData.mailTemplateSubject);
        listBody[j].body = Procedure.imw_utils.escapeHTML(result.data[i].mailTempFileData.mailTemplateBody);
    }
    var mailTemplateType = result.data[0].mailTempType[0];
    oMailTemplateDataModel.mailType = mailTemplateType.mailType;
    oMailTemplateDataModel.mailTypeName = mailTypeList[mailTemplateType.mailType];
    oMailTemplateDataModel.mailName = listMailName;
    oMailTemplateDataModel.note = listNote;
    oMailTemplateDataModel.defaultFlag =
            (codeUtil.getEnumCodeFlagStatus("Enable") == mailTemplateType.defaultFlag) ? true : false;
    oMailTemplateDataModel.updateCount = result.data[0].updateCount || "";
    var mailTempFileData = result.data[0].mailTempFileData;
    oMailTemplateFile.from = Procedure.imw_utils.escapeHTML(mailTempFileData.mailTemplateFrom);
    oMailTemplateFile.to = Procedure.imw_utils.escapeHTML(mailTempFileData.mailTemplateTo.join(MAIL_ADDRESS_SEPARATOR));
    oMailTemplateFile.cc = Procedure.imw_utils.escapeHTML(mailTempFileData.mailTemplateCc.join(MAIL_ADDRESS_SEPARATOR));
    oMailTemplateFile.bcc = Procedure.imw_utils.escapeHTML(mailTempFileData.mailTemplateBcc.join(MAIL_ADDRESS_SEPARATOR));
    oMailTemplateFile.replyTo = Procedure.imw_utils.escapeHTML(mailTempFileData.mailTemplateReplyTo.join(MAIL_ADDRESS_SEPARATOR));
    oMailTemplateFile.subject = listSubject;
    oMailTemplateFile.body = listBody;

    // hidden ɏo͂鍀ڂ̐ݒ
    Procedure.imw_utils.makeHiddenObject(oHidden, oResult);
    Procedure.imw_utils.makeHiddenObject(oHidden, oMailTemplateDataModel);
    conditionInfo4Json = Procedure.imw_utils.escapeHTML(conditionInfo4Json);
}

//=============================================================================
// XV֐
//   y  zrequest: tqk擾IuWFNg
//   y ԋp z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zXVs܂B
//=============================================================================
function actionUpdate(request) {
    var databaseResult;
    var leng;
    var i;

    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();
    var codeUtil = new WorkflowCodeUtil();

    // ZbV̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;
    var localeId = oSession.locale;

    // ^pǗ҂̏ꍇ͊e팠`FbN
    if (Procedure.imw_admin_utils.isWkfOpeAdmor(oSession, request.imwOpeType)) {
        var oParameter = new Object();
        oParameter.userId = userId;
        oParameter.loginGroupId = loginGroupId;
        oParameter.localeId = localeId;

        // [`̕ҏW`FbN
        oParameter.adminType = codeUtil.getEnumCodeAdministrationType("adminTyp_MailTemplate");
        oParameter.uniqueId = request.mailId;
        oParameter.errorId = "IMW.CLI.WRN.3207"; // ҏWΏۂ̃[`ҏW錠܂
        if (!Procedure.imw_admin_group_utils.checkUpdateAuth(result, oParameter)) {
            return result;
        }
    }

    // r`FbN
    var mailTemplateManager = new MailTemplateManager(loginGroupId); // Java-API}l[W
    databaseResult = mailTemplateManager.getMailTemplateData(request.mailId);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        return result;
    }
    if (databaseResult.data.length == 0) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage("IMW.CLI.WRN.3205"); // ҏWΏۂ̃[`񂪑݂܂B
        return result;
    }
    if ((databaseResult.data[0].updateCount || "") != request.updateCount) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage("IMW.CLI.WRN.3206"); // ҏWΏۂ̃[`񂪑̃[UɂĕύX܂B
        return result;
    }

    // łɓo^ς݂̃P[擾
    var existLocales = new Object();
    var xmlPaths = new Object();
    for (leng = databaseResult.data.length, i = 0; i < leng; i++) {
        existLocales[databaseResult.data[i].localeId] = true;
        xmlPaths[databaseResult.data[i].localeId] = databaseResult.data[i].mailTemplatePath;
    }

    // [ݒʂݒ
    var mailTypeProc = codeUtil.getEnumCodeMailType("mailTyp_Proc");
    var mailTypeResult =codeUtil.getEnumCodeMailType("mailTyp_Result");
    var mailTypeRef = codeUtil.getEnumCodeMailType("mailTyp_Ref");
    var mailTypeCfm = codeUtil.getEnumCodeMailType("mailTyp_Cnfm");
    var mailConfTypeFlow = codeUtil.getEnumCodeMailConfigType("mailConfTyp_Flow");
    var mailConfTypeProc = codeUtil.getEnumCodeMailConfigType("mailConfTyp_Proc");
    var mailConfTypeFlowNode = codeUtil.getEnumCodeMailConfigType("mailConfTyp_FlowNode");
    var mailConfigType;
    if (mailTypeProc == request.mailType) { // ˗
        mailConfigType = mailConfTypeProc; // 
    } else if (mailTypeResult == request.mailType) { // ʒʒm
        mailConfigType = mailConfTypeFlow; // t[
    } else if (mailTypeRef == request.mailType) { // Qƈ˗
        mailConfigType = mailConfTypeFlow; // t[
    } else if (mailTypeCfm == request.mailType) { // mF˗
        mailConfigType = mailConfTypeFlowNode; // t[m[h
    }

    /**
     * f[^쐬
     */
    var createRecords = new Array();
    var updateRecords = new Array();
    var deleteRecords = new Array();
    var mailTemplateData;
    var mailTemplateType;
    var mailTemplateFileData;

    for (var key in request.localeId) {
        // [ev[gt@C
        mailTemplateFileData = new Object();
        mailTemplateFileData.mailTemplateSubject = request.subject[key];
        mailTemplateFileData.mailTemplateFrom = Procedure.imw_utils.trim(request.from);
        mailTemplateFileData.mailTemplateTo = editSendToItemValue(request.to);
        mailTemplateFileData.mailTemplateCc = editSendToItemValue(request.cc);
        mailTemplateFileData.mailTemplateBcc = editSendToItemValue(request.bcc);
        mailTemplateFileData.mailTemplateReplyTo = editSendToItemValue(request.replyTo);
        mailTemplateFileData.mailTemplateBody = request.body[key];
        // [ev[gʏ
        mailTemplateType = new Object();
        mailTemplateType.mailId  = request.mailId;
        mailTemplateType.mailType = request.mailType;
        mailTemplateType.mailConfigType = mailConfigType;
        mailTemplateType.defaultFlag = codeUtil.getEnumCodeFlagStatus("Disable");
        // caf[^i[ev[gj
        mailTemplateData = new Object();
        mailTemplateData.mailId  = request.mailId;
        mailTemplateData.localeId = request.localeId[key];
        mailTemplateData.mailName = request.mailName[key];
        mailTemplateData.note = request.note[key];
        mailTemplateData.mailTemplatePath = xmlPaths[request.localeId[key]];
        mailTemplateData.mailTempFileData = mailTemplateFileData;
        mailTemplateData.updateCount = Procedure.imw_utils.incrementCount(request.updateCount);
        if (existLocales[request.localeId[key]]) {
            updateRecords[updateRecords.length] = mailTemplateData;
        } else {
            mailTemplateData.mailTempType = new Array(mailTemplateType);
            createRecords[createRecords.length] = mailTemplateData;
        }
        existLocales[request.localeId[key]] = false;
    }
    for (key in existLocales) {
        if (!existLocales[key]) {
            continue;
        }
        mailTemplateData = new Object();
        mailTemplateData.mailId  = request.mailId;
        mailTemplateData.localeId = key;
        deleteRecords[deleteRecords.length] = mailTemplateData;
    }

    // of[V`FbN
    var validateUtil = new WorkflowValidateUtil(loginGroupId);
    if (createRecords.length > 0) {
        databaseResult = validateUtil.validateForClass("MailTemplateDataModel", createRecords);
        if (!Procedure.imw_validate_utils.getWorkflowValidateMessage(databaseResult, result, "IMW.CLI.WRN.3270")) {
            return result;
        }
    }
    if (updateRecords.length > 0) {
        databaseResult = validateUtil.validateForClass("MailTemplateDataModel", updateRecords);
        if (!Procedure.imw_validate_utils.getWorkflowValidateMessage(databaseResult, result, "IMW.CLI.WRN.3270")) {
            return result;
        }
    }

    // gUNV̊Jn
    databaseResult = DatabaseManager.beginTransaction();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = databaseResult.errorMessage;
        return result;
    }

    // caXV
    // 폜s[[ev[g]
    if (deleteRecords.length > 0) {
        databaseResult = mailTemplateManager.deleteMailTemplateData(deleteRecords);
        if (!databaseResult.resultFlag) {
            result.resultFlag = false;
            result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
            // [obN
            databaseResult = DatabaseManager.rollback();
            if (databaseResult.error) {
                result.resultFlag = false;
                result.resultStatus.message = databaseResult.errorMessage;
            }
            return result;
        }
    }

    // VK쐬s[[ev[g]
    if (createRecords.length > 0) {
        databaseResult = mailTemplateManager.createMailTemplateData(createRecords);
        if (!databaseResult.resultFlag) {
            result.resultFlag = false;
            result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
            // [obN
            databaseResult = DatabaseManager.rollback();
            if (databaseResult.error) {
                result.resultFlag = false;
                result.resultStatus.message = databaseResult.errorMessage;
            }
            return result;
        }
    }

    // XVs[[ev[g]
    if (updateRecords.length > 0) {
        databaseResult = mailTemplateManager.updateMailTemplateData(updateRecords);
        if (!databaseResult.resultFlag) {
            result.resultFlag = false;
            result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
            // [obN
            databaseResult = DatabaseManager.rollback();
            if (databaseResult.error) {
                result.resultFlag = false;
                result.resultStatus.message = databaseResult.errorMessage;
            }
            return result;
        }
    }

    // R~bg
    databaseResult = DatabaseManager.commit();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = databaseResult.errorMessage;
        return result;
    }

    return result;
}

//=============================================================================
// 폜֐
//   y  zrequest: tqk擾IuWFNg
//   y ԋp z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv z폜s܂B
//=============================================================================
function actionDelete(request) {
    var databaseResult;
    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();
    var codeUtil = new WorkflowCodeUtil();

    // ZbV̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;
    var localeId = oSession.locale;

    // ^pǗ҂̏ꍇ͊e팠`FbN
    if (Procedure.imw_admin_utils.isWkfOpeAdmor(oSession, request.imwOpeType)) {
        var oParameter = new Object();
        oParameter.userId = userId;
        oParameter.loginGroupId = loginGroupId;
        oParameter.localeId = localeId;

        // [`̕ҏW`FbN
        oParameter.adminType = codeUtil.getEnumCodeAdministrationType("adminTyp_MailTemplate");
        oParameter.uniqueId = request.mailId;
        oParameter.errorId = "IMW.CLI.WRN.3207"; // ҏWΏۂ̃[`ҏW錠܂
        if (!Procedure.imw_admin_group_utils.checkUpdateAuth(result, oParameter)) {
            return result;
        }
    }

    // Rec``FbN
    var mailTemplateManager = new MailTemplateManager(loginGroupId); // Java-API}l[W
    var oConditionInfo = new Object();
    oConditionInfo.id = request.mailId;
    oConditionInfo.localeId = localeId;
    databaseResult = mailTemplateManager.getMailTemplateUseStatusListCount(oConditionInfo);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        return result;
    }
    if (databaseResult.data != 0) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage("IMW.CLI.WRN.3219"); // 폜Ώۂ̃[`́ARecŎgpĂ邽ߍ폜ł܂B
        return result;
    }

    // r`FbN
    databaseResult = mailTemplateManager.getMailTemplateData(request.mailId);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        return result;
    }
    if (databaseResult.data.length == 0) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage("IMW.CLI.WRN.3205"); // ҏWΏۂ̃[`񂪑݂܂B
        return result;
    }
    if ((databaseResult.data[0].updateCount || "") != request.updateCount) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage("IMW.CLI.WRN.3206"); // ҏWΏۂ̃[`񂪑̃[UɂĕύX܂B
        return result;
    }

    // f[^쐬
    var mailTemplateDataList = new Array();
    var mailTemplateData;
    for (var i = 0; i < databaseResult.data.length; i++) {
        // caf[^i[ev[gj
        mailTemplateData = new Object();
        mailTemplateData.mailId = databaseResult.data[i].mailId;
        mailTemplateData.localeId = databaseResult.data[i].localeId;
        mailTemplateData.mailTemplatePath = databaseResult.data[i].mailTemplatePath;
        mailTemplateDataList.push(mailTemplateData);
    }

    // gUNV̊Jn
    databaseResult = DatabaseManager.beginTransaction();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = databaseResult.errorMessage;
        return result;
    }

    // ca폜
    // 폜s[[ev[g,[ev[gʏ]
    databaseResult = mailTemplateManager.deleteMailTemplateDataFamily(mailTemplateDataList);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        // [obN
        databaseResult = DatabaseManager.rollback();
        if (databaseResult.error) {
            result.resultStatus.message = databaseResult.errorMessage;
        }
        return result;
    }

    // 폜s[ǗO[vǗΏۏ]
    var adminGroupManager = new AdminGroupManager(loginGroupId); // Java-API}l[W
    // ǗʁE[IDL[ɍ폜
    var adminTypeMailTemplate = codeUtil.getEnumCodeAdministrationType("adminTyp_MailTemplate");
    databaseResult = adminGroupManager.deleteAdminGroupManageWithTarget(adminTypeMailTemplate, request.mailId);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        // [obN
        databaseResult = DatabaseManager.rollback();
        if (databaseResult.error) {
            result.resultStatus.message = databaseResult.errorMessage;
        }
        return result;
    }

    // R~bg
    databaseResult = DatabaseManager.commit();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = databaseResult.errorMessage;
        return result;
    }

    return result;
}

//=============================================================================
// M捀ڕҏW֐
//   y  zvalue: ҏWΏە
//   y ԋp z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zM捀ڂ̕ҏWs܂B
//=============================================================================
function editSendToItemValue(value) {
    value = Procedure.imw_utils.trim(value);
    if (isBlank(value)) {
        return null;
    }
    var values = value.split(MAIL_ADDRESS_SEPARATOR);
    var result = new Array();
    var leng = values.length;
    var i;
    var str;
    for (i = 0; i < leng; i++) {
        str = Procedure.imw_utils.trim(values[i]);
        if (!isBlank(str)) {
            result[result.length] = str;
        }
    }
    return result;
}
