Procedure.define("imw_admin_group_utils", new imwAdminGroupUtils());

// =============================================================================
// ֐`
// y  z
// yԋplz
// y쐬ҁzNTT DATA INTRAMART
// y XV z
// y Tv zProcedure̓o^
// =============================================================================
function imwAdminGroupUtils() {
    this.checkInitAuth = checkInitAuth;
    this.checkSelectAuth = checkSelectAuth;
    this.checkCreateAuth = checkCreateAuth;
    this.checkUpdateAuth = checkUpdateAuth;
    this.checkAdminGroup = checkAdminGroup;
    this.getAdminGroup4Create = getAdminGroup4Create;
    this.getAdminGroup4Update = getAdminGroup4Update;
    this.getAdminGroup4Copy = getAdminGroup4Copy;
    this.createAdminGroup = createAdminGroup;
    this.updateAdminGroup = updateAdminGroup;
    this.deleteAdminGroup = deleteAdminGroup;
    this.validateAdminGroup4Create = validateAdminGroup4Create;
    this.validateAdminGroup4Update = validateAdminGroup4Update;
    this.validateAdminGroup4Copy = validateAdminGroup4Copy;
}

//=============================================================================
// ʕ\̊ef[^Qƌ`FbNs܂B init ֐Ŏgp܂B
// Ήf[^F RecE[gEt[E[
// Ȃꍇ̓VXeG[ʂ\܂B
//  y  zrequest: NGXgIuWFNg (init ֐̃p[^)
//            result: ʃIuWFNg
//            oParameter: `FbNΏۃf[^ (Object)
//                userId       = [UID (K{)
//                loginGroupId = OCO[vID (K{)
//                localeId     = P[ID (K{)
//                errorId      = Ȃꍇɕ\G[bZ[WID (K{)
//                adminType    = Qƌ`FbNsf[^̊Ǘ
//                               w肵Ȃꍇ̓ANZX[̃`FbN̂ݍs܂B
//                uniqueId     = Qƌ`FbNsf[^ID
//                               w肵Ȃꍇ̓ANZX[̃`FbN̂ݍs܂B
//                administratorType = ǗҎ (K{)
//  y ԋp z[UIDANZX[̔z
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z
//=============================================================================
function checkInitAuth(request, result, oParameter) {
    var userId = oParameter.userId;
    var loginGroupId = oParameter.loginGroupId;
    var localeId = oParameter.localeId;
    var adminType = oParameter.adminType;
    var uniqueId = oParameter.uniqueId;
    var errorId = oParameter.errorId;
    var administratorType = oParameter.administratorType;
    var accountManager;
    var accessRoles;
    var adminGroupManager;
    var databaseResult;

    // ǗO[v@\ݒ̎擾
    var wfpManager = new WorkflowParameterManager(loginGroupId);
    var wkfAdminGroupUseFlag = wfpManager.getBooleanParameter("administration-group");
    result.wkfAdminGroupUseFlag = wkfAdminGroupUseFlag + "";

    // ǗO[v@\gpꍇAVXeǗ҂^pǗ҂̔fs
    var codeUtil = new WorkflowCodeUtil();
    var wkfSysAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfSysAdmor");
    var wkfOpeAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfOpeAdmor");
    if (isBlank(administratorType)) {
        // G[ (ҏW錠܂)
        Module.alert.write(errorId, "");

    // VXeǗ҃j[J
    } else if (administratorType == wkfSysAdmor) {
        // ANZX[̎擾
        accountManager = new AccountManager(loginGroupId);
        accessRoles = accountManager.getRoleIds(userId, new Date());

        result.wkfOpeAdmorFlag = "false"; // VXeǗ
        return accessRoles;

    // ^pǗ҃j[J
    } else if (administratorType == wkfOpeAdmor) {
        // ǗO[vgpȂꍇ̓G[
        if (!wkfAdminGroupUseFlag) {
            // G[ (ҏW錠܂)
            Module.alert.write(errorId, "");
        }

        // ANZX[̎擾
        accountManager = new AccountManager(loginGroupId);
        accessRoles = accountManager.getRoleIds(userId, new Date());

        // ǗO[v̎擾
        adminGroupManager = new AdminGroupManager(loginGroupId);
        databaseResult = adminGroupManager.getAdminGroupWithAccessRole(localeId, accessRoles);
        if (!databaseResult.resultFlag) {
            Module.alert.write(databaseResult.resultStatus.messageId, "");
        }
        if (!databaseResult.data) {
            Module.alert.write(errorId, "");
        }

        // ǗO[vȂꍇ̓G[
        if (databaseResult.data.length == 0) {
            // G[ (ҏW錠܂)
            Module.alert.write(errorId, "");
        }

        // RecE[gEt[E[̎Qƌ`FbN
        if (!isBlank(adminType) && !isBlank(uniqueId)) {
            var adminGroups = databaseResult.data;
            databaseResult = adminGroupManager.getAdminGroupManageWithAdminTypeTargetId(adminType, uniqueId);
            if (!databaseResult.resultFlag) {
                Module.alert.write(databaseResult.resultStatus.messageId, "");
            }
            if (!databaseResult.data || !databaseResult.data.length) {
                // G[ (ҏW錠܂)
                Module.alert.write(errorId, "");
            }
            var targetGroups = databaseResult.data;

            // Qƌ̊mF
            var groups = new Object();
            var accept = false;
            var leng;
            var i;
            for (leng = adminGroups.length, i = 0; i < leng; i++) {
                if (adminGroups[i].adminGroupId) {
                    groups[adminGroups[i].adminGroupId] = true;
                }
            }
            for (leng = targetGroups.length, i = 0; i < leng; i++) {
                if (groups[targetGroups[i].adminGroupId]) {
                    accept = true;
                    break;
                }
            }
            if (!accept) {
                // G[ (ҏW錠܂)
                Module.alert.write(errorId, "");
            }
        }

        result.wkfOpeAdmorFlag = "true";  // ^pǗ
        result.wkfAdminGroupUseFlag = "false"; // ǗO[vIs
        return accessRoles;

    // ԕs
    } else {
        // G[ (ҏW錠܂)
        Module.alert.write(errorId, "");
    }
}

//=============================================================================
// ʕ\̊ef[^Qƌ`FbNs܂B init ֐̊OŎgp܂B
// Ήf[^F RecE[gEt[E[
// Ȃꍇ false ԋp܂B ̍ہA result ɃG[
// i[܂B
//  y  zresult: ʃIuWFNg
//            oParameter: `FbNΏۃf[^ (Object)
//                userId       = [UID (K{)
//                loginGroupId = OCO[vID (K{)
//                localeId     = P[ID (K{)
//                errorId      = Ȃꍇɕ\G[bZ[WID (K{)
//                adminType    = Qƌ`FbNsf[^̊Ǘ (K{)
//                uniqueId     = Qƌ`FbNsf[^ID (K{)
//  y ԋp z`FbN (true: OK, false: NG)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z
//=============================================================================
function checkSelectAuth(result, oParameter) {
    var userId = oParameter.userId;
    var loginGroupId = oParameter.loginGroupId;
    var localeId = oParameter.localeId;
    var adminType = oParameter.adminType;
    var uniqueId = oParameter.uniqueId;
    var errorId = oParameter.errorId;
    var databaseResult;

    // ǗO[v@\ݒ̎擾
    var wfpManager = new WorkflowParameterManager(loginGroupId);
    var wkfAdminGroupUseFlag = wfpManager.getBooleanParameter("administration-group");

    // ǗO[vgpȂꍇ̓G[
    if (!wkfAdminGroupUseFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(errorId);
        return false;
    }

    // ANZX[̎擾
    var accountManager = new AccountManager(loginGroupId);
    var accessRoles = accountManager.getRoleIds(userId, new Date());

    // ^pǗҏǗO[v̎擾
    var adminGroupManager = new AdminGroupManager(loginGroupId);
    databaseResult = adminGroupManager.getAdminGroupWithAccessRole(localeId, accessRoles);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        return false;
    }
    if (!databaseResult.data) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(errorId);
        return false;
    }
    var adminGroups = databaseResult.data;
    result.adminGroups = adminGroups;

    // ΏۊǗO[v̎擾
    databaseResult = adminGroupManager.getAdminGroupManageWithAdminTypeTargetId(adminType, uniqueId);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        return false;
    }
    var targetGroups = databaseResult.data;
    result.targetGroups = targetGroups;

    // ǗO[vȂꍇ̓G[
    if (adminGroups.length == 0) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(errorId);
        return false;
    }

    // Qƌ̊mF
    var groups = new Object();
    var accept = false;
    var leng;
    var i;
    for (leng = adminGroups.length, i = 0; i < leng; i++) {
        if (adminGroups[i].adminGroupId != null) {
            groups[adminGroups[i].adminGroupId] = true;
        }
    }
    for (leng = targetGroups.length, i = 0; i < leng; i++) {
        if (groups[targetGroups[i].adminGroupId]) {
            accept = true;
            break;
        }
    }

    // QƌȂꍇ̓G[
    if (!accept) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(errorId);
        return false;
    }

    return true;
}

//=============================================================================
// ʕ\̊ef[^VK쐬`FbNs܂B init ֐̊OŎgp܂B
// Ήf[^F RecE[gEt[E[
// Ȃꍇ false ԋp܂B ̍ہA result ɃG[
// i[܂B
//  y  zresult: ʃIuWFNg
//            oParameter: `FbNΏۃf[^ (Object)
//                userId       = [UID (K{)
//                loginGroupId = OCO[vID (K{)
//                localeId     = P[ID (K{)
//                errorId      = Ȃꍇɕ\G[bZ[WID (K{)
//  y ԋp z`FbN (true: OK, false: NG)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z
//=============================================================================
function checkCreateAuth(result, oParameter) {
    var userId = oParameter.userId;
    var loginGroupId = oParameter.loginGroupId;
    var localeId = oParameter.localeId;
    var errorId = oParameter.errorId;

    // ǗO[v@\ݒ̎擾
    var wfpManager = new WorkflowParameterManager(loginGroupId);
    var wkfAdminGroupUseFlag = wfpManager.getBooleanParameter("administration-group");

    // ǗO[vgpȂꍇ̓G[
    if (!wkfAdminGroupUseFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(errorId);
        return false;
    }

    // ANZX[̎擾
    var accountManager = new AccountManager(loginGroupId);
    var accessRoles = accountManager.getRoleIds(userId, new Date());

    // ^pǗҏǗO[v̎擾
    var adminGroupManager = new AdminGroupManager(loginGroupId);
    var databaseResult = adminGroupManager.getAdminGroupWithAccessRole(localeId, accessRoles);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        return false;
    }
    if (!databaseResult.data) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(errorId);
        return false;
    }
    var adminGroups = databaseResult.data;
    result.adminGroups = adminGroups;

    return true;
}

//=============================================================================
// ʕ\̊ef[^ҏWE폜`FbNs܂B init ֐̊OŎgp܂B
// Ήf[^F RecE[gEt[E[
// Ȃꍇ false ԋp܂B ̍ہA result ɃG[
// i[܂B
//  y  zresult: ʃIuWFNg
//            oParameter: `FbNΏۃf[^ (Object)
//                userId       = [UID (K{)
//                loginGroupId = OCO[vID (K{)
//                localeId     = P[ID (K{)
//                errorId      = Ȃꍇɕ\G[bZ[WID (K{)
//                adminType    = ҏW`FbNsf[^̊Ǘ (K{)
//                uniqueId     = ҏW`FbNsf[^ID (K{)
//  y ԋp z`FbN (true: OK, false: NG)
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z
//=============================================================================
function checkUpdateAuth(result, oParameter) {
    var userId = oParameter.userId;
    var loginGroupId = oParameter.loginGroupId;
    var localeId = oParameter.localeId;
    var adminType = oParameter.adminType;
    var uniqueId = oParameter.uniqueId;
    var errorId = oParameter.errorId;
    var databaseResult;

    // ǗO[v@\ݒ̎擾
    var wfpManager = new WorkflowParameterManager(loginGroupId);
    var wkfAdminGroupUseFlag = wfpManager.getBooleanParameter("administration-group");

    // ǗO[vgpȂꍇ̓G[
    if (!wkfAdminGroupUseFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(errorId);
        return false;
    }

    // ANZX[̎擾
    var codeUtil = new WorkflowCodeUtil();
    var authTypeEdit = codeUtil.getEnumCodeAuthorityType("authTypeEdit");
    var accountManager = new AccountManager(loginGroupId);
    var accessRoles = accountManager.getRoleIds(userId, new Date());

    // ^pǗҏǗO[v̎擾
    var adminGroupManager = new AdminGroupManager(loginGroupId);
    databaseResult = adminGroupManager.getAdminGroupWithAccessRole(localeId, accessRoles);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        return false;
    }
    if (!databaseResult.data) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(errorId);
        return false;
    }
    var adminGroups = databaseResult.data;
    result.adminGroups = adminGroups;

    // ΏۊǗO[v̎擾
    databaseResult = adminGroupManager.getAdminGroupManageWithAdminTypeTargetId(adminType, uniqueId);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        return false;
    }
    var targetGroups = databaseResult.data;
    result.targetGroups = targetGroups;

    // ǗO[vȂꍇ̓G[
    if (adminGroups.length == 0) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(errorId);
        return false;
    }

    // Qƌ̊mF
    var groups = new Object();
    var accept = false;
    var leng;
    var i;
    for (leng = adminGroups.length, i = 0; i < leng; i++) {
        if (adminGroups[i].adminGroupId != null) {
            groups[adminGroups[i].adminGroupId] = true;
        }
    }
    for (leng = targetGroups.length, i = 0; i < leng; i++) {
        if (groups[targetGroups[i].adminGroupId] && authTypeEdit == targetGroups[i].authType) {
            accept = true;
            break;
        }
    }

    // QƌȂꍇ̓G[
    if (!accept) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(errorId);
        return false;
    }

    return true;
}

//=============================================================================
// ǗO[v`̑݃`FbN֐
//   y  zrequest: tqk擾IuWFNg
//             result: ʃIuWFNg
//             loginGroupId: OCO[vID
//             localeId: P[ID
//   y ԋp ztrue: `FbN, false: `FbNs
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zǗO[v`̑݃`FbNs܂B
//=============================================================================
function checkAdminGroup(request, result, loginGroupId, localeId) {

    // ǗO[v@\ݒ̎擾
    var wfpManager = new WorkflowParameterManager(loginGroupId);
    var wkfAdminGroupUseFlag = wfpManager.getBooleanParameter("administration-group");

    // ǗO[vgpȂꍇ͐I
    if (!wkfAdminGroupUseFlag) {
        return true;
    }

    var databaseResult;
    var leng;
    var i;
    var adminGroupManager = new AdminGroupManager(loginGroupId);
    var adminGroupId;

    // ǗO[v̑݃`FbN
    for (leng = (isArray(request.adminGroupId) ? request.adminGroupId.length : 0), i = 0; i < leng; i++) {
        adminGroupId = request.adminGroupId[i];
        databaseResult = adminGroupManager.getAdminGroupCount(adminGroupId, localeId);
        if (!databaseResult.resultFlag) {
            result.resultFlag = false;
            result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
            return false;
        }
        if (databaseResult.data == 0) {
            result.resultFlag = false;
            result.resultStatus.message = MessageManager.getMessage("IMW.CLI.WRN.3211");
            return false;
        }
    }

    return true;
}

//=============================================================================
// ǗO[v`֐iVK쐬j
//   y  zrequest: tqk擾IuWFNg
//             result: ʃIuWFNg
//             loginGroupId: OCO[vID
//             adminType: ǗΏێ
//             uniqueId: ǗΏID
//   y ԋp zǗO[v̔z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zǗO[v`̃f[^쐬s܂B
//=============================================================================
function getAdminGroup4Create(request, result, loginGroupId, adminType, uniqueId) {
    var leng;
    var i;
    var codeUtil = new WorkflowCodeUtil();
    var authTypeEdit = codeUtil.getEnumCodeAuthorityType("authTypeEdit");
    var authTypeReference = codeUtil.getEnumCodeAuthorityType("authTypeReference");
    var adminRecords = new Array();
    var adminGroupId;
    var adminRecord;

    // ǗO[v@\ݒ̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var wfpManager = new WorkflowParameterManager(loginGroupId);
    var wkfAdminGroupUseFlag = wfpManager.getBooleanParameter("administration-group");

    if (Procedure.imw_admin_utils.isWkfOpeAdmor(oSession, request.imwOpeType)) {
        // ^pǗ҂̏ꍇAOC[ŮǗO[vo^
        for (leng = result.adminGroups.length, i = 0; i < leng; i++) {
            adminGroupId = result.adminGroups[i].adminGroupId;
            if (adminGroupId == null) {
                continue;
            }
            adminRecord = new Object();
            adminRecord.adminGroupId = adminGroupId;
            adminRecord.adminType = adminType;
            adminRecord.manageId = uniqueId;
            adminRecord.authType = authTypeEdit;
            adminRecord.updateCount = "1";
            adminRecords[adminRecords.length] = adminRecord;
        }
    } else if (wkfAdminGroupUseFlag) {
        // ǗO[vgpꍇAʏ̐ݒeo^
        var authTypeKey = new Object();
        for (leng = (isArray(request.authType) ? request.authType.length : 0), i = 0; i < leng; i++) {
            authTypeKey[request.authType[i]] = true;
        }
        for (leng = (isArray(request.adminGroupId) ? request.adminGroupId.length : 0), i = 0; i < leng; i++) {
            adminGroupId = request.adminGroupId[i];
            adminRecord = new Object();
            adminRecord.adminGroupId = adminGroupId;
            adminRecord.adminType = adminType;
            adminRecord.manageId = uniqueId;
            adminRecord.authType = authTypeKey[adminGroupId] ? authTypeEdit : authTypeReference;
            adminRecord.updateCount = "1";
            adminRecords[adminRecords.length] = adminRecord;
        }
    }

    return adminRecords;
}

//=============================================================================
// ǗO[v`֐iXVj
//   y  zrequest: tqk擾IuWFNg
//             result: ʃIuWFNg
//             loginGroupId: OCO[vID
//             adminType: ǗΏێ
//             uniqueId: ǗΏID
//   y ԋp zǗO[v̔z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zǗO[v`̃f[^쐬s܂B
//=============================================================================
function getAdminGroup4Update(request, result, loginGroupId, adminType, uniqueId) {
    var leng;
    var i;
    var codeUtil = new WorkflowCodeUtil();
    var authTypeEdit = codeUtil.getEnumCodeAuthorityType("authTypeEdit");
    var authTypeReference = codeUtil.getEnumCodeAuthorityType("authTypeReference");
    var adminRecords = new Array();
    var adminGroupId;
    var adminRecord;

    // ǗO[v@\ݒ̎擾
    var wfpManager = new WorkflowParameterManager(loginGroupId);
    var wkfAdminGroupUseFlag = wfpManager.getBooleanParameter("administration-group");

    if (wkfAdminGroupUseFlag) {
        // ǗO[vgpꍇAʏ̐ݒeo^
        var authTypeKey = new Object();
        for (leng = (isArray(request.authType) ? request.authType.length : 0), i = 0; i < leng; i++) {
            authTypeKey[request.authType[i]] = true;
        }
        for (leng = (isArray(request.adminGroupId) ? request.adminGroupId.length : 0), i = 0; i < leng; i++) {
            adminGroupId = request.adminGroupId[i];
            adminRecord = new Object();
            adminRecord.adminGroupId = adminGroupId;
            adminRecord.adminType = adminType;
            adminRecord.manageId = uniqueId;
            adminRecord.authType = authTypeKey[adminGroupId] ? authTypeEdit : authTypeReference;
            adminRecord.updateCount = "1";
            adminRecords[adminRecords.length] = adminRecord;
        }
    }

    return adminRecords;
}

//=============================================================================
// ǗO[v`֐iRs[j
//   y  zrequest: tqk擾IuWFNg
//             result: ʃIuWFNg
//             loginGroupId: OCO[vID
//             adminType: ǗΏێ
//             uniqueId: ǗΏID
//             srcId: ǗΏIDiRs[j
//   y ԋp zǗO[v̔z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zǗO[v`̃f[^쐬s܂B
//=============================================================================
function getAdminGroup4Copy(request, result, loginGroupId, adminType, uniqueId, srcId) {
    var databaseResult;
    var leng;
    var i;
    var codeUtil = new WorkflowCodeUtil();
    var authTypeEdit = codeUtil.getEnumCodeAuthorityType("authTypeEdit");
    var authTypeReference = codeUtil.getEnumCodeAuthorityType("authTypeReference");
    var adminRecords = new Array();
    var adminGroupId;
    var adminRecord;

    // ǗO[v@\ݒ̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var wfpManager = new WorkflowParameterManager(loginGroupId);
    var wkfAdminGroupUseFlag = wfpManager.getBooleanParameter("administration-group");

    if (Procedure.imw_admin_utils.isWkfOpeAdmor(oSession, request.imwOpeType)) {
        // ^pǗ҂̏ꍇAOC[ŮǗO[vo^
        for (leng = result.adminGroups.length, i = 0; i < leng; i++) {
            adminGroupId = result.adminGroups[i].adminGroupId;
            if (adminGroupId == null) {
                continue;
            }
            adminRecord = new Object();
            adminRecord.adminGroupId = adminGroupId;
            adminRecord.adminType = adminType;
            adminRecord.manageId = uniqueId;
            adminRecord.authType = authTypeEdit;
            adminRecord.updateCount = "1";
            adminRecords[adminRecords.length] = adminRecord;
        }
    } else if (wkfAdminGroupUseFlag) {
        // ǗO[vgpꍇAʏ̐ݒeo^
        var authTypeKey = new Object();
        for (leng = (isArray(request.authType) ? request.authType.length : 0), i = 0; i < leng; i++) {
            authTypeKey[request.authType[i]] = true;
        }
        for (leng = (isArray(request.adminGroupId) ? request.adminGroupId.length : 0), i = 0; i < leng; i++) {
            adminGroupId = request.adminGroupId[i];
            adminRecord = new Object();
            adminRecord.adminGroupId = adminGroupId;
            adminRecord.adminType = adminType;
            adminRecord.manageId = uniqueId;
            adminRecord.authType = authTypeKey[adminGroupId] ? authTypeEdit : authTypeReference;
            adminRecord.updateCount = "1";
            adminRecords[adminRecords.length] = adminRecord;
        }
    } else {
        // ̑̏ꍇARs[ɐݒ肳ĂǗO[vo^
        var adminGroupManager = new AdminGroupManager(loginGroupId);
        databaseResult = adminGroupManager.getAdminGroupManageWithAdminTypeTargetId(adminType, srcId);
        if (!databaseResult.resultFlag) {
            result.resultFlag = false;
            result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
            return false;
        }
        var adminGroups = databaseResult.data;
        for (leng = adminGroups.length, i = 0; i < leng; i++) {
            adminRecord = new Object();
            adminRecord.adminGroupId = adminGroups[i].adminGroupId;
            adminRecord.adminType = adminType;
            adminRecord.manageId = uniqueId;
            adminRecord.authType = adminGroups[i].authType;
            adminRecord.updateCount = "1";
            adminRecords[adminRecords.length] = adminRecord;
        }
    }

    return adminRecords;
}

//=============================================================================
// ǗO[v`VK쐬֐
//   y  zrequest: tqk擾IuWFNg
//             result: ʃIuWFNg
//             loginGroupId: OCO[vID
//             adminType: ǗΏێ
//             adminGroups: ǗO[v`̔z
//   y ԋp zǗO[v̔z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zǗO[v`VK쐬܂B
//=============================================================================
function createAdminGroup(request, result, loginGroupId, adminType, adminRecords) {

    // ǗO[v@\ݒ̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var wfpManager = new WorkflowParameterManager(loginGroupId);
    var wkfAdminGroupUseFlag = wfpManager.getBooleanParameter("administration-group");

    // VXeǗҁAAǗO[vgpȂꍇ͐I
    // ^pǗ҂̏ꍇ͎̊ǗO[vo^邽ߏIȂ
    if (!wkfAdminGroupUseFlag &&
            Procedure.imw_admin_utils.isWkfSysAdmor(oSession, request.imwOpeType)) {
        return true;
    }

    var databaseResult;
    var adminGroupManager = new AdminGroupManager(loginGroupId);

    // ǗO[vǗΏۏVK쐬
    if (adminRecords.length > 0) {
        databaseResult = adminGroupManager.createAdminGroupManage(adminRecords);
        if (!databaseResult.resultFlag) {
            result.resultFlag = false;
            result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
            return false;
        }
    }

    return true;
}

//=============================================================================
// ǗO[v`XV֐
//   y  zrequest: tqk擾IuWFNg
//             result: ʃIuWFNg
//             loginGroupId: OCO[vID
//             adminType: ǗΏێ
//             uniqueId: XVΏID
//             adminGroups: ǗO[v`̔z
//   y ԋp zǗO[v̔z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zǗO[v`XV܂B
//=============================================================================
function updateAdminGroup(request, result, loginGroupId, adminType, uniqueId, adminRecords) {

    // ǗO[v@\ݒ̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var wfpManager = new WorkflowParameterManager(loginGroupId);
    var wkfAdminGroupUseFlag = wfpManager.getBooleanParameter("administration-group");

    // ^pǗҁA܂́AǗO[vgpȂꍇ͐I
    // ^pǗ҂̏ꍇ͂łɓo^ĂǗO[v`XVłȂߏI
    if (!wkfAdminGroupUseFlag ||
            Procedure.imw_admin_utils.isWkfOpeAdmor(oSession, request.imwOpeType)) {
        return true;
    }

    var databaseResult;
    var adminGroupManager = new AdminGroupManager(loginGroupId);

    // ǗO[vǗΏۏ폜
    databaseResult = adminGroupManager.deleteAdminGroupManageWithTarget(adminType, uniqueId);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        return false;
    }

    // ǗO[vǗΏۏVK쐬
    if (adminRecords.length > 0) {
        databaseResult = adminGroupManager.createAdminGroupManage(adminRecords);
        if (!databaseResult.resultFlag) {
            result.resultFlag = false;
            result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
            return false;
        }
    }

    return true;
}

//=============================================================================
// ǗO[v`폜֐
//   y  zrequest: tqk擾IuWFNg
//             result: ʃIuWFNg
//             loginGroupId: OCO[vID
//             adminType: ǗΏێ
//             uniqueId: XVΏID
//   y ԋp zǗO[v̔z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zǗO[v`폜܂B
//=============================================================================
function deleteAdminGroup(request, result, loginGroupId, adminType, uniqueId) {

    // ǗO[v@\ݒ̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var wfpManager = new WorkflowParameterManager(loginGroupId);
    var wkfAdminGroupUseFlag = wfpManager.getBooleanParameter("administration-group");

    // VXeǗҁAAǗO[vgpȂꍇ͐I
    if (!wkfAdminGroupUseFlag &&
            Procedure.imw_admin_utils.isWkfSysAdmor(oSession, request.imwOpeType)) {
        return true;
    }

    var databaseResult;
    var adminGroupManager = new AdminGroupManager(loginGroupId);

    // ǗO[vǗΏۏ폜
    databaseResult = adminGroupManager.deleteAdminGroupManageWithTarget(adminType, uniqueId);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = MessageManager.getMessage(databaseResult.resultStatus.messageId);
        return false;
    }

    return true;
}

//=============================================================================
// ǗO[v`of[V֐iVK쐬j
//   y  zresult: ʃIuWFNg
//             validateUtil: of[V[eBeB
//             records: ǗO[v̔z
//   y ԋp zof[VG[ȂtO
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zǗO[v`̐VK쐬p̃of[V`FbNs܂B
//=============================================================================
function validateAdminGroup4Create(result, validateUtil, records) {
    if (!isArray(records) || records.length == 0) {
        return true;
    }
    var databaseResult = validateUtil.validateForClass("AdminGroupManageModel", records);
    if (!Procedure.imw_validate_utils.getWorkflowValidateMessage(databaseResult, result, "IMW.CLI.WRN.3269")) {
        return false;
    }
    return true;
}

//=============================================================================
// ǗO[v`of[V֐iXVj
//   y  zresult: ʃIuWFNg
//             validateUtil: of[V[eBeB
//             records: ǗO[v̔z
//   y ԋp zof[VG[ȂtO
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zǗO[v`̍XVp̃of[V`FbNs܂B
//=============================================================================
function validateAdminGroup4Update(result, validateUtil, records) {
    if (!isArray(records) || records.length == 0) {
        return true;
    }
    var databaseResult = validateUtil.validateForClass("AdminGroupManageModel", records);
    if (!Procedure.imw_validate_utils.getWorkflowValidateMessage(databaseResult, result, "IMW.CLI.WRN.3270")) {
        return false;
    }
    return true;
}

//=============================================================================
// ǗO[v`of[V֐iRs[j
//   y  zresult: ʃIuWFNg
//             validateUtil: of[V[eBeB
//             records: ǗO[v̔z
//   y ԋp zof[VG[ȂtO
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zǗO[v`̃Rs[p̃of[V`FbNs܂B
//=============================================================================
function validateAdminGroup4Copy(result, validateUtil, records) {
    if (!isArray(records) || records.length == 0) {
        return true;
    }
    var databaseResult = validateUtil.validateForClass("AdminGroupManageModel", records);
    if (!Procedure.imw_validate_utils.getWorkflowValidateMessage(databaseResult, result, "IMW.CLI.WRN.3269")) {
        return false;
    }
    return true;
}
