Procedure.define("imw_admin_utils", new imwAdminUtils());

// =============================================================================
// ֐`
// y  z
// yԋplz
// y쐬ҁzNTT DATA INTRAMART
// y XV z
// y Tv zProcedure̓o^
// =============================================================================
function imwAdminUtils() {
    this.encodeAdministratorType = encodeAdministratorType;
    this.decodeAdministratorType = decodeAdministratorType;
    this.isWkfSysAdmor = isWkfSysAdmor;
    this.isWkfOpeAdmor = isWkfOpeAdmor;
    this.isWkfAdmin = isWkfAdmin;
}

//=============================================================================
// ǗҎʈÍ֐
//  y  zoSession: ZbVIuWFNg
//            administratorType: ǗҎ
//  y ԋp zÍL[
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zǗҎʂ𕜌邽߂̕stÍ擾܂B
//=============================================================================
function encodeAdministratorType(oSession, administratorType) {
    var key = getAPOPKey(oSession, "administratorType");
    return getMessageDigest("SHA-1", key + administratorType);
}

//=============================================================================
// ǗҎʕ֐
//  y  zoSession: ZbVIuWFNg
//            encodeKey: ÍL[
//  y ԋp zǗҎ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zǗҎʂ𕜌邽߂̕stÍAǗҎʂ𕜍܂B
//=============================================================================
function decodeAdministratorType(oSession, encodeKey) {
    var codeUtil = new WorkflowCodeUtil();
    var key = getAPOPKey(oSession, "administratorType");
    var codes = codeUtil.getAdministratorType();
    var i;
    for (i = 0; i < codes.data.length; i++) {
        if (encodeKey == getMessageDigest("SHA-1", key + codes.data[i].code)) {
            return codes.data[i].code;
        }
    }
    return codeUtil.getEnumCodeAdministratorType("admorTyp_user");
}

//=============================================================================
// VXeǗҔ֐
//  y  zoSession: ZbVIuWFNg
//            encodeKey: ÍL[
//  y ԋp zǗҎ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zǗҎʂ𕜌邽߂̕stÍAVXeǗ҂ǂ
//            𔻒肵܂B
//=============================================================================
function isWkfSysAdmor(oSession, encodeKey) {
    var codeUtil = new WorkflowCodeUtil();
    return decodeAdministratorType(oSession, encodeKey) ==
            codeUtil.getEnumCodeAdministratorType("admorTyp_wkfSysAdmor");
}

//=============================================================================
// ^pǗҔ֐
//  y  zoSession: ZbVIuWFNg
//            encodeKey: ÍL[
//  y ԋp zǗҎ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zǗҎʂ𕜌邽߂̕stÍA^pǗ҂ǂ
//            𔻒肵܂B
//=============================================================================
function isWkfOpeAdmor(oSession, encodeKey) {
    var codeUtil = new WorkflowCodeUtil();
    return decodeAdministratorType(oSession, encodeKey) ==
            codeUtil.getEnumCodeAdministratorType("admorTyp_wkfOpeAdmor");
}

//=============================================================================
// [Nt[ǗҔ֐
//  y  zoSession: ZbVIuWFNg
//            encodeKey: ÍL[
//  y ԋp zǗҎ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zǗҎʂ𕜌邽߂̕stÍAVXeǗҁE^p
//            Ǘ҂̂ꂩǂ𔻒肵܂B
//=============================================================================
function isWkfAdmin(oSession, encodeKey) {
    var codeUtil = new WorkflowCodeUtil();
    var administratorType = decodeAdministratorType(oSession, encodeKey);
    return administratorType == codeUtil.getEnumCodeAdministratorType("admorTyp_wkfSysAdmor") ||
            administratorType == codeUtil.getEnumCodeAdministratorType("admorTyp_wkfOpeAdmor");
}

//=============================================================================
// APOP F؃L[擾֐
//  y  zoSession: ZbVIuWFNg
//            paramName: p[^
//  y ԋp zF؃L[
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zÍ邽߂̋^ APOP F؃L[擾܂B
//=============================================================================
function getAPOPKey(oSession, paramName) {
    return oSession.loginGroup + "\n" + oSession.user + "\n" + oSession.locale + "\n" +
            Format.fromDate("yyyy/MM/dd HH:mm:ss.SSS", oSession.loginTime) + "\n" +
            oSession.signature + "\n" + paramName + "\n<IM-Workflow7.2>" + "\n";
}
