Procedure.define("imw_flow_group_utils", new imwFlowGroupUtils());

// =============================================================================
// ֐`
// y  z
// yԋplz
// y쐬ҁzNTT DATA INTRAMART
// y XV z
// y Tv zProcedure̓o^
// =============================================================================
function imwFlowGroupUtils() {
    this.createFlowInfo = createFlowInfo;
    this.createFlowGroupList = createFlowGroupList;
    this.getChildFlowLists = getChildFlowLists;
}

//=============================================================================
// t[擾
//  y  zloginGroupId: OCO[vID
//            localeId    : P[ID
//            flowGroupId : t[O[vID
//  y ԋp z
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zʂ̃t[O[vIDŃt[O[vR{̏𐶐܂B
//=============================================================================
function createFlowInfo(loginGroupId, localeId, flowGroupId) {
    var managerFlowGroup = new FlowGroupManager(loginGroupId);
    var result;
    var i;
    var selectFlowGroup = new Array();
    var rows;
    var flowId;
    var idx = 0;
    var lastFlowGroup = "";
    if (!isBlank(flowGroupId)) {
        // t[O[vID
        selectFlowGroup = flowGroupId.split(",");
        // t[ID擾
        if (selectFlowGroup != null && selectFlowGroup.length > 0) {
            flowId = new Array();
            for (i = 0; i < selectFlowGroup.length; i++) {
                if (!isBlank(selectFlowGroup[i])) {
                    // t[擾
                    result = managerFlowGroup.getFlowGroupInfoList(selectFlowGroup[i], localeId);
                    if (!result.resultFlag) {
                        Module.alert.write(result.resultStatus.messageId, "");
                    }
                    if (result != null) {
                        for (rows = 0; rows < result.data.length; rows++) {
                            flowId[idx++] = result.data[rows].flowId;
                        }
                    }
                    lastFlowGroup = selectFlowGroup[i];
                }
            }
            // z̃t[O[vɕRÂt[ID擾
            if (!isBlank(lastFlowGroup)) {
                result = managerFlowGroup.getFlowDataListWithFlowGroupId(lastFlowGroup, localeId);
                if (!result.resultFlag) {
                    Module.alert.write(result.resultStatus.messageId, "");
                }
                if (result != null) {
                    for (rows = 0; rows < result.data.length; rows++) {
                        flowId[idx++] = result.data[rows].flowId;
                    }
                }
            }
        }
        // t[IDi[
        return flowId;
    } else {
        return null;
    }
}

//=============================================================================
// t[O[vR{쐬
//  y  zloginGroupId  : OCO[vID
//            localeId      : P[ID
//            groupHierarchy: O[vKwݒ̃p[^
//            flowGroupId   : t[O[vID
//  y ԋp zt[O[vR{IuWFNg
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zl̃t[O[vR{̏쐬܂B
//              \bhVisualDesignerłgpĂ邽߁A
//                Cꍇ̓C^tF[XȂтɓdlςȂƁB
//                ܂AL_ɂďCꍇVisualDesigneȑC
//                {邱ƁB
//=============================================================================
function createFlowGroupList(loginGroupId, localeId, groupHierarchy, flowGroupId) {
    var flowGroupSelectList = new Object();
    var selectFlowGroup = new Array();
    var rows;
    if (groupHierarchy > 0) {
        var managerFlowGroup = new FlowGroupManager(loginGroupId);
        var count;
        var result;
        if (!isBlank(flowGroupId)) {
            selectFlowGroup = isArray(flowGroupId) ? flowGroupId : flowGroupId.split(",");
        }
        for (count = 0; count < groupHierarchy; count++) {
            var localListData = new Object();
            var selectList= new Object();
            selectList[""] = "";
            if (count == 0) {
                result = managerFlowGroup.getChildFlowGroupDataListWithFlowGroupId("", localeId);
                if (!result.resultFlag) {
                    Module.alert.write(result.resultStatus.messageId, "");
                }
                if (result != null) {
                    for (rows = 0; rows < result.data.length; rows++) {
                        selectList[Procedure.imw_utils.escapeHTML(result.data[rows].flowGroupId)] =
                                Procedure.imw_utils.escapeHTML(result.data[rows].flowGroupName);
                    }
                    localListData.emptyFlag = rows == 0;
                }
            } else {
                if (!isBlank(selectFlowGroup[count - 1])) {
                    result = managerFlowGroup.getChildFlowGroupDataListWithFlowGroupId(
                            selectFlowGroup[count - 1], localeId);
                    if (!result.resultFlag) {
                        Module.alert.write(result.resultStatus.messageId, "");
                    }
                    if (result != null) {
                        for (rows = 0; rows < result.data.length; rows++) {
                            selectList[Procedure.imw_utils.escapeHTML(result.data[rows].flowGroupId)] =
                                    Procedure.imw_utils.escapeHTML(result.data[rows].flowGroupName);
                        }
                        localListData.emptyFlag = rows == 0;
                    }
                }
            }
            localListData.list = selectList;
            localListData.flowGroupId = selectFlowGroup[count];
            localListData.select = Procedure.imw_utils.escapeHTML(selectFlowGroup[count]);
            if (count < groupHierarchy - 1) {
                localListData.fnc = "selectGroupId(" + count + ")";
            }

            flowGroupSelectList[count] = localListData;
        }
    }

    return flowGroupSelectList;
}

//=============================================================================
// qt[O[v擾
//  y  zparentFlowGroupId: et[O[vID
//  y ԋp z
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zt[O[vR{IɁA
//            It[O[v̎qt[O[v擾B
//=============================================================================
function getChildFlowLists(parentFlowGroupId) {
    var leng;
    var i;
    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();
    var oSession = AccessSecurityManager.getSessionInfo();
    var flowGroupManager = new FlowGroupManager(oSession.loginGroup);
    if (!isBlank(parentFlowGroupId)) {
        result = flowGroupManager.getChildFlowGroupDataListWithFlowGroupId(parentFlowGroupId, oSession.locale);
        if (!result.resultFlag) {
            result.resultStatus.message = MessageManager.getMessage(result.resultStatus.messageId);
            return result;
        }
        for (leng = result.data.length, i = 0; i < leng; i++) {
            result.data[i].flowGroupId = Procedure.imw_utils.escapeHTML(result.data[i].flowGroupId);
            result.data[i].flowGroupName = Procedure.imw_utils.escapeHTML(result.data[i].flowGroupName);
        }
    }
    return result;
}
