Procedure.define("imw_flow_utils", new imwFlowUtils());

// =============================================================================
// ֐`
// y  z
// yԋplz
// y쐬ҁzNTT DATA INTRAMART
// y XV z
// y Tv zProcedure̓o^
// =============================================================================
function imwFlowUtils() {
    this.getNodeContentsPluginData = getNodeContentsPluginData;
    this.getNodePagePathData = getNodePagePathData;
    this.getNodeContentsMailTemplateData = getNodeContentsMailTemplateData;
    this.getNodeAttrNameConfig = getNodeAttrNameConfig;
    this.createNodeDetailBase = createNodeDetailBase;
    this.createNodeAttrBase = createNodeAttrBase;
    this.createNodeUnionBase = createNodeUnionBase;
}

//=============================================================================
// m[hAgڍ׏̘AgIDɕRÂRecvOC擾܂B
// init ֐Ŏgp܂B
//  contentsPluginIdList ̔z񐔂0̏ꍇ́ARecvOC񂩂
// ftHgtOLAw̃m[hʂ̃f[^ԋp܂B
//  y  zmanager: ContentsDataManager̃CX^X
//            details: m[hAgڍ׏̔z
//            contentsId: RecID
//            contentsVersionId: Reco[WID
//            localeId: P[ID
//            contentsRefAuthFlag: RecQƌ̐^U
//            nodeType: m[h
//  y ԋp zRecvOC񂩂擾
//            mails
//                action: ANV
//                arrive: B
//                    flag: m[hAgڍ׏̘AgIDɕRÂꍇ true AȊO false
//                    type: g|CgID
//                    id: RecvOCID
//                    name: vOC
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z
//=============================================================================
function getNodeContentsPluginData(manager, details, contentsId, contentsVersionId, localeId, contentsRefAuthFlag, nodeType) {

    // ߂l
    var plugins = new Object();
    plugins.action = new Object();
    plugins.arrive = new Object();
    plugins.nodeType = nodeType;

    var processMap = new Object();
    var MAPKEY_ACTION = "action";
    var MAPKEY_ARRIVE = "arrive";
    processMap[MAPKEY_ACTION] = "jp.co.intra_mart.workflow.plugin.event.node.action.process"; // ANV
    processMap[MAPKEY_ARRIVE] = "jp.co.intra_mart.workflow.plugin.event.node.arrive.process"; // B

    plugins.action.flag = false;
    plugins.action.type = processMap[MAPKEY_ACTION];
    plugins.action.list = new Array();

    plugins.arrive.flag = false;
    plugins.arrive.type = processMap[MAPKEY_ARRIVE];
    plugins.arrive.list = new Array();

    // RecQƌΏĕԂ
    if (!contentsRefAuthFlag) {
        return plugins;
    }

    // R[hl擾
    var codeUtil = new WorkflowCodeUtil();
    // tOXe[^X
    var flagStatusEnable = codeUtil.getEnumCodeFlagStatus("Enable"); // L
    // Ag
    var coopTypeArriveProcess = codeUtil.getEnumCodeCooperationType("coopTyp_NodeArriveProcess"); // m[hB
    var coopTypeActionProcess = codeUtil.getEnumCodeCooperationType("coopTyp_ActionProcess"); // ANV쏈
    // Ag
    var coopClassContentsPluginId = codeUtil.getEnumCodeCooperationClassify("coopClass_ContentsPluginId"); // RecvOCID

    var result;
    var model;
    var plugin;
    var leng;
    var i;
    var contentsPluginList = new Array();

    // vOCID擾
    for (leng = details.length, i = 0; i < leng; i++) {
        if (coopClassContentsPluginId == details[i].cooperationClassify) {
            if (flagStatusEnable == details[i].emptyFlag) {
                if (coopTypeActionProcess == details[i].cooperationType) {
                    plugins.action.flag = true;
                } else if (coopTypeArriveProcess == details[i].cooperationType) {
                    plugins.arrive.flag = true;
                }
            } else {
                contentsPluginList[contentsPluginList.length] = details[i];
            }
        }
    }

    // vOCݒ
    for (leng = contentsPluginList.length, i = 0; i < leng; i++) {
        result = manager.getContentsPluginDataWithLocale(
                contentsId, contentsVersionId, contentsPluginList[i].cooperationId, localeId);
        if (!result.resultFlag || result.data == null || nodeType != result.data.nodeType) {
            continue;
        }
        model = result.data;
        plugin = new Object();
        plugin.id = Procedure.imw_utils.escapeHTML(model.contentsPluginId);
        plugin.name = Procedure.imw_utils.escapeHTML(model.pluginName);
        if (coopTypeActionProcess == contentsPluginList[i].cooperationType &&
                processMap[MAPKEY_ACTION] == model.exPointId) {
            // ANV
            plugins.action.flag = true;
            plugins.action.list.push(plugin);
        } else if (coopTypeArriveProcess == contentsPluginList[i].cooperationType &&
                processMap[MAPKEY_ARRIVE] == model.exPointId) {
            // B
            plugins.arrive.flag = true;
            plugins.arrive.list.push(plugin);
        }
    }

    // m[hAgɎw̃m[hʂ̃f[^݂Ȃꍇ
    if (!plugins.action.flag || !plugins.arrive.flag) {
        // RecvOCftHgtOLAw̃m[hʂōiĎ擾
        var condition = new Object();
        var orderByObj = new Array();
        orderByObj[0] = new Object();
        orderByObj[0].columnName = "contentsPluginId";
        orderByObj[0].sortType = "ASC";
        condition.orderByList = orderByObj;
        condition.localeId = localeId;
        result = manager.getContentsPluginDataList(contentsId, contentsVersionId, condition);
        if (result.resultFlag) {
            var list = result.data;
            for (leng = list.length, i = 0; i < leng; i++) {
                model = list[i];
                plugin = new Object();
                plugin.id = Procedure.imw_utils.escapeHTML(model.contentsPluginId);
                plugin.name = Procedure.imw_utils.escapeHTML(model.pluginName);
                if (nodeType == model.nodeType && flagStatusEnable == model.defaultFlag) {
                    if (!plugins.action.flag && processMap[MAPKEY_ACTION] == model.exPointId) {
                        // ANV
                        plugins.action.list.push(plugin);
                    } else if (!plugins.arrive.flag && processMap[MAPKEY_ARRIVE] == model.exPointId) {
                        // B
                        plugins.arrive.list.push(plugin);
                    }
                }
            }
        }
    }

    return plugins;
}

//=============================================================================
// m[hAgڍ׏̘AgIDɕRÂʃpX擾܂B
// init ֐Ŏgp܂B
//  pagePathIdList ̔z񐔂0̏ꍇ́AʃpX񂩂
// ftHgtOLȍŏ̈ꌏڂ̃f[^ԋp܂B
//  y  zmanager: ContentsDataManager̃CX^X
//            details: m[hAgڍ׏̔z
//            contentsId: RecID
//            contentsVersionId: Reco[WID
//            localeId: P[ID
//            contentsRefAuthFlag: RecQƌ̐^U
//  y ԋp zʃpX񂩂擾
//            pages
//                app: \
//                tempSave: ꎞۑ
//                unApp: \
//                reApp: Đ\
//                proc: 
//                cfm: mF
//                procDetail: ڍ׉
//                refDetail: QƏڍ׉
//                cfmDetail: mFڍ׉
//                arcMatDetail: ߋQƏڍ
//                    type: ʎ
//                    flag: m[hAgڍ׏̘AgIDɕRÂꍇ true AȊO false
//                    id: ʃpXID
//                    name: ʖ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z
//=============================================================================
function getNodePagePathData(manager, details, contentsId, contentsVersionId, localeId, contentsRefAuthFlag) {

    // R[hl擾
    var codeUtil = new WorkflowCodeUtil();
    // ʎ
    var pageTypeApp = codeUtil.getEnumCodePageType("pageTyp_App"); // \
    var pageTypeTempSave = codeUtil.getEnumCodePageType("pageTyp_TempSave"); // ꎞۑ
    var pageTypeUnApp = codeUtil.getEnumCodePageType("pageTyp_UnApp"); // \
    var pageTypeReApp = codeUtil.getEnumCodePageType("pageTyp_ReApp"); // Đ\
    var pageTypeProc = codeUtil.getEnumCodePageType("pageTyp_Proc"); // 
    var pageTypecfm = codeUtil.getEnumCodePageType("pageTyp_Cnfm"); // mF
    var pageTypeProcdetail = codeUtil.getEnumCodePageType("pageTyp_Procdetail"); // ڍ׉
    var pageTypeRefdetail = codeUtil.getEnumCodePageType("pageTyp_Refdetail"); // QƏڍ׉
    var pageTypecfmdetail = codeUtil.getEnumCodePageType("pageTyp_Cnfmdetail"); // mFڍ׉
    var pageTypeArcMatdetail = codeUtil.getEnumCodePageType("pageTyp_ArcMatdetail"); // ߋQƏڍ

    // ߂l
    var pages = new Object();
    pages.app = initNodePagePathData(pageTypeApp);
    pages.tempSave = initNodePagePathData(pageTypeTempSave);
    pages.unApp = initNodePagePathData(pageTypeUnApp);
    pages.reApp = initNodePagePathData(pageTypeReApp);
    pages.proc = initNodePagePathData(pageTypeProc);
    pages.cfm = initNodePagePathData(pageTypecfm);
    pages.procDetail = initNodePagePathData(pageTypeProcdetail);
    pages.refDetail = initNodePagePathData(pageTypeRefdetail);
    pages.cfmDetail = initNodePagePathData(pageTypecfmdetail);
    pages.arcMatDetail = initNodePagePathData(pageTypeArcMatdetail);

    // RecQƌΏĕԂ
    if (!contentsRefAuthFlag) {
        return pages;
    }

    // tOXe[^X
    var flagStatusEnable = codeUtil.getEnumCodeFlagStatus("Enable"); // L
    // Ag
    var coopTypeApplyPage = codeUtil.getEnumCodeCooperationType("coopTyp_ApplyPage"); // \
    var coopTypeTemporarySavePage = codeUtil.getEnumCodeCooperationType("coopTyp_TemporarySavePage"); // ꎞۑ
    var coopTypeUnapplyPage = codeUtil.getEnumCodeCooperationType("coopTyp_UnapplyPage"); // \
    var coopTypeReapplyPage = codeUtil.getEnumCodeCooperationType("coopTyp_ReapplyPage"); // Đ\
    var coopTypeProcessPage = codeUtil.getEnumCodeCooperationType("coopTyp_ProcessPage"); // 
    var coopTypeConfirmPage = codeUtil.getEnumCodeCooperationType("coopTyp_ConfirmPage"); // mF
    var coopTypeProcessingDetailPage = codeUtil.getEnumCodeCooperationType("coopTyp_ProcessingDetailPage"); // ڍ׉
    var coopTypeReferenceDetailPage = codeUtil.getEnumCodeCooperationType("coopTyp_ReferenceDetailPage"); // QƏڍ׉
    var coopTypeConfirmDetailPage = codeUtil.getEnumCodeCooperationType("coopTyp_ConfirmDetailPage"); // mFڍ׉
    var coopTypeAchivedMatterDetailPage = codeUtil.getEnumCodeCooperationType("coopTyp_ArchivedMatterDetailPage"); // ߋQƏڍ
    // Ag
    var coopClassPagePathId = codeUtil.getEnumCodeCooperationClassify("coopClass_PagePathId"); // ʃpXID

    var result;
    var pageMap = new Object();
    var typeMap = new Object();
    var page;
    var leng;
    var i;
    var key;
    var pagePathList = new Array();

    // Agʁʎʂ̑Ή\쐬
    typeMap[coopTypeApplyPage] = pageTypeApp;
    typeMap[coopTypeTemporarySavePage] = pageTypeTempSave;
    typeMap[coopTypeUnapplyPage] = pageTypeUnApp;
    typeMap[coopTypeReapplyPage] = pageTypeReApp;
    typeMap[coopTypeProcessPage] = pageTypeProc;
    typeMap[coopTypeConfirmPage] = pageTypecfm;
    typeMap[coopTypeProcessingDetailPage] = pageTypeProcdetail;
    typeMap[coopTypeReferenceDetailPage] = pageTypeRefdetail;
    typeMap[coopTypeConfirmDetailPage] = pageTypecfmdetail;
    typeMap[coopTypeAchivedMatterDetailPage] = pageTypeArcMatdetail;

    // ID擾
    for (leng = details.length, i = 0; i < leng; i++) {
        if (coopClassPagePathId == details[i].cooperationClassify) {
            if (flagStatusEnable == details[i].emptyFlag) {
                page = new Object();
                page.flag = true;
                page.pageType = typeMap[details[i].cooperationType];
                page.pagePathId = "";
                page.pageName = "";
                pageMap[page.pageType] = page;
            } else {
                pagePathList.push(details[i]);
            }
        }
    }

    // ʏݒ
    for (leng = pagePathList.length, i = 0; i < leng; i++) {
        result = manager.getContentsPagePathDataWithLocale(
                contentsId, contentsVersionId, pagePathList[i].cooperationId, localeId);
        if (!result.resultFlag || result.data == null) {
            continue;
        }
        page = result.data;
        if (page.pageType == typeMap[pagePathList[i].cooperationType]) {
            page.flag = true;
            pageMap[page.pageType] = page;
        }
    }

    // ʃpXftHgtOLōiĎ擾
    var condition = new Object();
    var orderByObj = new Array();
    orderByObj[0] = new Object();
    orderByObj[0].columnName = "pagePathId";
    orderByObj[0].sortType = "ASC";
    condition.orderByList = orderByObj;
    condition.localeId = localeId;
    result = manager.getContentsPagePathDataList(contentsId, contentsVersionId, condition);
    if (result.resultFlag) {
        var list = result.data;
        for (leng = list.length, i = 0; i < leng; i++) {
            page = list[i];
            if (flagStatusEnable == page.defaultFlag && !pageMap[page.pageType]) {
                page.flag = false;
                pageMap[page.pageType] = page;
            }
        }
    }

    for (key in pageMap) {
        page = pageMap[key];
        if (pageTypeApp == page.pageType) {
            if (isBlank(pages.app.id)) {
                pages.app = initNodePagePathData(pageTypeApp, page);
            }
        } else if (pageTypeTempSave == page.pageType) {
            if (isBlank(pages.tempSave.id)) {
                pages.tempSave = initNodePagePathData(pageTypeTempSave, page);
            }
        } else if (pageTypeUnApp == page.pageType) {
            if (isBlank(pages.unApp.id)) {
                pages.unApp = initNodePagePathData(pageTypeUnApp, page);
            }
        } else if (pageTypeReApp == page.pageType) {
            if (isBlank(pages.reApp.id)) {
                pages.reApp = initNodePagePathData(pageTypeReApp, page);
            }
        } else if (pageTypeProc == page.pageType) {
            if (isBlank(pages.proc.id)) {
                pages.proc = initNodePagePathData(pageTypeProc, page);
            }
        } else if (pageTypecfm == page.pageType) {
            if (isBlank(pages.cfm.id)) {
                pages.cfm = initNodePagePathData(pageTypecfm, page);
            }
        } else if (pageTypeProcdetail == page.pageType) {
            if (isBlank(pages.procDetail.id)) {
                pages.procDetail = initNodePagePathData(pageTypeProcdetail, page);
            }
        } else if (pageTypeRefdetail == page.pageType) {
            if (isBlank(pages.refDetail.id)) {
                pages.refDetail = initNodePagePathData(pageTypeRefdetail, page);
            }
        } else if (pageTypecfmdetail == page.pageType) {
            if (isBlank(pages.cfmDetail.id)) {
                pages.cfmDetail = initNodePagePathData(pageTypecfmdetail, page);
            }
        } else if (pageTypeArcMatdetail == page.pageType) {
            if (isBlank(pages.arcMatDetail.id)) {
                pages.arcMatDetail = initNodePagePathData(pageTypecfmdetail, page);
            }
        }
    }

    pages.app = escapePagePathData(pages.app);
    pages.tempSave = escapePagePathData(pages.tempSave);
    pages.unApp = escapePagePathData(pages.unApp);
    pages.reApp = escapePagePathData(pages.reApp);
    pages.proc = escapePagePathData(pages.proc);
    pages.cfm = escapePagePathData(pages.cfm);
    pages.procDetail = escapePagePathData(pages.procDetail);
    pages.refDetail = escapePagePathData(pages.refDetail);
    pages.cfmDetail = escapePagePathData(pages.cfmDetail);
    pages.arcMatDetail = escapePagePathData(pages.arcMatDetail);

    return pages;
}

//=============================================================================
// m[hAgڍ׏̘AgIDɕRÂRec[ev[g擾܂B
// init ֐Ŏgp܂B
//  mailIdList ̔z񐔂0̏ꍇ́ARec[ev[g񂩂
// ftHgtOLAw̃[ʂ̃f[^ԋp܂B
//  y  zmanager: ContentsDataManager̃CX^X
//            details: m[hAgڍ׏̔z
//            contentsId: RecID
//            contentsVersionId: Reco[WID
//            localeId: P[ID
//            contentsRefAuthFlag: RecQƌ̐^U
//            mailType: [
//  y ԋp zRec[ev[g񂩂擾
//            mails
//                flag: m[hAgڍ׏̘AgIDɕRÂꍇ true AȊO false
//                mails
//                    type: [
//                    id: [ID
//                    name: [
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z
//=============================================================================
function getNodeContentsMailTemplateData(manager, details, contentsId, contentsVersionId, localeId, contentsRefAuthFlag, mailType) {

    // ߂l
    var mails = new Object();
    mails.type = mailType;
    mails.flag = false;
    mails.mails = new Array();

    // RecQƌΏĕԂ
    if (!contentsRefAuthFlag) {
        return mails;
    }

    // R[hl擾
    var codeUtil = new WorkflowCodeUtil();
    // tOXe[^X
    var flagStatusEnable = codeUtil.getEnumCodeFlagStatus("Enable"); // L
    // Ag
    var coopTypeProcessingRequestMail = codeUtil.getEnumCodeCooperationType("coopTyp_ProcessingRequestMail"); // ˗[
    var coopTypeConfirmRequestMail = codeUtil.getEnumCodeCooperationType("coopTyp_ConfirmRequestMail"); // mF˗[
    var coopTypeLastProcessResultMail = codeUtil.getEnumCodeCooperationType("coopTyp_LastProcessResultMail"); // ŏIʃ[
    var coopTypeReferenceOrderMail = codeUtil.getEnumCodeCooperationType("coopTyp_ReferenceOrderMail"); // Qƈ˗[
    // Ag
    var coopClassMailId = codeUtil.getEnumCodeCooperationClassify("coopClass_MailPluginId"); // [ID
    // [
    var mailTypeProc = codeUtil.getEnumCodeMailType("mailTyp_Proc"); // ˗
    var mailTypeResult = codeUtil.getEnumCodeMailType("mailTyp_Result"); // ʒʒm
    var mailTypeRef = codeUtil.getEnumCodeMailType("mailTyp_Ref"); // Qƈ˗
    var mailTypeConfirm = codeUtil.getEnumCodeMailType("mailTyp_Cnfm"); // mF˗

    var result;
    var typeMap = new Object();
    var model;
    var mail;
    var leng;
    var i;
    var mailList = new Array();

    // Agʁ[ʂ̑Ή\쐬
    typeMap[coopTypeProcessingRequestMail] = mailTypeProc;
    typeMap[coopTypeLastProcessResultMail] = mailTypeResult;
    typeMap[coopTypeReferenceOrderMail] = mailTypeRef;
    typeMap[coopTypeConfirmRequestMail] = mailTypeConfirm;

    // [ID擾
    for (leng = details.length, i = 0; i < leng; i++) {
        if (coopClassMailId == details[i].cooperationClassify) {
            if (flagStatusEnable == details[i].emptyFlag) {
                mails.flag = true;
            } else {
                mailList.push(details[i]);
            }
        }
    }

    // [ݒ
    for (leng = mailList.length, i = 0; i < leng; i++) {
        result = manager.getContentsMailTemplateDataWithLocale(
                contentsId, contentsVersionId, mailList[i].cooperationId, mailType, localeId);
        if (!result.resultFlag || result.data == null) {
            continue;
        }
        model = result.data;
        if (model.mailType == typeMap[mailList[i].cooperationType]) {
            mails.flag = true;
            mail = new Object();
            mail.id = Procedure.imw_utils.escapeHTML(model.mailId);
            mail.name = Procedure.imw_utils.escapeHTML(model.mailTempData.mailName);
            mails.mails.push(mail);
        }
    }

    // m[hAgɎw̃[ʂ̃f[^݂Ȃꍇ
    if (!mails.flag) {
        // Rec[ev[gftHgtOLAw̃[ʂōiĂ擾
        var condition = new Object();
        var orderByObj = new Array();
        orderByObj[0] = new Object();
        orderByObj[0].columnName = "mailId";
        orderByObj[0].sortType = "ASC";
        condition.orderByList = orderByObj;
        condition.localeId = localeId;
        result = manager.getContentsMailTemplateDataList(contentsId, contentsVersionId, condition);
        if (result.resultFlag) {
            var list = result.data;
            for (leng = list.length, i = 0; i < leng; i++) {
                model = list[i];
                if (flagStatusEnable == model.defaultFlag && mailType == model.mailType) {
                    mail = new Object();
                    mail.id = Procedure.imw_utils.escapeHTML(model.mailId);
                    mail.name = Procedure.imw_utils.escapeHTML(model.mailName);
                    mails.mails.push(mail);
                }
            }
        }
    }

    return mails;
}

//=============================================================================
// m[hAg񂩂疼̐ݒɊ֘A擾܂B
// init ֐Ŏgp܂B
//  y  zattributes: m[hAg̔z
//            locales: ݒiVXegp郍P[j
//  y ԋp zm[hAgÁAbZ[WvpeB擾̐ݒɊ֘A
//            nameConfig
//                apply: \
//                reapply: Đ\
//                discontinue: ~
//                draft: \
//                approve: F
//                approveEnd: FI
//                sendback: ߂
//                pullback: ߂
//                deny: ۔F
//                reserve: ۗ
//                reserveCancel: ۗ
//                transfer: U
//                confirm: mF
//                    enable: 
//                    list: ʂ̖
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z
//=============================================================================
function getNodeAttrNameConfig(attributes, locales) {

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var attrTypeProcTypName = codeUtil.getEnumCodeAttributeType("attrTyp_procTypName"); // ʖ
    var attrTypeProcEnable = codeUtil.getEnumCodeAttributeType("attrTyp_procEnable"); // 
    // 
    var procTypeApply = codeUtil.getEnumCodeProcessType("procTyp_apy"); // \
    var procTypeReapply = codeUtil.getEnumCodeProcessType("procTyp_rapy"); // Đ\
    var procTypeDiscontinue = codeUtil.getEnumCodeProcessType("procTyp_dct"); // ~
    var procTypeDraft = codeUtil.getEnumCodeProcessType("procTyp_drf"); // \
    var procTypeApprove = codeUtil.getEnumCodeProcessType("procTyp_apr"); // F
    var procTypeApproveEnd = codeUtil.getEnumCodeProcessType("procTyp_apre"); // FI
    var procTypeDeny = codeUtil.getEnumCodeProcessType("procTyp_deny"); // ۔F
    var procTypeReserve = codeUtil.getEnumCodeProcessType("procTyp_rsv"); // ۗ
    var procTypeReserveCancel = codeUtil.getEnumCodeProcessType("procTyp_rsvc"); // ۗ
    var procTypeSendback = codeUtil.getEnumCodeProcessType("procTyp_sbk"); // ߂
    var procTypePullback = codeUtil.getEnumCodeProcessType("procTyp_pbk"); // ߂
    var procTypeConfirm = codeUtil.getEnumCodeProcessType("procTyp_cnfm"); // mF
    var procTypeTransfer = codeUtil.getEnumCodeProcessType("procTyp_trans"); // U

    var nameConfig = new Object();
    nameConfig.apply = new Object();
    nameConfig.apply.list = new Array();
    nameConfig.reapply = new Object();
    nameConfig.reapply.list = new Array();
    nameConfig.discontinue = new Object();
    nameConfig.discontinue.list = new Array();
    nameConfig.draft = new Object();
    nameConfig.draft.list = new Array();
    nameConfig.approve = new Object();
    nameConfig.approve.list = new Array();
    nameConfig.approveEnd = new Object();
    nameConfig.approveEnd.list = new Array();
    nameConfig.sendback = new Object();
    nameConfig.sendback.list = new Array();
    nameConfig.pullback = new Object();
    nameConfig.pullback.list = new Array();
    nameConfig.deny = new Object();
    nameConfig.deny.list = new Array();
    nameConfig.reserve = new Object();
    nameConfig.reserve.list = new Array();
    nameConfig.reserveCancel = new Object();
    nameConfig.reserveCancel.list = new Array();
    nameConfig.transfer = new Object();
    nameConfig.transfer.list = new Array();
    nameConfig.confirm = new Object();
    nameConfig.confirm.list = new Array();

    var attributeMap = new Object();
    var localeId;
    var attrType;
    var i;
    for (i = 0; i < locales.length; i++) {
        localeId = locales[i].locale;
        attributeMap[localeId] = new Object();
        attributeMap[localeId][attrTypeProcTypName] = new Object();
        attributeMap[localeId][attrTypeProcEnable] = new Object();
    }

    var attrKey;
    for (i = 0; i < attributes.length; i++) {
        localeId = attributes[i].localeId;
        attrType = attributes[i].attributeType;
        attrKey = attributes[i].attributeKey;
        if (attributeMap[localeId] && attributeMap[localeId][attrType]) {
            attributeMap[localeId][attrType][attrKey] = new Object();
            attributeMap[localeId][attrType][attrKey] = attributes[i];
        }
    }

    var model;
    var displayName;
    for (i = 0; i < locales.length; i++) {
        localeId = locales[i].locale;
        displayName = locales[i].displayName;

        // \
        model = attributeMap[localeId][attrTypeProcEnable][procTypeApply];
        nameConfig.apply.enable = (model) ? model.value : null;
        model = attributeMap[localeId][attrTypeProcTypName][procTypeApply];
        nameConfig.apply.list[i] = getNodeAttrNameValue(model, localeId, displayName, "IMW.CAP.0010");

        // Đ\
        model = attributeMap[localeId][attrTypeProcEnable][procTypeReapply];
        nameConfig.reapply.enable = (model) ? model.value : null;
        model = attributeMap[localeId][attrTypeProcTypName][procTypeReapply];
        nameConfig.reapply.list[i] = getNodeAttrNameValue(model, localeId, displayName, "IMW.CAP.0455");

        // ~
        model = attributeMap[localeId][attrTypeProcEnable][procTypeDiscontinue];
        nameConfig.discontinue.enable = (model) ? model.value : null;
        model = attributeMap[localeId][attrTypeProcTypName][procTypeDiscontinue];
        nameConfig.discontinue.list[i] = getNodeAttrNameValue(model, localeId, displayName, "IMW.CAP.0127");

        // N[
        model = attributeMap[localeId][attrTypeProcEnable][procTypeDraft];
        nameConfig.draft.enable = (model) ? model.value : null;
        model = attributeMap[localeId][attrTypeProcTypName][procTypeDraft];
        nameConfig.draft.list[i] = getNodeAttrNameValue(model, localeId, displayName, "IMW.CAP.1114");

        // F
        model = attributeMap[localeId][attrTypeProcEnable][procTypeApprove];
        nameConfig.approve.enable = (model) ? model.value : null;
        model = attributeMap[localeId][attrTypeProcTypName][procTypeApprove];
        nameConfig.approve.list[i] = getNodeAttrNameValue(model, localeId, displayName, "IMW.CAP.0046");

        // FI
        model = attributeMap[localeId][attrTypeProcEnable][procTypeApproveEnd];
        nameConfig.approveEnd.enable = (model) ? model.value : null;
        model = attributeMap[localeId][attrTypeProcTypName][procTypeApproveEnd];
        nameConfig.approveEnd.list[i] = getNodeAttrNameValue(model, localeId, displayName, "IMW.CAP.0126");

        // ߂
        model = attributeMap[localeId][attrTypeProcEnable][procTypeSendback];
        nameConfig.sendback.enable = (model) ? model.value : null;
        model = attributeMap[localeId][attrTypeProcTypName][procTypeSendback];
        nameConfig.sendback.list[i] = getNodeAttrNameValue(model, localeId, displayName, "IMW.CAP.0458");

        // ߂
        model = attributeMap[localeId][attrTypeProcEnable][procTypePullback];
        nameConfig.pullback.enable = (model) ? model.value : null;
        model = attributeMap[localeId][attrTypeProcTypName][procTypePullback];
        nameConfig.pullback.list[i] = getNodeAttrNameValue(model, localeId, displayName, "IMW.CAP.0394");

        // ۔F
        model = attributeMap[localeId][attrTypeProcEnable][procTypeDeny];
        nameConfig.deny.enable = (model) ? model.value : null;
        model = attributeMap[localeId][attrTypeProcTypName][procTypeDeny];
        nameConfig.deny.list[i] = getNodeAttrNameValue(model, localeId, displayName, "IMW.CAP.0128");

        // ۗ
        model = attributeMap[localeId][attrTypeProcEnable][procTypeReserve];
        nameConfig.reserve.enable = (model) ? model.value : null;
        model = attributeMap[localeId][attrTypeProcTypName][procTypeReserve];
        nameConfig.reserve.list[i] = getNodeAttrNameValue(model, localeId, displayName, "IMW.CAP.0459");

        // ۗ
        model = attributeMap[localeId][attrTypeProcEnable][procTypeReserveCancel];
        nameConfig.reserveCancel.enable = (model) ? model.value : null;
        model = attributeMap[localeId][attrTypeProcTypName][procTypeReserveCancel];
        nameConfig.reserveCancel.list[i] = getNodeAttrNameValue(model, localeId, displayName, "IMW.CAP.0235");

        // U
        model = attributeMap[localeId][attrTypeProcEnable][procTypeTransfer];
        nameConfig.transfer.enable = (model) ? model.value : null;
        model = attributeMap[localeId][attrTypeProcTypName][procTypeTransfer];
        nameConfig.transfer.list[i] = getNodeAttrNameValue(model, localeId, displayName, "IMW.CAP.0386");

        // mF
        model = attributeMap[localeId][attrTypeProcEnable][procTypeConfirm];
        nameConfig.confirm.enable = (model) ? model.value : null;
        model = attributeMap[localeId][attrTypeProcTypName][procTypeConfirm];
        nameConfig.confirm.list[i] = getNodeAttrNameValue(model, localeId, displayName, "IMW.CAP.0308");
    }

    return nameConfig;
}

//=============================================================================
// ݂ꍇɂ̒lݒ肵A݂Ȃꍇ null ݒ肵ĕԂ܂B
// getNodePagePathData ֐Ŏgp܂B
//  y  ztype: ʎ
//            page: ʃpX
//  y ԋp zʏ
//            result
//                type: ʎ
//                flag: m[hAgڍ׏̘AgIDɕRÂꍇ true AȊO false
//                id: ID
//                name: ʖ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z
//=============================================================================
function initNodePagePathData(type, page) {
    var result = new Object();
    result.type = type;
    result.flag = isObject(page) ? page.flag : false;
    result.id = isObject(page) ? page.pagePathId : "";
    result.name = isObject(page) ? page.pageName : "";
    return result;
}

//=============================================================================
// ʏGXP[v܂B
//  y  zpage: ʏ
//  y ԋp zʏ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z
//=============================================================================
function escapePagePathData(page) {
    page.type = Procedure.imw_utils.escapeHTML(page.type);
    page.id = Procedure.imw_utils.escapeHTML(page.id);
    page.name = Procedure.imw_utils.escapeHTML(page.name);
    return page;
}

//=============================================================================
// m[hAgڍ׏ݒ֐
//   y  zrequest: tqk擾IuWFNg
//             cooperationType: Ag
//             cooperationClassify: Ag
//             cooperationId: AgID
//   y ԋp z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zm[hAgڍ׏̋ʂ̒lݒ肵܂B
//=============================================================================
function createNodeDetailBase(request, cooperationType, cooperationClassify, cooperationId) {
    var model = new Object();
    model.no = Identifier.get();
    model.flowId = request.flowId;
    model.flowVersionId = request.flowVersionId;
    model.contentsVersionId = request.contentsVersionId;
    model.routeVersionId = request.routeVersionId;
    model.nodeId = request.nodeId;
    model.cooperationType = cooperationType;
    model.cooperationClassify = cooperationClassify;
    model.cooperationId = cooperationId;
    return model;
}

//=============================================================================
// m[hAgݒ֐
//   y  zrequest: tqk擾IuWFNg
//             localeId: P[ID
//             hashNo: AԂ̃nbV
//             type: Ag
//             key: AgL[
//             value: l
//   y ԋp z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv zm[hAg̋ʂ̒lݒ肵܂B
//=============================================================================
function createNodeAttrBase(request, localeId, hashNo, type, key, value) {
    var model = new Object();
    var ukey = (type || "") + "\n" + ((key == hashNo.attrKeyNoSetting ? value : key) || "");
    model.no = hashNo[ukey] || Identifier.get();
    model.flowId = request.flowId;
    model.flowVersionId = request.flowVersionId;
    model.contentsVersionId = request.contentsVersionId;
    model.routeVersionId = request.routeVersionId;
    model.nodeId = request.nodeId;
    model.localeId = localeId;
    model.attributeType = type;
    model.attributeKey = key;
    model.value = value;
    hashNo[ukey] = model.no;
    return model;
}

//=============================================================================
// 򌋍ڍ׏ݒ֐
//   y  zrequest: tqk擾IuWFNg
//             no: m[hAg̘A
//             unionGroupId: 򌋍O[vID
//             unionGroupClassify: 򌋍O[v
//             targetNodeId: JEgΏۃm[hID
//   y ԋp z
//   y쐬ҁzNTT DATA INTRAMART
//   y Tv z򌋍ڍ׏̋ʂ̒lݒ肵܂B
//=============================================================================
function createNodeUnionBase(request, no, unionGroupId, unionGroupClassify, targetNodeId) {
    var model = new Object();
    model.branchUnionId = no;
    model.flowId = request.flowId;
    model.flowVersionId = request.flowVersionId;
    model.contentsVersionId = request.contentsVersionId;
    model.routeVersionId = request.routeVersionId;
    model.nodeId = request.nodeId;
    model.branchUnionGroupId = Identifier.get();
    model.branchUnionGroupClassify = unionGroupClassify;
    model.countTrue = "1";
    model.countTargetNodeId = targetNodeId;
    return model;
}

//=============================================================================
// ̂m[hAgÁAbZ[WvpeBݒ肵Ԃ܂B
// getAttrNameConfig ֐Ŏgp܂B
//  y  zmodel: m[hAg
//            localeId: P[ID
//            displayName: P[\
//            msgId: bZ[WID
//  y ԋp z
//            result
//                isDefault: bZ[WvpeB擾ꍇtrueAȊOfalse
//                displayName: P[\
//                name: 
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv z
//=============================================================================
function getNodeAttrNameValue(model, localeId, displayName, msgId) {
    var result = new Object();
    result.localeDisplayName = Procedure.imw_utils.escapeHTML(displayName);
    if (model) {
        result.isDefault = false;
        result.name = Procedure.imw_utils.escapeHTML(model.value);
    } else {
        result.isDefault = true;
        result.name = MessageManager.getLocaleMessage(localeId, msgId);
    }
    return result;
}
