// oChϐ錾
var oCaption = new Object();
var oCommon = new Object();
var oValidationMsg = new Object();
var oResult = new Object();
var oHidden = new Object();

// m[h̎s
var PROCESS_EXEC = "1"; // s
var PROCESS_RESERVE = "2"; // ۗ

// g|CgID
var APPLY_EXTENSION_POINT_ID = "jp.co.intra_mart.workflow.plugin.authority.node.apply";
var APPROVE_EXTENSION_POINT_ID = "jp.co.intra_mart.workflow.plugin.authority.node.approve";
var DYNAMIC_EXTENSION_POINT_ID = "jp.co.intra_mart.workflow.plugin.authority.node.dynamic";
var CONFIRM_EXTENSION_POINT_ID = "jp.co.intra_mart.workflow.plugin.authority.node.confirm";
var SYSNEXT_EXTENSION_POINT_ID = "jp.co.intra_mart.workflow.plugin.authority.node.approve.static";

// t[`vOC̓Kp
var FLOW_DISABLED_PLUGIN = false;

//=============================================================================
// ֐
//  y  zrequest: tqk擾IuWFNg
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zm[hݒiFEIFEmFjʂ\܂B
//=============================================================================
function init(request) {
    var databaseResult;
    var i;

    // LvV̎擾
    oCaption.title = MessageManager.getMessage("IMW.CAP.1088"); // ʃ^Cgum[hҏWv
    oCaption.close = MessageManager.getMessage("IMW.CAP.0039"); // 
    oCaption.nodeName = MessageManager.getMessage("IMW.CAP.0250"); // m[h
    oCaption.nodeEnabled = MessageManager.getMessage("IMW.CAP.0152"); // L
    oCaption.savedConfig = MessageManager.getMessage("IMW.CAP.1089"); // ۑςݐݒ
    oCaption.deleteConfig = MessageManager.getMessage("IMW.CAP.1026"); // 폜
    oCaption.nodeConfigName = MessageManager.getMessage("IMW.CAP.1090"); // ݒ薼
    oCaption.saveConfig = MessageManager.getMessage("IMW.CAP.1091"); //  
    oCaption.targetUser = MessageManager.getMessage("IMW.CAP.0323"); // Ώێ
    oCaption.confirmUser = MessageManager.getMessage("IMW.CAP.0324"); // mFΏێ
    oCaption.targetType = MessageManager.getMessage("IMW.CAP.0113"); // Ώێ
    oCaption.targetName = MessageManager.getMessage("IMW.CAP.0114"); // Ώۖ
    oCaption.showConfirm = MessageManager.getMessage("IMW.CAP.0051"); // 󋵊mF
    oCaption.search = MessageManager.getMessage("IMW.CAP.0359"); // 
    oCaption.remove = MessageManager.getMessage("IMW.CAP.0062"); // 
    oCaption.update = MessageManager.getMessage("IMW.CAP.0022"); // X V

    // ZbV̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var userId = oSession.user;
    var loginGroupId = oSession.loginGroup;
    var localeId = oSession.locale;

    // of[VbZ[W̎擾
    makeValidation(loginGroupId, localeId);

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var admorTypeWkfSysAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfSysAdmor");
    var admorTypeWkfOpeAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfOpeAdmor");
    var flagStatusEnable = codeUtil.getEnumCodeFlagStatus("Enable");
    var nodeTypeApply = codeUtil.getEnumCodeNodeType("nodeTyp_Apply");
    var nodeTypeApprove = codeUtil.getEnumCodeNodeType("nodeTyp_Approve");
    var nodeTypeDynamic = codeUtil.getEnumCodeNodeType("nodeTyp_Dynamic");
    var nodeTypeConfirm = codeUtil.getEnumCodeNodeType("nodeTyp_Confirm");

    // Č̎擾
    if (request.referer == "actv") {
        databaseResult = Procedure.imw_matter_utils.getActvMatterData(loginGroupId, localeId, userId,
                request.imwSystemMatterId);
    } else if (request.referer == "cpl") {
        databaseResult = Procedure.imw_matter_utils.getCplMatterData(loginGroupId, localeId, userId,
                request.imwSystemMatterId);
    }
    if (!databaseResult.resultFlag) {
        Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3549", databaseResult);
    }
    var matterData = databaseResult.data;

    // ҏWEČ쌠̃`FbN
    var administratorType = Procedure.imw_admin_utils.decodeAdministratorType(oSession, request.imwOpeType);
    if (request.referer == "actv") {
        databaseResult = Procedure.imw_matter_utils.checkActvNodeConfigEditAuth(loginGroupId, userId, localeId,
                administratorType, matterData, request.imwNodeId);
    } else if (request.referer == "cpl") {
        databaseResult = Procedure.imw_matter_utils.checkCplNodeConfigEditAuth(loginGroupId, userId, localeId,
                administratorType, matterData, request.imwNodeId);
    }
    if (!databaseResult.resultFlag) {
        Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3549", databaseResult);
    }

    // m[h̎擾
    var nodeManager;
    if (request.referer == "actv") {
        nodeManager = new ActvMatterNode(loginGroupId, localeId, request.imwSystemMatterId);
        databaseResult = getActvMatterNodeData(nodeManager, request.imwNodeId);
    } else if (request.referer == "cpl") {
        nodeManager = new CplMatterNode(loginGroupId, localeId, request.imwSystemMatterId);
        databaseResult = getCplMatterNodeData(nodeManager, request.imwNodeId);
    }
    if (!databaseResult.resultFlag) {
        Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3549", databaseResult);
    }
    var nodeData = databaseResult.data;
    if (!isObject(nodeData)) {
        Procedure.imw_error_utils.showErrorGreyboxClose("IMW.CLI.WRN.3509");
    }

    // OC[ÜČ쌠擾
    var loginUserHandleAuth = matterData.loginUserHandleAuth;
    var hasChangeUserAuth = true; // m[h̏EmFΏێ҂̕ύX
    var hasDeleteDynamicNodeAuth = true; // IFm[h̍폜
    var hasUndeleteDynamicNodeAuth = true; // IFm[h̕
    oResult.isAdmin = administratorType == admorTypeWkfSysAdmor || administratorType == admorTypeWkfOpeAdmor;
    if (!oResult.isAdmin) {
        hasChangeUserAuth = !isBlank(loginUserHandleAuth.changeUserFlag) &&
                loginUserHandleAuth.changeUserFlag == flagStatusEnable;
        hasDeleteDynamicNodeAuth = !isBlank(loginUserHandleAuth.deleteDynamicNodeFlag) &&
                loginUserHandleAuth.deleteDynamicNodeFlag == flagStatusEnable;
        hasUndeleteDynamicNodeAuth = !isBlank(loginUserHandleAuth.undeleteDynamicNodeFlag) &&
                loginUserHandleAuth.undeleteDynamicNodeFlag == flagStatusEnable;
    }

    // L`FbN{bNX̕\
    oResult.isShowNodeEnabled = false;
    oResult.isCantChangeNodeEnabled = true;
    if (request.referer == "actv" && nodeData.nodeType == nodeTypeDynamic) {
        oResult.isShowNodeEnabled = true;
        var nodeStatus = matterData.execFlowNodeMap[request.imwNodeId].status;
        if (!isObject(nodeData.masterNodeConfig)) {
            Procedure.imw_error_utils.showErrorGreyboxClose("IMW.CLI.WRN.3509");
        }
        if (flagStatusEnable == nodeData.masterNodeConfig.dynamicNodeDeleteDisableFlag) {
            // t[`œIFm[h̍폜֎~ݒ肳Ăꍇ͕ύXs
        } else if (nodeStatus == PROCESS_EXEC || nodeStatus == PROCESS_RESERVE) {
            // sEۗ̏ꍇ͕ύXs
        } else if (nodeData.isNodeEnabled && !hasDeleteDynamicNodeAuth) {
            // m[hLō폜Ȃꍇ͕ύXs
        } else if (!nodeData.isNodeEnabled && !hasUndeleteDynamicNodeAuth) {
            // m[hŕȂꍇ͕ύXs
        } else {
            oResult.isCantChangeNodeEnabled = false;
        }
    }

    // ۑςݐݒꗗ̎擾
    oResult.isShowNodeSave = false;
    oResult.userNodeConfigIdSelect = "";
    if (hasChangeUserAuth) {
        // m[h̏EmFΏێ҂̕ύXꍇ
        oResult.isShowNodeSave = true;
        oResult.userNodeConfigIdList = new Object();
        oResult.userNodeConfigIdList[""] = "";

        var userNodeConfig = new UserNodeConfig(loginGroupId, userId);
        var searchCondition = new ListSearchConditionNoMatterProperty();
        searchCondition.addCondition(UserNodeConfig.NODE_TYPE, nodeData.nodeType,
                ListSearchCondition.OP_EQ);
        searchCondition.addOrder(UserNodeConfig.CREATE_DATETIME, false);
        databaseResult = userNodeConfig.getUserNodeConfigList(searchCondition);
        if (!databaseResult.resultFlag) {
            Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3549", databaseResult);
        }
        for (i = 0; i < databaseResult.data.length; i++) {
            oResult.userNodeConfigIdList[databaseResult.data[i].nodeConfigId] =
                    databaseResult.data[i].nodeConfigName;
        }
        if (!isBlank(request.userNodeConfigIdSelect)) {
            oResult.userNodeConfigIdSelect = request.userNodeConfigIdSelect;
        }
        oResult.userNodeConfigIdList = Procedure.imw_utils.escapePullDownObject(oResult.userNodeConfigIdList);
    }

    // g|CgID̎擾
    var extensionPointIds = new Object();
    extensionPointIds[nodeTypeApply] = APPLY_EXTENSION_POINT_ID;
    extensionPointIds[nodeTypeApprove] = APPROVE_EXTENSION_POINT_ID;
    extensionPointIds[nodeTypeDynamic] = DYNAMIC_EXTENSION_POINT_ID;
    extensionPointIds[nodeTypeConfirm] = CONFIRM_EXTENSION_POINT_ID;
    var approvePointIds = new Object();
    approvePointIds[nodeTypeApply] = APPROVE_EXTENSION_POINT_ID;
    approvePointIds[nodeTypeApprove] = APPROVE_EXTENSION_POINT_ID;
    var extensionPointId = extensionPointIds[nodeData.nodeType];
    if (request.referer == "actv" && nodeTypeApprove == nodeData.nodeType &&
            isObject(nodeData.masterNodeConfig) &&
            isArray(nodeData.masterNodeConfig.backwardNodeIds) &&
            nodeData.masterNodeConfig.backwardNodeIds.length) {
        // ČAAFm[h̏ꍇ͑Om[h̎擾
        var backNodeId = nodeData.masterNodeConfig.backwardNodeIds[0];
        databaseResult = getActvMatterNodeData(nodeManager, backNodeId);
        if (databaseResult.resultFlag && databaseResult.data != null) {
            extensionPointId = approvePointIds[databaseResult.data.nodeType];
        }
        if (isBlank(extensionPointId)) {
            // g|CgIDłȂꍇ̓VXem[h̎̏Fm[hgp
            extensionPointId = SYSNEXT_EXTENSION_POINT_ID;
        }
    } else if (isBlank(extensionPointId)) {
        // g|CgIDłȂꍇ͓IFm[hgp
        extensionPointId = DYNAMIC_EXTENSION_POINT_ID;
    }
    oResult.baseExtensionPointId = extensionPointId;

    // AvP[Vʃ}X^̐ݒ
    Procedure.imw_plugin_utils.initAppCommonMaster(oResult, extensionPointId,
            loginGroupId, localeId, oResult.isAdmin,
            FLOW_DISABLED_PLUGIN ? (
            nodeData.isNodeEnabled ? nodeData.execNodeConfig.pluginParameterDisable :
            nodeData.masterNodeConfig.pluginParameterDisable) : null);
    oResult.imwAppCommonTargetDate = matterData.applyBaseDate;  // F\

    // Ώێ҈ꗗ̎擾
    oResult.isRemoveTargetUser = false;
    oResult.isShowSearchTargetUser = hasChangeUserAuth;
    oResult.isShowRemoveTargetUser = hasChangeUserAuth;
    databaseResult = getTargetUserList(request, loginGroupId, userId, localeId, matterData.applyBaseDate,
            nodeData.isNodeEnabled);
    if (!databaseResult.resultFlag) {
        Procedure.imw_error_utils.showErrorAlert("IMW.CLI.WRN.3549", databaseResult);
    }
    oResult.execProcessTargetList = databaseResult.data;

    // x̕ύX
    if (nodeTypeConfirm == nodeData.nodeType) {
        oCaption.targetUser = oCaption.confirmUser;
    }
    oCaption.imwAppCommonTitle = oCaption.targetUser;

    // hidden ɏo͂鍀ڂ̐ݒ
    oResult.imwSystemMatterId = request.imwSystemMatterId;
    oResult.imwUserDataId = request.imwUserDataId;
    oResult.imwNodeId = request.imwNodeId;
    oResult.imwOpeType = request.imwOpeType;
    oResult.referer = request.referer;
    oResult.imwFlowId = matterData.flowId;
    oResult.imwApplyBaseDate = matterData.applyBaseDate;
    oResult.nodeType = nodeData.nodeType;
    oResult.nodeName = nodeData.nodeName;
    oResult.isNodeEnabled = nodeData.isNodeEnabled || !isBlank(request.forceNodeEnabled);
    Procedure.imw_utils.makeHiddenObject(oHidden, oResult);
}

//=============================================================================
// of[V`FbN쐬֐
//  y  zloginGroupId: OCO[vID
//            localeId: P[ID
//  y ԋp zȂ
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zof[V`FbN쐬܂B
//=============================================================================
function makeValidation(loginGroupId, localeId) {
    var oParameter;
    oCommon = new Object();
    oCommon.localeId = localeId;
    oCommon.locales = System.getLocales(localeId);

    // VXeČID
    oParameter = Procedure.imw_validate_utils.makeParameter4SelectRequireId(
            "imwSystemMatterId", "IMW.CAP.1154");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);

    // ۑςݐݒ
    oParameter = Procedure.imw_validate_utils.makeParameter4SelectRequireId(
            "userNodeConfigId", "IMW.CAP.1089");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);

    // ݒ薼
    oParameter = Procedure.imw_validate_utils.makeParameter4Text(
            "nodeConfigName", "IMW.CAP.1090", 200);
    oParameter.requireInput = true;
    Procedure.imw_validate_utils.setParameterFromSettings(loginGroupId, oParameter, "node-config-name");
    Procedure.imw_validate_utils.makeValidateMessage(oValidationMsg, oCommon, oParameter);

    // IĂ鏈ΏێҐݒ藚폜܂B낵łH
    oValidationMsg.deleteConfirm = MessageManager.getMessage("IMW.CLI.INF.3508");
    // ݒۑ܂B낵łH
    oValidationMsg.saveConfirm = MessageManager.getMessage("IMW.CLI.INF.3509");
    // m[hݒ̍XVs܂B낵łH
    oValidationMsg.updateConfirm = MessageManager.getMessage("IMW.CLI.INF.3515");
    // m[hŎwłȂΏێ҂ĕۑςݐݒ𔽉f܂B
    oValidationMsg.removeTargetUser = MessageManager.getMessage("IMW.CLI.WRN.3281");
    // \ɂĖȏΏێ҂ĕۑςݐݒ𔽉f܂B
    oValidationMsg.invalidTargetUser = MessageManager.getMessage("IMW.CLI.WRN.3282");
}

//=============================================================================
// ݃`FbN֐
//  y  zrequest: tqk擾IuWFNg
//            oSession: ZbVIuWFNg
//            loginGroupId: OCO[vID
//            localeId: P[ID
//            userId: [UID
//  y ԋp z
//              result
//                resultFlg: ݂ꍇ trueAȊO false
//                resultStatus:
//                  messageId: G[bZ[WID
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČƁÄČ̃m[h̑݃`FbNs܂B
//=============================================================================
function checkExist(request, oSession, loginGroupId, localeId, userId) {
    var databaseResult;
    var administratorType = Procedure.imw_admin_utils.decodeAdministratorType(
            oSession, request.imwOpeType);

    // Č̑݃`FbN
    if (request.referer == "actv") {
        databaseResult = Procedure.imw_matter_utils.isExistRefActvMatter(loginGroupId, localeId, userId,
                request.imwSystemMatterId, administratorType);
    } else if (request.referer == "cpl") {
        databaseResult = Procedure.imw_matter_utils.isExistRefCplMatter(loginGroupId, localeId, userId,
                request.imwSystemMatterId, administratorType);
    }
    if (!databaseResult.resultFlag) {
        return databaseResult;
    }

    // wm[h̑݃`FbN
    var manager;
    if (request.referer == "actv") {
        manager = new ActvMatter(loginGroupId, localeId, request.imwSystemMatterId);
    } else if (request.referer == "cpl") {
        manager = new CplMatter(loginGroupId, localeId, request.imwSystemMatterId);
    }
    databaseResult = Procedure.imw_matter_utils.isExistMatterNode(manager, request.imwNodeId);
    return databaseResult;
}

//=============================================================================
// Č̃m[h擾֐
//  y  znodeManager: ActvMatterNode NX̃CX^X
//            nodeId: m[hID
//  y ԋp zʃIuWFNg
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ̃m[h擾܂B
//=============================================================================
function getActvMatterNodeData(nodeManager, nodeId) {
    var databaseResult;
    var result = new Object();
    result.resultFlag = true;
    result.data = new Object();
    result.resultStatus = new Object();

    // }X^t[̃m[hݒ擾
    databaseResult = nodeManager.getMasterNodeConfig(nodeId);
    if (!databaseResult.resultFlag) {
        return databaseResult;
    }
    result.data.masterNodeConfig = databaseResult.data;

    // st[̃m[hݒ擾
    databaseResult = nodeManager.getExecNodeConfig(nodeId);
    if (!databaseResult.resultFlag) {
        return databaseResult;
    }
    result.data.execNodeConfig = databaseResult.data;

    if (result.data.masterNodeConfig == null && result.data.execNodeConfig == null) {
        // }X^ɂsɂȂꍇ
        result.resultFlag = false;
        result.resultStatus.messageId = "IMW.CLI.WRN.3509";
        return result;
    } else if (result.data.masterNodeConfig != null && result.data.execNodeConfig == null) {
        // }X^ɂĎsɂȂꍇ
        result.data.nodeType = result.data.masterNodeConfig.nodeType;
        result.data.nodeName = result.data.masterNodeConfig.nodeName;
        result.data.isNodeEnabled = false;
    } else {
        // sɂꍇ
        result.data.nodeType = result.data.execNodeConfig.nodeType;
        result.data.nodeName = result.data.execNodeConfig.nodeName;
        result.data.isNodeEnabled = true;
    }

    return result;
}

//=============================================================================
// Č̃m[h擾֐
//  y  znodeManager: ActvMatterNode NX̃CX^X
//            nodeId: m[hID
//  y ԋp zʃIuWFNg
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ̃m[h擾܂B
//=============================================================================
function getCplMatterNodeData(nodeManager, nodeId) {
    var databaseResult;
    var result = new Object();
    result.resultFlag = true;
    result.data = new Object();
    result.resultStatus = new Object();

    // st[̃m[hݒ擾
    databaseResult = nodeManager.getExecNodeConfig(nodeId);
    if (!databaseResult.resultFlag) {
        return databaseResult;
    }
    result.data.execNodeConfig = databaseResult.data;

    if (result.data.execNodeConfig == null) {
        // sɂȂꍇ
        result.resultFlag = false;
        result.resultStatus.messageId = "IMW.CLI.WRN.3509"; // m[hݒ񂪑݂܂B
        return result;
    } else {
        // sɂꍇ
        result.data.nodeType = result.data.execNodeConfig.nodeType;
        result.data.nodeName = result.data.execNodeConfig.nodeName;
        result.data.isNodeEnabled = true;
    }

    return result;
}

//=============================================================================
// ΏێҎ擾֐
//  y  zrequest: tqk擾IuWFNg
//            loginGroupId: OCO[vID
//            userId: [UID
//            localeId: P[ID
//            baseDate: 
//            isEnabled: Lȃm[hł trueAȃm[hł false
//  y ԋp z
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zIꂽΏێ҂擾܂B
//=============================================================================
function getTargetUserList(request, loginGroupId, userId, localeId, baseDate, isEnabled) {
    var databaseResult;
    var i;

    // 
    var nodeManager;
    if (request.referer == "actv") {
        nodeManager = new ActvMatterNode(loginGroupId, localeId, request.imwSystemMatterId);
    } else if (request.referer == "cpl") {
        nodeManager = new CplMatterNode(loginGroupId, localeId, request.imwSystemMatterId);
    }

    if (isBlank(request.userNodeConfigIdSelect)) {
        // m[hݒIDw肳ĂȂꍇ
        if (isEnabled) {
            // Lȃm[h̏ꍇ͎s擾
            databaseResult = nodeManager.getExecProcessTargetList(request.imwNodeId);
        } else {
            // ȃm[h̏ꍇ̓}X^擾
            databaseResult = nodeManager.getMasterProcessTargetList(request.imwNodeId);
        }
    } else {
        // m[hݒIDw肳Ăꍇ

        // vOC\ݒ̎擾
        databaseResult = isEnabled ? nodeManager.getExecNodeConfig(request.imwNodeId) :
                nodeManager.getMasterNodeConfig(request.imwNodeId);
        if (!databaseResult.resultFlag) {
            return databaseResult;
        }
        var pluginParameterDisableMap = new Object();
        if (FLOW_DISABLED_PLUGIN && !oResult.isAdmin) {
            var pluginParameterDisable = databaseResult.data.pluginParameterDisable;
            for (i = 0; i < pluginParameterDisable.length; i++) {
                pluginParameterDisableMap[pluginParameterDisable[i]] = true;
            }
        }
        var pluginParameterEnableMap = new Object();
        if (isArray(oResult.imwAppCommonPluginList)) {
            for (i = 0; i < oResult.imwAppCommonPluginList.length; i++) {
                pluginParameterEnableMap[oResult.imwAppCommonPluginList[i].id] = true;
            }
        }

        // ۑ̎擾
        var searchCondition = new ListSearchConditionNoMatterProperty();
        searchCondition.addCondition(UserNodeConfig.DETAIL_NODE_CONFIG_ID,
                request.userNodeConfigIdSelect, ListSearchCondition.OP_EQ);
        searchCondition.addOrder(UserNodeConfig.DETAIL_NODE_NO, true);
        searchCondition.addOrder(UserNodeConfig.DETAIL_EXEC_USER_NO, true);
        var userNodeConfig = new UserNodeConfig(loginGroupId, userId);
        databaseResult = userNodeConfig.getUserNodeConfigDetailList(searchCondition);
        if (!databaseResult.resultFlag) {
            return databaseResult;
        }

        // ꗗ̎擾
        var record = new Array();
        var targetPlugin, pluginNameResult, typeName, targetName, pluginModel;
        for (i = 0; i < databaseResult.data.length; i++) {
            // \֎~Ăꍇ̓XLbv (ۑ̓XLbvȂ)
            if (request.saveFlag != "1") {
                if (pluginParameterDisableMap[databaseResult.data[i].pluginId]) {
                    oResult.isRemoveTargetUser = true;
                    continue;
                }
                if (!pluginParameterEnableMap[databaseResult.data[i].pluginId]) {
                    oResult.isRemoveTargetUser = true;
                    continue;
                }
            }

            // Ώێʖ̎擾
            pluginModel = new Object();
            pluginModel.extensionPointId = databaseResult.data[i].extensionPointId;
            pluginModel.pluginId = databaseResult.data[i].pluginId;
            pluginModel.parameter = databaseResult.data[i].parameter;
            targetPlugin = WorkflowPluginUtil.getLocalePluginName(
                    loginGroupId, localeId, pluginModel.extensionPointId, pluginModel.pluginId);
            if (!targetPlugin.resultFlag || isBlank(targetPlugin.data)) {
                oResult.isInvalidTargetUser = true;
                continue;
            }
            typeName = targetPlugin.data;

            // Ώۖ̎擾
            pluginNameResult = WorkflowPluginUtil.getLocaleDisplayName(
                    loginGroupId, localeId, pluginModel, baseDate, null);
            if (!pluginNameResult.resultFlag || isBlank(pluginNameResult.data)) {
                oResult.isInvalidTargetUser = true;
                continue;
            }
            targetName = pluginNameResult.data;

            databaseResult.data[i].processTargetClassifyName = typeName;
            databaseResult.data[i].processTargetName = targetName;

            record.push(databaseResult.data[i]);
        }
        databaseResult.data = record;
    }

    // HTML GR[h
    for (i = 0; i < databaseResult.data.length; i++) {
        databaseResult.data[i].extensionPointId = Procedure.imw_utils.escapeHTML(
                databaseResult.data[i].extensionPointId);
        databaseResult.data[i].pluginId = Procedure.imw_utils.escapeHTML(
                databaseResult.data[i].pluginId);
        databaseResult.data[i].parameter = Procedure.imw_utils.escapeHTML(
                databaseResult.data[i].parameter);
        databaseResult.data[i].processTargetClassifyName = Procedure.imw_utils.escapeHTML(
                databaseResult.data[i].processTargetClassifyName);
        databaseResult.data[i].processTargetName = Procedure.imw_utils.escapeHTML(
                databaseResult.data[i].processTargetName);
    }

    // m[hݒxbZ[W\tO
    oResult.isWarnReflectSetting = oResult.isRemoveTargetUser || oResult.isInvalidTargetUser;

    return databaseResult;
}

//=============================================================================
// ۑ֐
//  y  zrequest: tqk擾IuWFNg
//  y ԋp z
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zΏێҐݒۑ܂B
//=============================================================================
function actionSave(request) {
    var result;

    // OC[U̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var loginGroupId = oSession.loginGroup;
    var userId = oSession.user;
    var localeId = oSession.locale;

    // f[^x[X`FbN
    result = checkChangeUserAuth(request, oSession, loginGroupId, userId, localeId, "IMW.CLI.WRN.3592");
    if (!result.resultFlag) {
        return result;
    }

    // f[^ۑ
    result = saveData(request, loginGroupId, userId);
    if (!result.resultFlag) {
        return result;
    }

    return result;
}

//=============================================================================
// 폜֐
//  y  zrequest: tqk擾IuWFNg
//  y ԋp z
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zΏێҐݒۑ܂B
//=============================================================================
function actionDelete(request) {
    var result;

    // OC[U̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var loginGroupId = oSession.loginGroup;
    var userId = oSession.user;
    var localeId = oSession.locale;

    // f[^x[X`FbN
    result = checkChangeUserAuth(request, oSession, loginGroupId, userId, localeId, "IMW.CLI.WRN.3593");
    if (!result.resultFlag) {
        return result;
    }

    // f[^폜
    result = deleteData(request, loginGroupId, userId);
    if (!result.resultFlag) {
        return result;
    }

    return result;
}

//=============================================================================
// ΏێҕύX`FbN֐
//  y  zrequest: tqk擾IuWFNg
//            oSession: ZbVIuWFNg
//            loginGroupId: OCO[vID
//            userId: [UID
//            localeId: P[ID
//            errId: G[̃bZ[WID
//  y ԋp z
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ񂪍XVE폜\Ԃł邩mF܂B
//=============================================================================
function checkChangeUserAuth(request, oSession, loginGroupId, userId, localeId, errId) {
    var databaseResult;
    var manager;
    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();

    // ČAm[h̑݃`FbN
    databaseResult = checkExist(request, oSession, loginGroupId, localeId, userId);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                errId, databaseResult);
        return result;
    }

    // VXeǗ҂̏ꍇ
    if (Procedure.imw_admin_utils.isWkfSysAdmor(oSession, request.imwOpeType)) {
        return result;

    // ^pǗ҂̏ꍇ
    } else if (Procedure.imw_admin_utils.isWkfOpeAdmor(oSession, request.imwOpeType)) {
        // t[ID̎擾
        if (request.referer == "actv") {
            manager = new ActvMatter(loginGroupId, localeId, request.imwSystemMatterId);
            databaseResult = manager.getMatter();
        } else if (request.referer == "cpl") {
            manager = new CplMatter(loginGroupId, localeId, request.imwSystemMatterId);
            databaseResult = manager.getMatter();
        }
        if (!databaseResult.resultFlag) {
            return databaseResult;
        }

        // t[`̎Qƌ`FbN
        var oParameter = new Object();
        oParameter.userId = userId;
        oParameter.loginGroupId = loginGroupId;
        oParameter.localeId = localeId;
        oParameter.adminType = codeUtil.getEnumCodeAdministrationType("adminTyp_Flow");
        oParameter.uniqueId = databaseResult.data.flowId;
        oParameter.errorId = "IMW.CLI.WRN.3505";
        if (!Procedure.imw_admin_group_utils.checkSelectAuth(result, oParameter)) {
            return result;
        }

        return result;
    }

    return result;
}

//=============================================================================
// ۑ֐
//  y  zrequest: tqk擾IuWFNg
//            loginGroupId: OCO[vID
//            userId: [UID
//  y ԋp z
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zΏێҐݒۑ܂B
//=============================================================================
function saveData(request, loginGroupId, userId) {
    var databaseResult;
    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();
    result.data = new Object();

    // ΏێҐݒ̐ݒ
    var userNodeConfigParam = new Object();
    userNodeConfigParam.nodeConfigId = Identifier.get();
    userNodeConfigParam.nodeConfigName = request.nodeConfigName;
    userNodeConfigParam.nodeType = request.nodeType;
    userNodeConfigParam.nodeConfigDetails = new Array();

    var nodeConfigDetailInfo = new Object();
    nodeConfigDetailInfo.nodeName = request.nodeName;
    nodeConfigDetailInfo.plugins = new Array();
    var i, pluginInfo;
    if (request.extensionPointId) {
        for (i = 0; i < request.extensionPointId.length; i++) {
            pluginInfo = new Object();
            pluginInfo.extensionPointId = request.extensionPointId[i];
            pluginInfo.pluginId = request.pluginId[i];
            pluginInfo.parameter = request.parameter[i];
            nodeConfigDetailInfo.plugins.push(pluginInfo);
        }
        userNodeConfigParam.nodeConfigDetails.push(nodeConfigDetailInfo);
    }

    // gUNV̊Jn
    databaseResult = DatabaseManager.beginTransaction();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3592", databaseResult);
        return result;
    }

    // ۑ
    var userNodeConfig = new UserNodeConfig(loginGroupId, userId);
    result = userNodeConfig.createUserNodeConfig(userNodeConfigParam);
    if (!result.resultFlag) {
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3592", result);
        // [obN
        databaseResult = DatabaseManager.rollback();
        if (databaseResult.error) {
            result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                    "IMW.CLI.WRN.3592", databaseResult);
        }
        return result;
    }

    // R~bg
    databaseResult = DatabaseManager.commit();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3592", databaseResult);
        return result;
    }

    result.data = userNodeConfigParam.nodeConfigId;
    return result;
}

//=============================================================================
// 폜֐
//  y  zrequest: tqk擾IuWFNg
//            loginGroupId: OCO[vID
//            userId: [UID
//  y ԋp z
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zΏێҐݒ藚폜܂B
//=============================================================================
function deleteData(request, loginGroupId, userId) {
    var databaseResult;
    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();

    // ΏێҐݒ̐ݒ
    var userNodeConfigParam = new Object();
    userNodeConfigParam.nodeConfigId = request.userNodeConfigId;

    // gUNV̊Jn
    databaseResult = DatabaseManager.beginTransaction();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3593", databaseResult);
        return result;
    }

    // 폜
    var userNodeConfig = new UserNodeConfig(loginGroupId, userId);
    result = userNodeConfig.deleteUserNodeConfig(userNodeConfigParam);
    if (!result.resultFlag) {
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3593", result);
        // [obN
        databaseResult = DatabaseManager.rollback();
        if (databaseResult.error) {
            result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                    "IMW.CLI.WRN.3593", databaseResult);
        }
        return result;
    }

    // R~bg
    databaseResult = DatabaseManager.commit();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3593", databaseResult);
        return result;
    }

    return result;
}

//=============================================================================
// XV֐
//  y  zrequest: tqk擾IuWFNg
//  y ԋp z
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zΏێҏXV܂B
//=============================================================================
function actionUpdate(request) {
    var result;

    // OC[U̎擾
    var oSession = AccessSecurityManager.getSessionInfo();
    var loginGroupId = oSession.loginGroup;
    var userId = oSession.user;
    var localeId = oSession.locale;

    // f[^x[X`FbN
    var administratorType = Procedure.imw_admin_utils.decodeAdministratorType(
            oSession, request.imwOpeType);
    result = checkUpdateData(request, oSession, loginGroupId, userId, localeId, administratorType);
    if (!result.resultFlag) {
        return result;
    }

    // Č̎擾
    if (request.referer == "actv") {
        result = Procedure.imw_matter_utils.getActvMatterData(loginGroupId, localeId, userId,
                request.imwSystemMatterId);
    } else if (request.referer == "cpl") {
        result = Procedure.imw_matter_utils.getCplMatterData(loginGroupId, localeId, userId,
                request.imwSystemMatterId);
    }
    if (!result.resultFlag) {
        return result;
    }
    var matterData = result.data;

    // m[h̎擾
    var nodeManager;
    if (request.referer == "actv") {
        nodeManager = new ActvMatterNode(loginGroupId, localeId, request.imwSystemMatterId);
        result = getActvMatterNodeData(nodeManager, request.imwNodeId);
    } else if (request.referer == "cpl") {
        nodeManager = new CplMatterNode(loginGroupId, localeId, request.imwSystemMatterId);
        result = getCplMatterNodeData(nodeManager, request.imwNodeId);
    }
    if (!result.resultFlag) {
        return result;
    }
    var nodeData = result.data;

    // f[^XV
    var handleManager;
    if (request.referer == "actv") {
        handleManager = new ActvMatterHandleManager(loginGroupId, localeId, request.imwSystemMatterId,
                userId);
        result = updateData(request, handleManager, nodeManager, matterData, nodeData,
                administratorType, true);
    } else if (request.referer == "cpl") {
        handleManager = new CplMatterHandleManager(loginGroupId, localeId, request.imwSystemMatterId,
                userId);
        result = updateData(request, handleManager, nodeManager, matterData, nodeData,
                administratorType, false);
    }
    if (!result.resultFlag) {
        return result;
    }

    return result;
}

//=============================================================================
// XV`FbN֐
//  y  zrequest: tqk擾IuWFNg
//            oSession: ZbVIuWFNg
//            loginGroupId: OCO[vID
//            userId: [UID
//            localeId: P[ID
//            administratorType: ǗҎ
//  y ԋp z
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zČ񂪍XVE폜\Ԃł邩mF܂B
//=============================================================================
function checkUpdateData(request, oSession, loginGroupId, userId, localeId, administratorType) {
    var databaseResult;
    var manager;
    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();
    result.data = new Object();

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var admorTypeWkfSysAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfSysAdmor");
    var admorTypeWkfOpeAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfOpeAdmor");

    // ČAm[h̑݃`FbN
    databaseResult = checkExist(request, oSession, loginGroupId, localeId, userId);
    if (!databaseResult.resultFlag) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3594", databaseResult);
        return result;
    }

    // VXeǗ҂̏ꍇ
    if (administratorType == admorTypeWkfSysAdmor) {
        return result;

    // ^pǗ҂̏ꍇ
    } else if (administratorType == admorTypeWkfOpeAdmor) {
        // t[ID̎擾
        if (request.referer == "actv") {
            manager = new ActvMatter(loginGroupId, localeId, request.imwSystemMatterId);
            databaseResult = manager.getMatter();
        } else if (request.referer == "cpl") {
            manager = new CplMatter(loginGroupId, localeId, request.imwSystemMatterId);
            databaseResult = manager.getMatter();
        }
        if (!databaseResult.resultFlag) {
            return databaseResult;
        }

        // t[`̎Qƌ`FbN
        var oParameter = new Object();
        oParameter.userId = userId;
        oParameter.loginGroupId = loginGroupId;
        oParameter.localeId = localeId;
        oParameter.adminType = codeUtil.getEnumCodeAdministrationType("adminTyp_Flow");
        oParameter.uniqueId = databaseResult.data.flowId;
        oParameter.errorId = "IMW.CLI.WRN.3505";
        if (!Procedure.imw_admin_group_utils.checkSelectAuth(result, oParameter)) {
            return result;
        }

        return result;
    }

    return result;
}

//=============================================================================
// XV֐
//  y  zrequest: tqk擾IuWFNg
//            handleManager: ActvMatterHandleManager, CplMatterHandleManager NX̃CX^X
//            nodeManager: ActvMatterNode, CplMatterNode NX̃CX^X
//            matterData: ČIuWFNg
//            nodeData: m[hIuWFNg
//            administratorType: ǗҎ
//            isActv: Č̏ꍇ trueAȊO false
//  y ԋp z
//  y쐬ҁzNTT DATA INTRAMART
//  y Tv zm[hݒXV܂B
//=============================================================================
function updateData(request, handleManager, nodeManager, matterData, nodeData, administratorType, isActv) {
    var databaseResult;
    var i;
    var result = new Object();
    result.resultFlag = true;
    result.resultStatus = new Object();

    // R[hl̎擾
    var codeUtil = new WorkflowCodeUtil();
    var admorTypeWkfSysAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfSysAdmor");
    var admorTypeWkfOpeAdmor = codeUtil.getEnumCodeAdministratorType("admorTyp_wkfOpeAdmor");
    var flagStatusEnable = codeUtil.getEnumCodeFlagStatus("Enable");
    var flagStatusDisable = codeUtil.getEnumCodeFlagStatus("Disable");
    var nodeTypeDynamic = codeUtil.getEnumCodeNodeType("nodeTyp_Dynamic");
    var nodeTypeConfirm = codeUtil.getEnumCodeNodeType("nodeTyp_Confirm");
    var nodeTypeHorizontal = codeUtil.getEnumCodeNodeType("nodeTyp_Horizontal");
    var nodeTypeVertical = codeUtil.getEnumCodeNodeType("nodeTyp_Vertical");

    // OC[ÜČ쌠擾
    var loginUserHandleAuth = matterData.loginUserHandleAuth;
    var hasChangeUserAuth = true; // m[h̏EmFΏێ҂̕ύX
    var hasDeleteDynamicNodeAuth = true; // IFm[h̍폜
    var hasUndeleteDynamicNodeAuth = true; // IFm[h̕
    oResult.isAdmin = administratorType == admorTypeWkfSysAdmor || administratorType == admorTypeWkfOpeAdmor;
    if (!oResult.isAdmin) {
        hasChangeUserAuth = !isBlank(loginUserHandleAuth.changeUserFlag) &&
                loginUserHandleAuth.changeUserFlag == flagStatusEnable;
        hasDeleteDynamicNodeAuth = !isBlank(loginUserHandleAuth.deleteDynamicNodeFlag) &&
                loginUserHandleAuth.deleteDynamicNodeFlag == flagStatusEnable;
        hasUndeleteDynamicNodeAuth = !isBlank(loginUserHandleAuth.undeleteDynamicNodeFlag) &&
                loginUserHandleAuth.undeleteDynamicNodeFlag == flagStatusEnable;
    }

    // gUNV̊Jn
    databaseResult = DatabaseManager.beginTransaction();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3594", databaseResult);
        return result;
    }

    var isUpdate = true;
    if (nodeData.nodeType == nodeTypeDynamic) {
        // IFm[h̏ꍇ
        if (nodeData.isNodeEnabled && request.isNodeEnabled == flagStatusDisable) {
            // m[h폜̃`FbN
            if (!hasDeleteDynamicNodeAuth) {
                result.resultFlag = false;
                result.resultStatus.message = MessageManager.getMessage("IMW.CLI.WRN.3505");
                return result;
            }

            // L𖳌ɂꍇ̓m[h̍폜
            isUpdate = false;
            databaseResult = handleManager.deleteNode(request.imwNodeId);
            if (!databaseResult.resultFlag) {
                result.resultFlag = false;
                result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                        "IMW.CLI.WRN.3594", databaseResult);
                // [obN
                databaseResult = DatabaseManager.rollback();
                if (databaseResult.error) {
                    result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                            "IMW.CLI.WRN.3594", databaseResult);
                }
                return result;
            }
        } else if (!nodeData.isNodeEnabled && request.isNodeEnabled == flagStatusEnable) {
            // m[h̃`FbN
            if (!hasUndeleteDynamicNodeAuth) {
                result.resultFlag = false;
                result.resultStatus.message = MessageManager.getMessage("IMW.CLI.WRN.3505");
                return result;
            }

            // Lɂꍇ̓}X^t[Ƀm[h񂪑݂邩mF
            databaseResult = nodeManager.getMasterNodeConfig(request.imwNodeId);
            if (!databaseResult.resultFlag) {
                result.resultFlag = false;
                result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                        "IMW.CLI.WRN.3594", databaseResult);
                // [obN
                databaseResult = DatabaseManager.rollback();
                if (databaseResult.error) {
                    databaseResult.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                            "IMW.CLI.WRN.3594", databaseResult);
                }
                return result;
            }

            // Oɐڑm[hID擾
            var matterNode = matterData.execFlowNodeMap[request.imwNodeId];
            var backwardNodeIds = matterNode.backwardNodeIds;
            var backwardNodeId = "";
            while (!isBlank(backwardNodeIds) && isBlank(backwardNodeId)) {
                for (i = 0; i < backwardNodeIds.length; i++) {
                    backwardNodeId = backwardNodeIds[i];
                    matterNode = matterData.execFlowNodeMap[backwardNodeId];
                    // mFm[h̓XLbv
                    if (matterNode.nodeType == nodeTypeConfirm) {
                        continue;
                    }
                    // WJς݂̓IFEzuEczum[h͎̃m[h
                    // (st[ɑ݂Ȃ)
                    if (matterNode.isNodeExpand && (
                            matterNode.nodeType == nodeTypeDynamic ||
                            matterNode.nodeType == nodeTypeHorizontal ||
                            matterNode.nodeType == nodeTypeVertical)) {
                        backwardNodeId = "";
                    }
                    break;
                }
                backwardNodeIds = matterNode.backwardNodeIds;
            }

            // 㑤ɐڑm[hID擾
            matterNode = matterData.execFlowNodeMap[request.imwNodeId];
            var forwardNodeIds = matterNode.forwardNodeIds;
            var forwardNodeId = "";
            while (!isBlank(forwardNodeIds) && isBlank(forwardNodeId)) {
                for (i = 0; i < forwardNodeIds.length; i++) {
                    forwardNodeId = forwardNodeIds[i];
                    matterNode = matterData.execFlowNodeMap[forwardNodeId];
                    // mFm[h̓XLbv
                    if (matterNode.nodeType == nodeTypeConfirm) {
                        continue;
                    }
                    // WJς݂̓IFEzuEczum[h͎̃m[h
                    // (st[ɑ݂Ȃ)
                    if (matterNode.isNodeExpand && (
                            matterNode.nodeType == nodeTypeDynamic ||
                            matterNode.nodeType == nodeTypeHorizontal ||
                            matterNode.nodeType == nodeTypeVertical)) {
                        forwardNodeId = "";
                    }
                    break;
                }
                forwardNodeIds = matterNode.forwardNodeIds;
            }

            // m[h𕜊
            databaseResult = handleManager.copyNodeFromMasterFlow(request.imwNodeId, backwardNodeId,
                    forwardNodeId, request.imwNodeId);
            if (!result.resultFlag) {
                result.resultFlag = false;
                result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                        "IMW.CLI.WRN.3594", databaseResult);
                // [obN
                databaseResult = DatabaseManager.rollback();
                if (databaseResult.error) {
                    result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                            "IMW.CLI.WRN.3594", databaseResult);
                }
                return result;
            }
        } else if (!nodeData.isNodeEnabled && request.isNodeEnabled == flagStatusDisable) {
            // 疳̂܂܂̏ꍇ͉Ȃ
            isUpdate = false;
        }
    }

    if (isUpdate) {
        // EmFΏێҕύX̎擾
        var editAuthMap = isActv ?
                Procedure.imw_matter_utils.getActvNodeConfigEditAuth(
                    matterData, administratorType, matterData.execFlowNodeList) :
                Procedure.imw_matter_utils.getCplNodeConfigEditAuth(
                    matterData, administratorType, matterData.execFlowNodeList);

        // EmFΏێ҂̕ύXꍇ
        if (hasChangeUserAuth && editAuthMap[request.imwNodeId] == flagStatusEnable) {
            // EmFΏێ҂̍폜
            databaseResult = isActv ? handleManager.deleteProcessTargetAll(request.imwNodeId) :
                    handleManager.deleteConfirmTargetAll(request.imwNodeId);
            if (!databaseResult.resultFlag) {
                result.resultFlag = false;
                result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                        "IMW.CLI.WRN.3594", databaseResult);
                // [obN
                databaseResult = DatabaseManager.rollback();
                if (databaseResult.error) {
                    result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                            "IMW.CLI.WRN.3594", databaseResult);
                }
                return result;
            }

            // EmFΏێ҂̓o^
            if (request.extensionPointId) {
                var models = new Array();
                var plugin;
                for (i = 0; i < request.extensionPointId.length; i++) {
                    plugin = new Object();
                    plugin.extensionPointId = request.extensionPointId[i];
                    plugin.pluginId = request.pluginId[i];
                    plugin.parameter = request.parameter[i];
                    models.push(plugin);
                }
                databaseResult = isActv ? handleManager.createProcessTarget(request.imwNodeId, models) :
                        handleManager.createConfirmTarget(request.imwNodeId, models);
                if (!databaseResult.resultFlag) {
                    result.resultFlag = false;
                    result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                            "IMW.CLI.WRN.3594", databaseResult);
                    // [obN
                    databaseResult = DatabaseManager.rollback();
                    if (databaseResult.error) {
                        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                                "IMW.CLI.WRN.3594", databaseResult);
                    }
                    return result;
                }
            }
        }

        // EmFΏێ҂̍ēWJ̎擾
        var expandAuthMap = isActv ?
                Procedure.imw_matter_utils.getActvProcessTargetExpandAuth(
                        matterData, administratorType, matterData.execFlowNodeList) :
                Procedure.imw_matter_utils.getCplProcessTargetExpandAuth(
                        matterData, administratorType, matterData.execFlowNodeList);

        // EmFΏێ҂̍ēWJꍇ
        if (expandAuthMap[request.imwNodeId] == flagStatusEnable) {
            // EmFΏێ҂̍ēWJ
            if (nodeData.nodeType == nodeTypeConfirm) {
                databaseResult = handleManager.expandConfirmTarget(request.imwNodeId);
            } else {
                databaseResult = isActv ? handleManager.expandProcessTarget(request.imwNodeId) :
                        handleManager.expandConfirmTarget(request.imwNodeId);
            }
            if (!databaseResult.resultFlag) {
                result.resultFlag = false;
                result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                        "IMW.CLI.WRN.3594", databaseResult);
                // [obN
                databaseResult = DatabaseManager.rollback();
                if (databaseResult.error) {
                    result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                            "IMW.CLI.WRN.3594", databaseResult);
                }
                return result;
            }
        }
    }

    // R~bg
    databaseResult = DatabaseManager.commit();
    if (databaseResult.error) {
        result.resultFlag = false;
        result.resultStatus.message = Procedure.imw_error_utils.getErrorMessage(
                "IMW.CLI.WRN.3594", databaseResult);
        return false;
    }

    return result;
}
