CREATE TABLE imw_w_sync_batch
(
    no                             VARCHAR(20) NOT NULL,
    listener_name                  VARCHAR(100) NOT NULL,
    method_name                    VARCHAR(50) NOT NULL,
    parameter1                     VARCHAR(1000),
    parameter2                     VARCHAR(1000),
    parameter3                     VARCHAR(1000),
    parameter4                     VARCHAR(1000),
    parameter5                     VARCHAR(1000),
    create_user_code               VARCHAR(100),
    update_user_code               VARCHAR(100),
    create_date                    TIMESTAMP,
    update_date                    TIMESTAMP
);

CREATE TABLE imw_t_thread ( 
    system_matter_id        VARCHAR(20) NOT NULL,
    node_id                 VARCHAR(50) NOT NULL,
    thread_task_id          VARCHAR(20) NOT NULL,
    thread_id               VARCHAR(50),
    lock_flag               VARCHAR(1),
    note                    VARCHAR(100),
    create_user_code        VARCHAR(100),
    update_user_code        VARCHAR(100),
    create_date             TIMESTAMP,
    update_date             TIMESTAMP,
    PRIMARY KEY (system_matter_id, node_id, thread_task_id)
);